/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "parser/parse_expr.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 254 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    FCONST = 259,
    SCONST = 260,
    BCONST = 261,
    XCONST = 262,
    Op = 263,
    ICONST = 264,
    PARAM = 265,
    TYPECAST = 266,
    DOT_DOT = 267,
    COLON_EQUALS = 268,
    EQUALS_GREATER = 269,
    LESS_EQUALS = 270,
    GREATER_EQUALS = 271,
    NOT_EQUALS = 272,
    ABORT_P = 273,
    ABSOLUTE_P = 274,
    ACCESS = 275,
    ACTION = 276,
    ADD_P = 277,
    ADMIN = 278,
    AFTER = 279,
    AGGREGATE = 280,
    ALL = 281,
    ALSO = 282,
    ALTER = 283,
    ALWAYS = 284,
    ANALYSE = 285,
    ANALYZE = 286,
    AND = 287,
    ANY = 288,
    ARRAY = 289,
    AS = 290,
    ASC = 291,
    ASSERTION = 292,
    ASSIGNMENT = 293,
    ASYMMETRIC = 294,
    AT = 295,
    ATTRIBUTE = 296,
    AUTHORIZATION = 297,
    BACKWARD = 298,
    BEFORE = 299,
    BEGIN_P = 300,
    BETWEEN = 301,
    BIGINT = 302,
    BINARY = 303,
    BIT = 304,
    BOOLEAN_P = 305,
    BOTH = 306,
    BY = 307,
    CACHE = 308,
    CALLED = 309,
    CASCADE = 310,
    CASCADED = 311,
    CASE = 312,
    CAST = 313,
    CATALOG_P = 314,
    CHAIN = 315,
    CHAR_P = 316,
    CHARACTER = 317,
    CHARACTERISTICS = 318,
    CHECK = 319,
    CHECKPOINT = 320,
    CLASS = 321,
    CLOSE = 322,
    CLUSTER = 323,
    COALESCE = 324,
    COLLATE = 325,
    COLLATION = 326,
    COLUMN = 327,
    COMMENT = 328,
    COMMENTS = 329,
    COMMIT = 330,
    COMMITTED = 331,
    CONCURRENTLY = 332,
    CONFIGURATION = 333,
    CONFLICT = 334,
    CONNECTION = 335,
    CONSTRAINT = 336,
    CONSTRAINTS = 337,
    CONTENT_P = 338,
    CONTINUE_P = 339,
    CONVERSION_P = 340,
    COPY = 341,
    COST = 342,
    CREATE = 343,
    CROSS = 344,
    CSV = 345,
    CUBE = 346,
    CURRENT_P = 347,
    CURRENT_CATALOG = 348,
    CURRENT_DATE = 349,
    CURRENT_ROLE = 350,
    CURRENT_SCHEMA = 351,
    CURRENT_TIME = 352,
    CURRENT_TIMESTAMP = 353,
    CURRENT_USER = 354,
    CURSOR = 355,
    CYCLE = 356,
    DATA_P = 357,
    DATABASE = 358,
    DAY_P = 359,
    DEALLOCATE = 360,
    DEC = 361,
    DECIMAL_P = 362,
    DECLARE = 363,
    DEFAULT = 364,
    DEFAULTS = 365,
    DEFERRABLE = 366,
    DEFERRED = 367,
    DEFINER = 368,
    DELETE_P = 369,
    DELIMITER = 370,
    DELIMITERS = 371,
    DEPENDS = 372,
    DESC = 373,
    DICTIONARY = 374,
    DISABLE_P = 375,
    DISCARD = 376,
    DISTINCT = 377,
    DO = 378,
    DOCUMENT_P = 379,
    DOMAIN_P = 380,
    DOUBLE_P = 381,
    DROP = 382,
    EACH = 383,
    ELSE = 384,
    ENABLE_P = 385,
    ENCODING = 386,
    ENCRYPTED = 387,
    END_P = 388,
    ENUM_P = 389,
    ESCAPE = 390,
    EVENT = 391,
    EXCEPT = 392,
    EXCLUDE = 393,
    EXCLUDING = 394,
    EXCLUSIVE = 395,
    EXECUTE = 396,
    EXISTS = 397,
    EXPLAIN = 398,
    EXTENSION = 399,
    EXTERNAL = 400,
    EXTRACT = 401,
    FALSE_P = 402,
    FAMILY = 403,
    FETCH = 404,
    FILTER = 405,
    FIRST_P = 406,
    FLOAT_P = 407,
    FOLLOWING = 408,
    FOR = 409,
    FORCE = 410,
    FOREIGN = 411,
    FORWARD = 412,
    FREEZE = 413,
    FROM = 414,
    FULL = 415,
    FUNCTION = 416,
    FUNCTIONS = 417,
    GLOBAL = 418,
    GRANT = 419,
    GRANTED = 420,
    GREATEST = 421,
    GROUP_P = 422,
    GROUPING = 423,
    HANDLER = 424,
    HAVING = 425,
    HEADER_P = 426,
    HOLD = 427,
    HOUR_P = 428,
    IDENTITY_P = 429,
    IF_P = 430,
    ILIKE = 431,
    IMMEDIATE = 432,
    IMMUTABLE = 433,
    IMPLICIT_P = 434,
    IMPORT_P = 435,
    IN_P = 436,
    INCLUDING = 437,
    INCREMENT = 438,
    INDEX = 439,
    INDEXES = 440,
    INHERIT = 441,
    INHERITS = 442,
    INITIALLY = 443,
    INLINE_P = 444,
    INNER_P = 445,
    INOUT = 446,
    INPUT_P = 447,
    INSENSITIVE = 448,
    INSERT = 449,
    INSTEAD = 450,
    INT_P = 451,
    INTEGER = 452,
    INTERSECT = 453,
    INTERVAL = 454,
    INTO = 455,
    INVOKER = 456,
    IS = 457,
    ISNULL = 458,
    ISOLATION = 459,
    JOIN = 460,
    KEY = 461,
    LABEL = 462,
    LANGUAGE = 463,
    LARGE_P = 464,
    LAST_P = 465,
    LATERAL_P = 466,
    LEADING = 467,
    LEAKPROOF = 468,
    LEAST = 469,
    LEFT = 470,
    LEVEL = 471,
    LIKE = 472,
    LIMIT = 473,
    LISTEN = 474,
    LOAD = 475,
    LOCAL = 476,
    LOCALTIME = 477,
    LOCALTIMESTAMP = 478,
    LOCATION = 479,
    LOCK_P = 480,
    LOCKED = 481,
    LOGGED = 482,
    MAPPING = 483,
    MATCH = 484,
    MATERIALIZED = 485,
    MAXVALUE = 486,
    METHOD = 487,
    MINUTE_P = 488,
    MINVALUE = 489,
    MODE = 490,
    MONTH_P = 491,
    MOVE = 492,
    NAME_P = 493,
    NAMES = 494,
    NATIONAL = 495,
    NATURAL = 496,
    NCHAR = 497,
    NEXT = 498,
    NO = 499,
    NONE = 500,
    NOT = 501,
    NOTHING = 502,
    NOTIFY = 503,
    NOTNULL = 504,
    NOWAIT = 505,
    NULL_P = 506,
    NULLIF = 507,
    NULLS_P = 508,
    NUMERIC = 509,
    OBJECT_P = 510,
    OF = 511,
    OFF = 512,
    OFFSET = 513,
    OIDS = 514,
    ON = 515,
    ONLY = 516,
    OPERATOR = 517,
    OPTION = 518,
    OPTIONS = 519,
    OR = 520,
    ORDER = 521,
    ORDINALITY = 522,
    OUT_P = 523,
    OUTER_P = 524,
    OVER = 525,
    OVERLAPS = 526,
    OVERLAY = 527,
    OWNED = 528,
    OWNER = 529,
    PARALLEL = 530,
    PARSER = 531,
    PARTIAL = 532,
    PARTITION = 533,
    PASSING = 534,
    PASSWORD = 535,
    PLACING = 536,
    PLANS = 537,
    POLICY = 538,
    POSITION = 539,
    PRECEDING = 540,
    PRECISION = 541,
    PRESERVE = 542,
    PREPARE = 543,
    PREPARED = 544,
    PRIMARY = 545,
    PRIOR = 546,
    PRIVILEGES = 547,
    PROCEDURAL = 548,
    PROCEDURE = 549,
    PROGRAM = 550,
    QUOTE = 551,
    RANGE = 552,
    READ = 553,
    REAL = 554,
    REASSIGN = 555,
    RECHECK = 556,
    RECURSIVE = 557,
    REF = 558,
    REFERENCES = 559,
    REFRESH = 560,
    REINDEX = 561,
    RELATIVE_P = 562,
    RELEASE = 563,
    RENAME = 564,
    REPEATABLE = 565,
    REPLACE = 566,
    REPLICA = 567,
    RESET = 568,
    RESTART = 569,
    RESTRICT = 570,
    RETURNING = 571,
    RETURNS = 572,
    REVOKE = 573,
    RIGHT = 574,
    ROLE = 575,
    ROLLBACK = 576,
    ROLLUP = 577,
    ROW = 578,
    ROWS = 579,
    RULE = 580,
    SAVEPOINT = 581,
    SCHEMA = 582,
    SCROLL = 583,
    SEARCH = 584,
    SECOND_P = 585,
    SECURITY = 586,
    SELECT = 587,
    SEQUENCE = 588,
    SEQUENCES = 589,
    SERIALIZABLE = 590,
    SERVER = 591,
    SESSION = 592,
    SESSION_USER = 593,
    SET = 594,
    SETS = 595,
    SETOF = 596,
    SHARE = 597,
    SHOW = 598,
    SIMILAR = 599,
    SIMPLE = 600,
    SKIP = 601,
    SMALLINT = 602,
    SNAPSHOT = 603,
    SOME = 604,
    SQL_P = 605,
    STABLE = 606,
    STANDALONE_P = 607,
    START = 608,
    STATEMENT = 609,
    STATISTICS = 610,
    STDIN = 611,
    STDOUT = 612,
    STORAGE = 613,
    STRICT_P = 614,
    STRIP_P = 615,
    SUBSTRING = 616,
    SYMMETRIC = 617,
    SYSID = 618,
    SYSTEM_P = 619,
    TABLE = 620,
    TABLES = 621,
    TABLESAMPLE = 622,
    TABLESPACE = 623,
    TEMP = 624,
    TEMPLATE = 625,
    TEMPORARY = 626,
    TEXT_P = 627,
    THEN = 628,
    TIME = 629,
    TIMESTAMP = 630,
    TO = 631,
    TRAILING = 632,
    TRANSACTION = 633,
    TRANSFORM = 634,
    TREAT = 635,
    TRIGGER = 636,
    TRIM = 637,
    TRUE_P = 638,
    TRUNCATE = 639,
    TRUSTED = 640,
    TYPE_P = 641,
    TYPES_P = 642,
    UNBOUNDED = 643,
    UNCOMMITTED = 644,
    UNENCRYPTED = 645,
    UNION = 646,
    UNIQUE = 647,
    UNKNOWN = 648,
    UNLISTEN = 649,
    UNLOGGED = 650,
    UNTIL = 651,
    UPDATE = 652,
    USER = 653,
    USING = 654,
    VACUUM = 655,
    VALID = 656,
    VALIDATE = 657,
    VALIDATOR = 658,
    VALUE_P = 659,
    VALUES = 660,
    VARCHAR = 661,
    VARIADIC = 662,
    VARYING = 663,
    VERBOSE = 664,
    VERSION_P = 665,
    VIEW = 666,
    VIEWS = 667,
    VOLATILE = 668,
    WHEN = 669,
    WHERE = 670,
    WHITESPACE_P = 671,
    WINDOW = 672,
    WITH = 673,
    WITHIN = 674,
    WITHOUT = 675,
    WORK = 676,
    WRAPPER = 677,
    WRITE = 678,
    XML_P = 679,
    XMLATTRIBUTES = 680,
    XMLCONCAT = 681,
    XMLELEMENT = 682,
    XMLEXISTS = 683,
    XMLFOREST = 684,
    XMLPARSE = 685,
    XMLPI = 686,
    XMLROOT = 687,
    XMLSERIALIZE = 688,
    YEAR_P = 689,
    YES_P = 690,
    ZONE = 691,
    NOT_LA = 692,
    NULLS_LA = 693,
    WITH_LA = 694,
    POSTFIXOP = 695,
    UMINUS = 696
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 192 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;

#line 776 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 806 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  763
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   91938

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  459
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  618
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2512
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  4991

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   696

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   448,     2,     2,
     453,   454,   446,   444,   457,   445,   455,   447,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   458,   456,
     440,   442,   441,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   451,     2,   452,   449,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   443,   450
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   734,   734,   741,   748,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     884,   894,   905,   906,   907,   916,   917,   921,   922,   926,
     931,   935,   940,   945,   949,   953,   958,   962,  1010,  1012,
    1016,  1020,  1024,  1028,  1042,  1060,  1071,  1072,  1076,  1084,
    1102,  1114,  1122,  1143,  1150,  1167,  1174,  1191,  1209,  1220,
    1221,  1233,  1240,  1257,  1267,  1277,  1292,  1310,  1311,  1315,
    1322,  1330,  1331,  1332,  1333,  1334,  1335,  1349,  1355,  1361,
    1370,  1378,  1386,  1390,  1398,  1406,  1413,  1422,  1423,  1431,
    1442,  1450,  1458,  1469,  1477,  1485,  1492,  1501,  1511,  1512,
    1516,  1517,  1520,  1522,  1526,  1527,  1528,  1529,  1533,  1534,
    1535,  1541,  1553,  1557,  1561,  1576,  1583,  1584,  1585,  1589,
    1590,  1591,  1595,  1596,  1600,  1604,  1605,  1612,  1619,  1629,
    1636,  1646,  1647,  1652,  1653,  1658,  1664,  1670,  1676,  1682,
    1692,  1702,  1703,  1707,  1708,  1716,  1731,  1737,  1743,  1749,
    1755,  1774,  1783,  1792,  1803,  1814,  1823,  1832,  1843,  1854,
    1863,  1872,  1881,  1890,  1899,  1908,  1919,  1933,  1934,  1939,
    1948,  1957,  1966,  1975,  1984,  1992,  2000,  2009,  2018,  2027,
    2036,  2046,  2059,  2074,  2083,  2091,  2106,  2114,  2124,  2134,
    2141,  2148,  2156,  2164,  2171,  2178,  2186,  2194,  2202,  2209,
    2216,  2224,  2231,  2238,  2246,  2254,  2262,  2270,  2278,  2286,
    2296,  2303,  2311,  2319,  2327,  2335,  2343,  2350,  2357,  2364,
    2370,  2380,  2381,  2385,  2386,  2387,  2391,  2399,  2403,  2404,
    2408,  2415,  2422,  2429,  2439,  2442,  2443,  2447,  2448,  2453,
    2457,  2461,  2466,  2481,  2494,  2495,  2500,  2509,  2519,  2529,
    2555,  2561,  2594,  2623,  2645,  2646,  2650,  2651,  2660,  2661,
    2662,  2665,  2666,  2671,  2672,  2676,  2680,  2684,  2688,  2692,
    2696,  2700,  2704,  2708,  2712,  2716,  2720,  2724,  2728,  2737,
    2741,  2745,  2749,  2753,  2757,  2761,  2762,  2767,  2771,  2778,
    2785,  2786,  2787,  2788,  2789,  2793,  2797,  2805,  2816,  2832,
    2849,  2866,  2896,  2897,  2898,  2899,  2900,  2907,  2914,  2915,
    2919,  2920,  2924,  2925,  2929,  2933,  2940,  2944,  2951,  2952,
    2953,  2957,  2958,  2961,  2982,  3003,  3004,  3008,  3016,  3017,
    3018,  3049,  3056,  3063,  3074,  3085,  3097,  3106,  3139,  3146,
    3153,  3160,  3171,  3181,  3182,  3183,  3187,  3188,  3189,  3190,
    3191,  3192,  3201,  3209,  3213,  3226,  3241,  3255,  3270,  3284,
    3302,  3323,  3324,  3328,  3329,  3333,  3334,  3337,  3343,  3347,
    3355,  3360,  3366,  3367,  3371,  3376,  3383,  3384,  3394,  3396,
    3398,  3400,  3403,  3406,  3409,  3413,  3414,  3415,  3416,  3417,
    3420,  3421,  3426,  3427,  3428,  3429,  3432,  3433,  3434,  3435,
    3438,  3439,  3442,  3443,  3446,  3461,  3474,  3490,  3504,  3505,
    3506,  3518,  3531,  3547,  3560,  3561,  3573,  3593,  3603,  3616,
    3624,  3635,  3636,  3639,  3640,  3643,  3647,  3651,  3655,  3659,
    3663,  3667,  3671,  3675,  3679,  3683,  3687,  3693,  3694,  3698,
    3699,  3700,  3705,  3708,  3709,  3721,  3733,  3748,  3749,  3757,
    3758,  3762,  3763,  3767,  3768,  3772,  3773,  3777,  3788,  3801,
    3802,  3812,  3823,  3824,  3837,  3844,  3861,  3869,  3880,  3883,
    3887,  3891,  3895,  3899,  3911,  3921,  3924,  3928,  3941,  3950,
    3960,  3970,  3979,  3988,  3997,  4007,  4016,  4026,  4035,  4044,
    4053,  4062,  4071,  4080,  4089,  4098,  4107,  4116,  4125,  4134,
    4143,  4152,  4161,  4171,  4189,  4200,  4201,  4202,  4203,  4207,
    4208,  4212,  4213,  4223,  4234,  4254,  4262,  4274,  4275,  4279,
    4283,  4291,  4295,  4299,  4306,  4310,  4315,  4320,  4327,  4334,
    4339,  4349,  4363,  4364,  4369,  4370,  4374,  4375,  4385,  4396,
    4416,  4425,  4433,  4450,  4470,  4500,  4509,  4530,  4545,  4546,
    4550,  4558,  4573,  4584,  4585,  4597,  4605,  4622,  4644,  4660,
    4674,  4685,  4699,  4700,  4704,  4705,  4709,  4710,  4714,  4715,
    4719,  4720,  4724,  4725,  4726,  4727,  4728,  4738,  4757,  4777,
    4802,  4803,  4804,  4808,  4810,  4832,  4834,  4836,  4838,  4840,
    4845,  4850,  4860,  4861,  4865,  4866,  4870,  4871,  4875,  4876,
    4877,  4881,  4885,  4886,  4887,  4891,  4892,  4897,  4898,  4925,
    4926,  4927,  4928,  4929,  4930,  4935,  4946,  4969,  4979,  4993,
    4995,  5000,  5005,  5007,  5012,  5022,  5023,  5024,  5025,  5037,
    5057,  5080,  5090,  5101,  5111,  5121,  5132,  5141,  5148,  5155,
    5164,  5173,  5182,  5191,  5200,  5211,  5214,  5215,  5218,  5222,
    5229,  5230,  5231,  5232,  5233,  5236,  5239,  5240,  5248,  5255,
    5256,  5259,  5261,  5272,  5282,  5292,  5304,  5305,  5321,  5336,
    5337,  5341,  5351,  5362,  5371,  5381,  5390,  5391,  5394,  5395,
    5398,  5399,  5400,  5403,  5417,  5422,  5432,  5441,  5453,  5454,
    5458,  5466,  5478,  5488,  5501,  5511,  5533,  5543,  5561,  5572,
    5583,  5593,  5603,  5613,  5623,  5634,  5648,  5649,  5650,  5651,
    5652,  5653,  5654,  5655,  5656,  5657,  5658,  5659,  5660,  5661,
    5662,  5663,  5667,  5668,  5671,  5672,  5675,  5677,  5682,  5683,
    5693,  5704,  5705,  5706,  5740,  5749,  5758,  5767,  5776,  5785,
    5794,  5803,  5817,  5826,  5835,  5845,  5854,  5863,  5871,  5880,
    5889,  5898,  5910,  5911,  5912,  5913,  5914,  5915,  5916,  5917,
    5918,  5919,  5920,  5921,  5922,  5923,  5924,  5925,  5926,  5927,
    5928,  5929,  5930,  5931,  5935,  5936,  5950,  5961,  5972,  5983,
    5994,  6005,  6016,  6029,  6030,  6034,  6035,  6036,  6037,  6038,
    6039,  6040,  6041,  6042,  6043,  6044,  6047,  6048,  6058,  6064,
    6072,  6080,  6088,  6096,  6104,  6112,  6120,  6128,  6136,  6144,
    6152,  6160,  6168,  6176,  6184,  6192,  6202,  6203,  6206,  6207,
    6217,  6233,  6247,  6273,  6275,  6277,  6279,  6286,  6295,  6296,
    6299,  6306,  6313,  6320,  6334,  6342,  6350,  6358,  6366,  6374,
    6382,  6390,  6398,  6406,  6414,  6422,  6430,  6438,  6446,  6454,
    6466,  6467,  6471,  6472,  6477,  6478,  6482,  6483,  6488,  6504,
    6517,  6527,  6539,  6540,  6543,  6544,  6554,  6564,  6565,  6569,
    6573,  6577,  6588,  6601,  6615,  6632,  6633,  6634,  6635,  6647,
    6673,  6702,  6703,  6707,  6708,  6712,  6713,  6717,  6718,  6721,
    6722,  6730,  6741,  6752,  6765,  6766,  6769,  6770,  6773,  6774,
    6775,  6778,  6779,  6780,  6796,  6808,  6821,  6836,  6837,  6840,
    6841,  6845,  6846,  6854,  6855,  6859,  6860,  6875,  6884,  6893,
    6902,  6911,  6923,  6924,  6925,  6926,  6927,  6933,  6937,  6952,
    6953,  6959,  6969,  6973,  6978,  6986,  7027,  7031,  7035,  7039,
    7047,  7048,  7053,  7054,  7061,  7065,  7069,  7073,  7077,  7081,
    7085,  7089,  7093,  7097,  7101,  7105,  7109,  7113,  7117,  7122,
    7129,  7133,  7137,  7141,  7145,  7151,  7152,  7159,  7160,  7164,
    7165,  7168,  7180,  7184,  7199,  7210,  7211,  7216,  7217,  7232,
    7243,  7257,  7268,  7282,  7293,  7307,  7315,  7317,  7319,  7324,
    7326,  7339,  7348,  7349,  7353,  7357,  7369,  7380,  7391,  7404,
    7405,  7406,  7410,  7423,  7424,  7434,  7446,  7450,  7454,  7458,
    7465,  7486,  7495,  7504,  7513,  7524,  7525,  7528,  7529,  7530,
    7533,  7534,  7537,  7547,  7556,  7573,  7583,  7592,  7601,  7610,
    7619,  7628,  7637,  7647,  7656,  7665,  7674,  7683,  7693,  7703,
    7712,  7721,  7731,  7741,  7751,  7761,  7771,  7781,  7791,  7801,
    7811,  7821,  7831,  7841,  7852,  7863,  7874,  7885,  7895,  7905,
    7916,  7927,  7937,  7947,  7955,  7964,  7973,  7982,  7991,  8000,
    8009,  8018,  8027,  8041,  8042,  8045,  8046,  8056,  8066,  8076,
    8086,  8105,  8115,  8124,  8133,  8142,  8151,  8161,  8171,  8180,
    8189,  8198,  8207,  8216,  8225,  8234,  8243,  8252,  8261,  8270,
    8279,  8288,  8297,  8306,  8315,  8333,  8343,  8344,  8347,  8349,
    8359,  8368,  8376,  8384,  8392,  8400,  8409,  8417,  8425,  8434,
    8442,  8450,  8458,  8466,  8474,  8482,  8490,  8498,  8506,  8523,
    8540,  8541,  8542,  8547,  8553,  8562,  8563,  8564,  8565,  8566,
    8570,  8571,  8574,  8575,  8576,  8577,  8581,  8582,  8583,  8588,
    8599,  8621,  8631,  8632,  8635,  8644,  8650,  8669,  8676,  8683,
    8690,  8697,  8704,  8711,  8719,  8727,  8735,  8743,  8751,  8758,
    8765,  8774,  8775,  8776,  8780,  8783,  8786,  8789,  8792,  8799,
    8801,  8803,  8808,  8810,  8822,  8835,  8848,  8866,  8887,  8888,
    8889,  8890,  8900,  8916,  8926,  8927,  8931,  8932,  8936,  8940,
    8944,  8962,  8963,  8964,  8965,  8966,  8967,  8968,  8975,  8976,
    8987,  8994,  9001,  9012,  9029,  9036,  9054,  9060,  9076,  9089,
    9098,  9106,  9114,  9123,  9134,  9145,  9155,  9156,  9167,  9177,
    9188,  9199,  9210,  9221,  9230,  9242,  9243,  9257,  9280,  9288,
    9297,  9308,  9309,  9321,  9335,  9349,  9361,  9369,  9382,  9383,
    9387,  9388,  9389,  9390,  9391,  9404,  9414,  9427,  9428,  9432,
    9433,  9436,  9437,  9440,  9441,  9445,  9446,  9459,  9466,  9476,
    9483,  9493,  9494,  9495,  9496,  9497,  9498,  9499,  9500,  9501,
    9505,  9509,  9516,  9523,  9524,  9528,  9529,  9530,  9540,  9550,
    9551,  9555,  9556,  9557,  9558,  9568,  9575,  9593,  9594,  9604,
    9610,  9616,  9622,  9638,  9656,  9660,  9668,  9674,  9680,  9689,
    9691,  9696,  9707,  9717,  9727,  9733,  9742,  9751,  9757,  9758,
    9769,  9783,  9784,  9795,  9806,  9807,  9810,  9811,  9812,  9813,
    9814,  9815,  9816,  9817,  9820,  9821,  9825,  9826,  9827,  9838,
    9856,  9857,  9861,  9862,  9866,  9882,  9908,  9941,  9952,  9953,
    9963,  9974,  9977,  9978,  9979,  9980,  9981,  9984,  9985,  9986,
   10034, 10035, 10039, 10040, 10055, 10056, 10063, 10071, 10079, 10087,
   10095, 10103, 10114, 10115, 10142, 10156, 10171, 10172, 10191, 10195,
   10199, 10216, 10223, 10230, 10240, 10241, 10244, 10256, 10257, 10261,
   10273, 10281, 10286, 10291, 10296, 10301, 10309, 10317, 10322, 10327,
   10334, 10335, 10339, 10340, 10341, 10348, 10349, 10353, 10354, 10358,
   10359, 10363, 10367, 10368, 10371, 10380, 10393, 10394, 10395, 10396,
   10400, 10401, 10405, 10407, 10417, 10422, 10425, 10430, 10431, 10439,
   10449, 10450, 10451, 10459, 10463, 10464, 10467, 10468, 10493, 10494,
   10498, 10499, 10503, 10504, 10505, 10506, 10507, 10511, 10524, 10531,
   10538, 10545, 10546, 10550, 10551, 10555, 10556, 10560, 10561, 10565,
   10576, 10577, 10578, 10579, 10583, 10584, 10589, 10595, 10613, 10614,
   10618, 10619, 10625, 10630, 10638, 10645, 10653, 10688, 10713, 10717,
   10743, 10747, 10759, 10772, 10786, 10797, 10812, 10818, 10823, 10829,
   10836, 10837, 10845, 10849, 10853, 10859, 10866, 10871, 10872, 10873,
   10874, 10878, 10879, 10891, 10892, 10897, 10904, 10911, 10918, 10929,
   10930, 10943, 10947, 10954, 10967, 10980, 10981, 10996, 11006, 11018,
   11023, 11024, 11027, 11028, 11031, 11032, 11037, 11038, 11043, 11044,
   11052, 11057, 11058, 11062, 11066, 11072, 11102, 11107, 11114, 11119,
   11125, 11130, 11139, 11141, 11144, 11148, 11149, 11150, 11151, 11152,
   11153, 11158, 11178, 11179, 11180, 11181, 11192, 11198, 11206, 11207,
   11213, 11218, 11223, 11228, 11233, 11238, 11243, 11248, 11254, 11260,
   11266, 11273, 11295, 11304, 11308, 11316, 11320, 11328, 11340, 11361,
   11365, 11371, 11375, 11388, 11399, 11414, 11416, 11418, 11420, 11422,
   11424, 11429, 11430, 11434, 11435, 11442, 11451, 11459, 11468, 11479,
   11487, 11488, 11489, 11493, 11495, 11497, 11499, 11501, 11503, 11505,
   11510, 11515, 11521, 11529, 11534, 11541, 11548, 11552, 11556, 11592,
   11593, 11595, 11603, 11618, 11620, 11622, 11624, 11626, 11628, 11630,
   11632, 11634, 11636, 11638, 11640, 11642, 11644, 11647, 11649, 11651,
   11654, 11656, 11658, 11660, 11663, 11668, 11676, 11681, 11689, 11694,
   11702, 11707, 11716, 11724, 11732, 11740, 11758, 11766, 11774, 11782,
   11790, 11806, 11814, 11822, 11830, 11838, 11846, 11854, 11858, 11862,
   11866, 11870, 11878, 11886, 11894, 11902, 11922, 11944, 11955, 11962,
   11978, 11983, 12000, 12002, 12004, 12006, 12008, 12010, 12012, 12014,
   12016, 12018, 12020, 12022, 12024, 12026, 12028, 12030, 12032, 12034,
   12036, 12038, 12042, 12046, 12050, 12054, 12059, 12075, 12076, 12077,
   12092, 12126, 12128, 12130, 12141, 12165, 12176, 12187, 12195, 12205,
   12215, 12224, 12228, 12234, 12241, 12248, 12258, 12265, 12293, 12328,
   12339, 12340, 12347, 12353, 12379, 12389, 12402, 12410, 12423, 12433,
   12446, 12456, 12469, 12473, 12477, 12481, 12485, 12489, 12493, 12495,
   12499, 12508, 12513, 12520, 12535, 12542, 12546, 12550, 12554, 12558,
   12565, 12573, 12581, 12585, 12589, 12593, 12597, 12601, 12607, 12611,
   12620, 12624, 12628, 12633, 12647, 12649, 12653, 12655, 12657, 12660,
   12663, 12666, 12667, 12670, 12678, 12688, 12689, 12692, 12693, 12694,
   12699, 12703, 12707, 12711, 12722, 12723, 12727, 12728, 12736, 12737,
   12741, 12742, 12747, 12755, 12757, 12771, 12774, 12801, 12802, 12805,
   12806, 12817, 12835, 12842, 12851, 12868, 12913, 12921, 12929, 12937,
   12945, 12966, 12967, 12968, 12971, 12972, 12975, 12978, 12979, 12980,
   12983, 12984, 12987, 12988, 12989, 12990, 12991, 12992, 12993, 12994,
   12995, 12996, 12997, 12998, 13001, 13003, 13008, 13010, 13015, 13017,
   13019, 13021, 13023, 13025, 13037, 13041, 13048, 13052, 13058, 13062,
   13071, 13082, 13083, 13086, 13090, 13094, 13100, 13101, 13106, 13110,
   13117, 13118, 13119, 13120, 13121, 13122, 13123, 13124, 13134, 13138,
   13145, 13152, 13153, 13169, 13173, 13178, 13182, 13197, 13202, 13206,
   13209, 13212, 13213, 13214, 13217, 13224, 13234, 13248, 13249, 13253,
   13264, 13265, 13268, 13269, 13272, 13276, 13283, 13287, 13291, 13299,
   13310, 13311, 13315, 13316, 13320, 13321, 13324, 13325, 13336, 13337,
   13346, 13347, 13355, 13365, 13366, 13370, 13371, 13374, 13390, 13398,
   13406, 13428, 13429, 13440, 13444, 13471, 13473, 13478, 13481, 13484,
   13486, 13488, 13490, 13500, 13502, 13513, 13517, 13521, 13525, 13529,
   13538, 13545, 13577, 13581, 13587, 13594, 13598, 13602, 13608, 13609,
   13611, 13612, 13613, 13617, 13647, 13674, 13678, 13684, 13686, 13703,
   13704, 13705, 13710, 13711, 13712, 13717, 13718, 13719, 13720, 13726,
   13727, 13728, 13729, 13730, 13750, 13751, 13752, 13753, 13754, 13755,
   13756, 13757, 13758, 13759, 13760, 13761, 13762, 13763, 13764, 13765,
   13766, 13767, 13768, 13769, 13770, 13771, 13772, 13773, 13774, 13775,
   13776, 13777, 13778, 13779, 13780, 13781, 13782, 13783, 13784, 13785,
   13786, 13787, 13788, 13789, 13790, 13791, 13792, 13793, 13794, 13795,
   13796, 13797, 13798, 13799, 13800, 13801, 13802, 13803, 13804, 13805,
   13806, 13807, 13808, 13809, 13810, 13811, 13812, 13813, 13814, 13815,
   13816, 13817, 13818, 13819, 13820, 13821, 13822, 13823, 13824, 13825,
   13826, 13827, 13828, 13829, 13830, 13831, 13832, 13833, 13834, 13835,
   13836, 13837, 13838, 13839, 13840, 13841, 13842, 13843, 13844, 13845,
   13846, 13847, 13848, 13849, 13850, 13851, 13852, 13853, 13854, 13855,
   13856, 13857, 13858, 13859, 13860, 13861, 13862, 13863, 13864, 13865,
   13866, 13867, 13868, 13869, 13870, 13871, 13872, 13873, 13874, 13875,
   13876, 13877, 13878, 13879, 13880, 13881, 13882, 13883, 13884, 13885,
   13886, 13887, 13888, 13889, 13890, 13891, 13892, 13893, 13894, 13895,
   13896, 13897, 13898, 13899, 13900, 13901, 13902, 13903, 13904, 13905,
   13906, 13907, 13908, 13909, 13910, 13911, 13912, 13913, 13914, 13915,
   13916, 13917, 13918, 13919, 13920, 13921, 13922, 13923, 13924, 13925,
   13926, 13927, 13928, 13929, 13930, 13931, 13932, 13933, 13934, 13935,
   13936, 13937, 13938, 13939, 13940, 13941, 13942, 13943, 13944, 13945,
   13946, 13947, 13948, 13949, 13950, 13951, 13952, 13953, 13954, 13955,
   13956, 13957, 13958, 13959, 13960, 13961, 13962, 13963, 13964, 13965,
   13966, 13967, 13968, 13969, 13970, 13971, 13972, 13973, 13974, 13975,
   13976, 13977, 13978, 13979, 13980, 13981, 13982, 13983, 13984, 13985,
   13986, 13987, 13988, 13989, 13990, 13991, 13992, 13993, 13994, 13995,
   13996, 13997, 13998, 13999, 14000, 14001, 14002, 14003, 14004, 14005,
   14006, 14007, 14008, 14009, 14010, 14011, 14012, 14013, 14014, 14015,
   14016, 14017, 14018, 14019, 14020, 14034, 14035, 14036, 14037, 14038,
   14039, 14040, 14041, 14042, 14043, 14044, 14045, 14046, 14047, 14048,
   14049, 14050, 14051, 14052, 14053, 14054, 14055, 14056, 14057, 14058,
   14059, 14060, 14061, 14062, 14063, 14064, 14065, 14066, 14067, 14068,
   14069, 14070, 14071, 14072, 14073, 14074, 14075, 14076, 14077, 14078,
   14079, 14080, 14081, 14095, 14096, 14097, 14098, 14099, 14100, 14101,
   14102, 14103, 14104, 14105, 14106, 14107, 14108, 14109, 14110, 14111,
   14112, 14113, 14114, 14115, 14116, 14117, 14127, 14128, 14129, 14130,
   14131, 14132, 14133, 14134, 14135, 14136, 14137, 14138, 14139, 14140,
   14141, 14142, 14143, 14144, 14145, 14146, 14147, 14148, 14149, 14150,
   14151, 14152, 14153, 14154, 14155, 14156, 14157, 14158, 14159, 14160,
   14161, 14162, 14163, 14164, 14165, 14166, 14167, 14168, 14169, 14170,
   14171, 14172, 14173, 14174, 14175, 14176, 14177, 14178, 14179, 14180,
   14181, 14182, 14183, 14184, 14185, 14186, 14187, 14188, 14189, 14190,
   14191, 14192, 14193, 14194, 14195, 14196, 14197, 14198, 14199, 14200,
   14201, 14202, 14203
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "EQUALS_GREATER", "LESS_EQUALS", "GREATER_EQUALS", "NOT_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DEPENDS", "DESC", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL",
  "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P",
  "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM",
  "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED",
  "GREATEST", "GROUP_P", "GROUPING", "HANDLER", "HAVING", "HEADER_P",
  "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDING", "INCREMENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P",
  "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE",
  "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL",
  "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF",
  "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS",
  "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OWNED", "OWNER", "PARALLEL", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POLICY",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM",
  "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE",
  "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART",
  "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROLLUP", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA",
  "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE",
  "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET",
  "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP",
  "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA", "'<'", "'>'",
  "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "DropPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "type_name_list",
  "TruncateStmt", "opt_restart_seqs", "CommentStmt", "comment_type",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label_type",
  "security_label", "FetchStmt", "fetch_args", "from_in", "opt_from_in",
  "GrantStmt", "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "CreateTransformStmt", "transform_element_list",
  "DropTransformStmt", "ReindexStmt", "reindex_target_type",
  "reindex_target_multitable", "reindex_option_list",
  "reindex_option_elem", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "AlterObjectSchemaStmt",
  "AlterOperatorStmt", "operator_def_list", "operator_def_elem",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_target",
  "insert_rest", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "all_or_distinct", "distinct_clause",
  "opt_all_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "Typename", "opt_array_bounds", "SimpleTypename", "ConstTypename",
  "GenericType", "opt_type_modifiers", "Numeric", "opt_float", "Bit",
  "ConstBit", "BitWithLength", "BitWithoutLength", "Character",
  "ConstCharacter", "CharacterWithLength", "CharacterWithoutLength",
  "character", "opt_varying", "opt_charset", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "explicit_row", "implicit_row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "ctext_expr", "ctext_expr_list", "ctext_row", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "database_name", "access_method", "attr_name",
  "index_name", "file_name", "func_name", "AexprConst", "Iconst", "Sconst",
  "SignedIconst", "RoleId", "RoleSpec", "role_list", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
      60,    62,    61,   695,    43,    45,    42,    47,    37,    94,
     696,    91,    93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -4281

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4281)))

#define YYTABLE_NINF -2419

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2419)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    8926,  1278, 12329, -4281, -4281,  1278, -4281, 62966,   466,   141,
    1333,   167, 14750, 63400, 69910,   545,   318, 13982,  1278, 69910,
    1463, 48210, 59928,   742, 69910,   943,   590, 48210, 69910, 70344,
     692,   797,   870, 70778, 63834, 58626,  1395, 69910,   983,   348,
   71212, 64268,   827, 64702,   590, 44748,   135,   941, 71646, 69910,
    1522,  1428,  1045, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,   466,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
    1607, -4281,   753,  1987,  1667,   179,  1089, -4281, -4281, -4281,
   56456, 69910, 69910, 69910,  1341, 69910,  1300, 69910,   147, 56456,
   52550, 65136,  1526,  1366, 41270, 72080, -4281, 50814, 69910, 69910,
   72514, 69910,    86, 61230, 69910,  1459, 69910, 69910, 51248, 72948,
    1589,  1016, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, 69910,
    3280,   943, -4281, -4281,  1522, 69910,  1616, 56456, 69910,  1427,
   69910,  1523, 69910, -4281, 69910,  1557, 73382,   201,    44, 52550,
    1324, 41705,  1649, 69910, 52550, 73816, 69910, 69910, -4281, -4281,
    1661, 69910, 69910, -4281,  1748, 52984,  1275,  1766,  1959,  1841,
     678, -4281, 65570, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, 55588,   318, -4281, -4281,  1828, 56890, 69910,  1898, -4281,
   -4281, 74250, 89392,  1693, -4281,   438, 57324, 53418,  2034,  1706,
   42140,  2075, 74684, 53852, 75118, -4281, -4281, 75552, -4281, 75986,
    1829,  1898, 76420, 89814, 54286, -4281,  1915, 76854, -4281,  1682,
    1668,   841, 37331, -4281, -4281, -4281,   466, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281,   338,  1177,   225,   208,   253,
   -4281, -4281,   209,   221,   224,   338,  2138,  2138, -4281, 69910,
   -4281, -4281,  1177,    42,  1712,  1712,  1712,  1930,   -17, -4281,
    1712,  1886, -4281, -4281, -4281, -4281, 64702, -4281,  1825,   943,
    1833,  2246,  1891, -4281, -4281, -4281, -4281, -4281,  1927, 69910,
   69910, 69910, -4281, -4281,  2265,  1893,  2151,  1887, -4281, -4281,
   -4281,  2093,  2098,  2108,   116,   943,  2024, -4281,  2218, -4281,
    2147, 27083, 27083,   943, 66004, 77288,   211, 55588,   943, 66438,
    1972,  1288,  2150, -4281, -4281, -4281,   705, -4281,  2379,  2005,
    2238,  1887,  1016, 38641, -4281,  2000,  1222, 64702, -4281, -4281,
   -4281,   389,  2289, 27534, -4281, 69910,  2028, -4281,  2009,  2028,
    2039,  2040,  1667, -4281,  8926, 69910,   349,   349,  2401,   349,
    1231,  1638, -4281,  2234, -4281,  2342,  2309, 64702,   941,   242,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281,  2061,  1222, -4281,   264, -4281,  1432,  2060,
    1579,  1008, -4281, -4281,   200, 69910,  2182,   198,    21,  2104,
   66872,  3808,  2097, -4281, -4281, -4281,  2227,   326, -4281, -4281,
   -4281, -4281,  2365,  2410,  4644,   313, 67306, -4281, -4281, -4281,
   -4281, 69910, 69910, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281,  2116, -4281, -4281,  2102,  2425,  2311,  2411,  2291,
    1285,  2338,  1024,  2462,  4986,  1249, 67740, 69910,  2430,  2470,
    7814,   117,  1080,  2356,   239,  2411,  2463,  2320,  1285,  2493,
    7924, 69910, -4281,  2423,  2534,   775, -4281,   154, -4281,  2256,
    2396,    36,  2429, 56456,  2225, -4281, -4281, 69910, -4281, -4281,
   90236,  2303, -4281,   468, 56456, -4281,  2431,  2276, 42575, 69910,
   -4281, 69910, -4281, -4281, -4281, -4281, -4281,  2360,  2537, 69910,
   90236, -4281,  2484, 69910, -4281,  2240, -4281, -4281, -4281, -4281,
    1712, 69910,  2244,  2635, 90236,    89, 69910,  1335,  2665, 69910,
    2455,  1335,  2292, 77722, -4281, -4281,  1335, -4281, -4281, -4281,
   69910, 69910,  2260,  1293,  2456,  1335,  2469,  2676,  2677,  2334,
    2447,  1090,  1260,   165,  2570,  1335,  2315, 78156, 78590, 69910,
    2316, 69910,  2651, 56456, 69910,  2576, -4281,  2438, -4281, -4281,
    1062, -4281, -4281, -4281, -4281, -4281,  2591,  2061,   541,  2593,
    2283,  2595, -4281, -4281, -4281,  2331, -4281,  2331,  2331,  2287,
    2287,  2457,  2288,  2602, -4281, -4281, -4281,  1564,  2331,  2287,
   -4281, 91080, -4281,  1350,  1446, -4281,   157, -4281,  2712, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281,   151, -4281,  1115,
    1353, -4281, -4281,  2325, -4281,  2606,  2097,  2607, -4281,  2293,
   79024, -4281, 79458, 79892,  2611,  2116, 52550,  2613,  2496,  2615,
    2293,  2616,  2499,  2618,   541,  2619, -4281,  1251,  2608,  2622,
    2505,  2624,   157,  2626,  1761,  2293, 56022,  2628,   178, -4281,
   29338, -4281,  2406, -4281,   941, -4281,  1577, -4281, 47342, -4281,
     841,  1177, -4281, 69910,  1177, 69910,  1177, 69910,  1177, 69910,
    1177, 69910, 69910, 69910,  1177, -4281, -4281, -4281, 69910,  2321,
   69910, 69910, -4281, -4281, -4281, 60362, 52550, 60796, -4281, 69910,
   -4281,   666,   943, -4281, -4281, 90236,  2740, 52550,  2651, -4281,
    1584, -4281, -4281, -4281, -4281, -4281, -4281,  2560, 69910,  2633,
    2638, 60362, 52550, -4281, 80326, 55588,  2530,  2340, -4281, -4281,
   -4281, -4281, -4281,  1495,  2793,   308,  2796, 29338,  2343,   319,
     319,  2351,  2653, -4281, -4281, -4281,   268,  2352,  2355, -4281,
     278,   278,  2359,  2361, -4281,   281,  2362,  2364,  2814,  2815,
     287,  2375,  2383,  2386,  1564,   319, 29338, -4281,  2387,   278,
    2395,  2404,  2407,  2827,  2409, -4281,  2844,  2412,   284,   286,
    2416,  2418, -4281,  2359, -4281,   269,  2419,  2426,  2427,  2428,
    2433,  2435,  2436,  2439, 29338, 29338, 29338, -4281, 25730,  1222,
     943, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,   294,
    5262, -4281,  2440, -4281, -4281,  2580, -4281, -4281, 29338, -4281,
   -4281,   400, -4281,   297, -4281, -4281, -4281,  1222,  2664,  2421,
   -4281, -4281,  1360,  2434, -4281,  1922, -4281, -4281, -4281, -4281,
   -4281, -4281, 54720,  2849, -4281,   880,   943,   154,  1680,  2801,
   46474, 46908, -4281, -4281,  2669, -4281, 69910, -4281, -4281, 29338,
   44314, -4281,  1222,   159, -4281, -4281, -4281, -4281,  1594, -4281,
   -4281, -4281,   466, -4281, 13387, -4281,  1698,  2028, 69910, 69910,
    2859, -4281, -4281, -4281,  2009, -4281, -4281,  1667,  1667, 29338,
    1667,   998,  1452, 27985, 29338,  2741,  2640,  1336,  1788,  2742,
   -4281,  2643,  1231,  1638, 64702, 69910, 80760,  2561, -4281, 45182,
    1648,  1222,  2531,  2532,  2582, 49078,  2458,  2538,  2540,  2592,
   -4281,  2700, -4281, -4281,  2545,  2548, 81194, -4281, -4281,   257,
   -4281, -4281, -4281,   257, -4281,  2483,  1151,   952,  1321,  2552,
     383,  1041,  2848, -4281,  1380,  2605, -4281, -4281, -4281,  5647,
   69910,  2792,  8004,  2675,   313,  2681,  2614, -4281, -4281,  2723,
    2566, 69910,  2574,  2695,   313,   719, 81628, -4281, -4281, -4281,
   -4281, -4281, -4281,  5326, 24435, -4281,  2575,  2559,  2590, 69910,
   57758,   335,  2705,  2706,  1367,   337,   199,  2646, 69910,   243,
    2721, 69910,  2522,  2603,  2610,  2807,  2529,  1750,  2902,  2533,
   -4281, -4281, -4281,  1848,  1875,  2714, -4281,  2813,  2856,  7138,
    2600,  2604, 88548,  1281, 43010, 69910, 69910,  2898,  1392,  2630,
   -4281, -4281, -4281,  1392, 69910,  2631,  2637, 69910,   313, -4281,
    2950,   313,   313,  1731,  2953,  2642,   532,  1248,  1335,  2533,
    1659, -4281,  2644,  2645,   791, -4281,  2745, -4281, -4281,  1025,
    2648, 64702,   386,  1996,  2533,  2659,  2660,  2529,  2529, 69910,
   69910, 69910, 69910, 69910,   186,  2971,  2973,  2661,   185,  2702,
    2583, -4281,  1392, 51682,  2663, -4281,  1392, 69910,  2667,  2112,
    2533,  1053,    98, -4281, -4281, -4281,  1016, -4281, 69910, -4281,
   69910, -4281,  2061, 90236,  2767,  2839, -4281,  2623, -4281,  2097,
     313, -4281, 69910, 69910,  2116,  2786,   177,  1359, 90236,  2790,
    2853, 69910,  2855,  2682,  2647,  2674, 45611, -4281,  2260,  2627,
    3026, 69910, 49078, -4281,  3040,   257, -4281, 90236,  2806,  2934,
   -4281, 69910,  2831,  2632, -4281,  2972,  2684, -4281, -4281,    48,
   69910, -4281,  2942, 52550,  1383,   943,  2680, 52550,  2862, 69910,
   69910, 69910, 69910, -4281, -4281,  2838,   946,   488, -4281, 51682,
   -4281, 69910,  2841,  1659,  2850,  3060,   612,  1712, 82062,  2945,
   -4281, 82496,  2652,  3065, 90236,  2893, -4281,  1646, -4281,  2778,
   -4281, 56456,   541, -4281, -4281, -4281, -4281, 90236, 69910, -4281,
    2654, -4281, -4281, 29338, -4281, -4281, -4281,  2138, -4281, 90236,
    2331,  2331, -4281, -4281,  3075,  2736,  2743,  2138, -4281,  2138,
   -4281, 90236, -4281,  2668,  2670,  2776,  2138, -4281,  2744,  2746,
    2747, -4281,  2673,  2751,  2138, -4281, -4281,  1743, -4281, 82930,
   56456,   541, 52550, 52550,  2974,   178,  2976,  2730,  2988,  2732,
   43010,   541,   217, 69910, 69910, 52550, 69910, 69910, 69910, -4281,
   69910, -4281, -4281, -4281, -4281, 90236, 69910, 69910, 90236, -4281,
   52550, 51682,  2990,  2994,   541, 69910, 69910, -4281, 13387,  1722,
   83364,   841, 55154, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, 69910, -4281, 69910, -4281, 69910, -4281, 69910, -4281, 69910,
   -4281, -4281, -4281, 69910, -4281, 69910,  1729, -4281, -4281,  1738,
     144, 69910, 69910,   207, 56456, 69910,  2878, 69910, 69910, 69910,
   69910, 69910,  2761,  2434,  1243, -4281,  1142,   484, 64702,  2888,
   -4281, -4281,  1752,  1522,   -13, 69910,  1216,  1927, -4281, -4281,
   60796, 59928,  2982,   342, 69910, -4281, -4281,  4798, 29338,  1222,
   26632, -4281, -4281, 13387,  2728, 29338, 29338,  2690,  2138,  2138,
   -4281,   862, 29338, 29338, 29338,  2138,  2138,  5145, 29338, 43010,
   29338, 32495, 22657, 29338, 29338, 26181, -4281, 29338,  2906, 33842,
   29338,  1680,  2908, 29338,  1680,  5145,  3136,  3136,  1416,  5111,
    2694,  1222, -4281,  2138,  1153, -4281,   226, 90236, 29338, 29338,
   29338, 29338, 49078,  2779,   219, 69910, 29338,  2699,  1811, -4281,
   29338, -4281,  2701, 29338,  2783,   994, 29338, 29338, 29338, 29338,
   29338, 29338, 29338, 29338, 29338, -4281, 34714,   261,  2993,  3012,
     595,   779, 68174, 27083,  3004, 21753, -4281,   237,  3004, -4281,
   -4281, -4281, 69910,  2849, -4281, -4281,  2787, -4281, -4281, -4281,
   -4281, -4281,   299, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
    2707, -4281, -4281, -4281, -4281,  2707, -4281,  2713,  8540,  2708,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281,  2996,  2998,   541, 69910,
     389, 61664, -4281, 27534, -4281,  1753, -4281,  2715, -4281,  2975,
   -4281,  2717, -4281, 10623,  2975, -4281, -4281,   310,  2833,  2977,
    2917, -4281, -4281, -4281,  2722, 13387, -4281,  1685, 13387,  1997,
   -4281, -4281, -4281, -4281, -4281, -4281,   728, -4281, 69910,   660,
    2741,  1788,  2781,   424,  3146, 69910, -4281, 39077,  2914, -4281,
    3138, -4281, 91080, -4281,  2737, -4281, 90658, 87270, -4281, -4281,
     925, -4281,  1087,  2816,  2817,  2870, 52550, 69910, 69910, -4281,
   49078, 52550, 69910, 69910, -4281, 52550, 69910, 69910, -4281, -4281,
   -4281, -4281, -4281, 47776,   622, 59928,  2872, 59060, -4281, -4281,
    2748, 69910,  2803,  2997,  3001,   760, -4281, -4281, 83798, -4281,
    2949, 52550, 69910, 69910, 29338,  2957, 69910, 69910, -4281,   285,
    2828,  2834, -4281, 69910,  2835,  2980, 56456,  2760, 69910, 69910,
   90236,  2836,   715, 56456,  2804, 43445, 69910, 69910, 69910, 69910,
    2885,  3062, 90236, 69910,  3011,  1033, 64702,   216,  2148,  2533,
    2969, -4281,  3077,  1145, -4281, 52550, -4281, 69910,  2962, -4281,
   -4281, -4281, 68608,  3181,  2877, -4281, -4281, 84232, -4281, -4281,
   -4281,  1757, -4281, 52550, 52550, 69910,  8621, 84666,  1126,  2981,
   -4281, -4281, 90236, -4281, 69910, 69910, 69910,  3082,  3013, 69910,
   62098, 85100, 85534,  1193,  1208,  3015, 69910, 62532,  3016, -4281,
    2910, 69910, -4281, -4281, 49512, 52550, 69910,   767, 49078, -4281,
   -4281, 69910, -4281,  2983,   262, -4281, 69910, 10145, -4281, -4281,
    2858,  2876, 69910,  2985,   236,  2270,  2533, 69910, 69910,  2795,
    1767,  2871,     8, -4281,  2995,    56, 69910, 77288, -4281, 52550,
    1083, -4281,  2939, 52550, 69910,  7566, -4281, -4281,   313, -4281,
   -4281, -4281, -4281, -4281, 69910, 69910,   313, 69910,   313,   251,
   -4281, 52550, 69910, -4281, -4281, -4281, 69910,  9195, 69910, 69910,
   69910, 69910, 52550, 69910, -4281, -4281,   947,  1309,  1369,  1471,
     744, 69910,  3078, 69910, 85968, 52550, 69910, 69910, 69910,  1669,
   -4281, -4281,  2918, -4281, 52550,  1083, -4281,  9458, 69910, 69910,
    2874,  2880,   163,  2960, -4281, -4281, -4281, -4281, -4281, -4281,
    3057,  3225, 86402,   817, -4281,  3061,  3063,  2863,  2865,  3067,
   69910,   817, 69910, -4281, -4281, -4281, -4281,  3059, 69910,   817,
    3069,   817,  2978,  3017,   675,  3088,  2832,  1772, -4281, -4281,
   29338, 90236, -4281,  1774, -4281,  2837,   946, -4281, -4281, 49078,
   69910,   174,   908,  3135, 58192,  2432,  3124, 69910,  2869, 69910,
    3127,  2432, 69910, -4281,  1932, 59928, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281,  3131, -4281,   943,  2260,  2260,
    2260,  2260, -4281, -4281, -4281, -4281,  3033,  1810, -4281,  2840,
    2260, 69910,  2954,  2432,  2845,  3149, -4281,  1659,  3150,   842,
   69910, 58192,  1822,  2879,  3053,  3266,  1712,   943,  3056,  3043,
   -4281, 24857,  5985,  3052,  3105, 55588,  3142,  3143,  3163, -4281,
    2061, -4281,  3283, -4281, 29338,  1787,  2867,   157, -4281, -4281,
    2868,  2670,  2886,  2887,  2873,  2891, -4281,  2138,   194, 69910,
    2892,  1349,   118,  3000,  2138,  3092,  2894, -4281,  3189,   541,
    2097, -4281,  2293, -4281, 69910, -4281, 69910, 69910, 69910, 69910,
    2116, -4281, -4281,  3073,   541,  2293,  3074,   541,   541, -4281,
    3139,  3090,   541,   157,  2293,  3018,  3199, 55588, -4281,   178,
   -4281, -4281, 29338,  3109,  1712, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281,  1792, -4281, 69910, -4281,  3176,  3177,  3179,
    2927,  2928,  2964, 69910,  2930, -4281,  2927,   313,  2927,  2434,
    2434,  2927,  2928, 52116,  3352,  3223, -4281,  3014,  2936,  3232,
     196, -4281,   701,    49,  3157, -4281, -4281, -4281, -4281, 90236,
   -4281, 52550,  2979, 69910, 69910, -4281,   156,  3133,  2937, 52116,
    3343,   541, -4281, 56456, -4281, -4281, 90236,  3019,  3031, 56456,
    3144,  2987, -4281, -4281, -4281, -4281, -4281, 90236, -4281,  3193,
   69910,  1803, -4281, -4281,  1624, -4281,  1645, 29338,   192, -4281,
   11552,  1805, 29338,  2948,  2956, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281,  2958,  3244, -4281,  1807,  1812,  1818,  2959,  2961,
    3760,  2963, 11608,  2965,  2967, 32495, 32495, 25730,  2337, -4281,
   32495,  2968,  3140,  1826, 10949,  2966,  2986, 12087, 28436, 29338,
   28436, 28436, 12159,  2966,  2989,  1830, 49078,  3128, 12759,  1834,
   -4281, 29338, 49078,  4214, 29338, -4281, 29338,  2999, -4281, -4281,
    2114,  2114,  2114,  5145, -4281,  2992, -4281, 32495, 32495, -4281,
    2398, 25730, -4281, -4281,  3255, -4281, -4281,  2134, -4281,  2984,
   -4281, -4281,  2791, 43010,  2922, 29338,   232, 29338,  2699, 29338,
    3049,  2114,  2114,  2114,   446,   446,   230,   230,   230,  1851,
     779, -4281, -4281, -4281,  3002,  3003,  3005,  3156,  3006, 29338,
   -4281,  1806,  1856, 69910,  2657,  2991,  3694, -4281, -4281, -4281,
   35587,  3020, 29338, 29338, 29338,  3008, -4281,  1958, 13387,   642,
   -4281,   300,  3020, -4281,  1016,  2138,  1153, 47342, -4281, -4281,
   29338, -4281, -4281, -4281,  2009, -4281, -4281, -4281, -4281, -4281,
   69910,  1522, 29338, -4281, -4281,   512,  3010, 29338,  1685, -4281,
   -4281,  3030, -4281, 29338, -4281, -4281, -4281,  2434, -4281,  3203,
   -4281, -4281, -4281, 35587,  3034,  3025, 38204,  3171, -4281, 69910,
   -4281, 69910,   228, -4281, -4281, -4281,  3009, -4281, -4281, 87270,
    1353, -4281, 90658, -4281, 90658, -4281,  1353,  3381, -4281, 87270,
    1689, 52550, 69910, 69910, -4281, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, 52550, 52550,  3174,
   69910,  3187,  3194, 29338,   759, 69910,  3007,  3021,  1197,  3273,
   69910, -4281,  3321,   541, -4281, -4281,  3089, -4281, 13387, -4281,
   -4281, -4281, -4281, -4281, 52550, 69910, -4281, 55588, -4281, 69910,
    2061, 90236, -4281, -4281, -4281, 69910,  3045, 69910, -4281, 69910,
   69910, 69910,  2116, -4281, -4281, -4281, -4281,  1396, 90236, -4281,
   -4281, 69910, 69910,   111,  3093,  3095, 69910, -4281,  1019,  2745,
    9757, 69910, 69910, 69910,  3276, 69910, -4281, -4281, -4281, -4281,
    3221, -4281, -4281, 87270, -4281,  2293,   674,  3097,  2533,  3230,
   -4281,  3335,  3214, -4281,  1326, -4281, 69910,  3148, -4281, -4281,
   -4281, -4281,  3338,   541,  3339,   541, 69910, 69910, 69910, 69910,
    3152, -4281, -4281, -4281, -4281,  3153,  3271, -4281, 49078, 49078,
   49078,  1839, -4281, -4281,   943, -4281, -4281, -4281, -4281, -4281,
   -4281,  3307, -4281,  1858, -4281,  1513, -4281, -4281, -4281, -4281,
   -4281, -4281, 52550, 69910,  9928,  3350, 69910, 69910, 69910,  1675,
   -4281,   244, 90236, -4281, 88970, 52550, 69910, 49078, 69910,  3119,
   52550,  3098, -4281, -4281, -4281,  3281,  3218, -4281,   825,  3220,
   52550,  3110, -4281,  3132, -4281, -4281,  3137,  2405,  2533,  1659,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,  1002,   493,
    2502,  2533,  3145, -4281,  3147, -4281, -4281, -4281,  3279,  3284,
    3286,  3151,  3155,  3188,  3159,  3161,  3192, -4281,  3162,  3195,
    3168,  3197,  3256,  3169,   541, 90236,  3274,   943,  3186,  3387,
     541, -4281,  3170, -4281, -4281,  3491, -4281, 69910, -4281,  3172,
    2629,  2533, -4281, -4281, 52550, 69910, -4281, -4281, -4281,   817,
   90236, 69910,  3331, -4281, -4281, -4281,   817,   817, 69910, 69910,
     817,  3337, -4281,  3345, 69910,  3348, -4281,   817, -4281, -4281,
     252, -4281, -4281, -4281,  2978,  3382, 40835, -4281,  3549,  5704,
    3099, -4281, 49078, 40835,  1878,  1765,   215,  1335, -4281, 55588,
   69910, 55588, -4281,   908,  3214, 69910, 69910,  3101,  3100, -4281,
   -4281, -4281, -4281, 52550,   195, 52550,  2138, -4281, -4281,  3173,
   -4281, 69910,  1712,   942,  3180,  3516,  2677,  1383,  3249,  1618,
    3462,  2879, -4281, -4281, -4281, -4281, 69910, 69910,   946,   943,
   -4281,  3111,  3112, -4281, 69910, 69910, 69910, 69910, 69910,  2979,
    3113,  3114, 90236,   549,  3312,  3318,  2529,  3537,  3437,  1522,
    2879,  3204,  3439, 69910, -4281,  1860,   127, -4281,   943, 55588,
   87692,  3428, -4281,  4932, -4281, -4281,   811, 69910,  3414, -4281,
   -4281,  1522,   541, 90236,  1865, -4281, -4281, -4281,  2138, -4281,
   -4281,  1345,  1345,  3134, -4281,  3141, -4281,  3522, -4281, -4281,
   -4281, -4281, -4281, -4281,  3154, -4281, -4281, 69910, -4281,   541,
     178,  3190,   541,  3191,   541,   541, 69910, -4281, 69910, -4281,
   -4281, 69910, 69910, -4281, -4281, 69910, 51682,   541, -4281, 13387,
    3443, -4281, -4281,  3261,  3265,  3267, 69910,  2927, 56456, -4281,
    3160, 52550,  1252, -4281, -4281,  3332, -4281, -4281, 64702,  3260,
   -4281, -4281, -4281, -4281,  3457,  3458, -4281, -4281, -4281,   794,
   -4281, -4281, -4281, 52550, 60362,   367, 52550, -4281,  2061,  3399,
   -4281, -4281,  2097,   313, -4281,  3400, 69910,  3401, -4281, -4281,
   -4281,  3158, 13055, 29338, -4281,  3471, 90236, -4281,  5760, -4281,
   -4281, -4281, 29338, -4281, -4281, -4281, -4281, -4281, 29338, -4281,
   29338,  3447, -4281, 23109,  3599,  3599,  3164, 90236, 32495, 32495,
   32495, 32495,  1382,  2395, 32495, 32495, 32495, 32495, 32495, 32495,
   32495, 32495, 32495, 33397,   457, -4281,  3341, 29338, 29338,  3464,
    3447, -4281, 90236,  3165,  2966,  3166,  3175, 29338, -4281, -4281,
    1871, 34278,  3182, 49078, -4281, 29338, 11072,  1883,  3213, 13104,
    1222,  5829,   943, 29338,  2222,  2262, 29338,  1889, 29338,  3465,
   -4281, -4281, -4281,  3178, -4281, -4281, 90236, 29338,  3183,  4038,
   32495, 32495,  4115, -4281,  4170, 29338, 25730, -4281,  3359,  3211,
   39513, -4281, 23561,  3196,   590,   590,   590,   590, -4281, 69910,
   69910, 69910, 36023,  3468, 35150, 69042,  3200,  1704, -4281, 69042,
   69476, -4281,  3201, -4281,  3185,  1222, 29338,  3461,   828,   828,
    3359, -4281, 29338, 29338, 28887,  3206, -4281,  3461,   154,  3208,
   -4281, -4281, 13387,  3202, -4281, -4281,  3210, -4281,  3198, -4281,
    3010,  1340, -4281,  6091,  3373, -4281, -4281, -4281,  3200, 29789,
    3319, -4281,  1890, -4281, -4281,  3560,  3319, -4281, -4281,  1908,
   39077,  3034, 27534,  1222,  1909,  1734, -4281, -4281, 87270, -4281,
    3258, -4281, -4281, -4281,  2293,  2293,  1257,  2927,  3492,  1257,
    6373, -4281, -4281, 36459, 69910, 69910, -4281, 69910,  1913,  1405,
   69910, -4281, 69910, -4281, -4281, -4281, -4281, -4281,  3612, -4281,
   69910, -4281, -4281,  3250,  3259, -4281, 69910, 69910, 69910, 69910,
    3460, -4281, -4281,  2060, -4281, -4281, 52550, 69910, -4281, -4281,
   -4281,   408,  2636,  2533, -4281,  3289, -4281, -4281, -4281,  3477,
   -4281,  3618,  3303, 69910,  3530, 69910,  3222, -4281,  1405,  1046,
    2529,   734, -4281, -4281,  3288, -4281, -4281, 69910, -4281, 69910,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281,  3346, -4281, -4281,
   -4281, -4281, 49512, -4281, -4281, 69910, -4281, 49078, 40835, 49078,
   -4281,  1036,   411,  2649,  2533, 69910, -4281,  3300, -4281,  3302,
    3305,  3355,   987,  1129,  3308,  3310,  3356,  3233,  3234,  3239,
   -4281, -4281,  1920, -4281,  3237,  3386, 69910,  2293,  3243,  3282,
     338,   943, -4281, -4281,   943,  2293,   943, 69910, 69910, 69910,
    3645,  3330, 69910, 69910, 69910, 69910, 69910, 69910,  3548,   191,
    1840, 52550, 69910, 69910, 52550, 69910, 69910, 69910, 69910, 69910,
   69910,  3563, 69910, -4281,  3633,  3567,   380,  3611,  3329, 69910,
   -4281, 69910,  2745, 69910, 69910, -4281, -4281, -4281,  3270,  3523,
     817, -4281, -4281,  3524,  3525, -4281,   817,   817,  3526,   817,
   -4281, -4281, -4281,  1335, -4281,   252, 69910,  3198,  1848,  1875,
   -4281, -4281, -4281, -4281, -4281, -4281,  2832, -4281, -4281,  1999,
   -4281, -4281, 69910,  3278, 69910, 69910, 32495, -4281,  1460,  1071,
   -4281,  3527, 69910,  3311, -4281, -4281, -4281,  3438, 69910, -4281,
   -4281, -4281, -4281, -4281,  3285, -4281,  3550, 58192,  2293, 52550,
   52550,  2293, -4281, 90236,  3290,  2879, -4281, -4281, -4281, -4281,
   -4281, -4281, 52550,  3098, 52550,  1383,   881, 86836,  3313, -4281,
    3287,  3582, -4281,  3291,  3294, -4281, -4281, 69910,  3214,  1925,
    1659,  3704,   714,  1682, -4281, 59494,  1822,  3550, -4281, -4281,
   -4281,  3666,  3374, -4281,  1522, 69910,  2979,  3374,   943, 69910,
    2803, -4281, 87270, 29338, 29338, -4281,  3295, -4281,  3293,  6830,
   -4281,  3361,  3296,  2260, -4281, -4281, -4281, -4281, -4281, -4281,
    3372,  3301, 69910, -4281, -4281,  3304, -4281,  3314, -4281, -4281,
   -4281, -4281, -4281, -4281,   541, -4281, -4281, 69910, -4281, 69910,
   -4281, -4281,   541,   541,   541,   541, -4281,  3419, -4281, 69910,
   69910, 69910, 69910,  2927, -4281,   313, -4281,  3592, 52116, -4281,
   -4281,  1935, 69910, -4281, -4281, -4281,  3655,   342,  3600, -4281,
   -4281,  3558,   882,  3561,  3562,   882,  3565,   882, -4281, 29338,
   13387, -4281,  3315, -4281, 13387,  6392, 13387,  3464, -4281,  1939,
   29338, -4281,  2932,  2932,  2932,  3889,  3603, -4281,  1404,  3317,
    2932,  2932,  2932,   330,   330,   212,   212,   212,  3599,   457,
   13387, 13387, -4281, -4281,  3320, -4281, -4281, -4281,  2966, -4281,
   30240,  3469,  3713, -4281, -4281, -4281,  3357,  3363,  3326, -4281,
   29338, 30691,  3324, 91080,  3512, -4281,   365, 29338, 29338,  1771,
   -4281,  6317, 29338, 90236,  1940,  1771,   377, 29338,  2895,  3559,
   29338, 29338,  4279,  6669,  3333, 29338, 88114, -4281, -4281, -4281,
    1941, 29338, 69910, 69910, 69910, 69910, -4281, -4281, -4281, 69042,
   69476,  3336, 23998,  1704,  3334, 69910, -4281, -4281,  3340, 35587,
    3579,  3517, -4281, 35587,  3517,  1640,  3517,  3580,  3424, 39949,
   -4281, -4281,  3342,  3529, -4281, 21753,  1718, 13387,  3742,  3628,
   29338,  3347,  3349,  3353, 13387, 13387, 29338, -4281,   943,  3628,
     943, -4281, -4281, 43010, -4281, -4281, -4281, -4281, -4281,  3543,
   13387, 27083, -4281,  1522, 69910,  1222,    66, -4281,  3360, 69910,
   -4281,  3319, -4281, -4281,  3418,  1945, -4281, -4281, -4281, -4281,
   -4281,  3432, 59928,  3651, -4281, 29338,  1947, -4281,  3393,  3743,
     168,  1961,  1969,  1405, -4281,  3311, -4281,  1480,  3626,   124,
   -4281,   541, -4281, 90236, -4281, 69910, 69910, -4281, -4281, -4281,
   -4281, 69910,  2458, -4281, -4281, 69910, 69910, 69910, 69910, -4281,
   52550, 69910, -4281, 69910, -4281, 49078,  1765,  3564, -4281, -4281,
    3571,   338, 69910, -4281, 90236,   541,   541, -4281, -4281, -4281,
   -4281, -4281,  3383,  3762,  3448, 69910, 69910, 69910, -4281, 69910,
   52550, 69910, 69910,  2138,  2138, 90236,  3366, -4281,  2138,  2138,
    3367, -4281, 52550, 69910, 69910, -4281, -4281, -4281, -4281, 49078,
   40388,  3451, -4281, 29338,  3764, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, 52550, 69910,  3453, -4281,  3456, -4281, -4281,
   -4281, 69910, 69910, 69910, 69910,  3691, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, 69910, -4281, 69910, -4281,
   -4281,   943,   943, 90236,   541,   541, -4281, -4281, -4281,  3632,
     817, -4281,   817,   817, -4281, -4281,   817, -4281,  3384,   461,
   -4281,  1405,  1660,  3674,  3679, 29338, -4281,  1113,  3889, -4281,
   -4281, -4281, -4281,  3311,  1712,  3440, 56456,  1000, -4281,  3659,
     174, 58192,  1381,  3389,  3500, -4281,  2293,  2293,  3445, 69910,
    3811,  2293,  3282, -4281,  3601,   723, 69910,  3721,  3436, -4281,
     943, -4281, -4281,  2879, -4281,  1522, 69910, 58192,  2979,  1971,
   -4281, -4281, -4281,  3433,  3318,  1822,   894, 69910, -4281,  3441,
    3820, -4281, -4281,  3697,  3597,  3407, -4281, 13387, 13387,   943,
   91502,  4932, 90236,  3711, -4281, 69910,   679,  3682,   541, -4281,
   -4281,   541,   541, -4281, -4281, -4281, -4281, 69910,  2927,  2927,
    2927, -4281,  3610, -4281, -4281,  3675, -4281,   541, 52116,   882,
   -4281, -4281, -4281,   882,   882, -4281,   882, -4281, 13387, -4281,
   -4281, -4281, -4281,  6995, 32495,  3707, -4281,  3426, 90236, -4281,
    3427,  1983,  1994, 33842,  3583, -4281, -4281, -4281,  7513,  3478,
   13387,  3531,  3434,  3444,  1771,  1771,  6317,  2003, -4281,  1771,
   29338, 29338,  1771,  1771, 29338, -4281, -4281,  7569,  3613, -4281,
   -4281,  8147, -4281, -4281, -4281, -4281, -4281, -4281, 49946, 69042,
    3446, 69910,  1704, 35587, -4281, -4281,  1542, -4281, 35587,  3688,
   -4281, 35587, 56456, -4281, 69910,  3449, 69910, -4281,   642, 31142,
   29338,  3484, -4281, -4281, -4281,  3359, -4281,  3484, -4281,  3454,
   69910,  2421, -4281, -4281,  3826, 36459,  3786,  3463, -4281, -4281,
   -4281, -4281, 52116,  3650, 52116,  1405,  8452,  3311, 36459, 43880,
   69910, 69910, 69910,  3607,  3311,  3440, -4281, -4281, -4281, -4281,
   -4281, -4281,  3459, -4281, -4281, -4281, -4281,  3538, -4281, -4281,
     898,  2888, -4281,  2013, -4281, -4281, -4281, -4281, -4281,  3633,
   -4281, -4281, 40835, 52550, 69910, -4281,  3541, -4281, -4281, -4281,
   -4281, -4281, 37768, 43010, -4281,   987,  3466,  3467,  1129, -4281,
   -4281, -4281, -4281, -4281, -4281, 69910,  8656,  3470,   954,  2888,
   69910, 69910,  1664,  1237,  1608,  2927,  3767, -4281, -4281, -4281,
   -4281,  3633, -4281, -4281,   817, -4281, -4281, -4281, -4281, 49078,
   -4281,  2719, -4281,  1335,  3802, 56456,  3887,  3887, 69910, -4281,
    9289,  3673, -4281,  3440,  3698,  3744, -4281,  3473, 69910,  3635,
    3479,  3480,   275,   275, 69910, 69910, 69910,  2015,  1522, -4281,
    1383,  3789, 58192,  3214, -4281,  1198,  3482,  3792, -4281,  3902,
    2979,  3113,  3485, -4281, -4281, 59494,  3676,  3374,  3318,  3614,
   -4281,  3621, -4281,   282, -4281,  1522, 69910, 69910, 36459, -4281,
   90658, -4281,  2017, -4281, -4281, -4281,  3556,  3020,  3596,  3598,
    3493, 69910,    95, -4281, -4281, -4281, -4281, -4281, 69910, -4281,
     367, -4281, -4281, -4281, -4281, -4281,  4293, 32495, 90236,  2019,
   29338, -4281, 29338, -4281,  3898, -4281, -4281, -4281,   885, -4281,
   -4281, -4281,  1771,  1771,  1771, -4281,  3899,  3359, -4281, -4281,
    2041,  3922, -4281, 69910,  2048, -4281, 29338,  3505, -4281, -4281,
   35587,  1542,  3506,  2049, 69910,  2054, 90236,  3507,  3511,   514,
    3515, 22205,  3508, -4281, -4281, -4281, -4281, -4281, 13387, 13387,
   69910, -4281,  3519, -4281, -4281, -4281, 69910,  2056, -4281,    82,
   25279, -4281, -4281,  1252,  1257,   367,  3743,  3440, -4281,  3528,
   -4281, -4281, -4281,  1232,  1232, 69910,  3440, -4281, -4281, 69910,
    3602, -4281, -4281, 49078,  3570, -4281,  1001,  2888, 69910, 90236,
    2097,   109, -4281, 90236, 90236, -4281, -4281, -4281, 29338,  3608,
   -4281, -4281, -4281, -4281, -4281, 69910, 69910, 69910, 69910, 69910,
     541, -4281,  2065, -4281, 36895, -4281, -4281,  2665,   943,  2665,
    1632, -4281, -4281,  2665, -4281,  2665, -4281,  3384,   943,  3887,
     290, -4281, -4281, -4281,  1631,  3731, -4281,   855,  3719,  3616,
    3534, -4281, 56456,  3975,  3550, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -4281,  2066,  3214,  3834,  2879,  3441, 69910, -4281,
   -4281, -4281, -4281, 29338,  3695,  1522, -4281,  1822,  3550, -4281,
   -4281, -4281,  3374, -4281, -4281,  3921,  3727,  3927,  2979, -4281,
    2803,  2071, -4281,  6830, 91502, 90236,  3869,  3575,  3576, -4281,
   -4281,  3593, 69910, -4281, -4281,  3214, -4281,  4293,  2077, -4281,
    2081,  2083,  3692,  3609, -4281, 29338,  1475,  3201, 49946,  3544,
   -4281,  2087, -4281, 13387, 69910, -4281, -4281, 29338, -4281,  2088,
   -4281, -4281, 29338,  3566, 29338, -4281, 31142,  3545, -4281,  3976,
   -4281, -4281,  3020, 36459, -4281,  3678, -4281,  3853, -4281, 69910,
    3605, 43010,  3010,  3010,  1712, -4281,  1405, -4281, 69910, -4281,
   29338, -4281,  3646, -4281, -4281,  2119, -4281,   120,  3717,  3875,
    2123,  2124,  9372, 69910,  2928,  1608,  2928, -4281,  2927, -4281,
   -4281, 49078, -4281, 50380, -4281, -4281, -4281,   943, -4281,   943,
    3780, 69910, 46040,   943,   943, -4281, -4281, -4281, -4281, -4281,
    3905,  3848, -4281, -4281, -4281, -4281,   706, -4281,  3775,  3776,
   69910, -4281,  3584, -4281,  2128,  3702, -4281, -4281, 69910,  4004,
    4006, -4281,   751,  9479, 56456,  3441,  3318,  1822,  1765, -4281,
    3779, -4281,  3784, -4281,  3590,  2879,  4932, -4281, -4281,   305,
    3890,  3891, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
    2966, 31593, 31593,  3594, -4281, -4281, 69910, -4281,  2132,  2133,
   -4281,  2173, 31142,  2177, -4281, 69910,  3604, -4281, -4281, 39077,
   52116,  1232,  3615, -4281,  3617, -4281, -4281,  3698,  1405,  2888,
   13387, 69910, 56456,  3998, -4281, -4281, -4281,  3717, -4281, -4281,
   -4281,  2888, 69910, -4281, -4281,  2179, -4281, -4281, -4281, 69910,
    3287, -4281,  3287, -4281, -4281,  3730, -4281,   974,   974,  3941,
   -4281,  3661, -4281, -4281,  3619, -4281,  4051, 69910, -4281,   987,
    1522, 58192, -4281,  3622, -4281,  3374,  3318, -4281, -4281, 36459,
    3374, -4281, -4281, -4281,  2620, 56456, 56456, 32946,  3738,   746,
   11533, -4281, -4281, -4281, -4281,  2183, -4281,  3753, -4281,  2189,
   -4281, -4281, -4281,   -21,   367,  3010, 29338,  1405, -4281,  3719,
   -4281,  2888,  2097, 69910, -4281, -4281, -4281, -4281, 50380,  3287,
    3436, -4281,  4043, -4281,   903, -4281, -4281, -4281, -4281,  3214,
    3366,  3441, 48644, -4281,  3374,  2190,  3020, -4281,  2448, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281,  3620,  3623,  4033, -4281,
   -4281, -4281, -4281, -4281, -4281,  3634, -4281, -4281, -4281, -4281,
   -4281,  9966, -4281, -4281, -4281, -4281, -4281,  3926, -4281, -4281,
   -4281, -4281, -4281, -4281,  2195, -4281, -4281, -4281, -4281, -4281,
    2879, -4281,  1794, -4281, -4281,  1820,  2040,  3693,  3911, 32044,
   29338, -4281,  1405,  3778, -4281, 48644,  3374, -4281,  2448,  3726,
    3729, -4281, 10413, 56456, -4281,  3020, -4281,  3663,  3668, -4281,
    3636, -4281,  3929,  3931, 48644, 56456, 56456,  2197, -4281, -4281,
   -4281
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1498,  1283,   570,  1368,  1367,  1283,   255,     0,  1370,     0,
    1283,   390,  1018,     0,     0,     0,     0,   570,  1283,     0,
    1498,     0,     0,     0,     0,     0,  1511,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1283,     0,     0,  1518,
       0,     0,     0,     0,  1511,     0,  1372,     0,     0,     0,
       0,     0,     2,     4,    67,    68,    29,    28,    34,    33,
      92,    93,    53,    17,    81,    60,   127,   126,   128,    40,
      36,    75,    25,    27,    37,    41,    62,    43,    54,   105,
      61,    23,    59,    86,    63,    89,    48,    11,    12,    49,
      79,    13,    50,    80,    14,    51,    15,   101,    69,    94,
      32,    58,    22,    85,    42,    65,    91,    66,     5,    44,
      77,    73,    10,    55,    56,    57,    82,    83,    84,   110,
      88,   122,    39,   119,    98,    99,   116,   100,   117,     8,
     102,    52,    16,   113,   112,   114,    76,    45,    78,    64,
      90,   111,    26,   115,    18,    19,    21,    20,   118,    87,
     108,   104,   123,   121,   129,   106,    70,     6,     7,    95,
      24,    47,     9,    31,    30,    46,    38,   125,    35,  1370,
      97,   109,    96,    71,   103,    74,   107,   124,    72,   120,
    1471,  1470,  1520,  1474,  1497,     0,  1486,  1282,  1281,  1267,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   569,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1293,  2079,  2094,  2095,  2096,  2097,  2098,  2099,  2100,
    2101,   361,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2365,  2366,  2367,  2368,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2369,  2370,  2119,  2120,  2121,  2122,  2123,
    2371,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,
    2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,
    2143,  2144,  2145,  2372,  2373,  2146,  2147,  2148,  2149,  2150,
    2151,  2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,  2160,
    2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,
    2171,  2374,  2172,  2173,  2174,  2375,  2175,  2176,  2177,  2376,
    2178,  2179,  2180,  2181,  2182,  2183,  2184,  2377,  2378,  2185,
    2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  2199,  2200,  2201,  2379,  2202,  2203,  2204,
    2205,  2380,  2381,  2382,  2206,  2207,  2208,  2209,  2210,  2211,
    2212,  2213,  2383,  2214,  2215,  2216,  2217,  2218,  2219,  2220,
    2221,  2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,  2230,
    2231,  2232,  2233,  2384,  2385,  2234,  2235,  2386,  2236,  2237,
    2238,  2387,  2239,  2388,  2240,  2241,  2242,  2243,  2244,  2245,
    2246,  2247,  2389,  2248,  2390,  2249,  2250,  2251,  2252,  2253,
    2254,  2255,  2256,  2257,  2258,  2391,  2259,  2392,  2262,  2260,
    2261,  2263,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2393,
    2271,  2272,  2273,  2274,  2275,  2276,  2277,  2278,  2279,  2280,
    2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,  2289,  2290,
    2394,  2291,  2292,  2293,  2294,  2295,  2296,  2297,  2298,  2299,
    2300,  2301,  2302,  2303,  2304,  2305,  2395,  2306,  2307,  2308,
    2309,  2396,  2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,
    2318,  2319,  2320,  2321,  2397,  2322,  2323,  2324,  2325,  2326,
    2327,  2328,  2329,  2398,  2399,  2330,  2331,  2400,  2332,  2401,
    2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,
    2343,  2344,  2345,  2346,  2347,  2348,  2349,  2402,  2403,  2350,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,
    2362,  2363,  2364,   360,  1461,  2047,  2080,  2081,  1369,  1349,
     570,     0,  1270,   389,  1498,     0,     0,     0,     0,     0,
       0,     0,     0,   786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   178,     0,     0,   413,   412,
       0,     0,     0,   991,   418,     0,     0,     0,     0,     0,
     558,  1411,  2260,  1409,  1462,   256,   259,   260,   257,   258,
    2069,     0,  1101,  1102,  1104,     0,     0,     0,  1114,   824,
     825,     0,     0,     0,   827,     0,     0,     0,   820,     0,
       0,     0,     0,     0,     0,   826,   817,     0,   816,     0,
       0,  1114,     0,     0,     0,   818,     0,     0,  1271,  1408,
     419,  1498,     0,  1386,  1387,  1388,  1370,  1377,  1389,  1382,
    1384,  1383,  1385,  1381,  2068,  2095,   929,   929,   929,   929,
     926,   927,   929,   929,   929,  2277,     0,     0,   908,     0,
     910,  2070,   929,   934,   474,   474,   474,     0,   933,   938,
     474,     0,  1264,  1302,  2052,  1510,     0,   909,  1263,  2330,
    1400,     0,     0,  1129,  1125,  1127,  1128,  1126,     0,     0,
       0,  2293,  1275,   240,  2303,  2398,  2330,   239,   234,   235,
     208,  2099,     0,     0,   933,     0,  1272,  1273,   894,  1517,
    1515,     0,  2034,  2117,  2131,  2217,   231,  2288,  2294,  2303,
    2398,  2330,  2361,   187,   197,   192,     0,   249,  2303,  2398,
    2330,   245,  1293,     0,  1487,  1615,  2043,     0,  1266,  1265,
    1371,     0,  1374,     0,  1576,  2273,  1491,  1494,  1376,  1492,
    1483,     0,     0,     1,  1498,  1365,  1514,  1514,     0,  1514,
       0,  1475,  1483,  1478,  1482,     0,     0,     0,     0,  2079,
    2413,  2414,  2415,  2416,  2417,  2418,  2419,  2420,  2421,  2422,
    2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,
    2433,  2434,  2435,     0,     0,  2053,  2080,  2084,     0,   834,
       0,  1305,  2048,   978,     0,     0,     0,     0,  2047,     0,
       0,     0,     0,  2085,  2075,  2076,     0,  2073,  2074,  2086,
    2087,  2088,     0,  2190,     0,     0,     0,  1940,  1951,  1952,
    1953,  2121,  2175,  1948,  1949,  1950,  1942,  1943,  1944,  1945,
    1946,  1947,     0,  1099,  1941,     0,  2190,     0,   156,     0,
     134,     0,     0,  2190,     0,     0,     0,     0,     0,  2190,
       0,     0,     0,     0,     0,   156,  2222,     0,   134,  2190,
       0,     0,  1287,     0,     0,     0,  1289,  1292,  1268,  1352,
       0,  2043,     0,     0,     0,   871,   863,     0,   872,   864,
       0,     0,   874,     0,     0,   866,     0,     0,     0,     0,
     875,     0,   865,   867,   877,   868,   873,     0,     0,     0,
       0,   869,     0,     0,  1279,     0,  1402,  1404,  1403,  1401,
     474,     0,     0,     0,     0,     0,     0,   134,  1337,     0,
    2190,   134,     0,     0,   417,   416,   134,  2073,   415,   414,
    2121,  2175,     0,  1017,     0,   134,  2190,     0,   180,   643,
     573,     0,     0,   745,  2222,   134,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,   557,   570,  1412,  1410,
       0,  1105,   233,   232,  1103,   822,  2190,     0,   335,     0,
       0,  2190,  1324,  2082,  1673,  1702,  1680,  1702,  1702,  1669,
    1669,  2159,  1682,  2190,  1670,  1671,  1709,     0,  1702,  1669,
    1674,     0,  1672,  1712,  1712,  1697,   335,   838,  1654,  1655,
    1656,  1657,  1683,  1684,  1658,  1689,  1690,  1704,  1659,  1726,
    1669,  2083,   823,     0,   821,  2190,     0,  2190,  2077,   171,
       0,   819,  2121,  2175,  2190,     0,     0,  2190,     0,  2190,
     163,  2190,     0,  2190,   335,  2190,   574,     0,     0,  2190,
       0,  2190,   335,  2190,  2222,   165,     0,  2190,   335,   832,
       0,  1405,     0,  1379,  2402,  1394,     0,  1390,  1397,  1393,
    1498,   929,   928,     0,   929,     0,   929,     0,   929,     0,
     929,     0,     0,     0,   929,  2071,  2072,   911,     0,   935,
       0,     0,   942,   941,   940,     0,     0,     0,   943,     0,
    1619,  1435,     0,  1261,  1278,     0,     0,     0,   994,  1132,
       0,  1130,  1121,  1122,  1274,   238,   236,     0,     0,     0,
       0,     0,     0,  1280,     0,     0,     0,     0,  2056,  2058,
    2059,  1954,  2024,     0,  2366,  2367,  2368,  2013,     0,  2369,
    2370,  2371,  2415,  1856,  1843,  1852,  1857,  1844,  1846,  1853,
    2372,  2373,  2374,  2375,  2066,  2376,  2377,  2378,  2380,  2381,
    2382,  2383,  1848,  1850,  2384,  2385,     0,  2067,  2387,  2388,
    2244,  2390,  2391,  2393,  2394,  1854,  2396,  2397,  2398,  2399,
    2400,  2401,  2065,     0,  1855,  2403,  2405,  2406,  2407,  2408,
    2409,  2410,  2411,  2412,     0,     0,     0,  2040,     0,  1823,
       0,  1662,  1663,  1685,  1686,  1664,  1691,  1692,  1665,     0,
    2039,  1729,  1905,  1822,  1839,     0,  1828,  1829,     0,  1821,
    1817,  1500,  2035,     0,  1818,  2055,  2057,  2014,  1500,  2033,
     200,   251,     0,   252,  2041,  2303,   188,   230,   202,   229,
     203,   201,     0,  2119,   189,     0,     0,   190,     0,     0,
       0,     0,   248,   246,     0,  1269,     0,  1617,  1616,  2021,
       0,  2022,  2044,   843,  1364,  1362,  1363,  1361,     0,  1358,
    1360,  1373,  1370,  2029,  2028,  2030,     0,  1493,     0,     0,
       0,  1473,  1472,     3,  1376,  1512,  1513,     0,     0,     0,
       0,     0,     0,     0,     0,  1566,  1528,  1529,  1531,  1563,
    1567,  1575,     0,  1479,     0,     0,  1621,     0,  1577,     0,
       0,  2054,     0,     0,     0,     0,   835,     0,     0,     0,
    1311,     0,  1313,  1314,  1315,     0,     0,  1316,  1317,  1305,
     242,  1323,  1321,  1304,  1306,  1319,     0,     0,     0,     0,
       0,     0,     0,  1329,     0,     0,   169,   170,   586,   570,
       0,  2190,     0,     0,     0,     0,     0,  1057,  1064,     0,
       0,     0,     0,     0,     0,     0,     0,  1058,  1056,  1059,
     244,  1068,  1085,  1088,     0,   968,     0,     0,     0,     0,
       0,  1184,     0,     0,     0,  1184,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   265,
     277,   330,   549,     0,     0,     0,   552,     0,  2190,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     132,   133,   138,     0,     0,     0,     0,     0,     0,   536,
     548,     0,     0,     0,     0,     0,   545,     0,   134,   269,
     529,   533,     0,     0,     0,   652,   651,  1327,  1326,     0,
       0,     0,  1184,     0,   261,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     353,   354,     0,     0,     0,   138,     0,     0,     0,     0,
     271,     0,     0,  1288,  1285,  1286,     0,  1291,     0,  1348,
       0,   862,     0,     0,     0,     0,   879,     0,   876,     0,
       0,   870,  2121,  2175,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   392,     0,     0,   742,     0,     0,
       0,     0,     0,   753,     0,  1305,  1336,     0,     0,     0,
     579,     0,  2190,     0,   136,   787,     0,   743,   418,     0,
       0,   136,     0,     0,   174,     0,   647,     0,     0,     0,
       0,     0,     0,   691,   690,     0,     0,     0,   744,     0,
     136,     0,  2190,   532,  2190,     0,   474,   474,     0,     0,
     993,   996,     0,     0,     0,     0,  1465,  1467,  1466,     0,
    1464,     0,   335,   333,   334,   740,  1113,     0,     0,  1701,
    1688,  1696,  1695,     0,  1678,  1677,  1676,     0,  1675,     0,
    1702,  1702,  1700,  1679,  1654,     0,     0,     0,  1708,     0,
    1706,     0,   812,  1650,  1646,     0,     0,  1694,  1715,  1716,
    1717,  1714,  1727,  1713,     0,  1660,  1718,  1669,  1666,     0,
       0,   335,     0,     0,  2190,   335,  2190,     0,  2190,     0,
       0,   335,   335,     0,     0,     0,     0,     0,     0,   648,
       0,   831,   829,   828,   830,     0,     0,     0,     0,   810,
       0,     0,     0,  2190,   335,     0,     0,   809,  1964,     0,
       0,  1498,     0,   219,   220,   218,  1395,   221,  1396,  1392,
    1378,     0,   919,     0,   923,     0,   914,     0,   920,     0,
     915,   912,   913,     0,   918,     0,     0,   475,   477,     0,
       0,  2143,  2158,     0,  2181,  2210,  2211,  2294,  2299,     0,
    2325,  2335,     0,   944,   973,   939,   661,     0,     0,  1445,
    1262,  1971,     0,  1498,     0,     0,     0,     0,   237,   209,
       0,     0,     0,   975,  2293,  1277,   893,   570,     0,  1819,
       0,  1826,  1827,  2012,     0,     0,     0,     0,     0,     0,
    1825,  1979,     0,     0,     0,     0,     0,  1752,     0,     0,
       0,  1992,     0,  1998,     0,     0,  1789,     0,     0,     0,
       0,     0,     0,     0,     0,  1753,  1733,  1734,  1823,  1964,
       0,  1824,  2062,     0,  1726,  2038,  1954,     0,  1951,  1952,
    1953,     0,     0,     0,  2027,     0,  1962,     0,     0,  1767,
    1960,  1769,     0,     0,     0,     0,  1948,  1949,  1950,  1942,
    1943,  1944,  1945,  1946,  1947,  1958,  1749,     0,     0,  1907,
       0,  1748,     0,     0,  1579,     0,  2060,  2015,  1579,   253,
     254,   250,     0,     0,   205,   204,     0,   223,   227,   228,
     199,   226,     0,   222,   207,  1896,  1895,   206,   198,   195,
     193,   210,   212,   213,   196,   194,   247,     0,  2020,     0,
    2089,  2436,  2437,  2438,  2439,  2440,  2441,  2442,  2443,  2444,
    2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,  2454,
    2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,  2463,  2464,
    2465,  2466,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,  2483,  2484,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,  2494,
    2495,  2496,  2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,
    2505,  2506,  2507,  2508,  2509,  2510,  2511,  2512,  2017,  2016,
    2050,  2090,  2091,  2092,  2093,  2023,     0,     0,   335,  1356,
       0,  1353,  2032,     0,  1495,     0,  2045,     0,  1366,  1490,
    1489,  1521,  1522,  1010,  1488,  1546,  1547,  1542,     0,     0,
       0,  1572,  1570,  1538,  1532,  1537,  1535,     0,  1539,  1729,
    1565,  1477,  1526,  1527,  1530,  1476,     0,  1568,     0,  1448,
    1566,  1531,  1432,     0,  1414,     0,  1622,     0,  1032,  1034,
       0,  1033,     0,  1036,     0,  1045,     0,     0,  1031,  1050,
       0,  1039,  1037,     0,     0,     0,     0,     0,     0,   836,
       0,     0,     0,     0,  1312,     0,     0,  2325,   241,  1315,
    1320,  1307,  1318,     0,     0,     0,     0,     0,   977,   976,
       0,     0,   998,     0,     0,     0,  1332,   463,     0,   332,
       0,     0,     0,     0,     0,     0,     0,     0,   738,   735,
       0,     0,   734,     0,   584,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   622,     0,  1184,     0,   655,
       0,  1066,     0,     0,  1065,     0,  1069,     0,     0,  1067,
    1062,  1063,  2294,  2303,  2330,   243,  1087,     0,  1086,  1084,
    1020,     0,  1021,     0,     0,     0,     0,     0,  2168,  2190,
     279,   294,     0,  1183,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   317,
       0,     0,   320,   319,     0,     0,     0,     0,     0,   324,
     303,     0,   304,     0,     0,   323,     0,     0,   550,   551,
       0,     0,     0,     0,  1184,     0,   273,     0,     0,     0,
       0,     0,     0,  1100,     0,   679,     0,     0,   159,     0,
     155,   158,     0,     0,     0,     0,   535,   547,     0,   539,
     540,   537,   541,   542,     0,     0,     0,     0,     0,     0,
     534,     0,     0,   645,   644,   650,     0,     0,     0,     0,
       0,     0,     0,     0,  1134,  1133,     0,     0,     0,     0,
       0,     0,   777,     0,     0,     0,     0,     0,     0,     0,
     162,   664,     0,   663,     0,   160,   161,     0,     0,     0,
       0,     0,     0,     0,   217,  1284,  1290,  1351,  2051,  1350,
       0,     0,     0,     0,   878,     0,     0,     0,     0,     0,
       0,     0,     0,   880,   881,   882,   883,     0,     0,     0,
       0,     0,   367,     0,     0,     0,  2082,     0,   766,   741,
       0,     0,   754,     0,   756,   759,     0,  1303,   436,     0,
       0,   576,   622,     0,   421,   167,     0,     0,     0,     0,
     681,   131,   178,   180,   419,     0,   179,   181,   183,   184,
     185,   182,   186,   642,   646,     0,   572,     0,     0,     0,
       0,     0,   692,   696,   695,   699,   697,     0,   693,     0,
       0,  1642,     0,   154,     0,     0,   527,   531,     0,     0,
       0,   421,   505,   346,  2190,     0,   474,     0,  2190,     0,
     995,     0,     0,     0,     0,     0,     0,     0,     0,  1463,
       0,  1091,     0,  1325,     0,     0,     0,   335,  1699,  1698,
    1651,  1647,     0,     0,     0,     0,   839,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1667,  2190,   335,
       0,  1089,   172,  2078,     0,   814,     0,     0,     0,     0,
       0,  1093,   806,     0,   335,   164,     0,   335,   335,   575,
       0,     0,   335,   335,   166,     0,     0,     0,   567,   335,
     833,  1407,     0,  2190,   474,  1380,  1391,   916,   925,   924,
     922,   921,   917,     0,   936,     0,   473,     0,     0,     0,
     950,   951,     0,     0,   949,   966,   952,     0,   954,   946,
     945,   955,   956,     0,     0,   975,   659,     0,     0,     0,
       0,  1442,     0,  1440,     0,  1620,  1444,  1433,  1399,     0,
    1398,     0,   520,     0,     0,  1131,     0,     0,   933,     0,
       0,   335,  1276,     0,   895,   896,     0,     0,     0,     0,
       0,     0,   902,   899,   900,   901,   903,     0,   904,     0,
       0,     0,  2025,  1975,     0,  1976,     0,     0,  2011,  2007,
       0,     0,     0,     0,     0,  1980,  1983,  1984,  1985,  1982,
    1986,  1981,     0,     0,  1987,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2394,     0,     0,     0,     0,  1792,
       0,     0,  1935,     0,  1964,  1997,     0,     0,     0,     0,
       0,     0,  1964,  2003,     0,     0,     0,     0,  1894,     0,
    1891,     0,     0,     0,     0,  2024,     0,     0,  2063,  1730,
    1744,  1745,  1746,  1750,  2037,     0,  2026,     0,     0,  1731,
    1758,     0,  2004,  1785,     0,  1790,  1773,     0,  1766,     0,
    1771,  1775,  1754,     0,  1751,     0,  2027,  1963,     0,  1961,
       0,  1741,  1742,  1743,  1735,  1736,  1737,  1738,  1739,  1740,
    1747,  1939,  1937,  1938,     0,     0,     0,  1915,     0,     0,
    1770,  2183,  2217,     0,  1511,  1511,  1511,  1499,  1509,  2036,
       0,  1637,     0,     0,     0,     0,  1831,     0,  1968,  1520,
    1966,  1037,  1637,  2042,     0,     0,  1726,     0,  1618,  2018,
    2021,   841,   842,   840,  1376,  1359,  1355,  1354,  2031,  1375,
       0,  1498,     0,  1008,  1009,     0,  1013,     0,     0,  1540,
    1573,     0,  1564,     0,  1544,  1545,  1536,  1574,  1446,     0,
    1569,  1481,  1480,     0,  1640,     0,     0,  1424,  1416,     0,
    1623,     0,  1579,  1450,  1452,  1453,     0,  2024,  1035,     0,
    1669,  1046,     0,  1030,     0,  1029,  1669,     0,  1047,     0,
    1669,     0,     0,     0,  1221,  1136,  1192,   837,  1222,  1137,
    1193,  1223,  1138,  1322,  1310,  1309,  1308,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   717,  2190,   335,  1330,  1224,     0,  1139,   331,  1331,
    1194,  1335,   737,   736,     0,     0,  1195,     0,   585,     0,
       0,     0,   591,   592,   593,     0,     0,     0,   594,     0,
    2121,  2175,     0,   599,   606,   611,   601,     0,     0,   613,
     607,     0,     0,     0,     0,     0,     0,   619,   626,     0,
       0,     0,     0,     0,     0,     0,  1060,  1061,  1225,  1142,
       0,  1196,  1019,     0,  1143,   168,     0,     0,   266,  2190,
     281,     0,   628,   717,  1186,   301,     0,     0,   316,   311,
     312,   310,  2190,   335,  2190,   335,     0,     0,     0,     0,
       0,   313,   308,   309,   305,     0,     0,   318,  2098,  2160,
    2304,     0,   632,   634,     0,   639,   321,  1159,   342,   341,
     340,     0,   325,     0,   347,   350,   322,   299,   302,   300,
     296,   278,     0,     0,     0,     0,     0,     0,     0,     0,
    2049,     0,     0,  1095,     0,     0,     0,     0,     0,     0,
       0,   673,   157,  1174,   147,     0,     0,   143,     0,     0,
       0,     0,   137,     0,  1231,  1149,     0,     0,   270,   530,
     538,   543,  1153,   546,  1206,   544,  1237,  1150,     0,  1184,
       0,   262,     0,  1151,     0,  1200,  1233,  1176,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1338,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,  1186,  2190,
     335,  1232,     0,  1181,  1214,     0,   355,     0,  1175,     0,
       0,   272,  1155,  1208,     0,     0,   215,   214,   216,     0,
       0,  2158,     0,   885,   846,   884,     0,     0,     0,     0,
       0,     0,   854,     0,     0,     0,   845,     0,   844,   366,
       0,   391,   364,   365,   367,     0,     0,   765,     0,     0,
       0,   755,     0,     0,     0,  1328,     0,   134,   583,     0,
       0,     0,   578,   621,   628,     0,     0,     0,   420,   424,
     428,   429,   430,     0,     0,     0,     0,   148,   135,     0,
     795,     0,   474,     0,   677,     0,   180,   173,     0,     0,
       0,   346,   752,   750,   749,   751,     0,     0,     0,   770,
     748,     0,  1641,  1643,     0,     0,     0,     0,     0,   520,
     423,     0,   477,     0,     0,   509,     0,     0,     0,     0,
     346,     0,     0,     0,  1024,     0,  1042,  1025,     0,     0,
       0,     0,  1073,  1080,  1074,  1052,     0,     0,   555,  1468,
    1469,     0,   335,     0,     0,  1668,  1681,   813,     0,  1711,
    1710,  1712,  1712,     0,  1652,     0,  1703,  1704,  1720,  1721,
    1722,  1723,  1724,  1725,     0,  1719,  1661,     0,   623,   335,
     335,     0,   335,     0,   335,   335,     0,   670,     0,  1259,
     649,     0,     0,   725,   811,     0,     0,   335,   808,  1965,
       0,   937,   476,     0,     0,     0,     0,   948,     0,   553,
     953,     0,   965,   960,   962,     0,   969,   658,     0,     0,
    1443,  1436,  1438,  1437,     0,     0,  1434,  1972,   807,     0,
     526,  1123,  1124,     0,     0,   335,     0,   970,     0,     0,
     897,   898,     0,     0,   905,     0,     0,     0,  1516,  1973,
    1974,     0,     0,     0,  2008,     0,     0,  1869,     0,  1845,
    1847,  1859,     0,  1870,  1830,  1871,  1849,  1851,     0,  1955,
       0,     0,  1860,     0,  1794,  1795,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1810,  1809,  1861,  1934,     0,     0,  1995,
    1996,  1862,     0,     0,  2002,     0,     0,     0,  1867,  1872,
       0,     0,     0,     0,  1878,     0,  1899,     0,     0,     0,
    1820,  1965,     0,     0,     0,     0,     0,     0,     0,     0,
    1791,  1774,  1768,     0,  1772,  1776,     0,     0,     0,  1762,
       0,     0,  1760,  1786,  1756,     0,     0,  1787,     0,     0,
       0,  1838,     0,     0,  1511,  1511,  1511,  1511,  1508,     0,
       0,     0,     0,  2291,     0,  1601,  1578,  1580,  1588,  1601,
    1606,  1840,  1635,  1841,     0,  2043,     0,  1549,  1520,  1520,
    1520,  1837,     0,     0,     0,     0,  1519,  1549,   191,     0,
     224,   211,  2020,     0,  1357,  2046,     0,  1523,     0,  1956,
    1013,     0,  1525,     0,     0,  1571,  1533,  1447,  1431,     0,
    1429,  1418,     0,  1419,  2024,     0,  1429,  1415,  1458,     0,
       0,  1640,     0,  1457,     0,  1669,  1027,  1028,     0,  1051,
       0,  1220,  1135,  1191,   980,   981,     0,   979,     0,     0,
       0,   462,   997,     0,     0,     0,   717,     0,     0,   466,
       0,  1333,     0,  1238,  1173,   587,   588,   589,     0,   600,
       0,   609,   608,     0,     0,   596,     0,     0,     0,     0,
       0,   595,   615,   559,   616,   618,     0,     0,   617,   620,
     625,  1184,     0,   656,  1161,     0,  1212,  1054,  1187,     0,
    1022,     0,     0,     0,     0,     0,     0,   436,   295,     0,
       0,     0,   283,   293,     0,  1190,   327,     0,   298,     0,
     291,   314,   306,   315,   307,   326,   328,     0,   636,   637,
     635,   631,     0,   638,   640,     0,   344,     0,     0,     0,
    1227,     0,  1184,     0,   274,     0,  1157,     0,  1210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1228,  1197,     0,  1216,     0,     0,     0,   678,     0,   675,
       0,     0,   140,   139,     0,   146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   356,   337,     0,   773,     0,     0,     0,
     358,     0,     0,     0,     0,  1226,  1144,   847,     0,     0,
       0,   848,   859,     0,     0,   849,     0,     0,     0,     0,
     861,   369,   370,   134,   368,     0,     0,  2244,  1942,  1943,
     763,   768,   760,   762,   764,   761,     0,   767,   717,     0,
     757,   758,     0,     0,     0,     0,     0,   448,     0,     0,
     442,     0,     0,  1080,   435,   438,   439,     0,     0,   579,
     582,   580,   581,   614,     0,   455,   501,     0,   150,     0,
       0,   151,   149,     0,     0,   346,   682,   686,   684,   683,
     685,   680,     0,   673,     0,   176,   419,     0,     0,   571,
     698,   701,   694,     0,   769,   771,   746,     0,   628,     0,
     532,     0,   474,  1408,   515,     0,   505,   501,   503,   502,
     504,     0,   511,   345,     0,     0,   520,   511,     0,     0,
     998,  1023,     0,     0,     0,  1070,  1075,  1071,     0,     0,
    1038,     0,  1072,     0,  1053,  1016,  1254,  1255,  1252,  1253,
       0,     0,     0,  1460,  1092,     0,  1687,     0,  1707,  1705,
    1648,  1653,  1693,  1728,   335,  1090,   815,     0,   802,     0,
     804,  1094,   335,   335,   335,   335,   665,     0,   568,     0,
       0,     0,     0,   947,   967,     0,   963,     0,     0,   930,
     972,     0,     0,  1441,  1439,   518,     0,   975,     0,   931,
     974,     0,     0,     0,     0,     0,     0,     0,  1977,     0,
    2010,  2006,     0,  1842,  1978,     0,  1990,  1989,  1935,     0,
       0,  1793,  1805,  1806,  1807,  1991,     0,  1815,     0,     0,
    1802,  1803,  1804,  1796,  1797,  1798,  1799,  1800,  1801,  1808,
    2000,  1999,  1993,  1994,     0,  1864,  1865,  1866,  2001,  1873,
       0,  2112,  1900,  1877,  1893,  1892,     0,     0,     0,  1880,
       0,     0,  1889,     0,  1936,  2064,  1732,     0,     0,  1759,
    2005,  1777,     0,     0,     0,  1755,  1955,     0,     0,     0,
       0,     0,  1764,     0,     0,     0,  1918,  1913,  1914,  1932,
       0,     0,     0,     0,     0,     0,  1502,  1501,  1507,  1601,
    1606,     0,  1483,     0,  1588,     0,  1600,  1586,  1599,     0,
       0,  1612,  1610,     0,  1612,     0,  1612,     0,  1582,     0,
    1602,  1584,  1599,     0,  1627,     0,  2044,  1636,     0,  1562,
       0,     0,     0,     0,  1969,  1970,     0,  1967,  1832,  1562,
       0,  2019,  1496,     0,  1524,  1011,  1012,  1541,  1534,  2139,
    1638,     0,  1430,     0,     0,  1421,  1427,  1413,     0,     0,
    1451,  1429,  1454,  1048,     0,     0,  1040,   986,   987,   985,
     988,     0,     0,     0,   717,     0,     0,   482,     0,  1005,
    1005,     0,     0,   468,   514,  1080,   720,     0,     0,     0,
     718,   335,  1140,     0,   610,     0,     0,   605,   603,   602,
     604,     0,   560,  1236,  1141,     0,     0,     0,     0,  1055,
       0,     0,  1160,     0,   280,     0,   433,     0,   288,  1185,
       0,     0,     0,   287,     0,   335,   335,   329,   633,   343,
     348,   349,   352,     0,     0,     0,     0,     0,  1189,     0,
       0,     0,     0,     0,     0,     0,   796,   779,     0,     0,
     797,   798,     0,     0,     0,  1097,  1098,  1096,  1215,     0,
       0,     0,  1147,     0,     0,   669,   144,   141,   142,   145,
    1171,  1154,  1207,     0,     0,     0,  1152,     0,  1201,  1167,
    1163,     0,     0,     0,     0,     0,  1235,  1180,  1205,  1234,
    1178,  1203,  1177,  1202,  1179,  1204,     0,  1172,     0,  1645,
     776,     0,     0,     0,   335,   335,   667,  1156,  1209,     0,
       0,   850,     0,     0,   852,   853,     0,   856,   374,   394,
     687,   739,     0,     0,   716,     0,   440,     0,   446,   450,
     451,   449,   441,  1080,   474,   513,     0,     0,   729,     0,
     577,   421,   452,     0,     0,   425,   153,   152,     0,     0,
       0,   676,   675,   180,  2190,     0,     0,   703,   707,   747,
       0,  1644,   662,   346,   528,     0,     0,   421,   520,     0,
     426,   431,   432,     0,   509,   505,     0,     0,   517,  1301,
       0,   521,   523,     0,     0,     0,  1026,  1043,  1044,     0,
       0,  1080,     0,     0,  1079,     0,     0,   562,   335,  1649,
     624,   335,   335,   671,  1260,  1120,   726,     0,   959,   958,
     957,   554,     0,   961,   660,     0,   519,   335,     0,     0,
     907,   888,   906,     0,     0,   887,     0,   886,  2009,  1858,
    1868,  1988,  1934,  1965,     0,     0,  1816,     0,     0,  1863,
    2404,     0,     0,     0,     0,  1897,  1898,  1879,     0,  2235,
    1884,     0,     0,     0,  1783,  1781,  1778,     0,  1779,  1763,
       0,     0,  1761,  1757,     0,  1788,  1904,     0,  1920,  1917,
    1931,  1965,  1506,  1505,  1504,  1503,  1587,  1585,     0,  1590,
    1597,     0,  1581,     0,  1611,  1607,     0,  1608,     0,     0,
    1609,     0,     0,  1583,     0,  1597,     0,  1634,  1520,     0,
       0,  1909,  1835,  1836,  1833,  1520,  2061,  1909,   225,     0,
       0,  1428,  1417,  1420,     0,     0,     0,     0,  1459,  1449,
    1041,  1049,     0,     0,     0,   464,     0,  1080,     0,     0,
       0,  1007,  1007,     0,  1080,   513,   722,   721,   724,   719,
     723,  1334,     0,   597,   598,   612,  1162,     0,  1213,  1169,
       0,  1445,   282,     0,   629,   284,   285,   286,   289,   337,
     297,   290,     0,     0,     0,  1158,     0,  1211,  1165,  1229,
    1145,  1198,     0,     0,   785,     0,     0,     0,     0,  1230,
    1146,  1199,  1217,  1218,  1219,     0,     0,     0,     0,  1445,
       0,     0,     0,     0,     0,  1343,     0,  1188,   336,   775,
     774,   337,   357,  1182,     0,   851,   857,   858,   855,     0,
     363,   371,   395,   134,     0,     0,  1111,  1111,     0,   717,
       0,     0,   437,   513,   481,     0,   443,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   668,
     175,     0,   421,   628,   702,     0,     0,     0,   772,     0,
     520,   423,     0,  1406,   422,     0,     0,   511,   509,     0,
     506,     0,   510,     0,  1294,     0,     0,     0,     0,  1076,
       0,  1082,     0,  1037,  1014,  1077,     0,  1637,     0,     0,
       0,     0,   566,  1112,   803,   805,   666,   964,     0,   971,
     335,   889,   890,   891,   892,  1936,  1811,     0,     0,     0,
       0,  1874,     0,  1875,  1902,  1901,  1881,  1885,     0,  1882,
    1883,  1780,  1784,  1782,  1765,  1906,     0,  1520,  1933,  1630,
       0,  1633,  1589,     0,     0,  1591,     0,     0,  1593,  1595,
       0,     0,     0,     0,     0,     0,  2047,     0,  2138,  2378,
    2290,     0,  1548,  1550,  1553,  1555,  1554,  1556,  1552,  1561,
       0,  1485,     0,  1484,  1957,  1639,     0,     0,   999,     0,
       0,  1456,  1455,   965,     0,   335,  1005,   513,   483,  2244,
     484,  1004,  1006,  1010,  1010,     0,   513,   717,   590,     0,
       0,   267,   627,     0,   339,   351,     0,  1445,     0,     0,
       0,   792,   780,     0,     0,   799,  1148,   672,     0,     0,
     263,  1168,  1164,  1345,  1346,     0,     0,     0,     0,     0,
     335,   860,     0,   397,   404,   375,   380,  1337,     0,  1337,
       0,   377,   381,  1337,   376,  1337,   373,   374,     0,  1111,
       0,  1108,  1107,   715,     0,   472,   444,     0,   492,     0,
       0,   730,     0,     0,   501,   461,   460,   457,   456,   458,
     459,   454,   453,     0,   628,   789,   346,  1301,     0,   641,
     704,   705,   700,     0,     0,     0,   516,   505,   501,   427,
     436,   410,   511,   507,   508,     0,     0,     0,   520,  1347,
     998,     0,  1081,     0,     0,     0,     0,     0,     0,  1115,
     561,     0,     0,   565,   556,   628,   932,  1812,     0,  1813,
       0,     0,     0,  1887,  1886,     0,  1923,  1635,     0,     0,
    1629,     0,  1598,  1614,     0,  1594,  1592,     0,  1603,     0,
    1605,  1832,     0,     0,     0,  1557,     0,  1908,  1910,     0,
    1834,  1426,  1637,     0,  1423,     0,   982,     0,   983,  1007,
     487,     0,  1013,  1013,   474,   717,   465,  1170,     0,   630,
       0,   292,     0,   275,  1166,     0,   783,     0,   794,   792,
       0,     0,     0,     0,  1339,     0,  1340,  1341,  1344,   359,
     372,     0,   402,     0,   400,   399,   401,     0,   388,     0,
       0,     0,     0,     0,     0,   362,   393,  1106,  1110,  1109,
       0,     0,   445,   478,   479,   480,     0,   447,   488,   489,
       0,   727,     0,   732,     0,     0,   500,   653,     0,     0,
       0,  1295,     0,     0,     0,  1301,   509,   505,   434,   408,
       0,  1298,     0,   522,     0,   346,  1080,  1083,  1078,  1258,
       0,     0,   564,   563,   657,  1814,  1890,  1876,  1903,  1888,
    1919,     0,     0,     0,  1628,  1631,     0,  1596,     0,     0,
    1604,     0,     0,     0,  1551,     0,     0,  1425,  1000,     0,
       0,  1010,     0,   717,     0,  1002,  1001,   481,   467,  1445,
     338,     0,     0,     0,   790,   793,   781,   794,   801,   800,
     674,  1445,     0,   398,   407,     0,   405,   378,   383,     0,
     387,   385,   384,   379,   382,     0,   471,     0,     0,     0,
     490,     0,   491,   512,     0,   731,     0,     0,   788,     0,
       0,   421,   706,     0,  1296,   511,   509,  1299,  1300,     0,
     511,  1015,  1257,  1256,  1498,     0,     0,  2365,  2139,  2337,
       0,  1921,  1924,  1922,  1916,     0,  1613,  1626,  1559,     0,
    1558,  1911,  1912,  1637,   335,  1013,     0,   469,   485,   492,
     268,  1445,     0,     0,   782,   264,  1342,   403,     0,   386,
     707,   497,     0,   496,     0,   494,   493,   728,   733,   628,
     778,  1301,   710,   411,   511,     0,  1637,  1240,  1498,  1239,
    1241,  1249,  1246,  1248,  1247,  1245,  1118,  1119,     0,  1928,
    1927,  1926,  1930,  1929,  1632,     0,  1624,  1560,  1422,   984,
    1003,     0,   717,   276,   784,   791,   406,     0,   495,   499,
     498,   654,  1297,   712,     0,   708,   711,   713,   714,   409,
     346,   989,     0,  1250,  1244,  1483,  1470,     0,     0,     0,
       0,   486,   470,     0,   688,     0,   511,  1242,  1498,     0,
       0,  1925,     0,     0,   709,  1637,  1243,     0,     0,  1625,
       0,   990,     0,     0,   710,     0,     0,     0,  1116,  1117,
     689
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4281, -4281, -4281,  3351, -4281,  -841,   356,  2609, -1328, -4281,
   -4281, -4281,  1273, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
    3268, -4281, -4281,  1776, -2239, -4281, -4281,   149,  3226, -1217,
     134,  2846,  1441, -4281, -1062, -4281, -4281,  -532,   102, -4281,
    3235,   626, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -4281,
    -686,  1933,  1282,  -517, -2511, -4281, -4281, -1341, -2940, -4281,
     635, -4281, -4281,  1866, -4281, -4281, -4281,  1119,   551,  -438,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281,  -579, -4281, -4281,
    -764,   155,    43, -2257,  -254, -4281, -4281,   522,  -257, -1334,
   -4281, -3322, -4281,    73, -4281, -4281, -4281,  -232, -1307,  1390,
   -4281,  -646, -1079,  1690,  -656, -4281,  -116, -4281,  -736,  -585,
    -576,  -682, -3507, -3514, -3925, -3496, -3989,  1406,   158, -2874,
   -2967,   160,   498, -4281,   162,   164, -4281,   516,  -775, -1373,
   -4281,  -810, -4281, -4281, -4281, -2678, -4281, -4281, -4281, -4281,
      51, -4281, -4281, -4281, -4281,   558, -4281, -4281, -4281, -4281,
   -4281, -4281, -2508,  1863,  1864, -4281, -4281, -2897, -4281,  -817,
   -4281,   696, -2744,  1311, -4281, -4281, -4281,  2612, -4281, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -1494, -4281, -4281,
   -4281, -4281, -4281,   546,    88, -4281, -4281, -4281, -4281, -4281,
     166, -4281,  1876,  1123, -4281, -4281, -4281,  -715,  -808,  -788,
   -4281, -2732, -4281, -4281, -4281, -4281,  -178, -4281, -4281, -4281,
   -4281, -4281, -4281,  -832, -4281,  1180, -2905, -4281, -4281,  1185,
   -4281, -4281, -4281, -4281, -4281,  -653,  -115,  2650, -4281,  -500,
    -616, -4281, -4281, -4281,  -114, -4281, -4281, -4281, -4281, -4281,
   -4281, -1007,   -98,  -970,  -497, -4281, -4281, -4281, -4281, -2132,
   -4281, -4281, -4281, -3340, -4281,  4165,   390,   521,   169, -4281,
     -25,    50,  3086, -1067, -2430,   478,  -295, -4281, -1660, -4281,
   -4281, -4281, -2358, -4281, -4281, -4281, -4281, -3251,   171, -4281,
    3081, -4281, -3523, -4194, -3280, -3725, -4052, -3653, -3230, -4281,
   -4281, -1019, -4281, -4281, -4281, -1327,  2186, -1762, -4281, -1966,
     550,  1494,  -846, -2528, -3535,  -634, -3001, -4281, -4281, -3484,
    -396, -4281, -4281, -4281, -4281, -4281, -4281, -4281, -1018,  -553,
   -4281, -4281,  3625, -4281, -4029, -4281,  3627, -4281, -4281, -4281,
   -4281,  2492,  2497, -4281,  2498, -4281, -4281, -1316,  1290, -4281,
   -4281, -4281, -4281,   247, -4281, -4281, -4281, -4281,  -612,  -725,
   -4281, -4281, -4281,   172, -4281, -4281, -4281, -4281,  2035,  -829,
    -668,  3502,   173, -4280, -4281, -4281, -1029, -4281,  2904, -4281,
   -4281, -4281, -4281, -4281, -4281, -4281, -4281, -2421, -4281, -4281,
   -4106, -4281, -4281, -4281, -4281, -4281,  2285,  2290,    61,   -53,
   -4281, -4281, -1199, -4281,  -512, -4281,  2571, -4281, -4281, -4281,
   -4281, -1598,   176,   613, -4281,     3, -4281, -4281, -4281,   373,
   -4281, -4281, -3149,     5, -4281, -4281, -4281, -4281, -4075, -4281,
       6,  -528,   902, -4281, -4281, -2588, -4281,   182,    24, -4281,
   -4281,     1,     2,   -43,   -33,   -27,     4,   131,  3024, -4281,
    3027, -4281,   -12,  1694, -4281, -4281,  -724,  -139, -4281,  1591,
    -582,  2266,  2970,  3022, -4281,  1583, -4281, -4281,  1592, -4281,
     944,  -513,  -384, -4281, -4281, -4281, -4281,   404,  -580,  2274,
   -4281,  3032, -4281, -4281, -4281, -1693,  1582, -3152,   975, -3168,
   -3111,   448,   435, -1363,  -180,    -2,  -702,  3028, -4281, -4281,
     980,  -352, -4281, -4281,  -348, -2606,   931, -4281, -4025, -2147,
    -479,  2688,  -967, -4281, -4281,  -929, 14740, -4281, -4281, -4281,
   15595, 15910, -4281, -4281, 15995, 16280, -4281,  -806,  1187, 17226,
   14109,  -952, -1646,    38, 12994, -2234, -1141, -2395, -4281, -3186,
   -2279, -4281, -4281, -4281,  -135,  1048,   807, -4281, -4281, -4281,
   -4281,    69, -4281,  -478, -4281,  -473, -4281, -4281, -4281,  -457,
   -3643,  2486, -4281, -4281, -4281,  -193, -4281,  6574,  1642, -4281,
    -962, -2520, -2532, -3012, -1672, -4281, -4281, -4281, -4281, -4281,
   -4281, -4281, -1542, -3046,  -399,  1713, -4281, -4281,  1802, -4281,
   -4281, -4281, -1151,  1662,  -762, -2422,  1717, -1875, -4281,  -742,
   -4281,  -683,  2491,  -701,    -5, -1223,  6572,  -437, -2067, -1158,
   -1437, -4281,   -34, -4281,    -7,   -16,    -8,  -131,  -192,  -404,
    3677, 13117,  -589, -1235,  9673, 12441, 12958, -2853
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    51,    52,    53,    54,  1432,  2305,  2190,  3027,  3028,
      55,    56,  1428,    57,    58,    59,    60,    61,    62,    63,
    1359,    64,    65,   957,  1554,  2316,    66,  2038,   734,   735,
     736,  1860,  1861,  2255,  1862,  1850,  1248,  1687,  1380,   708,
     709,  1341,  1381,    68,    69,  1242,  1841,    70,    71,    72,
    1409,  1410,  1353,  1595,  4029,  4681,  2862,  2165,  3067,  2863,
    2864,    73,  1480,  1481,    74,    75,  2994,  2990,  3563,  4340,
    4341,  4556,   555,  2284,  4343,  4344,  4542,  4543,  4705,  4815,
    4816,  2317,  1549,  3061,  3646,  3018,  4099,  3019,  4100,  3020,
    4101,  3005,  3594,  3595,  3596,  3021,  4072,  4581,  3022,  2057,
    4722,  2352,  1709,  1707,  4568,  3906,  3907,  4793,  4727,  4728,
    4729,  4895,  4074,  3065,  3652,  4108,  4356,  2751,   643,  1575,
    3170,   644,  2355,   587,   645,  2318,    81,  2346,  2347,  1451,
    2198,  3570,  3150,    82,   977,  3412,  4412,  4623,  4624,    83,
     220,    84,  1558,    85,    86,  2301,  3012,    87,  2074,  2768,
      88,    89,  2797,  2798,  2799,    90,    91,  3437,  4283,  1411,
    2851,  2852,  2853,  2854,  3463,    92,  1556,  1456,  2325,    93,
      94,    95,    96,    97,  2468,  2469,    98,  2242,    99,   100,
     101,   102,   103,  3499,  3995,  3623,  2891,  3034,  3621,   104,
    2319,  1566,  2337,  2338,  4088,  4375,  4592,  4377,  4944,  4945,
    4349,  3389,  3920,   106,   107,  4067,  4068,  4734,   108,  2072,
     109,   110,   111,  1533,  2293,  2294,  3571,  1527,  2287,  2288,
    3633,  3634,   112,  2947,   113,  3976,  3977,   588,  4739,  4688,
    4806,   114,   115,  3980,  3981,   116,   117,   118,   119,   120,
     637,  1068,  1069,  1326,  1016,   121,  1958,   122,   923,  2974,
     123,  1136,  2510,  4151,   124,   668,  1082,  1083,  2320,   126,
     677,  2488,   679,  1722,  3152,  3153,  3719,  2454,   821,   127,
     128,  2465,  2491,   129,  1346,  2048,  2049,  3901,  2321,   589,
    1581,  2359,  2746,  4487,  4488,  4261,  4503,  2676,  3342,   131,
     590,  1385,  2121,  2362,  3075,  2015,  2016,  2017,  3669,  2018,
    3077,  2019,  1320,  2020,  3083,  3084,  3085,  3665,  3672,  3675,
    4401,  4402,   132,  1383,  2119,   133,   134,   135,  1423,   852,
     136,   602,   603,   137,  4561,   138,   990,   139,  4410,   140,
     141,   699,   700,  1120,  1121,   142,   143,  2135,  3444,   144,
     145,   146,  3492,  3493,   147,   148,  4909,  4952,  4953,  4954,
    3680,  4854,   149,  4911,  1113,   151,   152,   153,   189,   886,
     887,   888,  2322,  4394,   155,   156,  1342,  1343,  1344,  1345,
    2043,   157,   158,   159,   160,   161,   162,  1537,   163,   164,
    4535,   165,   166,  1499,   167,  1278,  1279,   168,   169,   549,
     752,  1282,  1290,   170,   647,  1076,  1077,  1078,  1689,   171,
    1116,   925,   648,  1071,   173,   649,  2003,  2697,  3352,  3353,
    3356,  4246,  3882,   650,  2694,   176,  1729,  2474,  2477,  2690,
     651,  2702,  2703,  2704,  2705,  2706,  3359,   652,   670,   980,
    2368,   653,  1209,   181,   182,   183,   762,   756,   757,   185,
    1834,  2637,   686,  1297,   721,   722,   770,  3326,  1971,  1972,
    1994,  1995,  1306,  1307,  1984,  1986,  2678,  1987,  2686,  1977,
    3859,  4472,  4473,  4474,  4475,  4476,  4477,  4231,  1990,  1991,
    1309,  1310,  1311,  1999,   186,  2641,  3306,  3307,  3308,  3836,
    3837,  3851,  3847,  4215,  4458,  3309,  1111,  1317,  4223,  4926,
    3310,  4449,  4450,  4640,  3854,  3317,  3350,  3051,  3052,  3053,
    2021,  1624,  1018,  1210,  1019,  1638,  1211,  1608,  1021,  1212,
    1213,  1214,  1024,  1215,  1216,  1217,  1027,  1600,  1627,  1218,
    1219,  1618,  1635,  1636,  1678,  2548,  1221,  1222,  1223,  3312,
    1224,  3792,  4182,  4171,  2569,  2570,  1857,  3788,  3252,  1829,
    2627,  4481,  4657,  4658,  3291,  3817,  4198,  4447,  4773,  4861,
    4862,  1225,  1226,  1227,  2624,  1825,   854,  1228,  3573,  1827,
    2563,  2649,  2650,  1732,  1752,  2516,  2532,  2533,  2543,  3211,
    2551,  2556,  3239,  3240,  2564,  2593,  1229,  2518,  2519,  3195,
    1754,  1230,  1271,  1869,  1272,  1749,  2588,  1285,  1286,   754,
    1238,  1231,  1232,  1723,   745,  4454,   544,   811,  2879,  1949,
     890,   683,  1233,  1234,  1235,  1236,  1416,   826,  1038,  1039,
     545,   805,   828,  2855,   546,   547,   807,  1954
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     604,   179,   180,   174,   184,   175,   177,   761,   827,   684,
     713,   853,   983,   672,   671,   860,  1686,  1641,   952,   672,
     671,  1706,   180,  1243,   184,  1415,   878,  1651,  1102,  1103,
    1104,   543,   747,  1645,  1108,  1950,  1318,  1485,   594,  1239,
    2056,   744,  1321,   771,  1614,  1273,  3327,  3017,  1455,  1312,
    2713,  2715,   760,  1079,  2455,   586,  2130,  2122,  1497,  3175,
    1637,  2257,  1620,  1257,  1742,  2159,  1965,  1045,   636,   981,
    1604,  1605,   678,  2647,  3037,  2342,   859,  2210,  2515,  2142,
    1613,   646,  3674,  2131,  2944,   714,  1528,   877,  2668,  1450,
    1950,  3438,  3644,   808,   810,  1968,  1535,   814,  3581,   816,
    1540,  3629,    67,  3908,  3458,  1544,  3460,  3156,  1679,  4065,
    3874,  2881,  3320,  3358,  1551,  3946,   765,  3603,  3418,   874,
    1547,  1955,  3318,  3319,  1570,   937,  2224,  2225,  3903,  1073,
    3657,  1568,  4104,  1017,  4121,  2480,  1062,  4115,   983,  2982,
    4105,  1592,  3850,  3575,  2360,  2652,  2220,  2986,  2578,  2988,
    3575,   773,  3833,  3260,  1017,    76,   803,   774,    77,  2115,
      78,  4112,    79,  1989,    80,   822,   105,  2029,   707,   125,
    1955,   130,   150,   154,   992,   741,   172,  2425,  1449,  4387,
     759,  3364,   178,  3641,  1464,  4262,   772,  1382,  1305,   733,
    1308,  1601,  1602,  3772,  1490,  1250,   834,  3909,  3848,  4463,
    1567,  4465,  1612,   654,  4611,   864,  4511,  3887, -2177, -2212,
    4504,   870,  1593,  1625,   880,   553,   600,  4537,  4538,  1050,
    1356, -2234,  1347,  3217, -2263, -2109,  2236,  2231,  2143,  3008,
    1065,  1604,  1605,  1593,   654,  4269,  3663,  1620,  4260,  2966,
    3030,  1797, -2054,  1956,  4530,  3311,  1790, -2082,  1531,   819,
    1613,  1084, -1940, -2180,  2712, -2082, -2082,   600,  2586, -1940,
    1330,  1474,   654,  4687,  3804,   882,  3482,  1475,  1688, -2083,
    1803,  2586,  1593, -2418, -1697,  1132,  4507, -2083, -2083,  1088,
    3414, -2418, -2418, -1669,  1524,  3363, -1682,  2621,  2133, -1712,
    3419, -1712, -1709,   775,  2622,   750, -2051,  2295,  3311,   600,
    1805,  4575,   600,   942,   600, -2053,  2447,  4741,  2133,  2452,
    2040,  3214,  3215, -1702,  2762,  3173,  3234,  1412,  4562,   654,
    1247,  3193,   654,   600, -1702,  1357,  4244,  1348,  4718,  4664,
    2868, -1697,  4852,  3009,  1099,  2886,  3160,  1331,  4605,  4621,
    3122,  3217,  3124,  1601,  1602,  4012,  4606,   654,  1356,  4576,
    2308,  3111,  2201,  3264,  3265,  1514,  3597,  4577,   883,  1106,
    -834,  3313,  3609,  2481,  4566,  2889,  1476,   660,   660,  1612,
   -2233,  3483,  3164,   776,   719,  1295,  1797,   947,   853,  2271,
     660, -1702,   947,   660,   660,  4578,  4803,  2640,  1332,   661,
     661,  1465,  1274,   947,  3316,  4155,  2252,  4157,  2150,   866,
     884,   550,   661, -1959,  4031,   661,   661,  2133,  2253,  2133,
   -1959,   669,   660,   944,  3313,   945,  2134,   669,  2141,     3,
       4,  1505,  1593,  2778,  4032,   867,  1466,   853,  1497,  2151,
    1467,  4265,  2890,  2254,   661,  1805,  3360,  2272,   946,  4649,
    1107,  1520,  4683,   955,  1643,  1851,  3165,  1791,  1632,  4804,
    1863,  1863,   885,  1357,   965,  1530,  1468,  1797,  2133,  2309,
    4579,  2887,   935,  4602,  2062,  4844,   938,  2218,  3217,  4719,
     720,  1296,  1594,  1957,  1349,  1837,  1325,   983,  2448,  4665,
    2133,  1333,  2202,  2133,   963,  2203,  1803,  1269,  2450,   983,
    2265,  1270,  2456,  1594,  2458,  1100,  2269,  2461,  4622,  1622,
    4853,  3010,  4013,  4607,  2470,  3419,  2297,  2490,  4670,  1350,
    2449,  2144,   820,  1477,  3415,  3610,  1805,  4675,  3484,  4245,
     837,  2869,  2145,   932,  2146,  4270,   601,   838,   839,   840,
    4717,  2039,  1594,  2695,  1674,   924,  -134,  1659,  3161,  1351,
    1033,  -134,  1532,  2453,   889,  1669,   983,  1275,  1478,  1276,
     930,  1677,  2967,  3485,  2101,   929,   180,   926,   184,   927,
     928,  2237,  1422,  3961,  2109,  2133,   943,  2584,  1690,  3664,
    1507,   595,   987,  1107,  3512, -1940,   777,  -396,  1479,  4353,
    2147,  2587,  1036,  3486,  3011,   982,   604, -2233,   751,  4812,
    2232,  4388,  2801,  1080,  3280,  1358,  1593,  2763,  2512,   761,
    1832,   922,  1352,  1746,  1626,  2206,  2517,  2208,  3561,  3562,
    2623,  1496,  2876,  1107,  1621,  3575,  1728,  4791,  1532,  1269,
     554,  4942,  2339,  1270,  2471,  1337,  2443,  1338,  2196,  3598,
    2549,  2199,  2200,  4580,  1313,  1676,  1731,  4404,  2567,  2215,
    1955,  2375,  1652,   180,   760,   184,  3104,  1081,   671,  1086,
     671,  1090,   671, -2233,  3913,  4905,  2260,  1094,   671,  1095,
    1096,  3232,  3850,   983, -2177, -2212, -2233,  2256,  2429,   666,
     667,   983,   983,  1114,  1643,  4080,  2099, -2234,  3382,  1824,
   -2263, -2109,  1594,  1072,  1110,  3360,  1955,  4212,  1269,  4111,
   -2054,  4216,  1270,  1097,  1122, -2082,  2289,   666,   667,  1133,
    2266,  4161,  1724,  1075,  1615,  2451,  1615,  1240,  2397, -2180,
    1249,   982,  1251,  1734,  2462,   853,  1599, -2083,  4206,  1244,
    1845, -2418, -1697,  1616,  4880,  1616, -1959,  1599,  1743,   773,
    2000,  1603,  2001,  2176,  1607,   774,  4885,  1617,  1267,  1619,
   -1709,  4092,  4249,  1420,  1421,  1110,  3366,  1793,  3367,  2118,
    1835,  4865,  2655, -2053,   666,   667,    39,  1413,  1414,  2063,
    1294, -1702,  2219,  2677,   772,   179,   180,   174,   184,   175,
     177,  4669, -1702,  4497,  3338,  1316,  3229,  3230,  3231,  3232,
    4506,  2802,   666,   667,  3935,  2340,  2511,  3965,  2514,    43,
    1797,  4187,  3867,  2820,  2521,  1950,   600,  3625,  1277,  1643,
    2535,  2536,  2537,  1034,  2378,  2379,  4933,  2472,  3648,  4421,
    2553,  2555,  1280,  4422,  4423,  2565,  4424,  2776,  1362,  1803,
    4827,  4845,   600,  2050,  3718,  1522,  2473,   596,   671,    47,
     600,  1419,  2110,  1508,  2992,  3641,  3949,  3547,  4408,   973,
    3895,  3162,    48,  2064,  3551,  3552,  4051,  1727,  3555,  1805,
    4672,  4673,  1545,  1546,  4653,  3560,  1594,  1833,  2877,  1502,
    4342,  2942,  2902,    49,  1259,  2525,    67,   600,  2350,  3513,
    1509,  2183,  2727,  1579,  1246,   548,  2858,  2696,  1254,   597,
    2647,  2647,  2647,  1847,  1412,   600,  1287,   600,  4050,   654,
     766,  4601,  1821,  1822,  1823,  1824,  3725,  2052,   681,  4920,
    2115,  3227,  3228,  3229,  3230,  3231,  3232,  3311,   768,  3311,
    2688,  3553,  3554,  1340,   598,  2053,   599,  2902,  2628,    76,
    2111,  4904,    77,  2865,    78,  3676,    79,  2859,    80,   640,
     105,  2353,  3885,   125,  1978,   130,   150,   154,  1543,  1582,
     172,  2341,  2737,  2180,  1647,  1649,   178,  3431,   600,    14,
    1430,   767,   843,   844,   845,   685,   846,   847,   848,   849,
     850,   851,  1573,  1576,  1577,   691,  2526,  1763,  3616,  2928,
    4096,  1431,  1979,   693,  2210,  2929,  -134,  -134,  3908,  2350,
    3950,  2735,    19,  3058,  3752,  3753,  3754,  3755,  3311,  1848,
    3760,  3761,  3762,  3763,  3764,  3765,  3766,  3767,  3768,  3769,
     707,  1459,  2158,   974,  4127,  3677,  2689,  4096,  4389,  3361,
    3330,  1330,  4939,  3432,  2860,  4723,  2050,  2459,  2460,   768,
    2738,  4390,  4451,  3313,  2261,  3313,  1791,   692,  1585,  4891,
    3572,  4921,  4358,  2051,  3076,  2527,  1494,  3572,  3726,  2277,
    2606,  4452,  2213,  3163,   568,  1614,  3808,  3809,  2629,  2054,
     982,  2993,  2720,  2943,   694,  4409,  3617,   975,  2298,  3909,
    2333,  4455,   982,   976,  3006,  2351,  4459,  4735,  2973,  4461,
    1981,   671,  3909,  3336,  2930,  2371,  3502,  2792,  4756,  1006,
    2777,  1260,   180,  4746,   184,  4314,  2894,  4754,  1331,  3951,
    2052,  4747,  3952,  1079,   768,  2528,  1730,  2410,  2529,  3324,
    1244,  1849,   570,  4828,  3313,  2364,  4749,  1692,  2053,  1694,
    1586,  1696,  2377,  1698,  3670,  1700,  1701,  1702,  2372,   982,
    3674, -1669,  1704,  1728,  2401,  1982,  1244,   882,  2405,  4633,
    1017,  4383,  4724,  4150,  2411,  2412,  3618,  3575,  4875,  1332,
    2334,  4359,  2386,  3678,   769,  1751,    31,  1261,  3973,  1975,
    2064,  2055,  2793,  4379,  4940,  2059,  4429,  2428,  1469,  2749,
    1128,  2373,  1587,  2895,  1760,   761,  2861,  4097,  1559,  2435,
    2607,  2423,  4255,    39,    39,  2608,  4372,  3583,  1085,  1087,
    1089,  4391,  4061,  1091,  1092,  1093,  2420,  2158,  2792,  1017,
     718,  2717,  2530,  1098,  1792,  1776, -1669,   695,  1495,  1470,
    4725,  4284,  2792,  1794,  4841,   742,    43,    43,  3679,  1560,
    1788,  2609,  3909,  2750,  4918,  2896,  2541,  1836,  4892,  1628,
     883,  2931,  3586,  1819,  1820,  1821,  1822,  1823,  1824,  1961,
    3147,   853,  1333,  4846,   696,   697,   982,  4510,  2402,  1853,
    1854,  1976,  2054,  4667,   982,   982,    47,    47,   671,  3974,
     578,  2415,   579,   671,   671,  1588,  2932,  1628,  2806,    48,
      48,  1867,   884,  2793,  1969,  1970,  2424,  1974,  2673,  2897,
     774,   774,  4851,   774,  3619,  3510,  1548,  2793,  4748,  2466,
      49,    49,  1334,  -621,  1563,  3860,  2933,  2065,  1629,  4893,
    3978,  2243,  3947,  4529,    50,    50,  2531,  2687,  1435,   772,
     772,  4248,   772,  2153,  1564,  2044,  1589,  2794,  4645,  3963,
    2004,  2796,  1316,  4894,   885,  2045,  4971,  1335,  2579,   693,
    4634,    34,  4062,   698,  1413,  1414,  1629,  2250,  3867,  1661,
    2335,  3250,  2046,  1436,  4235,  4228,   660,  3257,  2610,  3620,
    4682,  3511,  2795,  2336,  2055,  3975,  2807,  1336,  1630,  4903,
    2674,  1631,  4058, -1669,  4906,  1643,  1471,   671,   661,  4351,
    2467,  2313,  2251,  2898,  3590,  2326,  1561,   671,  2066,  4147,
    1662,  2226,  2227,  2228,  2229,  3964,  1337,  2243,  1338,  2718,
    1301,  3119,  2719,  4788,  2126,  1302,  1630,  4515,  2910,  1631,
    1590,  3979,  3125,  2149,   753,  2937,  2913,  3120,  2915,   882,
     694,  1260,  2058,  3591,  2549,  2549,  1095,  1096,  4949,  2549,
    2094,  1643,  3094,  4596,  2267,  2268,  4628,  3592,  4041,  3897,
    2909,  2185,  2796,  2280,  4044,  4045,  1339,  4047,   763,  2192,
    2059,   671,  2195,  2292,   671,   671,  2796,  2273,  2214,  3575,
    2818,  2663,  4795,  4796,  3311,  1632,  2549,  2549,  3311,  1303,
    1472,  2403,  4451,  3439,   983,  1565,   568,   853,  1643,  2217,
    1562,  2328,  2329,  2330,  2331,  3334,  1427,  1261,  2230,  2047,
    4975,  2314,  1839,  2899,  3406,  2160,  4589,  3909,  2274,  2243,
    1128,  2900,  2247,  1632,  2901,  1301,  3430,  3892,  3714,  1304,
    4091,  3875,   883,     3,     4,  2259,  3042,  3043,  3044,  3045,
    2068,   764,  3572,   671,  3756,  3593,  3757,  4685,  3050,  2908,
    2069,  4690,  4691,  1402,   570,  3407,  3916,  3377,  2836,  3738,
    4362,  4590,  3108,  1452,  3092,  2745,  4165,  1663,  4166, -1669,
    1340,  2921,  2782,  2838,   884,  1340,  2210,  1840, -1669,  2323,
    1603, -1669,  1325,   695, -1669,  2310,   778,  2315,  4536,  1633,
    3876,   640,  4591, -1483,  1303,  2181,  2414,  2370,  1453,  2417,
    3313,  2961,  2647,  4363,  3313, -1483,  2344,  2060,  1634,  2422,
   -1483,    14,  4059,  2356,  2837,  2207,   853,   966,  2430,  -998,
     696,   697,  3109,  2934,  1340,  3216,   885,  1633,  1340,  2839,
    1402,  3898,  4266,  3917, -2073,  -419,  2749,  3244,  -156,  2732,
    2376,  2774,  1691,  3514,    19,  1693,  2400,  1695,   967,  1697,
    2384,  1699,  2385,  2789, -1483,  1703,  2161,  4564,  2935,  2390,
    2182,  1664,   551,  3899,  -156,  1610,  1611,  2396,  3758,  3267,
    4131,  3840,  4132,   813, -1483,  2275,  1256,  4060,  3759,  3440,
     968,  4753,  3707,  2162,  3900,  4930,  4740,  3149,  2936,  3918,
    3385,  3919,  3494,  2822,  2070,  4533,   187,  4267,  1978,  1454,
    4167,  2464,   578,  3909,   579,  3441,  2163,  3293,  2164,  3747,
    3717,  3388,  3408,  1269, -1483,  2434,  4534,  1270,  2938,  1632,
     822,   815, -1483,   180,   715,   184,   969,  4737,  1548,  2071,
    2138,  2955,  2139,   948,  2670,   949,  1979,  1475,  3773,   188,
    1643,  2158,  3841,  1430,  -419,    34,  1322,  2589,  2939,  3718,
    3070,   187,  1438,  1244,  1244,  2437,  2487,  2438,  4420,  2439,
    2815,  2440,  3649,  2441,  1431,  3653,  2475,  2442,  4764,  2276,
    2482,  2187,  3842,  4620,   929,   180,   926,   184,   927,   928,
    3365,  1323,  3916,  1075, -1483,  2534,  2720,  3843,  2140,  2892,
    1980,  2523,  2524,  1430,   188,  3674, -1483,  3844,  2538,  2539,
    1439, -1483,  1532,  1855,  3405,  1615,  3409,  2295,    31,  4679,
    1615,  1324,  4771,   187,  1431,  4676,   983,   836,  4514,  1796,
    2940,   835,  1797,  3845,  1616,  4720,  2577, -1519,   872,  1616,
    2486,  2397, -1519,  3840,  1981,    39,  1476,   881,  2509,  4772,
    3841,  4616,  4456,  1617,  1856, -1483,  1603, -1483,  1325,  2592,
    2941,  1803,  3000,  3311,  4361,  4850,   188, -2419,  3311,  3917,
    4540,  4345,  4493,  3311,  4495, -1483,  3311,  2638,    43,  3583,
    3842,   568,  2201,  3088,  2724,  3584,  2656,  2653,   983,  2728,
    4382,  1805,  1440,  2731,  4370,  4218,  3585,  1863,   931,  1982,
    3311,  4346,  2168,  1327,    39,  3844, -1519,   654,  4273,  4274,
    3097,  3846,  1797,  3311,  3841, -1483,  1615,  1269,    47,  2755,
    1291,  1270,   641, -1483,  3586,  3918,  3587,  3919,  4710,  2169,
     934,    48,  3118,  4711,   654,  1616,  2150,    43,  1328,   570,
    1441,  1803,   853,  1442,  3842,  3137, -1519,  3127,  -525,  1619,
    3129,  3130,    49,  2209,   936,  3133,  3134,  2311,  4335,  3843,
    4336,  4337,  3138,  2808,  4338,  1671,   642,  2151,  1329,  3844,
     966,  1805,  2023,  3713,  3397,  3325,  2343,    47,  4712,  3313,
    4426,   947,  1444,  2594,  3313,  2595,  1672,  1301,   939,  3313,
      48,  4457,  3313,  4798,  4763,  3845,  1750, -2419,    50,  3479,
    3914,   967, -2419,  3588,  2664,  3468,  2667,  2024,  2596,  3846,
     953,    49,  2202,  2856,  1252,  2203,  3313,  3630,  3469,  2679,
     671,  3322,  3323,  1446,  3177,    50,  3639,  2160,  -524,  3313,
    2772,  2773,  3420,  3627,  3480,  1843,  3328,  2025, -2419,  2784,
     961,  2786,  2814,  1244,  4014,  2790,   970,   947, -1483,    39,
    3167,  2904,  4941,  3311,  2698,   180,  1303,  3443,  2684,  2685,
    4966,  3589,  1448,   561,  3481,  4015,  3590,  3179,  3784,  2916,
    2739,  1280,  2742,  3846,  3572,   972,  4533,   982,  3185,   969,
    2926,  1681,    43,  1812,  1682,  2736,   671,   578,  1736,   579,
     221,  1737,  2770,  2951,   971,   552,  1304,  4534,  1959,   822,
    3278,  1960,   947,   638,  2188,  3591,  4787,  2597,  2893,  2191,
     985,  4877,  2598,   584,  2366,  3311,  2367,  2599,   983,  3592,
    3047,   716,    47,   989,  1032,  3048,  3189,  2549,  2549,  2549,
    2549,  2432,  4533,  2549,  2549,  2549,  2549,  2549,  2549,  2549,
    2549,  2549,  2549,  2647,  2800,   568,  1251,  3190,  2647,  3948,
    3953,  3944,  3191,  4534,  2647,  3936,  2911,  3728,  2240,  2512,
    3782,  1040,  2246,  2958,  3423, -2419,  -992,  1041,  2161,  3313,
      50,  2670,  1796,  1066, -1482,  1797,  4707,  1046,  4709, -2419,
   -2419, -2419,  4713,  1433,  4714,  1070, -1482,  3370,  3582,  2549,
    2549, -1482,  1603,  3048,  2030,  2162,  2847,   654,  1482,  3688,
    3689,  1486,  1962,   570,  1803,  1963,  3966,  3593,  1057,  3243,
    1804,  3245,  3246,  3733,  2972,  1101,  3599,  2874,  2163,  1269,
    2164, -2054,  2981,  1270,  2983,  3294,  2431,  3295,   983,  2432,
    2985,  3313,  3894,  2444,  1805, -1482,  2445,  1603,  3474,  2030,
    1105,   671,  2446,  4627,  2600,  2445,  1603,  3038,  2030,   671,
    4962,   671,  4541,  2158,  2601, -1482,  2478,  2669, -2419,  2479,
    2670,  2812,  2512,  1109,  2813,  1819,  1820,  1821,  1822,  1823,
    1824,  2883,  4114,  2160,  2884,  3296,  2997,  3297,  3001,  2998,
    1141,  3002,  2865,  3217,  3962,  3395,  3391,  3218,  3219,  3220,
    3063,  3095,  3064,  3311,  2432, -1482,  3141,  2975,  4967,  2445,
    4968,  3749,  3060, -1482,  3797,  2975,  3269,  3188,  3270,  3197,
    2432,  3203,  2432,  2975,  2432,  2975,  3204,  4928,  3311,  2432,
    1141,  3154,  3205,  3217,  1291,  2432, -1471,  3218,  3219,  3220,
    3236,  3271,  1112,  2432,  3249,  3778,  1115,  2432,  3254,  3168,
    1806,  3255,  3398,  3461,  3798,  1807,  3462,  3154,  1117,  4585,
    4951,   578,  1118,   579,  3032,  3911,  3912,  1125,  3121,  3410,
    3123,  3041,  3466,   581,  3661,  3467,  3448,  3662,  3450,  3686,
   -1543, -1543,  2432,  2221,   583,  3779,  3572,  1548,  3780,  1126,
    3820,  1810,  3731,  3374,  3375,  3076,  1119,  3789,  4102,  2160,
    3790,  3071,  1128,  3800,  3883,  1141,  2432,  3884,  3217,   982,
    3059,   180,  3218,  3219,  3220,  1127,  1129,  3039,  4400,  3313,
    4874,  1130,  3888,  3893,  2161,  3889,  2719,  3915,  1131,  4981,
    2445,   766,  1135,  3734,  3988,  2160,  1812,  3989, -1482,  4093,
    3103,  3105,  2445, -1520,  3313,  3272,  3615,  3114, -1520,  4144,
    3273,  2162,  1728,  4162,  4188,  4200,  2432,  2479,  2432,  4251,
    1134,  4257,  2719,  3487,  4258,  3489,  1796,  1137,  1255,  1797,
     853,   982,  3187,  1258,  2163,  4263,  2164,  4052,  2445,  4053,
     983,  1262,   983,  4264,  3222,  4384,  2445,  3533,  4385,  3110,
    3112,  3113,   767,  3540,  4612,  2894,  2397,  4431,  1803,  2249,
    4432,  1263,  1264,  3932, -2419,  2549,  1268,  1281,  4433,  2158,
     671,  2432, -1520,  1299,  3311,  3023,  3721,  4441,  1814,  3178,
    2479,  1298,  1289,  1300,  3222,  3182,  3534,  4512,  1805,  4586,
    4513,  4613,  2445,  4629,  4614,  2803,  2479,  3600,  3171,  3602,
    2161,  4217,  3339,  4220,  3223,  1288,  3497,  4138,  4139,  4140,
     983,  3548, -1520,  1291,  1292,  4637,  3505,  2160,  4638,  1497,
     768,  1314,  4642,  4648,   761,  2670,  3637,  2162,  4650,  1315,
    4662,  3637,  2895,  4663,  1319,  1325,  2161,  3274,  3221,  4700,
    4736,  1355,  4701,  1842,  3223,  4755,  1360,  3275,  4663,  3371,
    2163,  4765,  2164,  3266,  2479,  4766,  1386,  4767,  3255,  3222,
    2432,  4777,  4780,  2162,  2670,  3637,  1388,  3667,   761,  1788,
    1384,  1815,  1389,  3856, -2419, -2419, -2419,  1424,  1819,  1820,
    1821,  1822,  1823,  1824,  2896,  2158,  2163,  1425,  2164,  1422,
    3313,  1426,  3393,  4802, -2419,  3684,  2479,  4808,  4809, -2419,
    2479,  2479,  4835,  2822,  4382,  4836,  4866,  4867,  2571,  2670,
    2432,  2574,  1427,  1788,  3861,  3862,  3863,  2878,  1434,  3223,
    1429,  2158,  3695,  3696,  1437,  3698,  3314,  3700,  3701,  4282,
    2592,  1460,  1461,  3024,  3685, -2419,  1473,  1483,  2897,  3608,
    3708,  3611,  3299,  3300,  3301,   769,  3287,  4868,  3298,  1484,
    2432,  4870,  2160,  4887,  2432,  1487,  4888,  4924,  2161,  1492,
    3637,   982,  3305,  4927,  4950,  1493,  4656,  4663,  3329,  4964,
     671,  4990,  4965,   761,  4965,  1498,  1500, -2326,  3729,  3314,
    1812,  1501,  3224,  3225,  3226,  2162,  3227,  3228,  3229,  3230,
    3231,  3232,   929,   180,   926,   184,   927,   928,  1503,  3401,
    3470,  3402,  3403,  3404,  1506,  4559,  1510,  1511,  2163,  1517,
    2164,  1518,  1521,  3490,  1523,  3305,    28,  1526,   760,  1529,
    1536,  1539,  3224,  3225,  3226,  1955,  3227,  3228,  3229,  3230,
    3231,  3232,  2898,  1532,  1541,  1552,  1550,  3742,  1553,  -177,
    1555,  1557,  4048,  2158,  1569,  4036,  1571,  1578,  1580,  2160,
    1584,   206,  3509,  1591,  2512,  1596,  1597,  1598,  3751,  1599,
    1603,  1607, -2419,  1606,  1609, -2326,  1623,  1639,  1640,  1642,
    1643,   982,  3025,  1650,  3494,  1653,  1654,  1655,  1656,  1657,
    1658,  1660,  1665,  3774,  1666,  1667,  1668,  4545,  1670,  3727,
    1675,  1680,  3545,  2161,  1705,  1733,  1738,  3224,  3225,  3226,
      39,  3227,  3228,  3229,  3230,  3231,  3232,  1740,  4322,  4323,
    1747,  4325,  1741,  1748, -2326,  3026,  1755,  1731, -1673,  1796,
    2162, -1680,  1797,  3339,  1756,  1758, -2326,  1757,  1759,  4546,
    3339, -2326,    50,    43,  1761,  1762, -2326,  1763,  4172, -1670,
   -1671, -2326,  2899,  2163, -2326,  2164,  4183, -2326,  1764,  3515,
    2900,  1803, -1674,  2901,  4547, -2419,  1765, -2419,  3464,  1766,
    1768,  4124,  1819,  1820,  1821,  1822,  1823,  1824,  1769, -1672,
    4548,  1830,  4400,    47,  4549, -2326,  2160,  1770,  2158,  1828,
    1771,  1805,  1772,  2160,  1832,  1773,    48,  4907,    28,  1774,
    2161,  1775,  1777,  3549,  4550, -2326,  2160,  4551,  1833,  1778,
    1779,  1780,  3503,  3495,  1846,  1866,  1781,    49,  1782,  1783,
    4552,  1842,  1784,  1858,  1967,  1302,  1996,  2162,  1304,  1998,
    2007,    50, -1251,  1141, -1251,  4141,  3217,  2026,  2027,  2028,
    3218,  3219,  3220,  2030,  2031, -2326,  2032, -2326,  2034,  2033,
    2163,  2035,  2164, -2326,  2036,  2042,  3277,  4190,  2061,  2067,
    1796,  3536,  2073,  1797,  2096,  2100,  2104,  1798,  1799,  1800,
    1141,  2102,  2105,  3217,  2243,  2103,  2108, -2419, -2419, -2419,
    2107,  2123,    39,  2975,  1801,  2158,  3544,  2124,  2125,  3716,
    2975,  2975,  1803,  3937,  2975,  2136,  2137, -2419,  1804,  2148,
    4553,  2975, -2419, -2326,  3564,  2154,  3967,  2152,  4554,  2155,
    3574,  2157,  2158,  2166,  3730,    43,  2156,  3574,  2170,   671,
    2167, -2328,  1805,   982,  2171,   982,   671,  2161,  2172,  2177,
    4367,  2186,  2197,  2178,  2161,  2204,  2189,  2193, -2419,  1402,
    3604,  3605,  2233,  2194,  2234,  4555,  2216,  2161,  2205,  3612,
    2211,  2212,   685,  2549,  2162,    47,  3614,  2262,  3702,  2238,
    3703,  2162,  4434,  3635,  3705,  2222,  2223,  2235,    48,  2244,
    2239,  2263,  3631,  2248,  2162,  2264,  2270,  2163, -2326,  2164,
    2278,  3640,  3642,  1812,  2163,  2279,  2164,  2281,  2282,    49,
    2285,  2291,  3666,   982,  2296,  2283,  2299,  2163,  3660,  2164,
    3656,   180, -2326,  4908, -2326, -2326,  2300,  2303,  4102, -2328,
    2290,   563,  2158,  2307,  2312,  2304,  2327,  2345,  3736,  2158,
    1454,  3687,  3683,   180,  2332,  2349,  2348,  3222,  1806,  2357,
    2363,  2365,  2158,  1807,  4544,  2361,  2369,  2374, -2326,  2380,
    2382, -2326, -2326, -2326,   822,  2389,  2404,  2383,  2406,  2387,
    2391,  2388,  2392,  2393,  1808,  1809,  2394,  2395, -2328,  2407,
    2408,  2409,  2426,  2457,  4078, -2419,  2427,  2463,  2476,  1810,
   -2328,  2489,  2517,  2522,  2566, -2328,  2572,  1797,  1321,  3814,
   -2328,  2576,  2591,  2585,  2603, -2328,  1110,  3223, -2328,  2605,
    2625, -2328,  2626,  2640,  2657,  2654,  2660,  2658,  2671,  1244,
    2661,  1811,  2662,   767,  2672,  2680,   671,  4130,  2682,  2683,
    2693,  2699,  2708,  2681,  1812,  4133,  4134,  4135,  4136, -2328,
    2709,  2711,  2721,  2722,  3223,  4916,  4917,  2723,  4241,  2740,
    2754,  2743,  2745,  2747,  2764,  4076,  4077,  2748,  2759, -2328,
    2765,  2767,  2769,  2771,  2787,  2779,  2788,  2775,  4081,  2791,
    2804,  2805,  2810,  1252,  3933,  1256,  2826,  2821, -2419,  2827,
    4641,  2840,  2845,  2846,  2872,  1819,  1820,  1821,  1822,  1823,
    1824,  4641,  2867,   761,  2873,  2875,  3795,  2885,  2903, -2328,
    2964, -2328,  2882,  2946,  2957,  2888,  2965, -2328,  2968,  2969,
    2970,   761,  2978,  2976,  2979,  2977,  1814,  2984,  3314,  2980,
    3314,  2987,  2995,  2989,  2996,  3339,  2991,  3015,  3029,  3003,
    3031,  3033,  3822,  3823,  3824,  3825,  2549,  3040,  1788,  3046,
    3054,  3056,  3057,  3049,  3826,  3827,  3828,  3066,  3055,  3068,
     892,  3069,  3072,  3073,  3829,   893,  3832, -2328,  3927,  3928,
    3929,  3930,  3086,  3087,  3089,  3090,  4698,  3091,  3093,  3098,
    4239,  3096,  3099,  3100,  1731,  4988,  4989,  3101,  3115,  4016,
    1632,  3117,  4019,  3126,  3128,  3224,  3225,  3226,   894,  3227,
    3228,  3229,  3230,  3231,  3232,  3102,  3107,  3131,  3116,  3314,
    3132,   895,   896,  3136,  3135,  3140,   685,  3143,  3144,  1815,
    3145,   897,  1816,  1817,  1818,   898,  1819,  1820,  1821,  1822,
    1823,  1824, -2419, -2419, -2419,  3155,  3227,  3228,  3229,  3230,
    3231,  3232, -2328,   899,  2670,  1676,  3146,  3148,  2490,  3158,
    3157,  3159,  3166,  3174,  1107,  3176,  3181,  3169,  3184,  3183,
    3180,  3186,  3199,  3202,  4271,   900, -2328,  3251, -2328, -2328,
    3200, -1932,  3201,  3206,  3268,  3207,   901,  3209,  4354,  3212,
    3213,  4778,  3235,  2432,   902,  3285,  3290,  3345,  3263,  3347,
    3351,  3355,  4083,  3368,  3376,  3316,   903,  3276,  4290,  4291,
    3241,   904, -2328,  3248,  4272, -2328, -2328, -2328,  3341,  3349,
    3378,  3362,  3574,  3262,  3379,  3286,  3288,  3387,  3289,  3292,
    3383,   671,  3321,  3390,   905,  3392,  4544,  3400,  3427,  3416,
    4631,  3417,  3429,  3433,  3384,  4289,  3434,  3435,  3436,  3446,
    3447,  3449,  4704,  3455,  3456,  3997,  4056,  3457,  3998,   906,
    3999,  3465,  3996,   671,  3475,  3496,  4304,  3498,  3501,  3500,
    3504,  4686,  4557,  4689,  4467,  4492,  3506,  3518,  3507,  1790,
     907,  4482,  3519,  3508,  3520,  3523,  3531,  4332,  4333,  3526,
    3535,  3516,  3528,  3517,  3530,  3537,  3154,  3521,  4694,  3539,
    4696,  3522,  2231,  3550,  2975,  3524,  4280,  3525,  3527,  3556,
    2975,  2975,   908,  2975,  3529,  3532,  3541,  3557,  3543,  3564,
    3559,  3566,  3576,  3579,  4331,  3606,  3622,  3607,  3624,  3613,
    3626,  1095,  1096,   909,  3628,  3636,  3645,  1141,  3647,  3637,
    3217,  3650,  3654,   206,  3218,  3219,  3220,  4054,  3651,  3655,
    3658,  3659,  3671,  3682,  1625,  3709,  3690,  4064,  3710,  3697,
    3699,  4191,  3711,  3691,  3712,  3720,  3722,  3723,  3724,  4318,
     910,  3732,  3735,  3737,  3741,   911,  3238,   912,  3693,  1750,
    3217,  4413, -1931,   913,  4414,  4415,   914,  3715,  3237,  3775,
    3776,  3750,  4085,  3791,  3802,   768,  3815,  3831,  3858,  3777,
    4419,  3803,  4820,  4822,  3878,  3881,  3783,  3806,  3855,  3886,
    3853,  4814,  4113,  4405,  3896,   915,  3902,  3923,   916,  3925,
    2356,  3873,   917,  3821,  3871,  4109,   180,  3839,  3926,   918,
    3868,   919,  3870,  4583,  3872,  3938,   920,  4948,  3931,  3939,
    3940,  3941,  3943,  4770,  3954,  3945,  3969,  3957,  3970,  3990,
     853,  3971,  3972,  3984,  3982,  4779,  3983,  3985,  3986,  1731,
    4781,   921,  4783,  3987, -2342,  3991,  3993,  4003,  4004,   680,
    3994,   682,  4011,  4028,  2434,   688,  4500,  4026,   671,  4030,
     702,   710,   680,  3949,   717,  4033,  4152,   710,   710,  4152,
     746,  4152,   749,  4636,  4039,  4040,  4042,  4043,  4046,  3673,
    4948,  4055,  4066,  4063,  4706,  4086,  4087,  4073,  4071,  4095,
    4889,  4106,  4107,  4079,  2445,  4089,  4120,  4122,  4125,  4948,
    4521,  4090,  4119,  4123,  4126,  4137,  4142,  4146,  4128,  4148,
    4149,  3222,  4164,  4153,  4154,  4174,  4129,  4156,  1796,  4159,
    4168,  1797,  4173,  4175,  4169,  1798,  1799,  1800,  4299,  4176,
    4177,  4181, -2342, -1933,  4213,  4221,  4214,  4196,  4209,  4208,
    4309,  4222,  1801,  4211,  4229,  4226,  4227,  3339,  4230,  4240,
    1803,  4232,  4247,  4233,  4250,  3314,  1804,  4234,  4252,  3314,
    4254,  4259,  4268,  4260,  4293,  4285,  4294,  4202,  4203,  4204,
    4205,  3223,  4286,  4305,  4308,  4292,  4814,  4315,  4317,  4320,
    1805, -2342,  4321,  4326,  4334,  4347,  4365,  4339,  4348,  4355,
    4360,  3305,  4364, -2342,  4366,  3305,  4368,  4371, -2342,  4374,
    4376,  4386,  4236, -2342,  4238,  4395,  4396,  4397, -2342,  4393,
    4398, -2342,  1363,  4934, -2342,  4406,  4427,   804,   809,   809,
     812,  4411,   809,  4417,   818,  4418,   804,  4253,   746,  4428,
    4430,   855,  4437,  4438,  4242,   180,  4435,   746,  4439,  4516,
     746,  4446, -2342,  4460,   809,  1364,   746,  1141,  4440,  4453,
    3217,  4480,  4464,  4626,  3218,  3219,  3220,  4486,  4484,  4489,
    4494,  4505, -2342,  4508,  4509,  4324,  4490,  4518,  4558,  4523,
    4524,  4539,  4560,  4528,  4062,  1365,  4570,  4567,  4569,  4572,
    4328,  4588,  4573,  4594,  4574,  4593,  1806,  4595,  4603,  4598,
    4600,  1807,  4615,  4287,   671,  4604,  4617,  4619,  4618,  1731,
    4632,  4635, -2342,  1366, -2342,   983,  3154,  4639,  4644,  4647,
   -2342,  4651,  1808,  1809,  4652,  4656,  4302,  4303,  4654,  4680,
    4678,  4306,  4307,  4660,  3574,  4721,  4693,  1810,  4668,  4726,
    4733,  4671,  4738,   671,  4730,  4750,  1367,  3534,  4731,  4744,
    4751,  4752,  4759,  4760,  4761,  4768,  4762,  4776,  4381,  3224,
    3225,  3226,  4785,  3227,  3228,  3229,  3230,  3231,  3232,  1811,
   -2342,  4786,  4790,  4769,  4801,  4329,  4330,  4789,  4805,  4782,
    4792,  1368,  1812,  4699,  2975,  1813,  2975,  2975,  4797,  4687,
    2975,  4819,  4357,  4825,  4826,  4829,  4831,  4834,  4837,  4839,
    1731,  4840,  4847,  4849,  1731,  1731,  1796,  4848,  4864,  1797,
    4883,  4855,  4856,  4890,  1369,  4827,  4898,  3816,  4828,   685,
    3154,  4919,  3154,  4925,  4938,  4959,   853,  4963,  4876,  4969,
    4970,  4878,  4973,  4897,  4378,  4902,  4977,  4957,  1803,  4978,
    4958,  4982,  1370,  1371, -2419, -2342,  4983,  4960,  3035,  4984,
    4985,  3222,  4986,  1458,  2245,  1387,  4380,   180,  3331,  3339,
    2871,  1457,  3960,  4399,  1814,  2956,  3442,  1865,  1805, -2342,
     853, -2342, -2342,  3565,   983,  1293,  4049,  1372,  4794,  4715,
    4407,    34,  4813,  1796,  4936,  1373,  1797,  4597,  4599,  4075,
    4352,  4582,  1374,  4152,  3381,  3142,  4758,  4152,  4152,  1375,
    4152,  4879,  4498,  4932,  4832, -2342,  4896,  1376, -2342, -2342,
   -2342,  3223,  4830,  4110,  3386,  1803,  4094,  4070,  3958,  1377,
    3459, -2419,  4501,  4502,  4502,  3013,  3014,  1378,  2324,  4082,
    4369,  3632,  3004,  3807,  3314,  4937,  4987,  4974,  1796,  3314,
    4571,  1797,  3580,  3577,  3314,  1805,  4900,  3314,  4462,  4807,
    4522,  4884,   687,  1725,  4525,  2306,  4143,  1815,  4666,  1735,
    1816,  1817,  1818,  2714,  1819,  1820,  1821,  1822,  1823,  1824,
    1803,  3314,  4116,  3369, -2419,  3305, -2419,  3208,  4757, -2419,
    3305,  1379,  1796,  3305,  3314,  1797,   891,   984,  2483,  1798,
    1799,  1800,   746,  2484,   804,  2485,  4312,   809,  3538,   812,
    1805,   809,  4910,  4976,  1265,  2665,  1801,  2041,   855,  4491,
    3810,  2666,   958,  2436,  1803, -2419,  4098,  4243,  1058,   809,
    1804,  4873,  3890,  3337,  4485,  1838,  3346,  2692,  4520,  4869,
    3344,  3869,  4784,  4237,  2691,  3348,  3574,  1993,  4207,  3834,
    4219,  4646,  3830,   804,  1805,   671,  4775,  1796,   812,  4774,
    1797, -2419,  3891,   804,  3692,  4630, -2419,   855,  4609,   983,
    1812,  1141,  2381,  3785,  3217,  3811,  4483,  4871,  3218,  3219,
    3220,   822,  1964,  4872,   809,  4863,  2630,  3340,  2975,  1803,
    3194,  3283,  3333,  3281,  2639, -2419,     0,     0,  1992,  3224,
    3225,  3226, -2419,  3227,  3228,  3229,  3230,  3231,  3232,     0,
       0,  1997,  2002,  4563,     0,     0, -2419,     0,     0,  1805,
       0, -2419,     0,     0,     0,     0,     0,  4929,     0,  1244,
       0,     0,     0,   746,  3314,     0,     0,     0,     0,  4587,
     180,     0,     0,     0,     0,     0,   746,  1812,  1124,     0,
       0,     0, -2419,     0,     0,     0,     0, -2419,     0,     0,
    1806,     0,  4610,     0,     0,  1807,  4608,   180,  1237,  1237,
       0,   746,   710,     0,     0,     0,   710,     0,     0,     0,
       0,     0,     0,     0,  4194,     0,  1808,  1809,     0,     0,
     746,     0,     0,     0,   746,     0,  3314,     0,   761,     0,
    1237,  1810,  1812,     0,     0,     0,     0,     0,  4695,     0,
    4697,     0,   746,     0,     0,     0,     0,   761,     0,     0,
       0,     0,     0,     0,   746, -2419,     0,     0,     0, -2419,
   -2419,     0,  3305,  1811,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1788,     0, -2419,  1812,     0,   853,  1813,
       0,     0,  1819,  1820,  1821,  1822,  1823,  1824,     0,     0,
       0,     0,  1788,     0,     0, -2419, -2419,   746,     0,     0,
    4674,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   746, -2419,     0,     0,     0,   809,   809,
       0,     0,     0,     0,     0,     0,     0,     0,   982,     0,
       0,     0,  4708,     0,     0,     0,     0,   671,  4732,     0,
       0,  1812,  4716,   710,   710,     0,     0,     0,     0,     0,
       0,     0, -2419,     0,     0,  3223,     0,     0,  1814,  1819,
    1820,  1821,  1822,  1823,  1824,     0,     0,     0,     0,     0,
     804,  4502,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   804,     0,  4742,     0,   855,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4745,   180,  3154,     0,
     809,     0,     0,     0,  3314,     0,     0, -2419,     0,     0,
       0,     0,     0,     0,  1819,  1820,  1821,  1822,  1823,  1824,
     746,     0,     0, -2419,     0,     0,     0,   809,   809,  3314,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4838,     0,     0,     0,   746,   746,   746,     0,   809,     0,
     804,  1815,     0,     0,  1816,  1817,  1818,     0,  1819,  1820,
    1821,  1822,  1823,  1824,     0,     0,  1390,     0,     0,     0,
       0,  3258,  1391,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   982,     0,     0,
       0,  4817,     0,  4818,     0,     0,     0,  4823,  4824,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4843,     0,  1392,     0,  4886,     0, -2419,   809,     0,   809,
     809,     0,     0,  1819,  1820,  1821,  1822,  1823,  1824,     0,
       0,     0,     0,  3224,  3225,  3226,     0,  3227,  3228,  3229,
    3230,  3231,  3232,     0,     0,     0,     0,  1237,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1393,     0,     0,  1394,     0,     0,     0,  4882,     0,
       0,  1395,     0,     0,  1396,     0,     0,  1708,  1708,     0,
       0,     0,   746,     0,   680,  4935,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1397,
       0,     0,     0,     0,     0,  1739,     0,     0,   746,     0,
       0,  1745,     0,     0,     0,  3314,     0,     0,     0,     0,
       0,   822,   822,  2493,  1237,     0,     0,     0,     0,     0,
    1398,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4901,   180,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1237,     0,  4915,   180,  4912,   184,  4913,
    4914,     0,     0,     0,     0,  4956,     0,     0,     0,     0,
    2494,     0,   982,     0,     0,     0,     0,     0,     0,     0,
       0,  1237,  1237,  1237,     0,  1237,  4947,     0,  1399,     0,
    1400,     0,     0,     0,     0,  4946,     0,     0,     0,     0,
    1401,  2495,     0,     0,     0,  1237,     0,     0,  1402,  4915,
    4955,  4912,   184,  4913,  4914,     0,     0,     0,  1403,     0,
       0,     0,     0,  2496,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2497,     0,     0,     0,     0,  4980,
       0,     0,     0,   746,     0,     0,  1237,     0,     0,  4947,
       0,   822,   822,  1404,  2498,     0,  1405,  1406,  4946,  2499,
       0,     0,     0,     0,     0,     0,     0,  3078,  4947,  4915,
     180,  4912,   184,  4913,  4914,     0,  1237,  4946,     0,     0,
    1237,  1237,     0,  1407,     0,     0,  1363,     0,     0,     0,
       0,   746,   746,  2006,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2500,  1390,     0,
       0,     0,     0,   710,  1391,     0,     0,     0,     0,  1364,
       0,     0,     0,     0,     0,     0,     0,     0,  2501,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1438,
       0,     0,     0,     0,     0,     0,  1408,     0,  2106,     0,
       0,     0,     0,   710,  1392,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   746,  2132,     0,     0,
       0,     0,     0,     0,     0,   746,     0,  1366,   809,     0,
       0,     0,     0,     0,     0,     0,     0,  1439,     0,     0,
       0,   206,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   855,     0,   746,     0,     0,  1394,     0,     0,     0,
    1367,   746,     0,  1395,   746,     0,  1396,     0,  2502,  1796,
       0,     0,  1797,     0,     0,  2503,  1798,  1799,  1800,     0,
       0,  2504,     0,     0,     0,     0,     0,     0,   746,     0,
    3079,  1397,     0,  1801,     0,  1368,   809,   809,   809,   809,
     746,  1803,     0,  1796,     0,     0,  1797,  1804,     0,     0,
    1798,  1799,  1800,  2505,   746,     0,  2506,     0,     0,  1440,
       0,     0,  1398,     0,     0,  2258,     0,   746,  1369,     0,
       0,  1805,     0,     0,  2507,  1803,     0,     0,     0,   809,
     809,  1804,     0,     0,     0,     0,     0,     0,   809,     0,
       0,     0,     0,     0,     0,     0,     0,  1371,   809,  2508,
       0,     0,     0,     0,     0,  1805,     0,  1441,     0,     0,
    1442,     0,     0,     0,     0,     0,     0,   746,     0,     0,
    1443,     0,  1400,     0,     0,     0,   809,   809,   809,   809,
       0,     0,  1401,     0,     0,    34,     0,     0,   746,  1373,
    1402,     0,     0,     0,     0,   746,  1374,     0,  2258,  1444,
    1403,     0,     0,  1375,     0,  1795,     0,     0,   804,     0,
    1796,  2117,     0,  1797,     0,   812,     0,  1798,  1799,  1800,
    1237,     0,     0,  1377,     0,     0,     0,  1806,     0,     0,
       0,  1378,  1807,     0,  1801,  1445,     0,  1802,  1405,  1406,
    1446,     0,  1803,     0,     0,     0,     0,     0,  1804,     0,
       0,  3081,     0,  1808,  1809,     0,     0,   804,     0,     0,
       0,  1806,     0,     0,     0,  1447,  1807,   855,  1810,     0,
       0,   809,  1805,     0,   809,     0,     0,     0,     0,  1448,
       0,     0,     0,     0,   809,  1379,     0,  1808,  1809,  3082,
    3673,     0,   809,   809,     0,     0,     0,   746,     0,     0,
    1811,     0,  1810,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1812,     0,     0,  1813,     0,     0,     0,
    1363,     0,  1708,     0,     0,     0,     0,     0,  1408,   809,
       0,   804,     0,     0,  1811,   746,   746,     0,   809,     0,
       0,     0,     0,     0,     0,   746,     0,  1812,     0,     0,
       0,     0,   746,  1364,     0,     0,     0,   680,   680,     0,
       0,  2492,     0,     0,     0,  1237,     0,  1237,     0,     0,
       0,     0,  1237,  1237,     0,     0,     0,     0,  1806,  1237,
    1237,  1237,     0,  1807,     0,  1237,   855,  1237,  1237,  1237,
    1237,  1237,  1237,     0,  1237,  1814,  1237,  1237,     0,     0,
    1237,     0,     0,     0,  1808,  1809,     0,     0,     0,     0,
       0,  1366,     0,     0,     0,  1237,  1237,  1237,  1237,  1810,
       0,     0,   809,  1237,     0,     0,     0,  1237,     0,  1814,
    1237,     0,     0,  1237,  1237,  1237,  1237,  1237,  1237,  1237,
    1237,  1237,     0,  1237,  1367,     0,     0,     0,     0,   746,
    1237,  1811,  1237,     0,     0,     0,     0,     0,     0,   746,
       0,     0,     0,     0,  1812,     0,     0,  1813,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1368,
       0,     0,     0,     0,     0,     0,     0,     0,  1815,     0,
       0,  1816,  1817,  1818,     0,  1819,  1820,  1821,  1822,  1823,
    1824,     0,     0,     0,     0,  2575,     0,     0,     0,     0,
       0,     0,  1369,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1815,     0,     0,  1816,  1817,  1818,     0,  1819,
    1820,  1821,  1822,  1823,  1824,     0,     0,     0,     0,     0,
       0,  1371,     0,     0,     0,     0,  1814,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   746,    34,
    1237,  2116,     0,  1373,     0,     0,     0,     0,     0,     0,
    1374,     0,     0,     0,     0,     0,     0,  1375,     0,     0,
       0,     0,     0,     0,     0,  2117,     0,  2075,     0,     0,
       0,     0,  2076,     0,     0,   746,     0,  1377,     0,     0,
       0,     0,  2700,     0,  2707,  1378,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1815,
       0,     0,  1816,  1817,  1818,  2077,  1819,  1820,  1821,  1822,
    1823,  1824,  1796,   812,     0,  1797,     0,     0,  2078,  1798,
    1799,  1800,   680,     0,   680,     0,     0,     0,     0,     0,
       0,     0,  2079,     0,     0,     0,  1801,     0,     0,  1379,
       0,  1237,     0,     0,  1803,     0,     0,     0,     0,     0,
    1804,     0,     0,   804,     0,   809,   809,     0,     0,     0,
     804,     0,   855,     0,   809,     0,   809,     0,  1796,     0,
     809,  1797,  2080,   746,  1805,  1798,  1799,  1800,     0,     0,
       0,     0,     0,  2081,     0,     0,     0,     0,     0,     0,
       0,     0,  1801,     0,   710,     0,     0,     0,     0,     0,
    1803,     0,     0,  2082,  2132,     0,  1804,     0,  2083,     0,
       0,     0,  2824,     0,     0,     0,     0,     0,     0,  2835,
       0,     0,     0,     0,     0,     0,     0,     0,   746,     0,
    1805,     0,     0,     0,     0,     0,     0,  1796,     0,     0,
    1797,     0,     0,     0,  1798,  1799,  1800,     0,     0,   746,
       0,     0,     0,     0,  2880,  2880,     0,     0,     0,     0,
       0,  1801,     0,   812,   710,     0,     0,     0,     0,  1803,
       0,     0,     0,     0,     0,  1804,     0,  2084,     0,     0,
    1806,   809,     0,     0,     0,  1807,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1805,
       0,     0,     0,     0,     0,     0,  1808,  1809,  2945,  2085,
    2948,  2950,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1806,     0,     0,   809,
     206,  1807,     0,     0,     0,     0,     0,   809,     0,   809,
       0,     0,     0,  1811,     0,   809,     0,     0,     0,     0,
       0,     0,  1808,  1809,     0,     0,  1812,  1237,     0,  1813,
       0,     0,     0,     0,  2086,     0,     0,  1810,     0,     0,
    2087,  2132,     0,  2088,  2880,     0,   746,     0,     0,  3036,
       0,     0,   680,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1806,     0,     0,     0,  1811,
    1807,     0,  2089,     0,     0,     0,     0,     0,  2945,  2090,
    3078,     0,  1812,     0,     0,  1813,  2091,   809,  3062,     0,
       0,  1808,  1809,  2092,     0,     0,     0,     0,     0,  1363,
       0,     0,     0,     0,     0,     0,  1810,     0,  1814,     0,
       0,  1237,     0,     0,     0,     0,     0,     0,  2093,     0,
       0,     0,     0,     0,     0,     0,  3106,     0,     0,     0,
       0,     0,  1364,     0,     0,     0,     0,     0,  1811,     0,
       0,   809,     0,   809,  2880,   809,  2880,     0,     0,     0,
       0,  1812,     0,     0,  1813,     0,     0,     0,     0,  1796,
       0,     0,  1797,     0,  1814,     0,  1798,  1799,  1800,  1237,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1708,  1801,     0,     0,     0,     0,     0,     0,
    1366,  1803,     0,     0,     0,     0,     0,  1804,     0,     0,
       0,  1815,     0,     0,  1816,  1817,  1818,     0,  1819,  1820,
    1821,  1822,  1823,  1824,     0,     0,     0,     0,  3578,     0,
     746,  1805,     0,  1367,     0,     0,     0,     0,     0,     0,
     804,     0,     0,  1814,     0,     0,   804,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   809,     0,     0,
       0,     0,     0,  3079,  1237,     0,     0,  1815,  1368,  1237,
    1816,  1817,  1818,     0,  1819,  1820,  1821,  1822,  1823,  1824,
       0,     0,     0,     0,  3743,     0,     0,     0,     0,     0,
       0,     0,  1237,  1237,  1237,     0,     0,  1237,     0,     0,
       0,  1369,     0,     0,     0,  1237,  1237,  1237,  1237,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1237,     0,
       0,  1237,     0,  1237,     0,     0,     0,     0,     0,     0,
    1371,     0,     0,     0,  1237,  1237,  1815,  1806,  1237,  1816,
    1817,  1818,  1807,  1819,  1820,  1821,  1822,  1823,  1824,     0,
     855,     0,  1237,  3794,  1237,     0,  1237,     0,     0,     0,
       0,     0,     0,  1808,  1809,     0,     0,     0,    34,     0,
       0,     0,  3080,     0,     0,     0,  1237,     0,  1810,  1374,
     746,     0,     0,     0,     0,     0,  1375,  3315,     0,  1237,
    1237,  1237,     0,     0,  2117,  1796,     0,     0,  1797,     0,
       0,     0,  1798,  1799,  1800,     0,  1377,  1237,     0,     0,
    1811,     0,     0,     0,  1378,     0,     0,     0,     0,  1237,
       0,     0,     0,  1812,  1237,     0,  1813,  1803,     0,     0,
    1237,     0,     0,  1804,  3081,     0,     0,     0,     0,     0,
    3315,     0,     0,  3354,     0,     0,  3357,     0,  2707,     0,
       0,  1796,     0,     0,  1797,     0,     0,  1805,  1798,  1799,
    1800,     0,     0,     0,     0,     0,     0,     0,  1379,     0,
    1796,     0,  3082,  1797,     0,  1801,     0,  1798,  1799,  1800,
       0,     0,     0,  1803,     0,     0,     0,     0,     0,  1804,
    1237,     0,  2880,     0,  1801,     0,     0,  1708,     0,     0,
       0,     0,  1803,     0,     0,  1814,     0,     0,  1804,     0,
       0,     0,     0,  1805,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   809,     0,   809,   809,   809,     0,
       0,     0,  1805,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1806,     0,     0,     0,     0,  1807,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2419,
   -2419,     0,     0,     0,     0,     0,     0,     0,  1815,     0,
       0,  1816,  1817,  1818,  1810,  1819,  1820,  1821,  1822,  1823,
    1824,     0,     0,     0,     0,  3877,     0,     0,     0,  1806,
       0,     0,     0,     0,  1807,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   746, -2419,     0,  1806,     0,
       0,     0,     0,  1807,     0,  1808,  1809,     0,     0,  1812,
       0,     0,     0,     0,     0,   593,     0,     0,     0,     0,
    1810,   639,     0,     0,  1808,  1809,     0,     0,     0,     0,
       0,   690,     0,     0,     0,     0,     0,     0,     0,  1810,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     758,   758,  1811,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1812,     0,     0,  1813,     0,
       0,  1811,     0,     0,     0,     0,     0,     0,   809,     0,
       0,     0,     0,     0,  1812,  2880,  2880,  1813,     0,     0,
       0,  1814,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1796,     0,     0,
    1797,     0,     0,     0,  1798,  1799,  1800,     0,     0,     0,
       0,     0,   746,   746,     0,     0,     0,     0,     0,     0,
       0,  1801,     0,     0,     0,     0,     0,     0,   746,  1803,
       0,     0,     0,     0,     0,  1804,     0,  1814,     0,     0,
       0,     0,     0,  1708,   746,     0,     0,     0,     0,     0,
       0,     0,  1708,   746,   746,     0,  1814,     0,     0,  1805,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     746,     0,     0,     0,  1815,     0,     0,  1816,  1817,  1818,
       0,  1819,  1820,  1821,  1822,  1823,  1824,     0,     0,   817,
       0,     0,     0,     0,     0,     0,     0,   857,     0,     0,
     861,   862,     0,   865,     0,     0,   871,     0,   873,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   809,     0,   809,     0,     0,     0,   809,
    1815,     0,     0,  1816,  1817,  1818,     0,  1819,  1820,  1821,
    1822,  1823,  1824,     0,     0,   804,     0,  3904,     0,  1815,
       0,     0,  1816,  1817,  1818,   746,  1819,  1820,  1821,  1822,
    1823,  1824,     0,     0,     0,  1806,  4160,     0,     0,     0,
    1807,   746,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   809,     0,  3078,     0,     0,     0,     0,
    1237,  1808,  1809,     0,     0,     0,     0,     0,     0,  1237,
       0,     0,     0,     0,  1363,  1237,  1810,  1237,     0,     0,
    1237,     0,     0,     0,     0,  1237,  1237,  1237,  1237,     0,
       0,  1237,  1237,  1237,  1237,  1237,  1237,  1237,  1237,  1237,
    1237,     0,     0,     0,  1237,  1237,     0,  1364,  1811,     0,
       0,     0,     0,     0,  1237,     0,     0,     0,  1237,     0,
       0,  1812,  1237,     0,  1813,     0,     0,     0,     0,     0,
    1237,     0,     0,  1237,     0,  1237,     0,     0,     0,     0,
       0,     0,     0,     0,  1237,     0,     0,  1237,  1237,     0,
       0,     0,  1237,  1237,     0,     0,     0,  3818,     0,  1237,
       0,     0,     0,     0,     0,  1366,   746,   746,   746,   804,
       0,  3315,  3838,     0,     0,     0,  3838,  3852,     0,     0,
       0,     0,     0,  1237,     0,     0,     0,     0,     0,  1237,
    1237,  1237,     0,  1796,     0,     0,  1797,     0,  1367,     0,
    1798,  1799,  1800,  1814,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1237,  1801,     0,     0,
       0,     0,     0,     0,     0,  1803,     0,  2707,  3079,  1237,
       0,  1804,     0,  1368,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3910,  1708,  1708,     0,  2258,  1805,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1369,     0,     0,     0,
       0,     0,     0,   809,   809,   809,   809,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1371,  1815,     0,     0,  1816,
    1817,  1818,  2132,  1819,  1820,  1821,  1822,  1823,  1824,     0,
       0,     0,     0,  4195,     0,     0,  3956,     0,     0,     0,
     933,     0,     0,     0,     0,     0,     0,     0,   941,     0,
       0,     0,     0,    34,     0,   954,     0,  1373,   959,   960,
       0,     0,     0,   962,  1374,     0,     0,     0,     0,     0,
    1390,  1375,     0,     0,   979,     0,  1391,     0,     0,  2117,
       0,  1806,     0,     0,     0,     0,  1807,     0,     0,   988,
       0,  1377,     0,     0,     0,     0,     0,     0,     0,  1378,
       0,     0,     0,     0,  1048,     0,  1052,  1808,  1809,  1054,
       0,  1056,     0,     0,  1060,     0,  1392,     0,     0,  3081,
       0,     0,  1810,     0,     0,     0,  4034,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1379,  1811,     0,     0,  3082,     0,     0,
       0,     0,     0,     0,     0,  2173,     0,  1812,  1394,   746,
    1813,   809,     0,  1237,     0,  1395,     0,     0,  1396,   746,
       0,     0,  1123,     0,     0,  4069,     0,     0,     0,     0,
       0,     0,     0,     0,  2132,     0,     0,     0,     0,     0,
       0,     0,     0,  1397,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   746,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2945,     0,     0,     0,     0,     0,
       0,     0,  4103,     0,  1398,     0,     0,   758,     0,     0,
       0,     0,   746,     0,     0,     0,  2258,     0,     0,  1814,
    1237,  1237,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2880,     0,  2880,     0,     0,     0,
       0,     0,  1399,     0,  1400,     0,   746,  1354,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,  1402,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,  1237,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1237,     0,     0,
       0,     0,  1815,     0,     0,  1816,  1817,  1818,     0,  1819,
    1820,  1821,  1822,  1823,  1824,     0,     0,  2174,     0,  4425,
    1405,  1406,     0,  1491,     0,     0,     0,  1237,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1237,  1237,  1504,
       0,     0,     0,     0,  1237,  1237,     0,  2175,     0,  1237,
       0,  1515,     0,  1516,  1237,     0,     0,  1237,  1237,     0,
       0,  1519,  1237,  4199,     0,     0,     0,     0,  1237,   746,
     746,   746,   746,  1525,     0,     0,  3838,  3852,  1534,  3838,
       0,  1538,  4210,     0,     0,     0,  3315,     0,     0,     0,
    3315,  1796,     0,     0,  1797,     0,  4225,     0,  1798,  1799,
    1800,     0,  1237,     0,     0,     0,     0,  1237,     0,     0,
    1408,     0,     0,  1237,     0,  1801,  1583,     0,     0,     0,
     855,     0,     0,  1803,     0,     0,     0,     0,  1237,  1804,
       0,  3354,     0,     0,     0,     0,  2707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1796,     0,   680,
    1797,     0,  1237,  1805,  1798,  1799,  1800,     0,  1390,     0,
       0,     0,     0,     0,  1391,     0,     0,     0,     0,     0,
       0,  1801,  2880,  2880,     0,     0,     0,     0,     0,  1803,
       0,     0,     0,     0,     0,  1804,     0,     0,     0,  1438,
    2132,     0,     0,     0,     0,     0,     0,     0,     0,  4288,
       0,     0,     0,     0,  1392,     0,     0,     0,     0,  1805,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1439,     0,     0,
    1237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1726,     0,     0,     0,     0,  1394,     0,     0,  1806,
     809,     0,     0,  1395,  1807,     0,  1396,     0,     0,     0,
       0,     0,     0,     0,     0,   809,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1808,  1809,     0,     0,     0,
       0,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
    1810,     0,  1237,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   804,     0,  1806,     0,     0,  2132,  1440,
    1807,     0,  1398,     0,     0,     0,  1708,     0,     0,     0,
       0,     0,  1811,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,  1809,   809,  3062,  1812,     0,     0,  1813,     0,
       0,     0,     0,     0,     0,     0,  1810,     0,     0,     0,
       0,     0,     0,     0,  1826,     0,     0,  1441,     0,     0,
    1442,     0,   746,     0,     0,     0,     0,     0,     0,     0,
    1443,     0,  1400,     0,     0,     0,     0,     0,  1811,     0,
       0,     0,  1401,     0,     0,     0,     0,     0,     0,     0,
    1402,  1812,     0,     0,  1813,     0,  1390,     0,     0,  1444,
    1403,  1237,  1391,     0,     0,     0,     0,     0,     0,     0,
    1237,     0,     0,     0,     0,     0,     0,  1814,  1826,     0,
     758,  1966,     0,     0,     0,     0,     0,  1237,  1237,     0,
       0,  1237,     0,     0,     0,  2906,     0,     0,  1405,  1406,
    1446,     0,  1392,     0,     0,   804,  3838,     0,     0,     0,
    3315,     0,     0,     0,     0,  3315,     0,     0,  3315,   804,
       0,  2945,     0,  4466,     0,  2907,  1237,  1237,     0,     0,
       0,     0,     0,  1814,     0,     0,     0,     0,     0,  1448,
       0,     0,  3910,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2095,     0,  1394,  3910,   855,   809,   809,   809,
       0,  1395,     0,     0,  1396,     0,  1390,     0,     0,     0,
    1815,     0,  1391,  1816,  1817,  1818,     0,  1819,  1820,  1821,
    1822,  1823,  1824,     0,     0,     0,     0,  4436,  1408,  1397,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   804,
     855,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1392,     0,     0,     0,     0,  2184,     0,     0,
    1398,     0,     0,     0,     0,     0,  1815,     0,     0,  1816,
    1817,  1818,     0,  1819,  1820,  1821,  1822,  1823,  1824,     0,
       0,     0,   804,  4445,     0,   746,  1390,     0,     0,     0,
       0,     0,  1391,     0,     0,  4069,     0,     0,     0,     0,
       0,   746,     0,  2880,  1394,     0,     0,     0,     0,  2132,
       0,  1395,     0,     0,  1396,     0,     0,     0,  1399,     0,
    1400,     0,  4103,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,  1392,   809,   746,  3910,     0,     0,  1402,  1397,
       0,     0,     0,     0,     0,     0,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1237,     0,     0,  1237,     0,  1237,
    1398,     0,     0,  2302,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1462,  1394,     0,  1405,  1406,     0,     0,
       0,  1395,     0,  1237,  1396,     0,     0,  3315,     0,     0,
       0,  4466,     0,     0,     0,     0,     0,     0,  1237,     0,
       0,     0,     0,  1463,     0,  1796,     0,  4659,  1797,  1397,
       0,     0,  1798,  1799,  1800,     0,     0,  1237,  1399,     0,
    1400,     0,     0,     0,     0,     0,     0,     0,     0,  1801,
    1401,     0,   746,     0,     0,     0,     0,  1803,  1402,     0,
    1398,     0,     0,  1804,     0,     0,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,  1237,     0,     0,     0,     0,
       0,  2399,   809,   809,   809,   809,  1408,  1805,     0,     0,
       0,     0,     0,     0,     0,  2413,     0,     0,  2416,     0,
    2418,     0,  2419,  1488,     0,     0,  1405,  1406,  2421,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1399,   804,
    1400,     0,  1826,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,     0,  1489,     0,   746,     0,     0,  1402,     0,
    1237,     0,     0,     0,     0,     0,     0,     0,  1403,     0,
       0,     0,     0,  1966,     0,     0,     0,  1966,     0,  1966,
       0,     0,  1966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1237,  2097,     0,   804,  1405,  1406,     0,     0,
       0,     0,     0,  1806,  1237,     0,  1408,  1826,  1807,  1237,
       0,  1237,     0,  1237,     0,     0,     0,     0,     0,     0,
    3910,  1826,     0,  2098,     0,  2550,   809,     0,   855,  1808,
    1809,     0,     0,     0,     0,     0,     0,  1237,     0,  1826,
    1826,  1826,     0,  1826,  1810,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1708,  1708,
       0,     0,     0,     0,     0,     0,  1811,     0,     0,     0,
       0,     0,     0,     0,     0,  1826,  1408,     0,     0,  1812,
       0,     0,  1813,     0,     0,   809,     0,     0,     0,     0,
       0,   804,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1826,     0,     0,     0,     0,     0,  1237,  1237,
       0,     0,     0,  2945,     0,     0,     0,     0,     0,  1237,
    1796,     0,  4659,  1797,     0,     0,  2707,  1798,  1799,  1800,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   804,
       0,     0,     0,     0,  1801,     0,     0,     0,     0,   809,
       0,  1814,  1803,     0,     0,     0,  1708,     0,  1804,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2132,     0,
       0,     0,  1805,     0,     0,     0,  3910,     0,     0,     0,
       0,     0,   804,   804,  1237,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1826,  1796,     0,
       0,  1797,     0,  1237,     0,  1798,  1799,  1800,     0,  1826,
     809,     0,  1826,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1801,     0,     0,     0,     0,     0,     0,     0,
    1803,     0,     0,     0,  1815,     0,  1804,  1816,  1817,  1818,
       0,  1819,  1820,  1821,  1822,  1823,  1824,     0,     0,  2725,
    2726,  4448,     0,     0,  2729,  2730,     0,     0,     0,  2733,
    1805,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2744,     0,     0,     0,     0,  1806,     0,
    2753,     0,     0,  1807,  2756,  2757,  1237,  1237,  2760,  2761,
       0,     0,     0,  1390,     0,  2766,     0,     0,     0,  1391,
     804,     0,     0,     0,  1808,  1809,     0,     0,  2783,     0,
    2785,     0,   804,   804,  1796,     0,     0,  1797,     0,  1810,
       0,  1798,  1799,  1800,     0,     0,     0,     0,     0,  2809,
       0,     0,     0,     0,  2811,     0,     0,     0,  1801,  1392,
       0,     0,     0,     0,     0,     0,  1803,  2816,     0,     0,
       0,  1811,  1804,     0,     0,     0,  2823,     0,  2825,     0,
       0,  2828,  2831,  2833,  1812,     0,  1806,  1813,  2841,  2844,
       0,  1807,     0,     0,     0,     0,  1805,     0,  2857,     0,
       0,     0,     0,  2866,     0,     0,     0,     0,  2870,     0,
       0,  1394,  1808,  1809,     0,     0,     0,     0,  1395,     0,
       0,  1396,     0,     0,     0,     0,     0,  1810,     0,     0,
       0,     0,     0,     0,     0,     0,  2905,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1397,  2912,     0,  2914,
       0,     0,     0,     0,  2917,     0,     0,     0,  2918,  1811,
    2922,  2923,  2924,  2925,     0,  2927,  1814,     0,     0,     0,
       0,     0,  1812,     0,     0,  1813,     0,  1398,  2952,  2953,
    2954,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2962,  2963,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1806,     0,     0,     0,     0,  1807,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,  1809,
       0,     0,     0,     0,     0,  1399,     0,  1400,     0,     0,
       0,     0,  3007,  1810,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,  1814,  1402,     0,     0,     0,  1815,
       0,     0,  1816,  1817,  1818,  1403,  1819,  1820,  1821,  1822,
    1823,  1824,     0,     0,     0,  1811,  4496,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1812,     0,
       0,  1813,     0,     0,     0,     0,  -130,     0,     0,     0,
    2817,     0,     0,  1405,  1406,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     0,     3,     4,     0,     0,
    1407,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     0,     0,     0,     0,     0,  1815,     0,     0,
    1816,  1817,  1818,     0,  1819,  1820,  1821,  1822,  1823,  1824,
       0,     6,  2659,     7,     8,     0,     0,     0,     0,     9,
    1814,    10,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    11,     0,    12,     0,     0,     0,     0,     0,
       0,     0,     0,  1408,     0,  1966,     0,     0,     0,     0,
       0,    13,     0,     0,    14,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    15,     0,    16,
       0,     0,     0,    17,     0,     0,  3172,     0,     0,    18,
       0,     0,     0,     0,     0,     0,     0,    19,     0,    20,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,     0,     0,  1815,  1826,     0,  1816,  1817,  1818,     0,
    1819,  1820,  1821,  1822,  1823,  1824,    23,     0,     0,     0,
    4527,     0,     0,     0,  1826,     0,  1826,     0,     0,  2550,
    2550,     0,  3233,     0,  2550,     0,     0,     0,  1826,     0,
       0,  1826,     0,     0,     0,     0,  1826,     0,     0,     0,
       0,     0,  1826,     0,     0,    24,    25,  1826,     0,     0,
       0,    26,     0,     0,  1826,  1826,  1826,  1826,     0,     0,
       0,  2550,  2550,    27,  1826,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,  1826,     0,  1826,     0,
       0,     0,     0,     0,     0,  1826,  1826,  1826,  1826,  1826,
    1826,  1826,  1826,  1826,  1826,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    29,     0,     0,  1390,     0,     0,
       0,     0,  1826,  1391,     0,     0,    30,     0,     0,     0,
       0,    31,    32,     0,    33,     0,     0,     0,     0,    34,
       0,     0,  3335,     0,    35,     0,     0,    36,     0,     0,
       0,     0,    37,     0,     0,     0,     0,    38,    39,     0,
       0,     0,     0,  1392,     0,    40,     0,     0,     0,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    43,     0,     0,  3372,  3373,     0,  1796,     0,     0,
    1797,     0,     0,     0,  1798,  1799,  1800,     0,     0,     0,
      44,     0,  1966,     0,     0,  1394,     0,     0,     0,     0,
      45,  1801,  1395,     0,     0,  1396,    46,     0,     0,  1803,
       0,    47,  1826,     0,     0,  1804,     0,  3394,     0,     0,
       0,  3396,     0,     0,    48,     0,     0,  3399,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,  1805,
       0,     0,     0,  3411,  3413,    49,     0,     0,  3413,     0,
       0,     0,     0,  3424,  3425,  3426,     0,  3428,     0,    50,
    1796,  1398,  -130,  1797,     0,     0,     0,  1798,  1799,  1800,
       0,     0,     0,     0,     0,     0,     0,     0,  3445,     0,
       0,     0,     0,     0,  1801,     0,     0,     0,  3451,  3452,
    3453,  3454,  1803,     0,     0,     0,     0,     0,  1804,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1399,
       0,  1400,  1805,     0,     0,  3471,     0,     0,  3476,  3477,
    3478,  1401,     0,     0,     0,     0,     0,     0,  3491,  1402,
       0,     0,     0,     0,     0,  1806,     0,     0,     0,  1403,
    1807,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1390,     0,     0,     0,     0,     0,  1391,  1796,     0,     0,
    1797,  1808,  1809,     0,  1798,  1799,  1800,     0,     0,     0,
       0,     0,     0,     0,  2919,     0,  1810,  1405,  1406,     0,
       0,  1801,     0,     0,     0,     0,     0,     0,     0,  1803,
       0,     0,     0,     0,     0,  1804,  1392,     0,     0,  3542,
       0,     0,     0,     0,  2920,     0,     0,  3546,  1811,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1806,  1805,
       0,  1812,     0,  1807,  1813,     0,  3558,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1826,  1808,  1809,     0,     0,  1394,     0,
       0,     0,  3601,     0,     0,  1395,     0,     0,  1396,  1810,
       0,     0,     0,     0,     0,     0,     0,  1408,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1397,     0,     0,     0,     0,     0,     0,
       0,  1811,     0,     0,     0,     0,  3638,     0,     0,     0,
    3643,     0,     0,  1814,  1812,     0,     0,  1813,     0,     0,
       0,     0,     0,     0,  1398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1806,     0,     0,     0,  3681,
    1807,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,  1809,     0,     0,     0,     0,     0,     0,  3694,
       0,     0,     0,     0,     0,     0,  1810,     0,     0,     0,
       0,     0,  1399,  3704,  1400,     0,     0,  3706,     0,     0,
       0,     0,     0,  1826,  1401,     0,  1814,     0,  1966,     0,
       0,     0,  1402,     0,     0,     0,  1815,     0,  1811,  1816,
    1817,  1818,  1403,  1819,  1820,  1821,  1822,  1823,  1824,     0,
       0,  1812,     0,  4565,  1813,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1826,  2959,     0,     0,
    1405,  1406,  1826,     0,     0,     0,     0,     0,     0,  1390,
       0,     0,     0,     0,     0,  1391,     0,     0,  3233,  3233,
       0,     0,  2550,  2550,  2550,  2550,     0,  2960,  2550,  2550,
    2550,  2550,  2550,  2550,  2550,  2550,  2550,  2550,  3233,  1815,
       0,     0,  1816,  1817,  1818,     0,  1819,  1820,  1821,  1822,
    1823,  1824,     0,  1814,     0,  1392,  4810,     0,     0,     0,
    1826,     0,     0,  1826,     0,  1826,     0,     0,  3233,  3233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1826,  2550,  2550,  1826,     0,  1826,     0,
    1408,     0,     0,   806,     0,     0,     0,     0,     0,     0,
       0,     0,   806,   829,     0,     0,     0,  1394,     0,     0,
     829,     0,     0,     0,  1395,     0,     0,  1396,     0,     0,
       0,   829,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1826,     0,     0,     0,
       0,     0,  1397,     0,     0,     0,  1815,  1826,     0,  1816,
    1817,  1818,     0,  1819,  1820,  1821,  1822,  1823,  1824,     0,
       0,     0,     0,  4842,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1398,     0,     0,     0,     0,     0,     0,
    1390,     0,     0,     0,  1826,     0,  1391,     0,     0,     0,
       0,     0,  3921,     0,  3922,     0,     0,     0,     0,     0,
       0,     0,  3924,     0,  1796,     0,     0,  1797,     0,     0,
       0,  1798,  1799,  1800,     0,     0,     0,     0,     0,  3934,
       0,     0,     0,     0,     0,     0,  1392,     0,  1801,     0,
       0,  1399,     0,  1400,     0,  3942,  1803,     0,     0,     0,
       0,     0,  1804,  1401,     0,     0,     0,     0,     0,  3955,
       0,  1402,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,  1805,  3959,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3968,  1394,     0,
       0,     0,     0,     0,     0,  1395,     0,     0,  1396,     0,
       0,     0,     0,     0,     0,     0,  3421,     0,  3992,  1405,
    1406,     0,     0,     0,     0,     0,     0,     0,     0,  4000,
    4001,  4002,     0,  1397,  4005,  4006,  4007,  4008,  4009,  4010,
       0,     0,     0,     0,  4017,  4018,  3422,  4020,  4021,  4022,
    4023,  4024,  4025,     0,  4027,     0,     0,     0,     0,     0,
       0,     0,     0,  4035,  1398,  4037,  4038,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3413,     0,
       0,     0,  1806,     0,     0,     0,     0,  1807,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4057,     0,  1408,
    2550,     0,     0,     0,     0,     0,     0,  1390,  1808,  1809,
       0,     0,  1399,  1391,  1400,     0,     0,     0,     0,     0,
       0,     0,     0,  1810,  1401,     0,     0,     0,     0,     0,
       0,     0,  1402,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1392,     0,  1811,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1812,     0,
     806,  1813,     0,     0,     0,     0,     0,  3472,     0,     0,
    1405,  1406,   829,     0,     0,     0,     0,   829,     0,     0,
       0,     0,     0,     0,  3413,     0,     0,     0,   829,     0,
       0,     0,     0,     0,     0,  1394,     0,  3473,     0,     0,
       0,     0,  1395,     0,   829,  1396,     0,     0,     0,   806,
       0,     0,  1966,  1966,  1966,  1031,     0,     0,     0,   806,
     829,     0,     0,     0,  4145,     0,   829,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,  1031,   829,     0,     0,
    1814,     0,     0,     0,  1826,   829,     0,     0,  1826,  1826,
    1826,     0,     0,     0,     0,     0,  3233,  3233,  3233,  3233,
    1408,  1398,     0,     0,  3233,  3233,  3233,  3233,  3233,  3233,
    3233,  3233,  3233,  3233,  1826,  1826,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1826,     0,     0,  1826,     0,  1826,     0,     0,     0,  1826,
       0,     0,  3233,  3233,     0,     0,  1826,  1826,     0,  1399,
       0,  1400,     0,     0,   806,   806,     0,     0,     0,     0,
     829,  1401,     0,  1815,     0,     0,  1816,  1817,  1818,  1402,
    1819,  1820,  1821,  1822,  1823,  1824,     0,     0,     0,  1403,
    4961,  1796,     0,     0,  1797,     0,   806,     0,  1798,  1799,
    1800,  1826,     0,     0,     0,     0,     0,     0,  1826,  1826,
       0,     0,     0,     0,     0,  1801,     0,     0,     0,     0,
       0,     0,     0,  1803,  1826,     0,     0,  1405,  1406,  1804,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1805,  1407,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4275,     0,     0,     0,  4276,  4277,  4278,
    4279,     0,     0,  4281,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4295,  4296,  4297,
       0,  4298,     0,  4300,  4301,     0,     0,  1408,     0,     0,
       0,     0,     0,     0,     0,  4310,  4311,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   806,     0,     0,     0,
       0,     0,     0,  1031,     0,     0,  4319,   806,     0,     0,
       0,     0,     0,  1966,  1966,     0,  1966,     0,     0,  1806,
       0,     0,     0,  1031,  1807,     0,     0,     0,  4327,     0,
       0,     0,     0,     0,     0,     0,     0,  1031,     0,     0,
       0,     0,     0,     0,     0,  1808,  1809,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1810,  1796,  3233,     0,  1797,     0,     0,     0,  1798,  1799,
    1800,     0,     0,     0,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,  1801,     0,     0,  4373,  2673,
       0,     0,  1811,  1803,     0,     0,     0,     0,     0,  1804,
       0,     0,     0,     0,     0,  1812,     0,     0,  1813,  4392,
       0,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,  1826,  1826,  1805,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4416,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   829,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1826,     0,     0,     0,     0,  1826,  2550,   829,
       0,  2674,     0,   806,     0,     0,     0,     0,     0,     0,
       0,   829,  1826,     0,  1826,     0,     0,  1814,  1826,  1826,
    1826,     0,     0,  1826,     0,     0,  1826,  1826,     0,     0,
       0,  1826,     0,     0,     0,  1826,     0,     0,     0,   829,
       0,     0,     0,  1966,     0,     0,     0,     0,  1031,     0,
     829,     0,     0,     0,     0,     0,     0,     0,  1966,  1806,
       0,     0,     0,     0,  1807,   829,     0,     0,   829,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,  1808,  1809,     0,     0,     0,
    1826,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1810,     0,     0,     0,     0,     0,     0,     0,     0,   806,
    1815,     0,     0,  1816,  1817,  1818,     0,  1819,  1820,  1821,
    1822,  1823,  1824,     0,     0,     0,  4517,  4979,     0,     0,
       0,     0,  1811,     0,     0,     0,     0,   806,   806,   806,
       0,   806,     0,     0,     0,  1812,     0,  4526,  1813,     0,
    1826,     0,  4531,  4532,     0,     0,     0,     0,     0,     0,
       0,   806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1826,   829,     0,     0,     0,     0,
       0,     0,     0,   829,   829,     0,     0,  4584,     0,     0,
       0,     0,   806,  1951,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1796,     0,     0,
    1797,     0,     0,     0,  1798,  1799,  1800,  1814,     0,     0,
       0,     0,   806,     0,     0,     0,   806,   806,     0,     0,
       0,  1801,     0,  3413,     0,     0,     0,     0,     0,  1803,
    4625,     0,  1031,     0,     0,  1804,     0,     0,  1951,     0,
    3233,  2550,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1826,  1826,  1826,  1805,
       0,     0,  2675,     0,     0,  1966,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1966,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1826,  1826,     0,     0,     0,  1031,  4661,     0,
    1815,     0,     0,  1816,  1817,  1818,     0,  1819,  1820,  1821,
    1822,  1823,  1824,     0,     0,     0,     0,     0,     0,     0,
    1796,  4677,     0,  1797,     0,     0,     0,  1798,  1799,  1800,
    4684,     0,     0,     0,     0,  1031,     0,     0,     0,     0,
       0,     0,     0,  3237,  1801,     0,     0,     0,  3238,     0,
       0,  1966,  1803,     0,     0,     0,     0,     0,  1804,     0,
       0,     0,     0,     0,     0,  1806,     0,     0,     0,     0,
    1807,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1805,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,  1809,     0,     0,     0,   829,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1810,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1031,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1031,     0,     0,  3413,     0,     0,     0,  1811,  1031,
       0,  3233,     0,     0,     0,  1951,     0,     0,     0,     0,
    1031,  1812,     0,     0,  1813,     0,  1966,  1826,     0,     0,
       0,     0,     0,     0,     0,     0,   829,     0,     0,     0,
     829,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   829,     0,     0,     0,     0,     0,  1806,     0,
    4799,     0,     0,  1807,     0,     0,     0,  1031,     0,     0,
       0,     0,     0,     0,   806,  4811,  1826,     0,     0,     0,
    1031,     0,     0,     0,  1808,  1809,   806,     0,     0,     0,
       0,     0,  1031,     0,     0,     0,     0,     0,     0,  1810,
       0,     0,     0,  1814,  1031,     0,     0,     0,     0,     0,
       0,     0,  4833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   806,     0,   829,   829,  1826,     0,     0,
       0,  1811,     0,     0,     0,     0,     0,     0,   829,     0,
       0,     0,     0,     0,  1812,     0,     0,  1813,  1031,     0,
       0,  1031,     0,   829,   829,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   829,     0,     0,     0,  3786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4881,  1826,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,   806,     0,  1816,
    1817,  1818,     0,  1819,  1820,  1821,  1822,  1823,  1824,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4899,
       0,     0,     0,     0,     0,     0,  1814,     0,     0,     0,
       0,   806,     0,   806,     0,     0,     0,     0,   806,   806,
       0,     0,  3787,     0,  1826,   806,   806,   806,     0,     0,
       0,   806,     0,   806,   806,   806,   806,   806,   806,     0,
     806,     0,   806,   806,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1031,   806,   806,   806,   806,  1951,     0,     0,     0,   806,
       0,     0,     0,   806,     0,     0,   806,     0,     0,   806,
     806,   806,   806,   806,   806,   806,   806,   806,     0,   806,
       0,     0,     0,     0,     0,  1826,   806,     0,   806,  1815,
       0,     0,  1816,  1817,  1818,     0,  1819,  1820,  1821,  1822,
    1823,  1824,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1796,     0,     0,  1797,     0,  1826,     0,  1798,  1799,
    1800,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1796,     0,     0,  1797,     0,  1801,     0,  1798,  1799,  1800,
       0,     0,     0,  1803,     0,     0,     0,     0,     0,  1804,
       0,     0,     0,     0,  1801,     0,     0,  3196,     0,     0,
       0,     0,  1803,     0,     0,     0,     0,     0,  1804,     0,
       0,     0,     0,  1805,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1796,     0,     0,  1797,
       0,     0,  1805,  1798,  1799,  1800,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   806,     0,     0,     0,
    1801,     0,     0,     0,     0,     0,     0,     0,  1803,     0,
       0,     0,     0,     0,  1804,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1805,     0,
       0,     0,     0,     0,     0,  1031,  4922,     0,     0,  1031,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,   829,
       0,     0,     0,  1951,   829,     0,     0,     0,   829,  1806,
       0,     0,     0,     0,  1807,     0,   829,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1806,     0,
       0,     0,     0,  1807,   829,  1808,  1809,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   806,
    1810,     0,     0,  1031,  1808,  1809,   806,     0,     0,     0,
       0,     0,     0,     0,     0,  1031,     0,     0,     0,  1810,
       0,     0,     0,     0,     0,     0,     0,     0,   829,     0,
       0,     0,  1811,     0,  1806,     0,     0,     0,     0,  1807,
       0,     0,     0,     0,     0,  1812,   829,   829,  1813,     0,
       0,  1811,     0,     0,     0,  1031,     0,     0,     0,     0,
    1808,  1809,     0,     0,  1812,     0,     0,  1813,  4923,     0,
       0,     0,     0,     0,     0,  1810,     0,  1951,   829,     0,
       0,  1951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,     0,     0,
       0,     0,   829,     0,     0,     0,   829,     0,     0,     0,
    1812,     0,     0,  1813,     0,     0,     0,  1814,     0,     0,
       0,     0,     0,     0,   829,     0,     0,     0,     0,  3210,
       0,     0,     0,     0,     0,   829,  1814,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   829,     0,
       0,     0,     0,     0,     0,     0,     0,   829,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1814,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   806,  1031,     0,     0,     0,     0,     0,
    1815,     0,  1951,  1816,  1817,  1818,     0,  1819,  1820,  1821,
    1822,  1823,  1824,     0,     0,     0,     0,     0,     0,  1815,
       0,     0,  1816,  1817,  1818,     0,  1819,  1820,  1821,  1822,
    1823,  1824,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1031,     0,     0,     0,   829,     0,
       0,     0,     0,     0,     0,  1815,     0,   806,  1816,  1817,
    1818,     0,  1819,  1820,  1821,  1822,  1823,  1824,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1796,     0,     0,  1797,     0,
     829,     0,  1798,  1799,  1800,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1801,
       0,     0,  3242,     0,     0,     0,     0,  1803,     0,     0,
       0,     0,     0,  1804,     0,     0,   829,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1031,     0,   829,     0,     0,  1805,     0,     0,
       0,     0,   829,     0,     0,     0,   806,  1796,     0,  1031,
    1797,     0,   806,     0,  1798,  1799,  1800,     0,     0,     0,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,  1801,     0,     0,     0,   806,     0,     0,     0,  1803,
       0,     0,     0,     0,     0,  1804,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   806,   806,
     806,     0,     0,   806,     0,     0,     0,     0,     0,  1805,
       0,   806,   806,   806,   806,     0,     0,     0,     0,  1951,
       0,     0,     0,     0,   806,  1951,     0,   806,     0,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,   806,     0,  1806,   806,     0,     0,     0,  1807,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   806,     0,
     806,     0,   806,     0,     0,     0,     0,     0,     0,  1808,
    1809,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   806,     0,  1810,     0,     0,     0,     0,     0,
       0,     0,     0,   806,     0,   806,   806,   806,  3247,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     829,     0,     0,   806,     0,  1806,  1811,     0,     0,     0,
    1807,     0,     0,     0,     0,   806,     0,     0,     0,  1812,
     806,     0,  1813,     0,   190,     0,   806,     0,     0,     0,
       0,  1808,  1809,     0,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1810,     0,     0,     0,
       0,     0,  1031,     0,     0,  1031,     0,  1031,     0,     0,
       0,     0,  1031,     0,   829,     0,     0,     0,     0,     0,
     191,     0,     0,     0,     0,     0,     0,     0,  1811,     0,
     829,   829,     0,     0,   192,     0,   806,     0,     0,     0,
       0,  1812,     0,     0,  1813,     0,     0,     0,     0,     0,
       0,  1814,   193,     0,     0,     0,     0,   829,   194,     0,
     829,     0,     0,     0,  1031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,     0,     0,     0,     0,     0,
       0,  1031,     0,     0,     0,   196,     0,     0,     0,     0,
       0,     0,     0,   197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   198,  1031,     0,     0,     0,
     199,     0,     0,     0,     0,     0,   200,     0,     0,     0,
       0,     0,     0,  1814,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   201,     0,     0,     0,     0,     0,     0,
       0,  1951,  1951,  1951,  1815,     0,     0,  1816,  1817,  1818,
       0,  1819,  1820,  1821,  1822,  1823,  1824,     0,   202,     0,
       0,     0,     0,     0,     0,   829,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1031,     0,  1031,   829,   203,
    1951,     0,     0,   829,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   829,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   204,     0,     0,     0,     0,  1815,     0,     0,  1816,
    1817,  1818,     0,  1819,  1820,  1821,  1822,  1823,  1824,     0,
       0,     0,   205,     0,     0,     0,     0,     0,  1031,     0,
       0,     0,   206,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   829,     0,     0,
       0,   830,     0,  1031,     0,     0,     0,     0,   830,   207,
       0,     0,     0,     0,   208,     0,   209,     0,     0,   830,
       0,     0,   210,     0,     0,   211,     0,     0,     0,  1031,
       0,     0,     0,     0,     0,  1951,  1031,     0,     0,     0,
       0,     0,   829,     0,   829,     0,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   829,   214,   829,     0,
       0,   215,     0,     0,     0,     0,     0,     0,     0,     0,
     216,     0,     0,     0,     0,   217,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   218,     0,     0,
       0,     0,     0,     0,     0,  1031,     0,     0,     0,     0,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   829,  1031,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1031,  1796,     0,     0,
    1797,     0,     0,     0,  1798,  1799,  1800,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1801,     0,     0,  3253,     0,     0,     0,     0,  1803,
       0,     0,     0,     0,     0,  1804,     0,     0,     0,   829,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   806,     0,     0,   829,     0,     0,     0,     0,  1805,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   829,     0,     0,   829,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   806,     0,     0,  1031,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,   806,     0,   806,     0,     0,   806,     0,     0,     0,
    1031,   806,   806,   806,   806,     0,     0,   806,   806,   806,
     806,   806,   806,   806,   806,   806,   806,     0,     0,     0,
     806,   806,     0,     0,     0,  1031,     0,     0,     0,     0,
     806,     0,     0,     0,   806,     0,  1951,     0,   806,     0,
       0,     0,     0,     0,     0,  1806,   806,     0,     0,   806,
    1807,   806,     0,     0,     0,     0,     0,     0,     0,  1031,
     806,     0,     0,   806,   806,     0,     0,     0,   806,   806,
       0,  1808,  1809,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,  1810,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   806,
       0,     0,     0,     0,     0,   806,   806,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1811,     0,
     830,     0,     0,     0,     0,   830,     0,     0,     0,     0,
       0,  1812,   806,     0,  1813,     0,   830,     0,     0,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,  1031,   830,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   806,     0,   830,     0,
       0,     0,     0,  1796,   830,     0,  1797,     0,     0,     0,
    1798,  1799,  1800,     0,     0,   830,     0,     0,     0,     0,
       0,     0,     0,   830,     0,     0,     0,  1801,     0,   829,
       0,     0,     0,     0,     0,  1803,     0,     0,     0,     0,
       0,  1804,     0,  1814,     0,     0,     0,     0,     0,     0,
       0,     0,  1796,     0,     0,  1797,     0,     0,     0,  1798,
    1799,  1800,     0,     0,     0,  1805,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1951,  1801,     0,     0,  3793,
    1951,  1031,  1951,     0,  1803,     0,     0,     0,     0,     0,
    1804,     0,     0,     0,     0,     0,     0,     0,   831,     0,
       0,     0,     0,     0,     0,   831,     0,     0,   830,     0,
       0,     0,     0,     0,  1805,     0,   831,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   829,     0,  1815,   829,     0,  1816,
    1817,  1818,     0,  1819,  1820,  1821,  1822,  1823,  1824,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1806,     0,     0,     0,     0,  1807,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1808,  1809,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1810,     0,     0,     0,     0,     0,     0,     0,
    1806,     0,   829,   829,     0,  1807,  1031,     0,     0,     0,
       0,     0,     0,     0,     0,   829,     0,   829,     0,     0,
       0,     0,     0,     0,  1811,     0,  1808,  1809,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1812,     0,     0,
    1813,  1810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1031,   806,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1811,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1812,     0,     0,  1813,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   829,     0,     0,     0,  1796,     0,     0,  1797,  1814,
       0,     0,  1798,  1799,  1800,     0,     0,     0,     0,     0,
       0,     0,   806,     0,     0,     0,     0,     0,     0,  1801,
       0,     0,     0,   806,     0,     0,     0,  1803,  3739,     0,
       0,     0,     0,  1804,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1814,     0,
       0,     0,     0,   806,     0,     0,     0,  1805,     0,     0,
       0,     0,     0,   806,   806,     0,  1031,     0,     0,     0,
     806,   806,     0,     0,     0,   806,  1031,     0,     0,     0,
     806,     0,     0,   806,   806,     0,     0,   830,   806,     0,
       0,     0,  1815,     0,   806,  1816,  1817,  1818,     0,  1819,
    1820,  1821,  1822,  1823,  1824,     0,     0,   830,     0,     0,
       0,     0,   806,     0,     0,     0,   806,     0,     0,   830,
       0,     0,     0,     0,     0,     0,     0,   831,   806,     0,
       0,     0,   831,   806,     0,     0,     0,     0,     0,   806,
       0,  1815,     0,   831,  1816,  1817,  1818,   830,  1819,  1820,
    1821,  1822,  1823,  1824,   806,     0,     0,     0,   830,   831,
       0,     0,     0,  1806,     0,     0,     0,     0,  1807,     0,
       0,     0,     0,   830,     0,   831,   830,     0,   806,     0,
       0,   831,     0,     0,     0,     0,     0,     0,     0,  1808,
    1809,     0,   831,     0,     0,     0,  1031,     0,     0,     0,
     831,     0,     0,     0,  1810,     0,     0,     0,     0,     0,
       0,     0,     0,   829,     0,     0,     0,     0,  1951,     0,
       0,     0,     0,     0,     0,     0,     0,  1031,     0,     0,
       0,     0,     0,     0,     0,     0,  1811,     0,     0,     0,
       0,     0,     0,   829,     0,     0,     0,     0,  1031,  1812,
       0,     0,  1813,     0,     0,   829,     0,     0,     0,     0,
       0,     0,  1951,  1031,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   829,     0,     0,     0,
       0,     0,     0,     0,     0,   831,     0,     0,     0,     0,
       0,     0,     0,   830,     0,     0,     0,     0,     0,     0,
       0,   830,   830,     0,     0,     0,  1031,     0,     0,     0,
       0,  1952,     0,     0,     0,  1220,  1220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   806,  1030,
       0,  1814,     0,     0,     0,     0,     0,     0,     0,   806,
       0,     0,     0,     0,     0,     0,     0,  1284,     0,     0,
    1030,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1952,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1031,     0,  1031,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   829,     0,     0,  1815,     0,     0,  1816,  1817,  1818,
       0,  1819,  1820,  1821,  1822,  1823,  1824,   806,     0,     0,
       0,  1031,     0,     0,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   806,   806,     0,     0,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   806,     0,     0,     0,     0,   806,     0,     0,     0,
       0,   806,     0,     0,   806,   806,     0,     0,     0,     0,
       0,     0,   806,   806,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   806,     0,
       0,     0,     0,     0,   830,   829,     0,   829,     0,     0,
       0,   806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1031,   829,     0,     0,     0,
       0,     0,     0,  1952,     0,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   830,     0,     0,     0,   830,     0,
       0,     0,   605,     0,   831,     0,     0,   606,     0,     0,
     830,     0,  1951,     0,     0,     0,     0,  1030,   806,   607,
       0,     0,     0,     0,   831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   831,  1030,     0,     0,
     608,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1030,     0,   609,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   831,     0,     0,   610,     0,     0,
       0,   806,     0,  1031,     0,   831,     0,     0,     0,     0,
       0,     0,     0,   830,   830,   611,     0,     0,     0,     0,
     831,     0,     0,   831,     0,     0,   830,     0,     0,     0,
     806,  1031,     0,   806,     0,   806,     0,   612,     0,     0,
       0,   830,   830,     0,     0,     0,     0,     0,   613,     0,
       0,     0,     0,   830,     0,     0,   614,     0,  1030,   806,
       0,     0,     0,   806,     0,     0,     0,     0,   615,  1031,
       0,  1753,     0,   616,   806,     0,     0,     0,     0,   617,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   806,     0,     0,   618,     0,     0,     0,
    1767,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1951,     0,     0,     0,
       0,     0,  1031,     0,     0,     0,  1031,  1031,  1785,  1786,
    1787,   806,  1789,     0,     0,     0,     0,     0,     0,     0,
     831,     0,   619,     0,     0,     0,     0,   829,   831,   831,
       0,     0,  1831,     0,     0,     0,     0,     0,  1953,     0,
       0,     0,  1030,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1952,   620,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   621,     0,     0,     0,     0,
       0,     0,     0,  1868,     0,   622,   806,     0,     0,     0,
       0,     0,     0,     0,     0,   206,     0,     0,     0,     0,
       0,     0,     0,  1953,     0,     0,     0,  1031,  1031,     0,
       0,     0,     0,  1973,     0,     0,     0,  1985,  1988,     0,
       0,     0,   623,     0,     0,     0,     0,   624,   806,   625,
       0,   806,     0,     0,     0,   626,     0,     0,   627,     0,
     806,     0,     0,     0,     0,   806,     0,   806,     0,   806,
       0,     0,     0,     0,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   628,     0,     0,
     629,     0,     0,   806,   630,     0,     0,     0,     0,     0,
       0,   631,     0,   632,     0,     0,     0,     0,   633,     0,
       0,     0,     0,     0,  1951,     0,   829,     0,     0,     0,
     634,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2022,     0,     0,     0,
       0,   831,     0,     0,   806,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
       0,     0,     0,   829,     0,     0,     0,   830,     0,     0,
       0,  1952,   830,     0,     0,   806,   830,     0,     0,     0,
       0,     0,     0,     0,   830,     0,     0,     0,     0,     0,
    1953,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2022,   830,     0,     0,     0,     0,     0,     0,     0,
       0,   831,     0,     0,     0,   831,     0,     0,     0,     0,
       0,     0,   806,     0,     0,     0,     0,   831,   806,   806,
     806,     0,     0,     0,     0,     0,     0,     0,     0,  1030,
       0,     0,     0,     0,     0,     0,   830,     0,     0,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   829,     0,     0,   830,   830,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1951,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1952,   830,     0,     0,  1952,
     831,   831,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   831,     0,     0,     0,     0,     0,     0,
    1030,     0,     0,     0,     0,     0,     0,     0,   831,   831,
     830,     0,   806,   806,   830,  1030,     0,     0,  1951,     0,
     831,     0,     0,  2022,     0,     0,   806,     0,     0,     0,
       0,     0,   830,     0,  1030,     0,     0,  1951,   806,   806,
       0,     0,     0,   830,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   830,     0,     0,     0,
       0,     0,     0,     0,     0,   830,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1030,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1030,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,     0,  1030,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1030,     0,
    1952,     0,  1029,     0,     0,     0,     0,     0,     0,  2520,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1953,     0,  2540,     0,  2542,     0,     0,  2554,  2557,  2562,
     556,     0,     0,     0,  2568,   557,     0,  2573,     0,     0,
       0,     0,  1030,     0,     0,  1030,     0,   558,     0,     0,
       0,     0,  2580,  2581,  2582,  2583,     0,     0,     0,     0,
    2590,     0,     0,     0,  2602,     0,   830,  2604,   559,     0,
    2611,  2612,  2613,  2614,  2615,  2616,  2617,  2618,  2619,     0,
    2620,   560,     0,     0,     0,     0,     0,  1220,     0,  2648,
       0,   561,     0,     0,     0,  -787,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   562,     0,     0,     0,     0,     0,   563,
       0,     0,     0,     0,     0,     0,     0,     0,   830,     0,
       0,     0,     0,     0,     0,   564,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   565,     0,     0,     0,
       0,     0,     0,     0,   566,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   830,     0,   567,     0,     0,     0,
       0,     0,     0,   568,  1030,     0,     0,   569,     0,     0,
       0,     0,   830,     0,     0,     0,     0,     0,     0,     0,
     830,     0,     0,     0,  -992,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2651,     0,     0,     0,     0,  1284,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   570,     0,     0,     0,     0,     0,     0,     0,     0,
    -525,     0,     0,     0,   831,     0,     0,     0,  1953,   831,
       0,     0,     0,   831,     0,     0,     0,     0,     0,     0,
       0,   831,     0,     0,     0,     0,     0,  1952,     0,  1029,
       0,     0,   571,  1952,     0,   572,     0,     0,     0,   831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,     0,     0,   573,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,  -419,     0,     0,     0,     0,     0,  2758,     0,
       0,     0,     0,   831,     0,     0,     0,     0,     0,     0,
     574,     0,     0,     0,     0,     0,     0,   575,     0,     0,
       0,   831,   831,  -419,     0,     0,   576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   830,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1953,   831,     0,  -419,  1953,     0,   577,   578,
    1029,   579,   580,     0,     0,     0,     0,     0,     0,  2710,
       0,   581,     0,  2022,  2716,     0,   582,     0,     0,     0,
       0,     0,   583,     0,     0,   584,     0,   831,   585,     0,
       0,   831,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -419,   830,     0,     0,     0,     0,     0,     0,   831,
       0,     0,     0,     0,     0,     0,     0,     0,   830,   830,
     831,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   831,     0,     0,     0,  1030,     0,     0,
       0,     0,   831,     0,     0,   830,     0,     0,   830,  1030,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1030,
       0,     0,     0,     0,     0,     0,     0,  1953,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2999,     0,     0,     0,     0,  1952,
    1952,  1952,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   830,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   831,     0,     0,   830,     0,  1952,     0,
       0,   830,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   830,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1020,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1852,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   831,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   830,     0,     0,  1030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   831,     0,     0,     0,     0,  3139,     0,  1029,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   831,
       0,     0,     0,  1952,     0,     0,     0,   831,     0,     0,
     830,     0,   830,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   830,     0,   830,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3192,     0,     0,     0,     0,  3198,     0,     0,     0,
     830,     0,     0,     0,  1953,     0,     0,     0,     0,     0,
    1953,  1029,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1789,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2562,     0,  2562,  2562,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3256,     0,     0,  3259,     0,
    3261,     0,     0,     0,     0,     0,     0,   830,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   830,     0,     0,     0,  1030,     0,     0,  3279,
       0,  3282,     0,  3284,     0,     0,     0,     0,     0,     0,
       0,     0,  1029,  1030,   830,   831,     0,   830,     0,     0,
       0,     0,     0,     0,  1030,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,     0,  1029,  2648,  2648,  2648,     0,
    1020,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,  3332,     0,     0,     0,     0,     0,
    1020,     0,     0,     0,     0,     0,  1973,     0,     0,     0,
       0,  3343,     0,     0,  1020,     0,     0,  1988,     0,   831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,  1952,   831,   831,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1029,     0,
       0,     0,   831,     0,     0,   831,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,  3380,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,     0,     0,     0,  2651,
    2651,  2651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1953,  1953,  1953,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2022,     0,     0,  2716,
     831,  2716,     0,     0,     0,     0,  2022,     0,     0,     0,
       0,     0,     0,   831,     0,  1953,     0,     0,   831,     0,
       0,     0,     0,     0,     0,  1020,     0,   830,   831,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1952,     0,  1030,  1029,     0,  1952,     0,
    1952,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   831,     0,     0,     0,     0,     0,     0,     0,
    2022,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1953,     0,   830,     0,     0,   830,     0,   831,     0,   831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   831,     0,   831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1030,
       0,  1030,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   831,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     830,   830,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,  1030,   830,     0,   830,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1030,     0,     0,
       0,     0,     0,     0,   831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   831,
       0,     0,     0,  2716,     0,     0,     0,     0,     0,     0,
    2716,  1029,     0,     0,  1020,  1029,  1029,     0,     0,     0,
       0,   831,     0,     0,   831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   830,
       0,     0,  1020,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1030,
       0,     0,     0,     0,     0,     0,     0,  3740,     0,  1029,
       0,     0,     0,     0,     0,     0,  3744,  2716,     0,     0,
       0,  1029,  3745,     0,  3746,     0,     0,  1022,     0,     0,
    1030,  1953,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,  3770,  3771,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,  1020,     0,     0,     0,     0,     0,  2568,
       0,     0,     0,     0,     0,     0,     0,  3796,  1020,     0,
    3799,     0,  3801,     0,     0,     0,  1020,     0,     0,     0,
       0,  3805,     0,     0,     0,     0,     0,  1020,     0,  3812,
    3813,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3857,     0,     0,  1030,     0,     0,  3864,  3865,  2648,     0,
       0,     0,     0,     0,  1020,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1030,     0,     0,  1020,     0,     0,
       0,     0,     0,  3880,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,     0,     0,  1284,     0,     0,  1030,
       0,  1020,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   831,     0,     0,     0,     0,     0,
       0,   830,     0,     0,     0,     0,  1952,     0,     0,     0,
       0,     0,     0,  1030,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,  1020,     0,     0,  1020,     0,
       0,   830,     0,     0,     0,     0,     0,     0,     0,     0,
    1953,     0,     0,   830,     0,  1953,     0,  1953,     0,     0,
    1952,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2651,     0,     0,   830,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,     0,     0,   831,
       0,     0,   831,     0,     0,  2022,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,  1022,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,     0,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   831,   831,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     831,     0,   831,     0,     0,  2716,     0,     0,  1029,   830,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,  1022,  1025,     0,     0,
       0,     0,     0,     0,     0,     0,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4117,  4118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   831,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   830,     0,   830,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1022,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1030,     0,     0,  4158,   830,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4163,     0,     0,     0,     0,     0,
       0,     0,  1020,     0,     0,     0,  1020,  1020,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2022,
    1952,     0,     0,     0,  4178,  4180,     0,     0,     0,     0,
       0,  4184,  4185,     0,     0,     0,  4186,     0,     0,     0,
       0,  4189,     0,     0,  4192,  4193,     0,     0,     0,  4197,
    1023,     0,     0,     0,     0,  4201,     0,     0,  1029,     0,
    1020,  1029,     0,  1029,     0,     0,     0,     0,  1029,     0,
    1023,     0,  1020,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1023,     0,     0,     0,     0,  2648,
       0,     0,     0,     0,  2648,     0,     0,     0,     0,     0,
    2648,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1020,     0,     0,  1220,     0,     0,     0,     0,
    1029,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,  1025,     0,  1029,   831,  4256,
       0,     0,     0,  1953,     0,     0,     0,     0,     0,     0,
    1030,     0,     0,  1026,  1022,  1025,     0,     0,     0,     0,
    1030,  1023,  1029,     0,     0,     0,     0,     0,   831,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     831,     0,     0,     0,     0,     0,     0,  1953,     0,     0,
       0,     0,     0,     0,  1952,     0,     0,     0,     0,     0,
       0,   831,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2651,     0,     0,     0,     0,  2651,     0,  1022,
       0,     0,     0,  2651,     0,   830,     0,  4316,     0,     0,
       0,  1029,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1022,     0,     0,
       0,     0,     0,     0,     0,  1023,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,     0,     0,     0,     0,
    1030,     0,     0,     0,     0,     0,     0,     0,     0,  4350,
       0,     0,     0,     0,  1029,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1030,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1030,     0,     0,     0,     0,     0,  1022,     0,
       0,  1020,     0,     0,     0,  1029,   831,  2716,     0,     0,
    1025,     0,  1029,  1022,     0,     0,     0,     0,     0,     0,
       0,  1022,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1022,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1952,     0,   830,     0,     0,     0,     0,     0,
    1030,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,     0,     0,     0,     0,  1022,
    1026,     0,     0,     0,  4442,  4443,     0,     0,  4444,  1029,
       0,     0,  1022,     0,     0,     0,     0,     0,     0,     0,
    1026,     0,  1029,     0,  1022,     0,     0,     0,     0,     0,
     831,     0,   831,     0,  1026,     0,  1022,     0,     0,  1020,
       0,     0,     0,  4478,  4479,     0,     0,     0,     0,  1023,
       0,   830,     0,     0,     0,     0,  1020,  4403,     0,  1030,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,   831,     0,     0,     0,     0,     0,     0,     0,     0,
    1022,     0,     0,  1022,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1030,     0,     0,     0,     0,
       0,  1026,     0,     0,  1023,     0,     0,  1953,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,  1025,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1029,     0,     0,   830,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1952,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,  1022,     0,     0,  1026,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1952,     0,     0,  2716,
       0,     0,     0,  1023,     0,     0,     0,  1025,     0,     0,
       0,     0,     0,     0,  2568,  1952,     0,     0,  1023,     0,
       0,     0,     0,     0,     0,     0,  1023,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1023,     0,  1020,
    4643,     0,  1020,     0,  1020,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,     0,  1789,     0,     0,     0,     0,
       0,  1953,     0,     0,     0,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,  1284,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1023,     0,     0,     0,  1025,     0,
       0,     0,   831,     0,     0,     0,     0,  1023,     0,     0,
       0,  1020,     0,  1025,     0,     0,     0,  2716,     0,  1023,
       0,  1025,  4692,     0,     0,     0,     0,     0,  1020,     0,
       0,  1023,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1030,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1023,     0,  1029,  1023,  1025,
       0,     0,     0,  1030,     0,     0,     0,  4743,     0,     0,
       0,     0,  1025,     0,     0,     0,     0,     0,     0,  1026,
       0,     0,     0,     0,  1025,     0,     0,  1022,     0,     0,
       0,  1022,  1022,     0,     0,     0,  1025,     0,     0,     0,
       0,     0,  1020,     0,  1020,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1030,     0,     0,     0,
    1030,  1030,     0,     0,     0,     0,     0,     0,     0,     0,
    4478,     0,     0,     0,     0,     0,     0,     0,     0,  1953,
    1025,   831,     0,  1025,  1026,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4800,  1022,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,  1022,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,  1023,     0,     0,
    1020,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1029,     0,     0,     0,     0,  1022,     0,     0,
       0,  4403,  1030,     0,     0,     0,  1020,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,   831,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4860,  4860,     0,     0,     0,
       0,  1029,     0,     0,     0,     0,  4478,     0,     0,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,     0,     0,
       0,     0,  1025,     0,     0,     0,     0,     0,  1026,     0,
       0,     0,  1020,     0,     0,     0,  1026,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1026,     0,     0,
    1020,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,   831,     0,     0,     0,
       0,  4860,     0,     0,     0,     0,     0,     0,     0,  1028,
    1953,     0,     0,     0,  1026,     0,     0,     0,     0,     0,
    4931,     0,     0,     0,     0,     0,     0,  1026,     0,     0,
       0,     0,     0,     0,     0,     0,  1022,     0,     0,  1026,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1026,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1023,  1953,     0,     0,  1023,  1023,     0,     0,
       0,     0,     0,     0,     0,     0,  1020,     0,     0,     0,
       0,     0,  1953,     0,     0,  1026,     0,     0,  1026,     0,
       0,     0,     0,  4860,  4972,     0,  1022,  1020,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1020,     0,     0,     0,     0,     0,     0,     0,
    1023,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,  1025,     0,     0,
       0,  1025,  1025,     0,     0,     0,  1020,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1022,  1025,     0,  1026,     0,     0,
       0,     0,     0,     0,  1029,     0,     0,  1025,     0,     0,
       0,  1022,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,     0,  1022,     0,     0,     0,     0,     0,  1020,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,  1025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1029,     0,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1023,     0,     0,     0,     0,     0,     0,  1020,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,     0,     0,     0,     0,     0,  1028,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1023,     0,     0,     0,     0,     0,  1029,     0,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,  1026,  1026,     0,     0,
       0,     0,     0,     0,  1022,     0,     0,  1022,     0,  1022,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1028,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,  1025,     0,     0,     0,
    1026,     0,     0,     0,     0,     0,  1022,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,     0,     0,     0,     0,     0,  1023,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,  1020,     0,     0,     0,  1023,     0,  1022,     0,
       0,     0,  1026,     0,     0,     0,     0,  1023,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1025,     0,     0,  1022,     0,  1022,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1025,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1025,     0,     0,     0,     0,     0,     0,  1029,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,  1029,     0,     0,
    1022,     0,     0,  1020,     0,  1028,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1022,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,     0,     0,     0,     0,     0,  1023,
       0,     0,  1023,     0,  1023,     0,     0,     0,  1029,  1023,
       0,     0,  1029,  1029,     0,     0,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,  1022,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,  1023,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,  1020,     0,     0,     0,  1023,     0,
       0,     0,     0,     0,  1025,     0,     0,  1025,     0,  1025,
       0,     0,     0,     0,  1025,  1020,     0,     0,     0,     0,
       0,     0,     0,  1023,  1029,     0,     0,     0,     0,  1028,
    1020,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,  1028,     0,     0,     0,     0,     0,     0,  1026,
       0,     0,     0,  1028,     0,     0,  1025,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,  1026,     0,     0,     0,
       0,     0,     0,  1025,     0,     0,     0,  1026,     0,     0,
       0,  1022,  1023,     0,  1023,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
    1028,     0,  1022,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1028,     0,  1022,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1028,     0,     0,
       0,     0,     0,     0,     0,  1023,     0,     0,     0,     0,
       0,     0,  1020,     0,     0,     0,     0,     0,     0,     0,
       0,  1022,     0,     0,     0,     0,     0,  1025,     0,  1025,
    1023,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1028,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1023,     0,  1020,     0,
       0,     0,     0,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,     0,  1025,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1026,
    1023,  1025,  1026,     0,  1026,     0,     0,     0,  1025,  1026,
       0,     0,     0,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,     0,     0,
       0,     0,  1020,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1026,     0,     0,     0,     0,     0,  1025,     0,     0,
       0,     0,     0,  1022,     0,     0,     0,     0,  1026,     0,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1023,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1023,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1020,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,  1026,     0,     0,     0,  1020,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1023,     0,     0,     0,
       0,  1025,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1020,     0,  1022,     0,
       0,     0,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1026,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,  1028,     0,
       0,     0,  1028,  1028,     0,     0,     0,     0,     0,     0,
    1026,     0,     0,     0,     0,     0,     0,  1022,     0,  1020,
       0,     0,     0,  1020,  1020,     0,     0,     0,     0,     0,
       0,  1025,     0,     0,     0,     0,  1026,     0,  1023,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,  1028,     0,
    1026,     0,     0,  1025,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,  1023,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1025,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1026,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1026,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1028,  1022,     0,
       0,     0,  1026,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1022,
       0,     0,     0,     0,     0,     0,  1026,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1022,     0,  1023,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,  1028,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1026,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1023,     0,  1028,     0,     0,     0,     0,
       0,     0,     0,  1023,     0,     0,     0,  1022,     0,     0,
       0,     0,  1028,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1026,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1023,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1023,     0,  1022,     0,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,     0,     0,
    1023,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1028,     0,     0,  1028,     0,
    1028,     0,  1026,  1023,     0,  1028,     0,     0,     0,  1025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,  1028,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,     0,  1022,     0,     0,     0,     0,  1025,     0,
       0,     0,  1023,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1022,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,  1023,     0,
       0,     0,     0,  1026,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
    1028,     0,     0,     0,  1022,     0,     0,  1025,  1022,  1022,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1025,     0,     0,     0,     0,     0,     0,
       0,  1028,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,     0,     0,
       0,     0,  1023,  1026,     0,     0,     0,     0,     0,     0,
    1022,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1028,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,  1026,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1026,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1026,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1025,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,     0,     0,
    1023,     0,     0,  1026,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1023,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1023,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1028,  1025,     0,     0,     0,     0,     0,  1023,
       0,     0,     0,  1023,  1023,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,  1026,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1025,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1028,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1025,     0,     0,     0,  1025,  1025,
       0,     0,     0,     0,     0,  1023,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1026,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1026,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1026,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1026,
       0,     0,     0,  1026,  1026,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,  1026,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1028,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1028,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1028,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1028,     0,     0,     0,  1028,
    1028,     0,     0,     0,     0,     0,   779,  1138,   600,  1139,
    1140,  1141,   654,  1142,     0,     0,     0,     0,     0,     0,
       0,   223,   224,   225,   226,   227,   228,   229,   230,  2642,
     232,   233,   234,     0,     0,     0,     0,  1143,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,   242,
    1144,   781,  1145,  1146,     0,   246,   247,   248,   249,   250,
    1147,  1148,   251,   252,  1149,  1150,   255,     0,   256,   257,
     258,   259,  1151,     0,  1152,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,  1028,   784,   274,   275,   276,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,   277,   278,   279,   280,   281,   282,  1160,
    1161,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,  2643,     0,   296,   297,  1001,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,  1162,   312,   313,   314,  1163,
    1164,   316,     0,   317,   318,  1165,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,  1166,
       0,  1167,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,   789,   346,   347,   348,   349,   350,  1168,
    1169,     0,  1170,     0,   354,   790,   791,   355,   792,   356,
     357,   358,   359,   360,     0,     0,   361,  1171,   793,   363,
     794,     0,   364,   365,   366,  1172,  1173,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,  1174,   795,  1175,   385,   386,   387,  1176,
     388,   389,   796,   390,  1177,  1178,   392,  1179,   394,   395,
     396,     0,   397,     0,     0,  1180,   399,   400,     0,     0,
     401,   402,   797,   403,   798,  1181,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,  1182,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,  1183,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,  1184,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,  1185,   464,   465,   466,   467,   468,   800,   469,   470,
    1186,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,  1187,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,  1188,  1189,     0,
       0,   495,   496,  1190,   498,  1191,  1192,   500,   501,   502,
     503,   504,   505,   506,     0,  1193,   507,   508,   509,   510,
     511,  1194,     0,   512,   513,   514,   515,   516,   517,  1195,
    2644,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,  1196,
    1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,   541,   542,
    1204,     0,     0,     0,     0,     0,     0,  1205,  1206,  2645,
       0,     0,     0,     0,     0,     0,  1208,  2646,   779,  1138,
     600,  1139,  1140,  1141,   654,  1142,     0,     0,     0,     0,
       0,     0,     0,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,  1143,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,   242,  1144,   781,  1145,  1146,     0,   246,   247,   248,
     249,   250,  1147,  1148,   251,   252,  1149,  1150,   255,     0,
     256,   257,   258,   259,  1151,     0,  1152,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,   276,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,   277,   278,   279,   280,   281,
     282,  1160,  1161,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,  1001,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,  1162,   312,   313,
     314,  1163,  1164,   316,     0,   317,   318,  1165,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,  1166,     0,  1167,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,   789,   346,   347,   348,   349,
     350,  1168,  1169,     0,  1170,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,  1171,
     793,   363,   794,     0,   364,   365,   366,  1172,  1173,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,  1174,   795,  1175,   385,   386,
     387,  1176,   388,   389,   796,   390,  1177,  1178,   392,  1179,
     394,   395,   396,     0,   397,     0,     0,  1180,   399,   400,
       0,     0,   401,   402,   797,   403,   798,  1181,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,  1182,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,  1183,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,  1184,   451,
     452,   453,   454,   455,   456,   457,   458,    39,   459,   460,
     461,   462,   463,  1185,   464,   465,   466,   467,   468,   800,
     469,   470,  1186,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,  1187,     0,   485,   486,
      43,   487,   801,   488,   489,   490,   491,   492,     0,  1188,
    1189,     0,     0,   495,   496,  1190,   498,  1191,  1192,   500,
     501,   502,   503,   504,   505,   506,     0,  1193,   507,   508,
     509,   510,   511,  1194,     0,   512,   513,   514,   515,   516,
    1074,  1195,     0,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,    48,   525,   526,   527,   528,   529,   530,
     531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,
     541,   542,  1204,     0,    49,     0,     0,     0,     0,  1205,
    1206,     0,     0,     0,     0,     0,     0,     0,  1208,  4655,
     779,  1138,   600,  1139,  1140,  1141,   654,  1142,     0,     0,
       0,     0,     0,     0,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,  1143,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,   242,  1144,   781,  1145,  1146,     0,   246,
     247,   248,   249,   250,  1147,  1148,   251,   252,  1149,  1150,
     255,     0,   256,   257,   258,   259,  1151,     0,  1152,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,   278,   279,
     280,   281,   282,  1160,  1161,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,  1001,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,  1162,
     312,   313,   314,  1163,  1164,   316,     0,   317,   318,  1165,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,  1166,     0,  1167,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,   789,   346,   347,
     348,   349,   350,  1168,  1169,     0,  1170,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,     0,     0,
     361,  1171,   793,   363,   794,     0,   364,   365,   366,  1172,
    1173,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,  1174,   795,  1175,
     385,   386,   387,  1176,   388,   389,   796,   390,  1177,  1178,
     392,  1179,   394,   395,   396,     0,   397,     0,     0,  1180,
     399,   400,     0,     0,   401,   402,   797,   403,   798,  1181,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,  1182,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  1183,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
    1184,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,  1185,   464,   465,   466,   467,
     468,   800,   469,   470,  1186,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,  1187,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,  1188,  1189,     0,     0,   495,   496,  1190,   498,  1191,
    1192,   500,   501,   502,   503,   504,   505,   506,     0,  1193,
     507,   508,   509,   510,   511,  1194,     0,   512,   513,   514,
     515,   516,   517,  1195,     0,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
    1203,   540,   541,   542,  1204,     0,     0,     0,     0,     0,
       0,  1205,  1206,     0,     0,     0,     0,     0,     0,     0,
    1208,  2552,   779,  1138,   600,  1139,  1140,  1141,   654,  1142,
       0,     0,     0,     0,     0,     0,     0,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,     0,     0,  1143,     0,     0,   235,   236,     0,   237,
     238,   780,   239,   240,   241,   242,  1144,   781,  1145,  1146,
       0,   246,   247,   248,   249,   250,  1147,  1148,   251,   252,
    1149,  1150,   255,     0,   256,   257,   258,   259,  1151,     0,
    1152,     0,   261,   262,   263,   264,   783,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,   784,   274,
     275,   276,  1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,
     278,   279,   280,   281,   282,  1160,  1161,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,  1001,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,  1162,   312,   313,   314,  1163,  1164,   316,     0,   317,
     318,  1165,   320,     0,   321,     0,   322,   786,     0,   787,
     323,   324,   325,     0,   326,  1166,     0,  1167,   329,     0,
     330,   331,   332,   333,   334,   788,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,   789,
     346,   347,   348,   349,   350,  1168,  1169,     0,  1170,     0,
     354,   790,   791,   355,   792,   356,   357,   358,   359,   360,
       0,     0,   361,  1171,   793,   363,   794,     0,   364,   365,
     366,  1172,  1173,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,  1174,
     795,  1175,   385,   386,   387,  1176,   388,   389,   796,   390,
    1177,  1178,   392,  1179,   394,   395,   396,     0,   397,     0,
       0,  1180,   399,   400,     0,     0,   401,   402,   797,   403,
     798,  1181,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,  1182,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,  1183,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,   799,   447,
     448,   449,  1184,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,  1185,   464,   465,
     466,   467,   468,   800,   469,   470,  1186,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
    1187,     0,   485,   486,     0,   487,   801,   488,   489,   490,
     491,   492,     0,  1188,  1189,     0,     0,   495,   496,  1190,
     498,  1191,  1192,   500,   501,   502,   503,   504,   505,   506,
       0,  1193,   507,   508,   509,   510,   511,  1194,     0,   512,
     513,   514,   515,   516,   517,  1195,     0,   519,   802,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,  1203,   540,   541,   542,  1204,     0,     0,     0,
       0,     0,     0,  1205,  1206,     0,     0,     0,     0,     0,
       0,     0,  1208,  3748,   779,  1138,   600,  1139,  1140,  1141,
     654,  1142,     0,     0,     0,     0,     0,     0,     0,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,  1143,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,   242,  1144,   781,
    1145,  1146,     0,   246,   247,   248,   249,   250,  1147,  1148,
     251,   252,  1149,  1150,   255,     0,   256,   257,   258,   259,
    1151,     0,  1152,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,  1153,  1154,  1155,  1156,  1157,  1158,
    1159,   277,   278,   279,   280,   281,   282,  1160,  1161,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,  1001,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,  1162,   312,   313,   314,  1163,  1164,   316,
       0,   317,   318,  1165,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,  1166,     0,  1167,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,   789,   346,   347,   348,   349,   350,  1168,  1169,     0,
    1170,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,  1171,   793,   363,   794,     0,
     364,   365,   366,  1172,  1173,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1174,   795,  1175,   385,   386,   387,  1176,   388,   389,
     796,   390,  1177,  1178,   392,  1179,   394,   395,   396,     0,
     397,     0,     0,  1180,   399,   400,     0,     0,   401,   402,
     797,   403,   798,  1181,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,  1182,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
    1183,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,  1184,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,  1185,
     464,   465,   466,   467,   468,   800,   469,   470,  1186,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,  1187,     0,   485,   486,     0,   487,   801,   488,
     489,   490,   491,   492,     0,  1188,  1189,     0,     0,   495,
     496,  1190,   498,  1191,  1192,   500,   501,   502,   503,   504,
     505,   506,     0,  1193,   507,   508,   509,   510,   511,  1194,
       0,   512,   513,   514,   515,   516,   517,  1195,     0,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,  1196,  1197,  1198,
    1199,  1200,  1201,  1202,  1203,   540,   541,   542,  1204,     0,
       0,   222,     0,     0,     0,  1205,  1206,     0,     0,     0,
       0,     0,     0,     0,  1208,  3819,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,  3835,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0, -1601,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0, -1601,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345, -1601,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355, -1601,   356,   357,   358,   359,   360,     0,
       0,   361,   362, -1601,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383, -1601,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446, -1601,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,     0,     0,     0,   993,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1291,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,     0,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,     0,   994,   781,   995,   996,     0,   246,   247,   248,
     249,   250,     0,     0,   251,   252,   997,   998,   255,     0,
     256,   257,   258,   259,     0,     0,   782,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,   276,     0,     0,
       0,   785,     0,     0,     0,   277,   278,   279,   280,   281,
     282,   999,  1000,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,  1001,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,     0,   312,   313,
     314,     0,     0,   316,     0,   317,   318,  1002,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,     0,     0,     0,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,  2008,   339,   340,   341,
     342,   343,   344,     0,   345,   789,  2009,   347,   348,   349,
     350,  1004,  1005,     0,  1006,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,     0,
     793,   363,   794,     0,   364,   365,   366,     0,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,  1007,   795,  1008,   385,   386,
       0,     0,   388,   389,   796,   390,     0,     0,   392,  1009,
     394,   395,   396,     0,   397,     0,     0,   398,   399,   400,
       0,     0,   401,  2011,   797,   403,   798,     0,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,     0,
     416,     0,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,  1010,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,     0,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,     0,   464,   465,  2012,   467,   468,   800,
     469,   470,  1012,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,     0,     0,   485,   486,
       0,   487,   801,   488,   489,   490,   491,   492,     0,  1013,
    1014,     0,     0,   495,   496,     0,   498,     0,     0,   500,
     501,   502,   503,   504,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,     0,   512,   513,   514,   515,   516,
       0,  1015,  2013,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     993,     0,     0,     0,     0,     0,     0,     0,     0,   540,
     541,   542,     0,     0,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,  2120,
       0,     0,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,     0,   994,   781,   995,   996,     0,   246,
     247,   248,   249,   250,     0,     0,   251,   252,   997,   998,
     255,     0,   256,   257,   258,   259,     0,     0,   782,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
       0,     0,     0,   785,     0,     0,     0,   277,   278,   279,
     280,   281,   282,   999,  1000,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,  1001,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,     0,
     312,   313,   314,     0,     0,   316,     0,   317,   318,  1002,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,     0,     0,     0,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,  2008,   339,
     340,   341,   342,   343,   344,     0,   345,   789,  2009,   347,
     348,   349,   350,  1004,  1005,     0,  1006,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,     0,     0,
     361,     0,   793,   363,   794,     0,   364,   365,   366,     0,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,  1007,   795,  1008,
     385,   386,     0,     0,   388,   389,   796,   390,     0,     0,
     392,  1009,   394,   395,   396,     0,   397,     0,     0,   398,
     399,   400,     0,     0,   401,  2011,   797,   403,   798,     0,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,     0,   416,     0,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  1010,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
       0,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,     0,   464,   465,  2012,   467,
     468,   800,   469,   470,  1012,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,     0,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,  1013,  1014,     0,     0,   495,   496,     0,   498,     0,
       0,   500,   501,   502,   503,   504,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,     0,   512,   513,   514,
     515,   516,     0,  1015,  2013,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   779,  1138,   600,  1139,  1140,  1141,   654,  1142,
       0,   540,   541,   542,     0,     0,     0,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,  3074,     0,  1143,     0,     0,   235,   236,     0,   237,
     238,   780,   239,   240,   241,   242,  1144,   781,  1145,  1146,
       0,   246,   247,   248,   249,   250,  1147,  1148,   251,   252,
    1149,  1150,   255,     0,   256,   257,   258,   259,  1151,     0,
    1152,     0,   261,   262,   263,   264,   783,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,   784,   274,
     275,   276,  1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,
     278,   279,   280,   281,   282,  1160,  1161,   285,  1283,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,  1001,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,  1162,   312,   313,   314,  1163,  1164,   316,     0,   317,
     318,  1165,   320,     0,   321,     0,   322,   786,     0,   787,
     323,   324,   325,     0,   326,  1166,     0,  1167,   329,     0,
     330,   331,   332,   333,   334,   788,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,   789,
     346,   347,   348,   349,   350,  1168,  1169,     0,  1170,     0,
     354,   790,   791,   355,   792,   356,   357,   358,   359,   360,
       0,     0,   361,  1171,   793,   363,   794,     0,   364,   365,
     366,  1172,  1173,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,  1174,
     795,  1175,   385,   386,   387,  1176,   388,   389,   796,   390,
    1177,  1178,   392,  1179,   394,   395,   396,     0,   397,     0,
       0,  1180,   399,   400,     0,     0,   401,   402,   797,   403,
     798,  1181,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,  1182,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,  1183,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,   799,   447,
     448,   449,  1184,   451,   452,   453,   454,   455,   456,   457,
     458,    39,   459,   460,   461,   462,   463,  1185,   464,   465,
     466,   467,   468,   800,   469,   470,  1186,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
    1187,     0,   485,   486,    43,   487,   801,   488,   489,   490,
     491,   492,     0,  1188,  1189,     0,     0,   495,   496,  1190,
     498,  1191,  1192,   500,   501,   502,   503,   504,   505,   506,
       0,  1193,   507,   508,   509,   510,   511,  1194,     0,   512,
     513,   514,   515,   516,  1074,  1195,     0,   519,   802,   520,
     521,   522,   523,     0,     0,   524,     0,    48,   525,   526,
     527,   528,   529,   530,   531,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,  1203,   540,   541,   542,  1204,     0,    49,     0,
       0,     0,     0,  1205,  1206,     0,     0,     0,     0,     0,
       0,     0,  1208,   779,  1138,   600,  1139,  1140,  1141,   654,
    1142,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,  1143,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,  1144,   781,  1145,
    1146,     0,   246,   247,   248,   249,   250,  1147,  1148,   251,
     252,  1149,  1150,   255,     0,   256,   257,   258,   259,  1151,
       0,  1152,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
     277,   278,   279,   280,   281,   282,  1160,  1161,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1001,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,  1162,   312,   313,   314,  1163,  1164,   316,     0,
     317,   318,  1165,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,  1166,     0,  1167,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,  1168,  1169,     0,  1170,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,  1171,   793,   363,   794,     0,   364,
     365,   366,  1172,  1173,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1174,   795,  1175,   385,   386,   387,  1176,   388,   389,   796,
     390,  1177,  1178,   392,  1179,   394,   395,   396,     0,   397,
       0,     0,  1180,   399,   400,     0,     0,   401,   402,   797,
     403,   798,  1181,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,  1182,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1183,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,  1184,   451,   452,   453,   454,   455,   456,
     457,   458,    39,   459,   460,   461,   462,   463,  1185,   464,
     465,   466,   467,   468,   800,   469,   470,  1186,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,  1187,     0,   485,   486,    43,   487,   801,   488,   489,
     490,   491,   492,     0,  1188,  1189,     0,     0,   495,   496,
    1190,   498,  1191,  1192,   500,   501,   502,   503,   504,   505,
     506,     0,  1193,   507,   508,   509,   510,   511,  1194,     0,
     512,   513,   514,   515,   516,  1074,  1195,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,    48,   525,
     526,   527,   528,   529,   530,   531,  1196,  1197,  1198,  1199,
    1200,  1201,  1202,  1203,   540,   541,   542,  1204,     0,    49,
       0,     0,     0,     0,  1205,  1206,     0,     0,     0,     0,
       0,     0,     0,  1208,   779,  1138,   600,  1139,  1140,  1141,
     654,  1142,     0,     0,     0,     0,     0,     0,     0,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,  1143,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,   242,  1144,   781,
    1145,  1146,  2558,   246,   247,   248,   249,   250,  1147,  1148,
     251,   252,  1149,  1150,   255,     0,   256,   257,   258,   259,
    1151,     0,  1152,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,  1153,  1154,  1155,  1156,  1157,  1158,
    1159,   277,   278,   279,   280,   281,   282,  1160,  1161,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,  1001,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,  1162,   312,   313,   314,  1163,  1164,   316,
       0,   317,   318,  1165,   320,     0,   321,     0,   322,   786,
    2559,   787,   323,   324,   325,     0,   326,  1166,     0,  1167,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,   789,   346,   347,   348,   349,   350,  1168,  1169,     0,
    1170,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,  2560,   361,  1171,   793,   363,   794,     0,
     364,   365,   366,  1172,  1173,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1174,   795,  1175,   385,   386,   387,  1176,   388,   389,
     796,   390,  1177,  1178,   392,  1179,   394,   395,   396,     0,
     397,     0,     0,  1180,   399,   400,     0,     0,   401,   402,
     797,   403,   798,  1181,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,  1182,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
    1183,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,  1184,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,  1185,
     464,   465,   466,   467,   468,   800,   469,   470,  1186,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,  1187,     0,   485,   486,     0,   487,   801,   488,
     489,   490,   491,   492,     0,  1188,  1189,     0,  2561,   495,
     496,  1190,   498,  1191,  1192,   500,   501,   502,   503,   504,
     505,   506,     0,  1193,   507,   508,   509,   510,   511,  1194,
       0,   512,   513,   514,   515,   516,   517,  1195,     0,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,  1196,  1197,  1198,
    1199,  1200,  1201,  1202,  1203,   540,   541,   542,  1204,     0,
       0,     0,     0,     0,     0,  1205,  1206,     0,     0,     0,
       0,     0,     0,     0,  1208,   779,  1138,   600,  1139,  1140,
    1141,   654,  1142,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,  1143,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,  1144,
     781,  1145,  1146,     0,   246,   247,   248,   249,   250,  1147,
    1148,   251,   252,  1149,  1150,   255,     0,   256,   257,   258,
     259,  1151,     0,  1152,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,   277,   278,   279,   280,   281,   282,  1160,  1161,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1001,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,  1162,   312,   313,   314,  1163,  1164,
     316,     0,   317,   318,  1165,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,  1166,     0,
    1167,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,  1168,  1169,
       0,  1170,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,  1171,   793,   363,   794,
       0,   364,   365,   366,  1172,  1173,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1174,   795,  1175,   385,   386,   387,  1176,   388,
     389,   796,   390,  1177,  1178,   392,  1179,   394,   395,   396,
       0,   397,     0,     0,  1180,   399,   400,     0,     0,   401,
     402,   797,   403,   798,  1181,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,  1182,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1183,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,  1184,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
    1185,   464,   465,   466,   467,   468,   800,   469,   470,  1186,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,  1187,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,  1188,  1189,     0,     0,
     495,   496,  1190,   498,  1191,  1192,   500,   501,   502,   503,
     504,   505,   506,     0,  1193,   507,   508,   509,   510,   511,
    1194,     0,   512,   513,   514,   515,   516,   517,  1195,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,  1196,  1197,
    1198,  1199,  1200,  1201,  1202,  1203,   540,   541,   542,  1204,
       0,     0,     0,     0,     0,     0,  1205,  1206,     0,     0,
       0,     0,     0,  1750,  2513,  1208,   779,  1138,   600,  1139,
    1140,  1141,   654,  1142,     0,     0,     0,     0,     0,     0,
       0,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,  1143,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,   242,
    1144,   781,  1145,  1146,     0,   246,   247,   248,   249,   250,
    1147,  1148,   251,   252,  1149,  1150,   255,     0,   256,   257,
     258,   259,  1151,     0,  1152,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,   784,   274,   275,   276,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,   277,   278,   279,   280,   281,   282,  1160,
    1161,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,  1001,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,  1162,   312,   313,   314,  1163,
    1164,   316,     0,   317,   318,  1165,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,  1166,
       0,  1167,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,   789,   346,   347,   348,   349,   350,  1168,
    1169,     0,  1170,     0,   354,   790,   791,   355,   792,   356,
     357,   358,   359,   360,     0,     0,   361,  1171,   793,   363,
     794,     0,   364,   365,   366,  1172,  1173,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,  1174,   795,  1175,   385,   386,   387,  1176,
     388,   389,   796,   390,  1177,  1178,   392,  1179,   394,   395,
     396,     0,   397,     0,     0,  1180,   399,   400,     0,     0,
     401,   402,   797,   403,   798,  1181,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,  1182,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,  1183,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,  1184,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,  1185,   464,   465,   466,   467,   468,   800,   469,   470,
    1186,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,  1187,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,  1188,  1189,     0,
       0,   495,   496,  1190,   498,  1191,  1192,   500,   501,   502,
     503,   504,   505,   506,     0,  1193,   507,   508,   509,   510,
     511,  1194,     0,   512,   513,   514,   515,   516,   517,  1195,
       0,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,  1196,
    1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,   541,   542,
    1204,     0,     0,     0,     0,     0,     0,  1205,  1206,  1207,
       0,     0,     0,     0,     0,     0,  1208,   779,  1138,   600,
    1139,  1140,  1141,   654,  1142,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,  1143,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,  1144,   781,  1145,  1146,     0,   246,   247,   248,   249,
     250,  1147,  1148,   251,   252,  1149,  1150,   255,     0,   256,
     257,   258,   259,  1151,     0,  1152,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,  1153,  1154,  1155,
    1156,  1157,  1158,  1159,   277,   278,   279,   280,   281,   282,
    1160,  1161,   285,  1283,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
    1001,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,  1162,   312,   313,   314,
    1163,  1164,   316,     0,   317,   318,  1165,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
    1166,     0,  1167,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
    1168,  1169,     0,  1170,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,  1171,   793,
     363,   794,     0,   364,   365,   366,  1172,  1173,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1174,   795,  1175,   385,   386,   387,
    1176,   388,   389,   796,   390,  1177,  1178,   392,  1179,   394,
     395,   396,     0,   397,     0,     0,  1180,   399,   400,     0,
       0,   401,   402,   797,   403,   798,  1181,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,  1182,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,  1183,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,  1184,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,  1185,   464,   465,   466,   467,   468,   800,   469,
     470,  1186,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,  1187,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,  1188,  1189,
       0,     0,   495,   496,  1190,   498,  1191,  1192,   500,   501,
     502,   503,   504,   505,   506,     0,  1193,   507,   508,   509,
     510,   511,  1194,     0,   512,   513,   514,   515,   516,   517,
    1195,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
    1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,   541,
     542,  1204,     0,     0,     0,     0,     0,     0,  1205,  1206,
       0,     0,     0,     0,     0,     0,     0,  1208,   779,  1138,
     600,  1139,  1140,  1141,   654,  1142,     0,     0,     0,     0,
       0,     0,     0,   223,   224,   225,   226,   227,   228,   229,
     230,  1983,   232,   233,   234,     0,     0,     0,     0,  1143,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,   242,  1144,   781,  1145,  1146,     0,   246,   247,   248,
     249,   250,  1147,  1148,   251,   252,  1149,  1150,   255,     0,
     256,   257,   258,   259,  1151,     0,  1152,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,   276,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,   277,   278,   279,   280,   281,
     282,  1160,  1161,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,  1001,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,  1162,   312,   313,
     314,  1163,  1164,   316,     0,   317,   318,  1165,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,  1166,     0,  1167,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,   789,   346,   347,   348,   349,
     350,  1168,  1169,     0,  1170,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,  1171,
     793,   363,   794,     0,   364,   365,   366,  1172,  1173,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,  1174,   795,  1175,   385,   386,
     387,  1176,   388,   389,   796,   390,  1177,  1178,   392,  1179,
     394,   395,   396,     0,   397,     0,     0,  1180,   399,   400,
       0,     0,   401,   402,   797,   403,   798,  1181,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,  1182,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,  1183,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,  1184,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,  1185,   464,   465,   466,   467,   468,   800,
     469,   470,  1186,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,  1187,     0,   485,   486,
       0,   487,   801,   488,   489,   490,   491,   492,     0,  1188,
    1189,     0,     0,   495,   496,  1190,   498,  1191,  1192,   500,
     501,   502,   503,   504,   505,   506,     0,  1193,   507,   508,
     509,   510,   511,  1194,     0,   512,   513,   514,   515,   516,
     517,  1195,     0,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,
     541,   542,  1204,     0,     0,     0,     0,     0,     0,  1205,
    1206,     0,     0,     0,     0,     0,     0,     0,  1208,   779,
    1138,   600,  1139,  1140,  1141,   654,  1142,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
    1143,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,  1144,   781,  1145,  1146,     0,   246,   247,
     248,   249,   250,  1147,  1148,   251,   252,  1149,  1150,   255,
       0,   256,   257,   258,   259,  1151,     0,  1152,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,  1153,
    1154,  1155,  1156,  1157,  1158,  1159,   277,   278,   279,   280,
     281,   282,  1160,  1161,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,  1001,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,  1162,   312,
     313,   314,  1163,  1164,   316,     0,   317,   318,  1165,   320,
       0,   321,     0,   322,   786,  2559,   787,   323,   324,   325,
       0,   326,  1166,     0,  1167,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,  1168,  1169,     0,  1170,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
    1171,   793,   363,   794,     0,   364,   365,   366,  1172,  1173,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,  1174,   795,  1175,   385,
     386,   387,  1176,   388,   389,   796,   390,  1177,  1178,   392,
    1179,   394,   395,   396,     0,   397,     0,     0,  1180,   399,
     400,     0,     0,   401,   402,   797,   403,   798,  1181,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
    1182,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,  1183,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,  1184,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,  1185,   464,   465,   466,   467,   468,
     800,   469,   470,  1186,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,  1187,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
    1188,  1189,     0,     0,   495,   496,  1190,   498,  1191,  1192,
     500,   501,   502,   503,   504,   505,   506,     0,  1193,   507,
     508,   509,   510,   511,  1194,     0,   512,   513,   514,   515,
     516,   517,  1195,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,
     540,   541,   542,  1204,     0,     0,     0,     0,     0,     0,
    1205,  1206,     0,     0,     0,     0,     0,     0,     0,  1208,
     779,  1138,   600,  1139,  1140,  1141,   654,  1142,     0,     0,
       0,     0,     0,     0,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,  1143,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,   242,  1144,   781,  1145,  1146,     0,   246,
     247,   248,   249,   250,  1147,  1148,   251,   252,  1149,  1150,
     255,     0,   256,   257,   258,   259,  1151,     0,  1152,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,   278,   279,
     280,   281,   282,  1160,  1161,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,  1001,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,  1162,
     312,   313,   314,  1163,  1164,   316,     0,   317,   318,  1165,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,  1166,     0,  1167,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,   789,   346,   347,
     348,   349,   350,  1168,  1169,     0,  1170,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,     0,     0,
     361,  1171,   793,   363,   794,     0,   364,   365,   366,  1172,
    1173,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,  1174,   795,  1175,
     385,   386,   387,  1176,   388,   389,   796,   390,  1177,  1178,
     392,  1179,   394,   395,   396,     0,   397,     0,     0,  1180,
     399,   400,     0,     0,   401,   402,   797,   403,   798,  1181,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,  1182,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  1183,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
    1184,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,  1185,   464,   465,   466,   467,
     468,   800,   469,   470,  1186,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,  1187,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,  1188,  1189,     0,     0,   495,   496,  1190,   498,  1191,
    1192,   500,   501,   502,   503,   504,   505,   506,     0,  1193,
     507,   508,   509,   510,   511,  1194,     0,   512,   513,   514,
     515,   516,   517,  1195,  3866,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
    1203,   540,   541,   542,  1204,     0,     0,     0,     0,     0,
       0,  1205,  1206,     0,     0,     0,     0,     0,     0,     0,
    1208,   779,  1138,   600,  1139,  1140,  1141,   654,  1142,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,  1143,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,  1144,   781,  1145,  1146,     0,
     246,   247,   248,   249,   250,  1147,  1148,   251,   252,  1149,
    1150,   255,     0,   256,   257,   258,   259,  1151,     0,  1152,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,  1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,   278,
     279,   280,   281,   282,  1160,  1161,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1001,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
    1162,   312,   313,   314,  1163,  1164,   316,     0,   317,   318,
    1165,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,  1166,     0,  1167,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,  1168,  1169,     0,  1170,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,  1171,   793,   363,   794,     0,   364,   365,   366,
    1172,  1173,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1174,   795,
    1175,   385,   386,   387,  1176,   388,   389,   796,   390,  1177,
    1178,   392,  1179,   394,   395,   396,     0,   397,     0,     0,
    1180,   399,   400,     0,     0,   401,   402,   797,   403,   798,
    1181,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,  1182,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1183,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,  1184,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,  1185,   464,   465,   466,
     467,   468,   800,   469,   470,  1186,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,  1187,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1188,  1189,     0,     0,   495,   496,  1190,   498,
    1191,  1192,   500,   501,   502,   503,   504,   505,   506,     0,
    1193,   507,   508,   509,   510,   511,  1194,     0,   512,   513,
     514,   515,   516,   517,  1195,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,  1196,  1197,  1198,  1199,  1200,  1201,
    1202,  1203,   540,   541,   542,  1204,     0,     0,     0,     0,
       0,     0,  1205,  1206,     0,     0,     0,     0,     0,     0,
       0,  1208,   779,  1138,   600,  1139,  1140,  1141,   654,  1142,
       0,     0,     0,     0,     0,     0,     0,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,     0,     0,  1143,     0,     0,   235,   236,     0,   237,
     238,   780,   239,   240,   241,   242,  1144,   781,  1145,  1146,
       0,   246,   247,   248,   249,   250,  1147,  1148,   251,   252,
    1149,  1150,   255,     0,   256,   257,   258,   259,  1151,     0,
    1152,     0,   261,   262,   263,   264,   783,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,   784,   274,
     275,  3879,  1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,
     278,   279,   280,   281,   282,  1160,  1161,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,  1001,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,  1162,   312,   313,   314,  1163,  1164,   316,     0,   317,
     318,  1165,   320,     0,   321,     0,   322,   786,     0,   787,
     323,   324,   325,     0,   326,  1166,     0,  1167,   329,     0,
     330,   331,   332,   333,   334,   788,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,   789,
     346,   347,   348,   349,   350,  1168,  1169,     0,  1170,     0,
     354,   790,   791,   355,   792,   356,   357,   358,   359,   360,
       0,     0,   361,  1171,   793,   363,   794,     0,   364,   365,
     366,  1172,  1173,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,  1174,
     795,  1175,   385,   386,   387,  1176,   388,   389,   796,   390,
    1177,  1178,   392,  1179,   394,   395,   396,     0,   397,     0,
       0,  1180,   399,   400,     0,     0,   401,   402,   797,   403,
     798,  1181,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,  1182,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,  1183,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,   799,   447,
     448,   449,  1184,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,  1185,   464,   465,
     466,   467,   468,   800,   469,   470,  1186,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
    1187,     0,   485,   486,     0,   487,   801,   488,   489,   490,
     491,   492,     0,  1188,  1189,     0,     0,   495,   496,  1190,
     498,  1191,  1192,   500,   501,   502,   503,   504,   505,   506,
       0,  1193,   507,   508,   509,   510,   511,  1194,     0,   512,
     513,   514,   515,   516,   517,  1195,     0,   519,   802,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,  1203,   540,   541,   542,  1204,     0,     0,     0,
       0,     0,     0,  1205,  1206,     0,     0,     0,     0,     0,
       0,     0,  1208,   779,  1138,   600,  1139,  1140,  1141,   654,
    1142,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,  1143,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,  1144,   781,  1145,
    1146,     0,   246,   247,   248,   249,   250,  1147,  1148,   251,
     252,  1149,  1150,   255,     0,   256,   257,   258,   259,  1151,
       0,  1152,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
     277,   278,   279,   280,   281,   282,  1160,  1161,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1001,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,  1162,   312,   313,   314,  1163,  1164,   316,     0,
     317,   318,  1165,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,  1166,     0,  1167,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,  1168,  1169,     0,  1170,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,  1171,   793,   363,   794,     0,   364,
     365,   366,  1172,  1173,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1174,   795,  1175,   385,   386,   387,  1176,   388,   389,   796,
     390,  1177,  1178,   392,  1179,   394,   395,   396,     0,   397,
       0,     0,  1180,   399,   400,     0,     0,   401,   402,   797,
     403,   798,  1181,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,  1182,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1183,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,  1184,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,  1185,   464,
     465,   466,   467,   468,   800,   469,   470,  1186,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,  1187,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,  1188,  1189,     0,     0,   495,   496,
    1190,   498,  1191,  1192,   500,   501,   502,   503,   504,   505,
     506,     0,  1193,   507,   508,   509,   510,   511,  1194,     0,
     512,   513,   514,   515,   516,   517,  1195,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,  4170,  1196,  1197,  1198,  1199,
    1200,  1201,  1202,  1203,   540,   541,   542,  1204,     0,     0,
       0,     0,     0,     0,  1205,  1206,     0,     0,     0,     0,
       0,     0,     0,  1208,   779,  1138,   600,  1139,  1140,  1141,
     654,  1142,     0,     0,     0,     0,     0,     0,     0,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,  1143,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,   242,  1144,   781,
    1145,  1146,     0,   246,   247,   248,   249,   250,  1147,  1148,
     251,   252,  1149,  1150,   255,     0,   256,   257,   258,   259,
    1151,     0,  1152,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,  1153,  1154,  1155,  1156,  1157,  1158,
    1159,   277,   278,   279,   280,   281,   282,  1160,  1161,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,  1001,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,  1162,   312,   313,   314,  1163,  1164,   316,
       0,   317,   318,  1165,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,  1166,     0,  1167,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,   789,   346,   347,   348,   349,   350,  1168,  1169,     0,
    1170,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,  1171,   793,   363,   794,     0,
     364,   365,   366,  1172,  1173,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1174,   795,  1175,   385,  4179,   387,  1176,   388,   389,
     796,   390,  1177,  1178,   392,  1179,   394,   395,   396,     0,
     397,     0,     0,  1180,   399,   400,     0,     0,   401,   402,
     797,   403,   798,  1181,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,  1182,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
    1183,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,  1184,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,  1185,
     464,   465,   466,   467,   468,   800,   469,   470,  1186,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,  1187,     0,   485,   486,     0,   487,   801,   488,
     489,   490,   491,   492,     0,  1188,  1189,     0,     0,   495,
     496,  1190,   498,  1191,  1192,   500,   501,   502,   503,   504,
     505,   506,     0,  1193,   507,   508,   509,   510,   511,  1194,
       0,   512,   513,   514,   515,   516,   517,  1195,     0,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,  1196,  1197,  1198,
    1199,  1200,  1201,  1202,  1203,   540,   541,   542,  1204,     0,
       0,     0,     0,     0,     0,  1205,  1206,     0,     0,     0,
       0,     0,     0,     0,  1208,   779,  1138,   600,  1139,  1140,
    1141,   654,  1142,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,  1143,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,  1144,
     781,  1145,  1146,     0,   246,   247,   248,   249,   250,  1147,
    1148,   251,   252,  1149,  1150,   255,     0,   256,   257,   258,
     259,  1151,     0,  1152,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,  4468,   276,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,   277,   278,   279,   280,   281,   282,  1160,  1161,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1001,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,  1162,   312,   313,   314,  1163,  1164,
     316,     0,   317,   318,  1165,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,  1166,     0,
    4469,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,  1168,  1169,
       0,  1170,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,  1171,   793,   363,   794,
       0,   364,   365,   366,  1172,  1173,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1174,   795,  1175,   385,   386,   387,  1176,   388,
     389,   796,   390,  1177,  1178,   392,  1179,   394,   395,   396,
       0,   397,     0,     0,  1180,   399,   400,     0,     0,   401,
     402,   797,   403,   798,  1181,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,  1182,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1183,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,  4470,  1184,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
    1185,   464,   465,   466,   467,   468,   800,   469,   470,  1186,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,  1187,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,  1188,  1189,     0,     0,
     495,   496,  1190,   498,  1191,  1192,   500,   501,   502,   503,
     504,   505,   506,     0,  1193,   507,   508,   509,   510,   511,
    1194,     0,   512,   513,   514,   515,   516,   517,  1195,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,  1196,  1197,
    1198,  1199,  1200,  1201,  1202,  1203,   540,   541,   542,  1204,
       0,     0,     0,     0,     0,     0,  1205,  1206,     0,     0,
       0,     0,     0,     0,     0,  4471,   779,  1138,   600,  1139,
    1140,  1141,   654,  1142,     0,     0,     0,     0,     0,     0,
       0,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,  1143,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,  4857,
    1144,   781,  1145,  1146,     0,   246,   247,   248,   249,   250,
    1147,  1148,   251,   252,  1149,  1150,   255,     0,   256,   257,
     258,   259,  1151,     0,  1152,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,   784,   274,   275,  4858,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,   277,   278,   279,   280,   281,   282,  1160,
    1161,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,  1001,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,  1162,   312,   313,   314,  1163,
    1164,   316,     0,   317,   318,  1165,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,  1166,
       0,  1167,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,   789,   346,   347,   348,   349,   350,  1168,
    1169,     0,  1170,     0,   354,   790,   791,   355,   792,   356,
     357,   358,   359,   360,     0,     0,   361,  1171,   793,   363,
     794,     0,   364,   365,   366,  1172,  1173,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,  1174,   795,  1175,   385,   386,   387,  1176,
     388,   389,   796,   390,  1177,  1178,   392,  1179,   394,   395,
     396,     0,   397,     0,     0,  1180,   399,   400,     0,     0,
     401,   402,   797,   403,   798,  1181,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,  1182,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,  1183,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,  1184,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,  1185,   464,   465,   466,   467,   468,   800,   469,   470,
    1186,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,  1187,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,  1188,  1189,     0,
       0,   495,   496,  1190,   498,  1191,  1192,   500,   501,   502,
     503,  4859,   505,   506,     0,  1193,   507,   508,   509,   510,
     511,  1194,     0,   512,   513,   514,   515,   516,   517,  1195,
       0,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,  1196,
    1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,   541,   542,
    1204,     0,     0,     0,     0,     0,     0,  1205,  1206,     0,
       0,     0,     0,     0,     0,     0,  1208,   779,  1138,   600,
    1139,  1140,  1141,   654,  1142,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,  1143,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,  1144,   781,  1145,  1146,     0,   246,   247,   248,   249,
     250,  1147,  1148,   251,   252,  1149,  1150,   255,     0,   256,
     257,   258,   259,  1151,     0,  1152,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,  4858,  1153,  1154,  1155,
    1156,  1157,  1158,  1159,   277,   278,   279,   280,   281,   282,
    1160,  1161,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
    1001,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,  1162,   312,   313,   314,
    1163,  1164,   316,     0,   317,   318,  1165,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
    1166,     0,  1167,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
    1168,  1169,     0,  1170,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,  1171,   793,
     363,   794,     0,   364,   365,   366,  1172,  1173,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1174,   795,  1175,   385,   386,   387,
    1176,   388,   389,   796,   390,  1177,  1178,   392,  1179,   394,
     395,   396,     0,   397,     0,     0,  1180,   399,   400,     0,
       0,   401,   402,   797,   403,   798,  1181,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,  1182,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,  1183,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,  1184,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,  1185,   464,   465,   466,   467,   468,   800,   469,
     470,  1186,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,  1187,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,  1188,  1189,
       0,     0,   495,   496,  1190,   498,  1191,  1192,   500,   501,
     502,   503,  4859,   505,   506,     0,  1193,   507,   508,   509,
     510,   511,  1194,     0,   512,   513,   514,   515,   516,   517,
    1195,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
    1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,   541,
     542,  1204,     0,     0,     0,     0,     0,     0,  1205,  1206,
       0,     0,     0,     0,     0,     0,     0,  1208,   779,  1138,
     600,  1139,  1140,  1141,   654,  1142,     0,     0,     0,     0,
       0,     0,     0,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,  1143,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,   242,  1144,   781,  1145,  1146,     0,   246,   247,   248,
     249,   250,  1147,  1148,   251,   252,  1149,  1150,   255,     0,
     256,   257,   258,   259,  1151,     0,  1152,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,   276,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,   277,   278,   279,   280,   281,
     282,  1160,  1161,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,  1001,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,  1162,   312,   313,
     314,  1163,  1164,   316,     0,   317,   318,  1165,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,  1166,     0,  1167,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,   789,   346,   347,   348,   349,
     350,  1168,  1169,     0,  1170,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,  1171,
     793,   363,   794,     0,   364,   365,   366,  1172,  1173,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,  1174,   795,  1175,   385,   386,
     387,     0,   388,   389,   796,   390,  1177,  1178,   392,  1179,
     394,   395,   396,     0,   397,     0,     0,  1180,   399,   400,
       0,     0,   401,   402,   797,   403,   798,  1181,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,  1182,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,  1183,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,  2544,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,  1185,   464,   465,   466,   467,   468,   800,
     469,   470,  1186,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,  1187,     0,   485,   486,
       0,   487,   801,   488,   489,   490,   491,   492,     0,  1188,
    1189,     0,     0,   495,   496,  1190,   498,  1191,  1192,   500,
     501,   502,   503,   504,   505,   506,     0,     0,   507,   508,
     509,   510,   511,  1194,     0,   512,   513,   514,   515,   516,
     517,  1195,     0,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,
     541,   542,     0,     0,     0,     0,     0,     0,     0,  2545,
    2546,     0,     0,     0,     0,     0,     0,     0,  2547,   779,
    1138,   600,  1139,  1140,  1141,   654,  1142,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
    1143,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241, -2419,  1144,   781,  1145,  1146,     0,   246,   247,
     248,   249,   250,  1147,  1148,   251,   252,  1149,  1150,   255,
       0,   256,   257,   258,   259,  1151,     0,  1152,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,  4858,  1153,
    1154,  1155,  1156,  1157,  1158,  1159,   277,   278,   279,   280,
     281,   282,  1160,  1161,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,  1001,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,  1162,   312,
     313,   314,  1163,  1164,   316,     0,   317,   318,  1165,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,  1166,     0,  1167,   329,     0,   330,   331,   332,
     333,   334, -2419,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,  1168,  1169,     0,  1170,     0,   354,     0,     0,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
    1171,   793,   363, -2419,     0,   364,   365,   366,  1172,  1173,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,  1174,   795,  1175,   385,
     386,   387,  1176,   388,   389,     0,   390,  1177,  1178,   392,
    1179,   394,   395,   396,     0,   397,     0,     0,  1180,   399,
     400,     0,     0,   401,   402,   797,   403,   798,  1181,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
    1182,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,  1183,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,  1184,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,  1185,   464,   465,   466,   467,   468,
   -2419,   469,   470,  1186,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,  1187,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
    1188,  1189,     0,     0,   495,   496,  1190,   498,  1191,  1192,
     500,   501,   502,   503,  4859,   505,   506,     0,  1193,   507,
     508,   509,   510,   511,  1194,     0,   512,   513,   514,   515,
     516,   517,  1195,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,
     540,   541,   542, -2419,     0,     0,     0,     0,     0,     0,
    1205,  1206,     0,     0,     0,     0,     0,     0,     0,  1208,
     779,  1138,   600,  1139,  1140,  1141,   654,  1142,     0,     0,
       0,     0,     0,     0,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,  1143,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,   242,  1144,   781,  1145,  1146,     0,   246,
     247,   248,   249,   250,  1147,  1148,   251,   252,  1149,  1150,
     255,     0,   256,   257,   258,   259,  1151,     0,  1152,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,   278,   279,
     280,   281,   282,  1160,  1161,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,  1001,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,  1162,
     312,   313,   314,  1163,  1164,   316,     0,   317,   318,  1165,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,  1166,     0,  1167,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,   789,   346,   347,
     348,   349,   350,  1168,  1169,     0,  1170,     0,   354,     0,
     791,   355,   792,   356,   357,   358,   359,   360,     0,     0,
     361,  1171,   793,   363,   794,     0,   364,   365,   366,  1172,
    1173,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,  1174,   795,  1175,
     385,   386,   387,     0,   388,   389,   796,   390,  1177,  1178,
     392,  1179,   394,   395,   396,     0,   397,     0,     0,  1180,
     399,   400,     0,     0,   401,   402,   797,   403,   798,  1181,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,  1182,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  1183,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
    2544,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,  1185,   464,   465,   466,   467,
     468,   800,   469,   470,  1186,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,  1187,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,  1188,  1189,     0,     0,   495,   496,  1190,   498,  1191,
    1192,   500,   501,   502,   503,   504,   505,   506,     0,     0,
     507,   508,   509,   510,   511,  1194,     0,   512,   513,   514,
     515,   516,   517,  1195,     0,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
    1203,   540,   541,   542,     0,     0,     0,     0,     0,     0,
       0,  2545,  2546,     0,     0,   779,  1138,   600,  1139,  1140,
    2547,   654,  1142,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,  1143,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,  1144,
     781,  1145,  1146,     0,   246,   247,   248,   249,   250,  1147,
    1148,   251,   252,  1149,  1150,   255,     0,   256,   257,   258,
     259,  1151,     0,  1152,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,   277,   278,   279,   280,   281,   282,  1160,  1161,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1001,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,  1162,   312,   313,   314,  1163,  1164,
     316,     0,   317,   318,  1165,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,  1166,     0,
    1167,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,  1168,  1169,
       0,  1170,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,  1171,   793,   363,   794,
       0,   364,   365,   366,  1172,  1173,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1174,   795,  1175,   385,   386,   387,     0,   388,
     389,   796,   390,  1177,  1178,   392,  1179,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,  1181,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,  1182,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1183,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,  2544,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
    1185,   464,   465,   466,   467,   468,   800,   469,   470,  1186,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,  1187,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,  1188,  1189,     0,     0,
     495,   496,  1190,   498,  1191,  1192,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
    1194,     0,   512,   513,   514,   515,   516,   517,  1195,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,  1196,  1197,
    1198,  1199,  1200,  1201,  1202,  1203,   540,   541,   542,     0,
       0,   779,  1138,   600,  1139,  1140,     0,   654,  1142,     0,
       0,     0,     0,     0,     0,  2547,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,  1143,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,  1144,   781,  1145,  1146,     0,
    3781,   247,   248,   249,   250,  1147,  1148,   251,   252,  1149,
    1150,   255,     0,   256,   257,   258,   259,  1151,     0,  1152,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,  1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,   278,
     279,   280,   281,   282,  1160,  1161,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1001,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
    1162,   312,   313,   314,  1163,  1164,   316,     0,   317,   318,
    1165,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,  1166,     0,  1167,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,  1168,  1169,     0,  1170,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,  1171,   793,   363,   794,     0,   364,   365,   366,
    1172,  1173,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1174,   795,
    1175,   385,   386,   387,     0,   388,   389,   796,   390,  1177,
    1178,   392,  1179,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
    1181,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,  1182,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1183,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,  2544,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,  1185,   464,   465,   466,
     467,   468,   800,   469,   470,  1186,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,  1187,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1188,  1189,     0,     0,   495,   496,  1190,   498,
    1191,  1192,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,  1194,     0,   512,   513,
     514,   515,   516,   517,  1195,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,  1196,  1197,  1198,  1199,  1200,  1201,
    1202,  1203,   540,   541,   542,     0,     0,   779,  1138,   600,
    1139,  1140,  1141,   654,  1142,     0,     0,     0,     0,     0,
       0,  2547,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,  1143,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
       0,  1144,   781,  1145,  1146,     0,   246,   247,   248,   249,
     250,  1147,  1148,   251,   252,  1149,  1150,   255,     0,   256,
     257,   258,   259,  1151,     0,  1152,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,  1153,  1154,  1155,
    1156,  1157,  1158,  1159,   277,   278,   279,   280,   281,   282,
    1160,  1161,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
    1001,   299,   300,     0,   301,   302,   303,     0,   304,     0,
     306,     0,   307,   308,   309,   310,  1162,   312,   313,   314,
    1163,  1164,   316,     0,   317,   318,  1165,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
    1166,     0,  1167,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
    1168,  1169,     0,  1170,     0,   354,     0,     0,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,  1171,   793,
     363,     0,     0,   364,   365,   366,  1172,  1173,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1174,   795,  1175,   385,   386,   387,
    1176,   388,   389,     0,   390,  1177,  1178,   392,  1179,   394,
     395,   396,     0,   397,     0,     0,  1180,   399,   400,     0,
       0,   401,   402,   797,   403,   798,  1181,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,  1182,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,  1183,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,  1184,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,  1185,   464,   465,   466,   467,   468,     0,   469,
     470,  1186,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,  1187,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,  1188,  1189,
       0,     0,   495,   496,  1190,   498,  1191,  1192,   500,   501,
     502,   503,   504,   505,   506,     0,  1193,   507,   508,   509,
     510,   511,  1194,     0,   512,   513,   514,   515,   516,   517,
    1195,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
    1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,   541,
     542,     0,     0,   779,     0,     0,     0,     0,  1205,  1206,
       0,     0,     0,     0,     0,     0,     0,  1208,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,  1148,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,  1151,
       0,  1152,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,  1163,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,  1166,     0,   328,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,  3302,     0,   361,  1171,   793,   363,   794,     0,   364,
     365,   366,  1172,  1173,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,  1178,   392,   393,   394,   395,   396,     0,   397,
       0,   743,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,  1181,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,  1182,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,  3303,   452,   453,   454,   455,   456,
     457,   458,    39,   459,   460,   461,   462,   463,  1185,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,  1187,     0,   485,   486,    43,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
    1190,   498,  1191,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,  1194,     0,
     512,   513,   514,   515,   516,  1074,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,    48,   525,
     526,   527,   528,   529,   530,   531,  1196,  1197,  1198,  1199,
    1200,  1201,  1202,  1203,   540,   541,   542,     0,     0,    49,
     779,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3304,     0,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,     0,     0,     0,   235,   236,     0,   237,   238,   780,
     239,   240,   241,   242,   243,   781,   244,   245,     0,   246,
     247,   248,   249,   250,     0,  1148,   251,   252,   253,   254,
     255,     0,   256,   257,   258,   259,  1151,     0,  1152,     0,
     261,   262,   263,   264,   783,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,   784,   274,   275,   276,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,   278,   279,
     280,   281,   282,   283,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,   298,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,   313,   314,  1163,     0,   316,     0,   317,   318,   319,
     320,     0,   321,     0,   322,   786,     0,   787,   323,   324,
     325,     0,   326,  1166,     0,   328,   329,     0,   330,   331,
     332,   333,   334,   788,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,   789,   346,   347,
     348,   349,   350,   351,   352,     0,   353,     0,   354,   790,
     791,   355,   792,   356,   357,   358,   359,   360,  3302,     0,
     361,  1171,   793,   363,   794,     0,   364,   365,   366,  1172,
    1173,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   795,   384,
     385,   386,   387,     0,   388,   389,   796,   390,     0,  1178,
     392,   393,   394,   395,   396,     0,   397,     0,   743,   398,
     399,   400,     0,     0,   401,   402,   797,   403,   798,  1181,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,  1182,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,   799,   447,   448,   449,
     450,  3303,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,  1185,   464,   465,   466,   467,
     468,   800,   469,   470,   471,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,  1187,     0,
     485,   486,     0,   487,   801,   488,   489,   490,   491,   492,
       0,   493,   494,     0,     0,   495,   496,  1190,   498,  1191,
       0,   500,   501,   502,   503,   504,   505,   506,     0,     0,
     507,   508,   509,   510,   511,  1194,     0,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   802,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
    1203,   540,   541,   542,     0,     0,   779,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3304,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,     0,     0,     0,
     235,   236,     0,   237,   238,   780,   239,   240,   241,   242,
     243,   781,   244,   245,     0,   246,   247,   248,   249,   250,
       0,  1148,   251,   252,   253,   254,   255,     0,   256,   257,
     258,   259,  1151,     0,  1152,     0,   261,   262,   263,   264,
     783,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,   784,   274,   275,   276,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,   277,   278,   279,   280,   281,   282,   283,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,   298,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,  1163,
       0,   316,     0,   317,   318,   319,   320,     0,   321,     0,
     322,   786,     0,   787,   323,   324,   325,     0,   326,  1166,
       0,   328,   329,     0,   330,   331,   332,   333,   334,   788,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,   789,   346,   347,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   790,   791,   355,   792,   356,
     357,   358,   359,   360,     0,     0,   361,  1171,   793,   363,
     794,     0,   364,   365,   366,  1172,  1173,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   795,   384,   385,   386,   387,     0,
     388,   389,   796,   390,     0,  1178,   392,   393,   394,   395,
     396,     0,   397,     0,     0,   398,   399,   400,     0,     0,
     401,   402,   797,   403,   798,  1181,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,  1182,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,   799,   447,   448,   449,   450,  3303,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,  1185,   464,   465,   466,   467,   468,   800,   469,   470,
     471,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,  1187,     0,   485,   486,     0,   487,
     801,   488,   489,   490,   491,   492,     0,   493,   494,     0,
       0,   495,   496,  1190,   498,  1191,     0,   500,   501,   502,
     503,   504,   505,   506,     0,     0,   507,   508,   509,   510,
     511,  1194,     0,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   802,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,  1196,
    1197,  1198,  1199,  1200,  1201,  1202,  1203,   540,   541,   542,
       0,     0,   779,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    50,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,     0,     0,     0,     0,     0,   235,   236,     0,   237,
     238,   780,   239,   240,   241,   242,   243,   781,   244,   245,
       0,   246,   247,   248,   249,   250,     0,  1148,   251,   252,
     253,   254,   255,     0,   256,   257,   258,   259,  1151,     0,
    1152,     0,   261,   262,   263,   264,   783,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,   784,   274,
     275,   276,  1153,  1154,  1155,  1156,  1157,  1158,  1159,   277,
     278,   279,   280,   281,   282,   283,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,   298,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,   313,   314,  1163,     0,   316,     0,   317,
     318,   319,   320,     0,   321,     0,   322,   786,     0,   787,
     323,   324,   325,     0,   326,  1166,     0,   328,   329,     0,
     330,   331,   332,   333,   334,   788,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,   789,
     346,   347,   348,   349,   350,   351,   352,     0,   353,     0,
     354,   790,   791,   355,   792,   356,   357,   358,   359,   360,
       0,     0,   361,  1171,   793,   363,   794,     0,   364,   365,
     366,  1172,  1173,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     795,   384,   385,   386,   387,     0,   388,   389,   796,   390,
       0,  1178,   392,   393,   394,   395,   396,     0,   397,     0,
       0,   398,   399,   400,     0,     0,   401,   402,   797,   403,
     798,  1181,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,  1182,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,   799,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,  1185,   464,   465,
     466,   467,   468,   800,   469,   470,   471,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
    1187,     0,   485,   486,     0,   487,   801,   488,   489,   490,
     491,   492,     0,   493,   494,     0,     0,   495,   496,  1190,
     498,  1191,     0,   500,   501,   502,   503,   504,   505,   506,
       0,     0,   507,   508,   509,   510,   511,  1194,     0,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   802,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,  1196,  1197,  1198,  1199,  1200,
    1201,  1202,  1203,   540,   541,   542,     0,     0,   823,  1412,
     600,     0,     0,     0,   654,     0,     0,     0,     0,     0,
       0,     0,  3905,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,     0,
       0,     0,   235,   236,     0,   237,   238,   780,   239,   240,
     241,   242,   243,   781,   244,   245,     0,   246,   247,   248,
     249,   250,     0,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,   259,   260,     0,   782,     0,   261,   262,
     263,   264,   783,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,   784,   274,   275,   276,     0,     0,
       0,   785,     0,     0,     0,   277,   278,   279,   280,   281,
     282,   283,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,   298,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,   313,
     314,   315,  1683,   316,     0,   317,   318,   319,   320,     0,
     321,     0,   322,   786,     0,   787,   323,   324,   325,     0,
     326,   327,     0,   328,   329,     0,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,   789,   346,   347,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,     0,     0,   361,   362,
     793,   363,   794,     0,   364,   365,   366,     0,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   795,   384,   385,   386,
     387,     0,   388,   389,   796,   390,     0,   391,   392,   393,
     394,   395,   396,     0,   397,  1684,     0,   398,   399,   400,
       0,     0,   401,   402,   797,   403,   798,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,   799,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   800,
     469,   470,   471,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,   485,   486,
       0,   487,   801,   488,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,   496,   497,   498,   499,  1685,   500,
     501,   502,   503,   504,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,     0,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   802,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,     0,   823,     0,     0,     0,     0,  1413,
    1414,  4702,     0,     0,     0,     0,     0,     0,  4703,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     3,     4,     0,     0,     0,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,   242,   243,   781,
     244,   245,     0,   246,   247,   248,   249,   250,     0,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,   259,
     260,     0,   782,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,     0,     0,     0,   785,     0,     0,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,   298,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,   327,     0,   328,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,   789,   346,   347,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,   362,   793,   363,   794,     0,
     364,   365,   366,     0,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   795,   384,   385,   386,   387,     0,   388,   389,
     796,   390,     0,   391,   392,   393,   394,   395,   396,     0,
     397,     0,     0,   398,   399,   400,     0,     0,   401,   402,
     797,   403,   798,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,    39,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   800,   469,   470,   471,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,   485,   486,    43,   487,   801,   488,
     489,   490,   491,   492,     0,   493,   494,     0,     0,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
       0,   512,   513,   514,   515,   516,  1074,   518,     0,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,    48,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,     0,     0,
      49,   779,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,     0,     0,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4519,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,    39,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,    43,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,  1074,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,    48,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,     0,     0,    49,   222,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,     0,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,     0,     0,     0,   235,   236,
       0,   237,   238,     0,   239,   240,   241,   242,   243,     0,
     244,   245,     0,   246,   247,   248,   249,   250,     0,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,   259,
     260,     0,     0,     0,   261,   262,   263,   264,     0,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
       0,   274,   275,   276,     0,     0,     0,     0,     0,     0,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,   298,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,     0,   321,     0,   322,     0,
       0,     0,   323,   324,   325,     0,   326,   327,     0,   328,
     329,     0,   330,   331,   332,   333,   334,     0,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,   351,   352,     0,
     353,     0,   354,     0,     0,   355,     0,   356,   357,   358,
     359,   360,     0,     0,   361,   362,     0,   363,     0,     0,
     364,   365,   366,     0,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,   384,   385,   386,   387,     0,   388,   389,
       0,   390,     0,   391,   392,   393,   394,   395,   396,     0,
     397,     0,     0,   398,   399,   400,     0,     0,   401,   402,
       0,   403,     0,   404,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,     0,   469,   470,   471,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,   485,   486,     0,   487,     0,   488,
     489,   490,   491,   492,     0,   493,   494,     0,     0,   495,
     496,   497,   498,   499,     0,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
       0,   512,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,     0,     0,
     222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1266,   223,   224,   225,   226,   227,
     228,   229,   230,     0,   232,   233,   234,     0,     0,     0,
       0,     0,     0,     0,   235,   236,     0,   237,   238,     0,
     239,   240,   241,   242,   243,     0,   244,   245,     0,   246,
     247,   248,   249,   250,     0,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,   259,   260,     0,     0,     0,
     261,   262,   263,   264,     0,   265,   266,   267,     0,   268,
     269,   270,   271,   272,   273,     0,     0,   274,   275,   276,
       0,     0,     0,     0,     0,     0,     0,   277,   278,   279,
     280,   281,   282,   283,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,     0,
       0,   296,   297,   298,   299,   300,     0,   301,   302,   303,
       0,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,     0,   321,     0,   322,     0,     0,     0,   323,   324,
     325,     0,   326,   327,     0,   328,   329,     0,   330,   331,
     332,   333,   334,     0,   335,   336,   337,   338,     0,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,   351,   352,     0,   353,     0,   354,     0,
       0,   355,     0,   356,   357,   358,   359,   360,     0,     0,
     361,   362,     0,   363,     0,     0,   364,   365,   366,     0,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,   384,
     385,   386,   387,     0,   388,   389,     0,   390,     0,   391,
     392,   393,   394,   395,   396,     0,   397,     0,     0,   398,
     399,   400,     0,     0,   401,   402,     0,   403,     0,   404,
     405,   406,   407,   408,   409,   410,   411,   412,     0,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     0,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   445,   446,     0,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,     0,   469,   470,   471,   472,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     0,
     485,   486,     0,   487,     0,   488,   489,   490,   491,   492,
       0,   493,   494,     0,     0,   495,   496,   497,   498,   499,
       0,   500,   501,   502,   503,   504,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,     0,   512,   513,   514,
     515,   516,   517,   518,     0,   519,     0,   520,   521,   522,
     523,     0,     0,   524,     0,     0,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,     0,     0,   222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2701,   223,   224,   225,   226,   227,   228,   229,   230,     0,
     232,   233,   234,     0,     0,     0,     0,     0,     0,     0,
     235,   236,     0,   237,   238,     0,   239,   240,   241,   242,
     243,     0,   244,   245,     0,   246,   247,   248,   249,   250,
       0,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,   259,   260,     0,     0,     0,   261,   262,   263,   264,
       0,   265,   266,   267,     0,   268,   269,   270,   271,   272,
     273,     0,     0,   274,   275,   276,     0,     0,     0,     0,
       0,     0,     0,   277,   278,   279,   280,   281,   282,   283,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,     0,     0,   296,   297,   298,
     299,   300,     0,   301,   302,   303,     0,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,     0,   321,     0,
     322,     0,     0,     0,   323,   324,   325,     0,   326,   327,
       0,   328,   329,     0,   330,   331,   332,   333,   334,     0,
     335,   336,   337,   338,     0,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,   351,
     352,     0,   353,     0,   354,     0,     0,   355,     0,   356,
     357,   358,   359,   360,     0,     0,   361,   362,     0,   363,
       0,     0,   364,   365,   366,     0,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,   384,   385,   386,   387,     0,
     388,   389,     0,   390,     0,   391,   392,   393,   394,   395,
     396,     0,   397,     0,     0,   398,   399,   400,     0,     0,
     401,   402,     0,   403,     0,   404,   405,   406,   407,   408,
     409,   410,   411,   412,     0,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     0,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,     0,
     445,   446,     0,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,     0,   469,   470,
     471,   472,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     0,   485,   486,     0,   487,
       0,   488,   489,   490,   491,   492,     0,   493,   494,     0,
       0,   495,   496,   497,   498,   499,     0,   500,   501,   502,
     503,   504,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,     0,   512,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
       0,     0,   222,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3816,   223,   224,   225,
     226,   227,   228,   229,   230,     0,   232,   233,   234,     0,
       0,     0,     0,     0,     0,     0,   235,   236,     0,   237,
     238,     0,   239,   240,   241,   242,   243,     0,   244,   245,
       0,   246,   247,   248,   249,   250,     0,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,   259,   260,     0,
       0,     0,   261,   262,   263,   264,     0,   265,   266,   267,
       0,   268,   269,   270,   271,   272,   273,     0,     0,   274,
     275,   276,     0,     0,     0,     0,     0,     0,     0,   277,
     278,   279,   280,   281,   282,   283,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,     0,     0,   296,   297,   298,   299,   300,     0,   301,
     302,   303,     0,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,     0,   321,     0,   322,     0,     0,     0,
     323,   324,   325,     0,   326,   327,     0,   328,   329,     0,
     330,   331,   332,   333,   334,     0,   335,   336,   337,   338,
       0,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,   351,   352,     0,   353,     0,
     354,     0,     0,   355,     0,   356,   357,   358,   359,   360,
       0,     0,   361,   362,     0,   363,     0,     0,   364,   365,
     366,     0,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
       0,   384,   385,   386,   387,     0,   388,   389,     0,   390,
       0,   391,   392,   393,   394,   395,   396,     0,   397,     0,
       0,   398,   399,   400,     0,     0,   401,   402,     0,   403,
       0,   404,   405,   406,   407,   408,   409,   410,   411,   412,
       0,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     0,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,     0,   445,   446,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,     0,   469,   470,   471,   472,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     0,   485,   486,     0,   487,     0,   488,   489,   490,
     491,   492,     0,   493,   494,     0,     0,   495,   496,   497,
     498,   499,     0,   500,   501,   502,   503,   504,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,     0,   512,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   520,
     521,   522,   523,     0,     0,   524,     0,     0,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,     0,     0,     0,     0,
       0,   993,  1412,   600,     0,     0,   837,   654,     0,     0,
       0,     0,  4224,   838,   839,   840,   223,   224,   225,   226,
     227,   228,   229,   230,  1871,   232,   233,   234,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,   235,   236,  1879,   237,   238,
     780,   239,   240,   241,     0,   994,   781,   995,   996,  1880,
     246,   247,   248,   249,   250,  1881,  1882,   251,   252,   997,
     998,   255,  1883,   256,   257,   258,   259,     0,  1884,   782,
    1885,   261,   262,   263,   264,   783,   265,   266,   267,  1886,
     268,   269,   270,   271,   272,   273,  1887,   784,   274,   275,
     276,  1888,  1889,  1890,   785,  1891,  1892,  1893,   277,   278,
     279,   280,   281,   282,   999,  1000,   285,  1894,   286,  1895,
     287,   288,   289,   290,   291,   292,  1896,   293,   294,   295,
    1897,  1898,   296,   297,  1001,   299,   300,  1899,   301,   302,
     303,  1900,   304,   305,   306,  1901,   307,   308,   309,   310,
       0,   312,   313,   314,     0,  1902,   316,  1903,   317,   318,
    1002,   320,  1904,   321,  1905,   322,   786,  1906,   787,   323,
     324,   325,  1907,   326,     0,  1908,     0,   329,  1909,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,  1910,
     339,   340,   341,   342,   343,   344,  1911,   345,   789,     0,
     347,   348,   349,   350,  1004,  1005,  1912,  1006,  1913,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,  1914,
    1915,   361,     0,   793,   363,   794,  1916,   364,   365,   366,
    1917,  1918,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1007,   795,
    1008,   385,   386,  4313,  1919,   388,   389,   796,   390,  1920,
       0,   392,  1009,   394,   395,   396,  1921,   397,  1922,  1923,
    3567,   399,   400,  1924,  1925,   401,     0,   797,   403,   798,
       0,   405,   406,   407,   408,   409,   410,   411,   412,  1926,
     413,   414,     0,   416,     0,   418,   419,   420,  1927,   421,
     422,   423,   424,   425,   426,   427,   428,  1010,   430,   431,
     432,   433,  1928,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,  1929,   445,   446,   799,   447,   448,
     449,     0,   451,   452,   453,   454,   455,   456,   457,   458,
    1930,   459,   460,   461,   462,   463,  1931,   464,   465,  2012,
     467,   468,   800,   469,   470,  1012,   472,  1932,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,     0,
    1933,   485,   486,  1934,   487,   801,   488,   489,   490,   491,
     492,  1935,  1013,  1014,  1936,  1937,   495,   496,     0,   498,
       0,  1938,   500,   501,   502,   503,   504,   505,   506,  1939,
    1940,   507,   508,   509,   510,   511,  1941,  1942,   512,   513,
     514,   515,   516,     0,  1015,  1943,   519,   802,   520,   521,
     522,   523,  1944,  1945,   524,  1946,  1947,   525,   526,   527,
     528,   529,   530,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   540,   541,   542,     0,     0,     0,   843,   844,
     845,     0,  3568,  3569,   848,   849,   850,   851,   993,  1412,
     600,     0,     0,   837,   654,     0,     0,     0,     0,     0,
     838,   839,   840,   223,   224,   225,   226,   227,   228,   229,
     230,  1871,   232,   233,   234,  1872,  1873,  1874,  1875,  1876,
    1877,  1878,   235,   236,  1879,   237,   238,   780,   239,   240,
     241,     0,   994,   781,   995,   996,  1880,   246,   247,   248,
     249,   250,  1881,  1882,   251,   252,   997,   998,   255,  1883,
     256,   257,   258,   259,     0,  1884,   782,  1885,   261,   262,
     263,   264,   783,   265,   266,   267,  1886,   268,   269,   270,
     271,   272,   273,  1887,   784,   274,   275,   276,  1888,  1889,
    1890,   785,  1891,  1892,  1893,   277,   278,   279,   280,   281,
     282,   999,  1000,   285,  1894,   286,  1895,   287,   288,   289,
     290,   291,   292,  1896,   293,   294,   295,  1897,  1898,   296,
     297,  1001,   299,   300,  1899,   301,   302,   303,  1900,   304,
     305,   306,  1901,   307,   308,   309,   310,     0,   312,   313,
     314,     0,  1902,   316,  1903,   317,   318,  1002,   320,  1904,
     321,  1905,   322,   786,  1906,   787,   323,   324,   325,  1907,
     326,     0,  1908,     0,   329,  1909,   330,   331,   332,   333,
     334,   788,   335,   336,   337,   338,  1910,   339,   340,   341,
     342,   343,   344,  1911,   345,   789,     0,   347,   348,   349,
     350,  1004,  1005,  1912,  1006,  1913,   354,   790,   791,   355,
     792,   356,   357,   358,   359,   360,  1914,  1915,   361,     0,
     793,   363,   794,  1916,   364,   365,   366,  1917,  1918,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,  1007,   795,  1008,   385,   386,
       0,  1919,   388,   389,   796,   390,  1920,     0,   392,  1009,
     394,   395,   396,  1921,   397,  1922,  1923,  3567,   399,   400,
    1924,  1925,   401,     0,   797,   403,   798,     0,   405,   406,
     407,   408,   409,   410,   411,   412,  1926,   413,   414,     0,
     416,     0,   418,   419,   420,  1927,   421,   422,   423,   424,
     425,   426,   427,   428,  1010,   430,   431,   432,   433,  1928,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,  1929,   445,   446,   799,   447,   448,   449,     0,   451,
     452,   453,   454,   455,   456,   457,   458,  1930,   459,   460,
     461,   462,   463,  1931,   464,   465,  2012,   467,   468,   800,
     469,   470,  1012,   472,  1932,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,     0,  1933,   485,   486,
    1934,   487,   801,   488,   489,   490,   491,   492,  1935,  1013,
    1014,  1936,  1937,   495,   496,     0,   498,     0,  1938,   500,
     501,   502,   503,   504,   505,   506,  1939,  1940,   507,   508,
     509,   510,   511,  1941,  1942,   512,   513,   514,   515,   516,
       0,  1015,  1943,   519,   802,   520,   521,   522,   523,  1944,
    1945,   524,  1946,  1947,   525,   526,   527,   528,   529,   530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   540,
     541,   542,     0,   222,     0,   843,   844,   845,   837,  3568,
    3569,   848,   849,   850,   851,   838,   839,   840,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   841,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   842,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,     0,   222,     0,
     843,   844,   845,   837,   846,   847,   848,   849,   850,   851,
     838,   839,   840,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,     0,
       0,     0,   235,   236,     0,   237,   238,     0,   239,   240,
     241,   242,   243,     0,   244,   245,     0,   246,   247,   248,
     249,   250,     0,     0,   251,   252,   253,   254,   255,     0,
     256,   950,   258,   259,   260,     0,     0,     0,   261,   262,
     263,   264,     0,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,     0,   274,   275,   276,     0,     0,
       0,     0,     0,     0,     0,   277,   278,   279,   280,   281,
     282,   283,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,   298,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,   313,
     314,   315,     0,   951,     0,   317,   318,   319,   320,     0,
     321,     0,   322,     0,     0,     0,   323,   324,   325,     0,
     326,   327,     0,   328,   329,     0,   330,   331,   332,   333,
     334,     0,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,   351,   352,     0,   353,     0,   354,     0,     0,   355,
       0,   356,   357,   358,   359,   360,     0,     0,   361,   362,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,     0,   388,   389,     0,   390,     0,   391,   392,   393,
     394,   395,   396,     0,   397,     0,     0,   398,   399,   400,
       0,     0,   401,   402,     0,   403,     0,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,     0,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,     0,
     469,   470,   471,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,   485,   486,
       0,   487,     0,   488,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,     0,   512,   513,   514,   515,   516,
     517,   518,     0,   519,     0,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,   222,     0,   843,   844,   845,   837,   846,
     847,   848,   849,   850,   851,   838,   839,   840,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,  1042,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,  1043,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  1044,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,     0,   222,     0,
     843,   844,   845,   837,   846,   847,   848,   849,   850,   851,
     838,   839,   840,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,     0,
       0,     0,   235,   236,     0,   237,   238,     0,   239,   240,
     241,   242,   243,     0,   244,   245,     0,   246,   247,   248,
     249,   250,     0,     0,   251,   252,   253,   254,   255,     0,
     256,  1512,   258,   259,   260,     0,     0,     0,   261,   262,
     263,   264,     0,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,     0,   274,   275,   276,     0,     0,
       0,     0,     0,     0,     0,   277,   278,   279,   280,   281,
     282,   283,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,   298,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,   313,
     314,   315,     0,  1513,     0,   317,   318,   319,   320,     0,
     321,     0,   322,     0,     0,     0,   323,   324,   325,     0,
     326,   327,     0,   328,   329,     0,   330,   331,   332,   333,
     334,     0,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,   351,   352,     0,   353,     0,   354,     0,     0,   355,
       0,   356,   357,   358,   359,   360,     0,     0,   361,   362,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,     0,   388,   389,     0,   390,     0,   391,   392,   393,
     394,   395,   396,     0,   397,     0,     0,   398,   399,   400,
       0,     0,   401,   402,     0,   403,     0,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,     0,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,     0,
     469,   470,   471,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,   485,   486,
       0,   487,     0,   488,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,     0,   512,   513,   514,   515,   516,
     517,   518,     0,   519,     0,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,   222,     0,   843,   844,   845,   837,   846,
     847,   848,   849,   850,   851,   838,   839,   840,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,     0,   222,     0,
     843,   844,   845,   837,   846,   847,   848,   849,   850,   851,
     838,   839,   840,   223,   224,   225,   226,   227,   228,   229,
     230,     0,   232,   233,   234,     0,     0,     0,     0,     0,
       0,     0,   235,   236,     0,   237,   238,     0,   239,   240,
     241,   242,   243,     0,   244,   245,     0,   246,   247,   248,
     249,   250,     0,     0,   251,   252,   253,   254,   255,     0,
     256,  2780,   258,   259,   260,     0,     0,     0,   261,   262,
     263,   264,     0,   265,   266,   267,     0,   268,   269,   270,
     271,   272,   273,     0,     0,   274,   275,   276,     0,     0,
       0,     0,     0,     0,     0,   277,   278,   279,   280,   281,
     282,   283,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,     0,     0,   296,
     297,   298,   299,   300,     0,   301,   302,   303,     0,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,   313,
     314,   315,     0,  2781,     0,   317,   318,   319,   320,     0,
     321,     0,   322,     0,     0,     0,   323,   324,   325,     0,
     326,   327,     0,   328,   329,     0,   330,   331,   332,   333,
     334,     0,   335,   336,   337,   338,     0,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,   351,   352,     0,   353,     0,   354,     0,     0,   355,
       0,   356,   357,   358,   359,   360,     0,     0,   361,   362,
       0,   363,     0,     0,   364,   365,   366,     0,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,   384,   385,   386,
     387,     0,   388,   389,     0,   390,     0,   391,   392,   393,
     394,   395,   396,     0,   397,     0,     0,   398,   399,   400,
       0,     0,   401,   402,     0,   403,     0,   404,   405,   406,
     407,   408,   409,   410,   411,   412,     0,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,     0,   445,   446,     0,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,     0,
     469,   470,   471,   472,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     0,   485,   486,
       0,   487,     0,   488,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,   496,   497,   498,   499,     0,   500,
     501,   502,   503,   504,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,     0,   512,   513,   514,   515,   516,
     517,   518,     0,   519,     0,   520,   521,   522,   523,     0,
       0,   524,     0,     0,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,     0,   222,     0,   843,   844,   845,   837,   846,
     847,   848,   849,   850,   851,   838,   839,   840,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,  4499,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,  1870,     0,     0,
     843,   844,   845,     0,   846,   847,   848,   849,   850,   851,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
    1871,   232,   233,   234,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,   235,   236,  1879,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,  1880,   246,   247,   248,   249,
     250,  1881,  1882,   251,   252,   253,   254,   255,  1883,   256,
     257,   258,   259,   260,  1884,   782,  1885,   261,   262,   263,
     264,   783,   265,   266,   267,  1886,   268,   269,   270,   271,
     272,   273,  1887,   784,   274,   275,   276,  1888,  1889,  1890,
     785,  1891,  1892,  1893,   277,   278,   279,   280,   281,   282,
     283,   284,   285,  1894,   286,  1895,   287,   288,   289,   290,
     291,   292,  1896,   293,   294,   295,  1897,  1898,   296,   297,
     298,   299,   300,  1899,   301,   302,   303,  1900,   304,   305,
     306,  1901,   307,   308,   309,   310,   311,   312,   313,   314,
     315,  1902,   316,  1903,   317,   318,   319,   320,  1904,   321,
    1905,   322,   786,  1906,   787,   323,   324,   325,  1907,   326,
     327,  1908,   328,   329,  1909,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,  1910,   339,   340,   341,   342,
     343,   344,  1911,   345,   789,   346,   347,   348,   349,   350,
     351,   352,  1912,   353,  1913,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,  1914,  1915,   361,   362,   793,
     363,   794,  1916,   364,   365,   366,  1917,  1918,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
    1919,   388,   389,   796,   390,  1920,   391,   392,   393,   394,
     395,   396,  1921,   397,  1922,  1923,   398,   399,   400,  1924,
    1925,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,  1926,   413,   414,   415,   416,
     417,   418,   419,   420,  1927,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,  1928,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
    1929,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,  1930,   459,   460,   461,
     462,   463,  1931,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,  1932,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1933,   485,   486,  1934,
     487,   801,   488,   489,   490,   491,   492,  1935,   493,   494,
    1936,  1937,   495,   496,   497,   498,   499,  1938,   500,   501,
     502,   503,   504,   505,   506,  1939,  1940,   507,   508,   509,
     510,   511,  1941,  1942,   512,   513,   514,   515,   516,   517,
     518,  1943,   519,   802,   520,   521,   522,   523,  1944,  1945,
     524,  1946,  1947,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
    1948,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   993,     0,     0,     0,     0,
       0,     0,     0,     0,   748,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,     0,   994,
     781,   995,   996,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   997,   998,   255,     0,   256,   257,   258,
     259,     0,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   999,  1000,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1001,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,     0,   312,   313,   314,     0,     0,
     316,     0,   317,   318,  1002,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,     0,     0,
       0,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,  2008,   339,   340,   341,   342,   343,   344,
       0,   345,   789,  2009,   347,   348,   349,   350,  1004,  1005,
       0,  1006,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,     0,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1007,   795,  1008,   385,   386,     0,     0,   388,
     389,   796,   390,     0,     0,   392,  1009,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,  2010,   401,
    2011,   797,   403,   798,     0,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,     0,   416,     0,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1010,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,     0,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,  2012,   467,   468,   800,   469,   470,  1012,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,     0,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,  1013,  1014,     0,     0,
     495,   496,     0,   498,     0,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,     0,  1015,  2013,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,     0,     0,     0,
       0,     0,     0,     0,  2286,     0,   540,   541,   542,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2014,   223,
     224,   225,   226,   227,   228,   229,   230,     0,   232,   233,
     234,     0,     0,     0,     0,     0,     0,     0,   235,   236,
       0,   237,   238,   780,   239,   240,   241,     0,   994,   781,
     995,   996,     0,   246,   247,   248,   249,   250,     0,     0,
     251,   252,   997,   998,   255,     0,   256,   257,   258,   259,
       0,     0,   782,     0,   261,   262,   263,   264,   783,   265,
     266,   267,     0,   268,   269,   270,   271,   272,   273,     0,
     784,   274,   275,   276,     0,     0,     0,   785,     0,     0,
       0,   277,   278,   279,   280,   281,   282,   999,  1000,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,     0,     0,   296,   297,  1001,   299,   300,
       0,   301,   302,   303,     0,   304,   305,   306,     0,   307,
     308,   309,   310,     0,   312,   313,   314,     0,     0,   316,
       0,   317,   318,  1002,   320,     0,   321,     0,   322,   786,
       0,   787,   323,   324,   325,     0,   326,     0,     0,     0,
     329,     0,   330,   331,   332,   333,   334,   788,   335,   336,
     337,   338,  2008,   339,   340,   341,   342,   343,   344,     0,
     345,   789,  2009,   347,   348,   349,   350,  1004,  1005,     0,
    1006,     0,   354,   790,   791,   355,   792,   356,   357,   358,
     359,   360,     0,     0,   361,     0,   793,   363,   794,     0,
     364,   365,   366,     0,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,  1007,   795,  1008,   385,   386,     0,     0,   388,   389,
     796,   390,     0,     0,   392,  1009,   394,   395,   396,     0,
     397,     0,     0,   398,   399,   400,     0,  2010,   401,  2011,
     797,   403,   798,     0,   405,   406,   407,   408,   409,   410,
     411,   412,     0,   413,   414,     0,   416,     0,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
    1010,   430,   431,   432,   433,     0,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     799,   447,   448,   449,     0,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,   463,     0,
     464,   465,  2012,   467,   468,   800,   469,   470,  1012,   472,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,     0,     0,   485,   486,     0,   487,   801,   488,
     489,   490,   491,   492,     0,  1013,  1014,     0,     0,   495,
     496,     0,   498,     0,     0,   500,   501,   502,   503,   504,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
       0,   512,   513,   514,   515,   516,     0,  1015,  2013,   519,
     802,   520,   521,   522,   523,     0,     0,   524,     0,     0,
     525,   526,   527,   528,   529,   530,     0,     0,     0,     0,
       0,     0,     0,   222,     0,   540,   541,   542,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2014,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   823,  1412,   600,
       0,     0,     0,   654,     0,     0,  4821,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,  1859,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,  1683,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,  1684,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,  1685,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   823,  1412,   600,     0,     0,     0,   654,  1413,  1414,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,  1864,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,  1683,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,  1684,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,  1685,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   823,  1412,   600,     0,     0,
       0,   654,  1413,  1414,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,  1683,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,   362,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,  1684,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,  1685,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   823,
       0,   600,     0,     0,     0,   654,  1413,  1414,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,  2734,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,  1683,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
     362,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,  1684,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,  1685,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,   654,
     666,   667,     0,     0,     0,     0,     0,     0,   223,   655,
     225,   226,   227,   228,   229,   230,   656,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   657,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   658,   319,   320,     0,   321,     0,   659,     0,   660,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   661,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     662,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   663,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   664,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   665,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,  1870,  4943,   600,
       0,     0,     0,   654,   666,   667,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
    1871,   232,   233,   234,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,   235,   236,  1879,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,  1880,   246,   247,   248,   249,
     250,  1881,  1882,   251,   252,   253,   254,   255,  1883,   256,
     257,   258,   259,   260,  1884,   782,  1885,   261,   262,   263,
     264,   783,   265,   266,   267,  1886,   268,   269,   270,   271,
     272,   273,  1887,   784,   274,   275,   276,  1888,  1889,  1890,
     785,  1891,  1892,  1893,   277,   278,   279,   280,   281,   282,
     283,   284,   285,  1894,   286,  1895,   287,   288,   289,   290,
     291,   292,  1896,   293,   294,   295,  1897,  1898,   296,   297,
     298,   299,   300,  1899,   301,   302,   303,  1900,   304,   305,
     306,  1901,   307,   308,   309,   310,   311,   312,   313,   314,
     315,  1902,   316,  1903,   317,   318,   319,   320,  1904,   321,
    1905,   322,   786,  1906,   787,   323,   324,   325,  1907,   326,
     327,  1908,   328,   329,  1909,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,  1910,   339,   340,   341,   342,
     343,   344,  1911,   345,   789,   346,   347,   348,   349,   350,
     351,   352,  1912,   353,  1913,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,  1914,  1915,   361,   362,   793,
     363,   794,  1916,   364,   365,   366,  1917,  1918,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
    1919,   388,   389,   796,   390,  1920,   391,   392,   393,   394,
     395,   396,  1921,   397,  1922,  1923,   398,   399,   400,  1924,
    1925,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,  1926,   413,   414,   415,   416,
     417,   418,   419,   420,  1927,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,  1928,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
    1929,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,  1930,   459,   460,   461,
     462,   463,  1931,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,  1932,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1933,   485,   486,  1934,
     487,   801,   488,   489,   490,   491,   492,  1935,   493,   494,
    1936,  1937,   495,   496,   497,   498,   499,  1938,   500,   501,
     502,   503,   504,   505,   506,  1939,  1940,   507,   508,   509,
     510,   511,  1941,  1942,   512,   513,   514,   515,   516,   517,
     518,  1943,   519,   802,   520,   521,   522,   523,  1944,  1945,
     524,  1946,  1947,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,  1870,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,  1871,   232,   233,   234,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,   235,   236,  1879,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,  1880,
     246,   247,   248,   249,   250,  1881,  1882,   251,   252,   253,
     254,   255,  1883,   256,   257,   258,   259,   260,  1884,   782,
    1885,   261,   262,   263,   264,   783,   265,   266,   267,  1886,
     268,   269,   270,   271,   272,   273,  1887,   784,   274,   275,
     276,  1888,  1889,  1890,   785,  1891,  1892,  1893,   277,   278,
     279,   280,   281,   282,   283,   284,   285,  1894,   286,  1895,
     287,   288,   289,   290,   291,   292,  1896,   293,   294,   295,
    1897,  1898,   296,   297,   298,   299,   300,  1899,   301,   302,
     303,  1900,   304,   305,   306,  1901,   307,   308,   309,   310,
     311,   312,   313,   314,   315,  1902,   316,  1903,   317,   318,
     319,   320,  1904,   321,  1905,   322,   786,  1906,   787,   323,
     324,   325,  1907,   326,   327,  1908,   328,   329,  1909,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,  1910,
     339,   340,   341,   342,   343,   344,  1911,   345,   789,   346,
     347,   348,   349,   350,   351,   352,  1912,   353,  1913,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,  1914,
    1915,   361,   362,   793,   363,   794,  1916,   364,   365,   366,
    1917,  1918,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,  1919,   388,   389,   796,   390,  1920,
     391,   392,   393,   394,   395,   396,  1921,   397,  1922,  1923,
     398,   399,   400,  1924,  1925,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,  1926,
     413,   414,   415,   416,   417,   418,   419,   420,  1927,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,  1928,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,  1929,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
    1930,   459,   460,   461,   462,   463,  1931,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,  1932,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1933,   485,   486,  1934,   487,   801,   488,   489,   490,   491,
     492,  1935,   493,   494,  1936,  1937,   495,   496,   497,   498,
     499,  1938,   500,   501,   502,   503,   504,   505,   506,  1939,
    1940,   507,   508,   509,   510,   511,  1941,  1942,   512,   513,
     514,   515,   516,   517,   518,  1943,   519,   802,   520,   521,
     522,   523,  1944,  1945,   524,  1946,  1947,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,  1870,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,  2848,   228,   229,   230,  1871,   232,
     233,   234,  1872,  1873,  1874,  1875,  1876,  1877,  1878,   235,
     236,  1879,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,  1880,   246,   247,   248,   249,   250,  1881,
    1882,   251,   252,   253,   254,   255,  1883,   256,   257,   258,
     259,   260,  1884,   782,  1885,   261,   262,   263,   264,   783,
     265,   266,   267,  1886,   268,   269,   270,   271,   272,   273,
    1887,   784,   274,   275,   276,  1888,  1889,  1890,   785,  1891,
    1892,  1893,   277,   278,   279,   280,   281,   282,   283,   284,
     285,  1894,   286,  1895,   287,   288,   289,   290,   291,   292,
    1896,   293,   294,   295,  1897,  1898,   296,   297,   298,  2849,
     300,  1899,   301,   302,   303,  1900,   304,   305,   306,  1901,
     307,   308,   309,   310,   311,   312,   313,   314,   315,  1902,
     316,  1903,   317,   318,   319,   320,  1904,   321,  1905,   322,
     786,  1906,   787,   323,   324,   325,  1907,   326,   327,  1908,
     328,   329,  1909,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,  1910,   339,   340,   341,   342,   343,   344,
    1911,   345,   789,   346,   347,   348,   349,   350,   351,   352,
    1912,   353,  1913,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,  1914,  1915,   361,   362,   793,   363,   794,
    1916,   364,   365,   366,  1917,  1918,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,  1919,   388,
     389,   796,   390,  1920,   391,   392,   393,   394,   395,   396,
    1921,   397,  1922,  1923,   398,   399,   400,  1924,  1925,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,  1926,   413,   414,   415,   416,   417,   418,
     419,   420,  1927,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,  1928,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,  1929,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,  1930,   459,   460,   461,   462,   463,
    1931,  2850,   465,   466,   467,   468,   800,   469,   470,   471,
     472,  1932,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1933,   485,   486,  1934,   487,   801,
     488,   489,   490,   491,   492,  1935,   493,   494,  1936,  1937,
     495,   496,   497,   498,   499,  1938,   500,   501,   502,   503,
     504,   505,   506,  1939,  1940,   507,   508,   509,   510,   511,
    1941,  1942,   512,   513,   514,   515,   516,   517,   518,  1943,
     519,   802,   520,   521,   522,   523,  1944,  1945,   524,  1946,
    1947,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   779,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,  1148,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,  1151,     0,  1152,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,  1153,
    1154,  1155,  1156,  1157,  1158,  1159,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,  1163,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,  1166,     0,   328,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
    1171,   793,   363,   794,     0,   364,   365,   366,  1172,  1173,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,  1178,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,  1181,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
    1182,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,  1185,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,  1187,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,  1190,   498,  1191,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,  1194,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,
     540,   541,   542,   823,     0,   600,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,  1683,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
    1684,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,  1685,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
     858,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,   824,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,   825,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   823,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,   875,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,   824,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   876,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,   825,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   823,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,   824,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,   362,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
     825,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
    2241,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,   824,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,   327,  3151,   328,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
     362,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,   825,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   823,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,   824,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,   825,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,   824,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   964,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,   825,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   823,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,   824,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1037,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,   825,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   823,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,   824,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1049,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,   362,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
     825,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,   824,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  1063,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
     362,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,  1064,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,   825,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   823,     0,   600,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,  1844,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     3,     4,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   823,     0,   600,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,   242,   243,   781,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,   362,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   795,
     384,   385,   386,   387,     0,   388,   389,   796,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,   797,   403,   798,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   800,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   823,     0,   600,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,   242,   243,
     781,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1673,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,   362,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   795,   384,   385,   386,   387,     0,   388,
     389,   796,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,   797,   403,   798,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   800,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   779,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,   242,   243,   781,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
     362,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   795,   384,   385,
     386,   387,     0,   388,   389,   796,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,   797,   403,   798,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     800,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   779,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,   242,   243,   781,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   986,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,   362,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   795,   384,   385,   386,   387,     0,   388,   389,   796,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,   797,
     403,   798,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   800,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   779,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
     242,   243,   781,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  1035,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,   362,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   795,   384,   385,   386,   387,
       0,   388,   389,   796,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,   797,   403,   798,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   800,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,  2050,   256,   257,   258,   259,   260,     0,     0,
    2127,   261,   262,   263,   264,     0,   265,   266,   267,  2051,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,  2128,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,  2053,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  2129,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,  2054,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
    2055,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,  2050,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,  2051,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
    2128,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,  2053,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,  3016,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,  2054,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,  2055,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   711,
     229,   230,   673,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,   674,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
     712,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     675,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   676,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,   673,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,   674,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,  2741,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   675,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   676,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,  2050,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,  2051,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,  2128,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
    2053,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,  2054,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,  2055,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,   673,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,   674,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   675,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     676,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,  1710,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,  1711,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,  1712,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,  1713,   322,
       0,     0,     0,  1714,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
    1715,  1716,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,  1717,
     455,   456,   457,   458,     0,  1718,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,  1719,   487,     0,
    1720,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,  1721,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,   674,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     675,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   676,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,   868,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   869,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,   743,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     3,     4,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,  2829,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,  2830,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,  2842,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
    2843,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,   591,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   592,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
     703,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   704,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   705,   494,
       0,     0,   706,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,   737,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   738,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   739,   494,     0,     0,   740,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,   743,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,   832,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   833,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,   978,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
    1241,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
    1252,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   723,   252,   253,
     254,  1253,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   726,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   727,   448,
     449,   450,   451,   452,   453,   728,   455,   456,   457,   458,
       0,   459,   460,   461,   462,  1245,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   730,   494,     0,     0,   731,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   732,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1361,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,   743,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,  1417,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  1418,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,   703,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,  2631,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,  2632,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,  2633,
     487,     0,   488,  2634,   490,  2635,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,  2636,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,   600,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,  3835,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,  3849,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   689,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   701,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   723,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   724,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   725,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   726,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   727,   448,   449,   450,   451,   452,   453,   728,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   729,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   730,   494,     0,     0,
     731,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   732,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   755,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   856,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   863,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   879,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   940,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   956,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   991,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  1047,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1051,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1053,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  1055,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  1059,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  1067,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   723,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   726,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   727,   448,
     449,   450,   451,   452,   453,   728,   455,   456,   457,   458,
       0,   459,   460,   461,   462,  1245,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   730,   494,     0,     0,   731,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   732,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1542,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  1572,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  1574,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  1644,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  1646,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  1648,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,  1744,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,  2005,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,   334,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   723,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   726,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   727,   448,   449,   450,   451,   452,
     453,   728,   455,   456,   457,   458,     0,   459,   460,   461,
     462,  1245,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,  2037,   489,   490,   491,   492,     0,   730,   494,
       0,     0,   731,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   732,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   723,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,   334,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   726,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   727,   448,
     449,   450,   451,   452,   453,  2112,   455,   456,   457,   458,
       0,   459,   460,   461,   462,  2113,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   730,   494,     0,     0,  2114,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   732,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,  2354,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  2358,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  2398,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  2433,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  2752,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   723,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   726,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   727,   448,   449,   450,   451,   452,   453,   728,
     455,   456,   457,   458,     0,   459,   460,   461,   462,  2113,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   730,   494,     0,     0,
    2114,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   732,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  2819,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,     0,   239,   240,   241,   242,   243,     0,   244,
     245,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   259,   260,
       0,     0,     0,   261,   262,   263,   264,     0,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,     0,
     274,   275,   276,     0,     0,     0,     0,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   283,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,   298,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,     0,   321,     0,   322,     0,     0,
       0,   323,   324,   325,     0,   326,   327,     0,   328,   329,
       0,   330,   331,   332,   333,  2832,     0,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,   351,   352,     0,   353,
       0,   354,     0,     0,   355,     0,   356,   357,   358,   359,
     360,     0,     0,   361,   362,     0,   363,     0,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   384,   385,   386,   387,     0,   388,   389,     0,
     390,     0,   391,   392,   393,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,   402,     0,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,     0,   469,   470,   471,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   485,   486,     0,   487,     0,   488,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,   496,
     497,   498,   499,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,  2834,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
       0,   239,   240,   241,   242,   243,     0,   244,   245,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   259,   260,     0,     0,
       0,   261,   262,   263,   264,     0,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,     0,   274,   275,
     276,     0,     0,     0,     0,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   283,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,   298,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,     0,   321,     0,   322,     0,     0,     0,   323,
     324,   325,     0,   326,   327,     0,   328,   329,     0,   330,
     331,   332,   333,  2949,     0,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,   351,   352,     0,   353,     0,   354,
       0,     0,   355,     0,   356,   357,   358,   359,   360,     0,
       0,   361,   362,     0,   363,     0,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
     384,   385,   386,   387,     0,   388,   389,     0,   390,     0,
     391,   392,   393,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,   402,     0,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,     0,   469,   470,   471,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
       0,   485,   486,     0,   487,     0,   488,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,   496,   497,   498,
     499,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,     0,   239,   240,   241,   242,   243,
       0,   244,   245,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
     259,   260,     0,     0,     0,   261,   262,   263,   264,     0,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,     0,   274,   275,   276,     0,     0,     0,     0,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   283,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,  2971,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,     0,   321,     0,   322,
       0,     0,     0,   323,   324,   325,     0,   326,   327,     0,
     328,   329,     0,   330,   331,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,   351,   352,
       0,   353,     0,   354,     0,     0,   355,     0,   356,   357,
     358,   359,   360,     0,     0,   361,   362,     0,   363,     0,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   384,   385,   386,   387,     0,   388,
     389,     0,   390,     0,   391,   392,   393,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
     402,     0,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,     0,   469,   470,   471,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     0,   485,   486,     0,   487,     0,
     488,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,   496,   497,   498,   499,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,     0,   239,
     240,   241,   242,   243,     0,   244,   245,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   259,   260,     0,     0,     0,   261,
     262,   263,   264,     0,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,     0,   274,   275,   276,     0,
       0,     0,     0,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   283,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,   298,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
       0,   321,     0,   322,     0,     0,     0,   323,   324,   325,
       0,   326,   327,     0,   328,   329,     0,   330,   331,   332,
     333,  4084,     0,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,   351,   352,     0,   353,     0,   354,     0,     0,
     355,     0,   356,   357,   358,   359,   360,     0,     0,   361,
     362,     0,   363,     0,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   384,   385,
     386,   387,     0,   388,   389,     0,   390,     0,   391,   392,
     393,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,   402,     0,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,     0,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
       0,   469,   470,   471,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     0,   485,
     486,     0,   487,     0,   488,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,   496,   497,   498,   499,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   993,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,     0,   994,   781,   995,
     996,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   997,   998,   255,     0,   256,   257,   258,   259,     0,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   999,  1000,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1001,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,     0,   312,   313,   314,     0,     0,   316,     0,
     317,   318,  1002,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,     0,     0,     0,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,  2008,   339,   340,   341,   342,   343,   344,     0,   345,
     789,  2009,   347,   348,   349,   350,  1004,  1005,     0,  1006,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,     0,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1007,   795,  1008,   385,   386,     0,     0,   388,   389,   796,
     390,     0,     0,   392,  1009,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,  2011,   797,
     403,   798,     0,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,     0,   416,     0,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1010,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,     0,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,  2012,   467,   468,   800,   469,   470,  1012,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,     0,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,  1013,  1014,     0,     0,   495,   496,
       0,   498,     0,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,     0,  1015,  2013,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   993,     0,     0,     0,     0,
       0,     0,     0,     0,   540,   541,   542,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,     0,   994,
     781,   995,   996,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   997,   998,   255,     0,   256,   257,   258,
     259,     0,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   999,  1000,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1001,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,     0,   312,   313,   314,     0,     0,
     316,     0,   317,   318,  1002,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,     0,     0,
       0,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,     0,   347,   348,   349,   350,  1004,  1005,
       0,  1006,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,     0,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1007,   795,  1008,   385,   386,     0,     0,   388,
     389,   796,   390,  2108,     0,   392,  1009,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
       0,   797,   403,   798,     0,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,     0,   416,     0,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1010,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,     0,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,  2012,   467,   468,   800,   469,   470,  1012,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,     0,     0,   485,   486,  3668,   487,   801,
     488,   489,   490,   491,   492,     0,  1013,  1014,     0,     0,
     495,   496,     0,   498,     0,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,     0,  1015,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   222,     0,     0,
       0,     0,     0,     0,     0,     0,   540,   541,   542,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,     0,   239,   240,   241,
     242,   243,     0,   244,   245,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,   259,   260,     0,     0,     0,   261,   262,   263,
     264,     0,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,     0,   274,   275,   276,     0,     0,     0,
       0,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     283,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
     298,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,     0,   321,
       0,   322,     0,     0,     0,   323,   324,   325,     0,   326,
     327,     0,   328,   329,     0,   330,   331,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
     351,   352,     0,   353,     0,   354,     0,     0,   355,     0,
     356,   357,   358,   359,   360,     0,     0,   361,   362,     0,
     363,     0,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   384,   385,   386,   387,
       0,   388,   389,     0,   390,     0,   391,   392,   393,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,   402,     0,   403,     0,   404,   405,   406,   407,
     408,   409,     0,   411,   412,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,     0,   447,   448,   449,   450,     0,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,     0,   469,
     470,   471,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     0,   485,   486,     0,
     487,     0,   488,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,   496,   497,   498,   499,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   993,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,     0,   994,   781,   995,   996,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   997,
     998,   255,     0,   256,   257,   258,   259,     0,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   999,  1000,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1001,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
       0,   312,   313,   314,     0,     0,   316,     0,   317,   318,
    1002,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,     0,     0,     0,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,     0,
     347,   348,   349,   350,  1004,  1005,     0,  1006,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,     0,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1007,   795,
    1008,   385,   386,  2179,     0,   388,   389,   796,   390,     0,
       0,   392,  1009,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,     0,   797,   403,   798,
       0,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,     0,   416,     0,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1010,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,     0,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,  1011,
     467,   468,   800,   469,   470,  1012,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,     0,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1013,  1014,     0,     0,   495,   496,     0,   498,
       0,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,     0,  1015,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   993,     0,     0,     0,     0,     0,     0,
       0,     0,   540,   541,   542,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,     0,   994,   781,   995,
     996,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   997,   998,   255,     0,   256,   257,   258,   259,     0,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   999,  1000,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1001,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,     0,   312,   313,   314,     0,     0,   316,     0,
     317,   318,  1002,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,     0,     0,     0,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,     0,   347,   348,   349,   350,  1004,  1005,     0,  1006,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,     0,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1007,   795,  1008,   385,   386,  3488,     0,   388,   389,   796,
     390,     0,     0,   392,  1009,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,     0,   797,
     403,   798,     0,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,     0,   416,     0,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1010,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,     0,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,  1011,   467,   468,   800,   469,   470,  1012,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,     0,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,  1013,  1014,     0,     0,   495,   496,
       0,   498,     0,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,     0,  1015,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   993,     0,     0,     0,     0,
       0,     0,     0,     0,   540,   541,   542,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,     0,   994,
     781,   995,   996,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,   997,   998,   255,     0,   256,   257,   258,
     259,     0,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,   999,  1000,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,  1001,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,     0,   312,   313,   314,     0,     0,
     316,     0,   317,   318,  1002,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,     0,     0,
       0,   329,     0,   330,   331,   332,   333,  1003,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,     0,   347,   348,   349,   350,  1004,  1005,
       0,  1006,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,     0,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,  1007,   795,  1008,   385,   386,     0,     0,   388,
     389,   796,   390,     0,     0,   392,  1009,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
       0,   797,   403,   798,     0,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,     0,   416,     0,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,  1010,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,     0,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,  1011,   467,   468,   800,   469,   470,  1012,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,     0,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,  1013,  1014,     0,     0,
     495,   496,     0,   498,     0,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,     0,  1015,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,   993,     0,     0,
       0,     0,     0,     0,     0,     0,   540,   541,   542,     0,
       0,     0,   223,   224,   225,   226,   227,   228,   229,   230,
       0,   232,   233,   234,     0,     0,     0,     0,     0,     0,
       0,   235,   236,     0,   237,   238,   780,   239,   240,   241,
       0,   994,   781,   995,   996,     0,   246,   247,   248,   249,
     250,     0,     0,   251,   252,   997,   998,   255,     0,   256,
     257,   258,   259,     0,     0,   782,     0,   261,   262,   263,
     264,   783,   265,   266,   267,     0,   268,   269,   270,   271,
     272,   273,     0,   784,   274,   275,   276,     0,     0,     0,
     785,     0,     0,     0,   277,   278,   279,   280,   281,   282,
     999,  1000,   285,     0,   286,     0,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,     0,     0,   296,   297,
    1001,   299,   300,     0,   301,   302,   303,     0,   304,   305,
     306,     0,   307,   308,   309,   310,     0,   312,   313,   314,
       0,     0,   316,     0,   317,   318,  1002,   320,     0,   321,
       0,   322,   786,     0,   787,   323,   324,   325,     0,   326,
       0,     0,     0,   329,     0,   330,   331,   332,   333,  1061,
     788,   335,   336,   337,   338,     0,   339,   340,   341,   342,
     343,   344,     0,   345,   789,     0,   347,   348,   349,   350,
    1004,  1005,     0,  1006,     0,   354,   790,   791,   355,   792,
     356,   357,   358,   359,   360,     0,     0,   361,     0,   793,
     363,   794,     0,   364,   365,   366,     0,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,  1007,   795,  1008,   385,   386,     0,
       0,   388,   389,   796,   390,     0,     0,   392,  1009,   394,
     395,   396,     0,   397,     0,     0,   398,   399,   400,     0,
       0,   401,     0,   797,   403,   798,     0,   405,   406,   407,
     408,   409,   410,   411,   412,     0,   413,   414,     0,   416,
       0,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,  1010,   430,   431,   432,   433,     0,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
       0,   445,   446,   799,   447,   448,   449,     0,   451,   452,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     462,   463,     0,   464,   465,  1011,   467,   468,   800,   469,
     470,  1012,   472,     0,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,     0,     0,   485,   486,     0,
     487,   801,   488,   489,   490,   491,   492,     0,  1013,  1014,
       0,     0,   495,   496,     0,   498,     0,     0,   500,   501,
     502,   503,   504,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,     0,   512,   513,   514,   515,   516,     0,
    1015,     0,   519,   802,   520,   521,   522,   523,     0,     0,
     524,     0,     0,   525,   526,   527,   528,   529,   530,   993,
       0,     0,     0,     0,     0,     0,     0,     0,   540,   541,
     542,     0,     0,     0,   223,   224,   225,   226,   227,   228,
     229,   230,     0,   232,   233,   234,     0,     0,     0,     0,
       0,     0,     0,   235,   236,     0,   237,   238,   780,   239,
     240,   241,     0,   994,   781,   995,   996,     0,   246,   247,
     248,   249,   250,     0,     0,   251,   252,   997,   998,   255,
       0,   256,   257,   258,   259,     0,     0,   782,     0,   261,
     262,   263,   264,   783,   265,   266,   267,     0,   268,   269,
     270,   271,   272,   273,     0,   784,   274,   275,   276,     0,
       0,     0,   785,     0,     0,     0,   277,   278,   279,   280,
     281,   282,   999,  1000,   285,     0,   286,     0,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,     0,     0,
     296,   297,  1001,   299,   300,     0,   301,   302,   303,     0,
     304,   305,   306,     0,   307,   308,   309,   310,     0,   312,
     313,   314,     0,     0,   316,     0,   317,   318,  1002,   320,
       0,   321,     0,   322,   786,     0,   787,   323,   324,   325,
       0,   326,     0,     0,     0,   329,     0,   330,   331,   332,
     333,   334,   788,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,     0,   345,   789,     0,   347,   348,
     349,   350,  1004,  1005,     0,  1006,     0,   354,   790,   791,
     355,   792,   356,   357,   358,   359,   360,     0,     0,   361,
       0,   793,   363,   794,     0,   364,   365,   366,     0,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,  1007,   795,  1008,   385,
     386,     0,     0,   388,   389,   796,   390,     0,     0,   392,
    1009,   394,   395,   396,     0,   397,     0,     0,   398,   399,
     400,     0,     0,   401,     0,   797,   403,   798,     0,   405,
     406,   407,   408,   409,   410,   411,   412,     0,   413,   414,
       0,   416,     0,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,  1010,   430,   431,   432,   433,
       0,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,     0,   445,   446,   799,   447,   448,   449,     0,
     451,   452,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   462,   463,     0,   464,   465,  1011,   467,   468,
     800,   469,   470,  1012,   472,     0,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,     0,     0,   485,
     486,     0,   487,   801,   488,   489,   490,   491,   492,     0,
    1013,  1014,     0,     0,   495,   496,     0,   498,     0,     0,
     500,   501,   502,   503,   504,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,     0,   512,   513,   514,   515,
     516,     0,  1015,     0,   519,   802,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   525,   526,   527,   528,   529,
     530,   993,     0,     0,     0,     0,     0,     0,     0,     0,
     540,   541,   542,     0,     0,     0,   223,   224,   225,   226,
     227,   228,   229,   230,     0,   232,   233,   234,     0,     0,
       0,     0,     0,     0,     0,   235,   236,     0,   237,   238,
     780,   239,   240,   241,     0,   994,   781,   995,   996,     0,
     246,   247,   248,   249,   250,     0,     0,   251,   252,   997,
     998,   255,     0,   256,   257,   258,   259,     0,     0,   782,
       0,   261,   262,   263,   264,   783,   265,   266,   267,     0,
     268,   269,   270,   271,   272,   273,     0,   784,   274,   275,
     276,     0,     0,     0,   785,     0,     0,     0,   277,   278,
     279,   280,   281,   282,   999,  1000,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
       0,     0,   296,   297,  1001,   299,   300,     0,   301,   302,
     303,     0,   304,   305,   306,     0,   307,   308,   309,   310,
       0,   312,   313,   314,     0,     0,   316,     0,   317,   318,
    1002,   320,     0,   321,     0,   322,   786,     0,   787,   323,
     324,   325,     0,   326,     0,     0,     0,   329,     0,   330,
     331,   332,   333,   334,   788,   335,   336,   337,   338,     0,
     339,   340,   341,   342,   343,   344,     0,   345,   789,     0,
     347,   348,   349,   350,  1004,  1005,     0,  1006,     0,   354,
     790,   791,   355,   792,   356,   357,   358,   359,   360,     0,
       0,   361,     0,   793,   363,   794,     0,   364,   365,   366,
       0,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,  1007,   795,
    1008,   385,   386,     0,     0,   388,   389,   796,   390,     0,
       0,   392,  1009,   394,   395,   396,     0,   397,     0,     0,
     398,   399,   400,     0,     0,   401,     0,   797,   403,   798,
       0,   405,   406,   407,   408,   409,   410,   411,   412,     0,
     413,   414,     0,   416,     0,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  1010,   430,   431,
     432,   433,     0,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,     0,   445,   446,   799,   447,   448,
     449,     0,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,   463,     0,   464,   465,  2012,
     467,   468,   800,   469,   470,  1012,   472,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,     0,
       0,   485,   486,     0,   487,   801,   488,   489,   490,   491,
     492,     0,  1013,  1014,     0,     0,   495,   496,     0,   498,
       0,     0,   500,   501,   502,   503,   504,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,     0,   512,   513,
     514,   515,   516,     0,  1015,     0,   519,   802,   520,   521,
     522,   523,     0,     0,   524,     0,     0,   525,   526,   527,
     528,   529,   530,   993,     0,     0,     0,     0,     0,     0,
       0,     0,   540,   541,   542,     0,     0,     0,   223,   224,
     225,   226,   227,   228,   229,   230,     0,   232,   233,   234,
       0,     0,     0,     0,     0,     0,     0,   235,   236,     0,
     237,   238,   780,   239,   240,   241,     0,   994,   781,   995,
     996,     0,   246,   247,   248,   249,   250,     0,     0,   251,
     252,   997,   998,   255,     0,   256,   257,   258,   259,     0,
       0,   782,     0,   261,   262,   263,   264,   783,   265,   266,
     267,     0,   268,   269,   270,   271,   272,   273,     0,   784,
     274,   275,   276,     0,     0,     0,   785,     0,     0,     0,
     277,   278,   279,   280,   281,   282,   999,  1000,   285,     0,
     286,     0,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,     0,     0,   296,   297,  1001,   299,   300,     0,
     301,   302,   303,     0,   304,   305,   306,     0,   307,   308,
     309,   310,     0,   312,   313,   314,     0,     0,   316,     0,
     317,   318,  1002,   320,     0,   321,     0,   322,   786,     0,
     787,   323,   324,   325,     0,   326,     0,     0,     0,   329,
       0,   330,   331,   332,   333,   334,   788,   335,   336,   337,
     338,     0,   339,   340,   341,   342,   343,   344,     0,   345,
     789,     0,   347,   348,   349,   350,  1004,  1005,     0,  1006,
       0,   354,   790,   791,   355,   792,   356,   357,   358,   359,
     360,     0,     0,   361,     0,   793,   363,   794,     0,   364,
     365,   366,     0,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
    1007,   795,  1008,   385,   386,     0,     0,   388,   389,   796,
     390,     0,     0,   392,  1009,   394,   395,   396,     0,   397,
       0,     0,   398,   399,   400,     0,     0,   401,     0,   797,
     403,   798,     0,   405,   406,   407,   408,   409,   410,   411,
     412,     0,   413,   414,     0,   416,     0,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  1010,
     430,   431,   432,   433,     0,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   799,
     447,   448,   449,     0,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   462,   463,     0,   464,
     465,     0,   467,   468,   800,   469,   470,  1012,   472,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,     0,     0,   485,   486,     0,   487,   801,   488,   489,
     490,   491,   492,     0,  1013,  1014,     0,     0,   495,   496,
       0,   498,     0,     0,   500,   501,   502,   503,   504,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,     0,
     512,   513,   514,   515,   516,     0,  1015,     0,   519,   802,
     520,   521,   522,   523,     0,     0,   524,     0,     0,   525,
     526,   527,   528,   529,   530,   993,     0,     0,     0,     0,
       0,     0,     0,     0,   540,   541,   542,     0,     0,     0,
     223,   224,   225,   226,   227,   228,   229,   230,     0,   232,
     233,   234,     0,     0,     0,     0,     0,     0,     0,   235,
     236,     0,   237,   238,   780,   239,   240,   241,     0,     0,
     781,     0,     0,     0,   246,   247,   248,   249,   250,     0,
       0,   251,   252,     0,     0,   255,     0,   256,   257,   258,
     259,     0,     0,   782,     0,   261,   262,   263,   264,   783,
     265,   266,   267,     0,   268,   269,   270,   271,   272,   273,
       0,   784,   274,   275,   276,     0,     0,     0,   785,     0,
       0,     0,   277,   278,   279,   280,   281,   282,     0,     0,
     285,     0,   286,     0,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,     0,     0,   296,   297,   298,   299,
     300,     0,   301,   302,   303,     0,   304,   305,   306,     0,
     307,   308,   309,   310,     0,   312,   313,   314,     0,     0,
     316,     0,   317,   318,     0,   320,     0,   321,     0,   322,
     786,     0,   787,   323,   324,   325,     0,   326,     0,     0,
       0,   329,     0,   330,   331,   332,   333,   334,   788,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
       0,   345,   789,     0,   347,   348,   349,   350,     0,     0,
       0,     0,     0,   354,   790,   791,   355,   792,   356,   357,
     358,   359,   360,     0,     0,   361,     0,   793,   363,   794,
       0,   364,   365,   366,     0,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   795,     0,   385,   386,     0,     0,   388,
     389,   796,   390,     0,     0,   392,     0,   394,   395,   396,
       0,   397,     0,     0,   398,   399,   400,     0,     0,   401,
       0,   797,   403,   798,     0,   405,   406,   407,   408,   409,
     410,   411,   412,     0,   413,   414,     0,   416,     0,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   430,   431,   432,   433,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   799,   447,   448,   449,     0,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   462,   463,
       0,   464,   465,     0,   467,   468,   800,   469,   470,     0,
     472,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,     0,     0,   485,   486,     0,   487,   801,
     488,   489,   490,   491,   492,     0,     0,     0,     0,     0,
     495,   496,     0,   498,     0,     0,   500,   501,   502,   503,
     504,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,     0,   512,   513,   514,   515,   516,     0,     0,     0,
     519,   802,   520,   521,   522,   523,     0,     0,   524,     0,
       0,   525,   526,   527,   528,   529,   530,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   540,   541,   542
};

static const yytype_int16 yycheck[] =
{
      16,     0,     0,     0,     0,     0,     0,    50,   200,    25,
      35,   204,   601,    21,    21,   207,  1078,  1036,   571,    27,
      27,  1100,    20,   724,    20,   835,   218,  1045,   674,   675,
     676,     7,    44,  1040,   680,  1270,   778,   878,    14,   722,
    1347,    43,   804,   182,  1011,   747,  2652,  2304,   865,   773,
    2016,  2017,    50,   642,  1714,    12,  1390,  1384,   887,  2489,
    1030,  1498,  1014,   731,  1131,  1406,  1289,   620,    17,   601,
     999,  1000,    22,  1835,  2313,  1569,   207,  1450,  1750,  1395,
    1009,    20,  3083,  1390,  2231,    35,   932,   218,  1963,   864,
    1325,  2823,  3059,   191,   192,  1294,   937,   195,  3003,   197,
     941,  3041,     0,  3383,  2848,   946,  2850,  2465,  1070,  3593,
    3340,  2178,  2644,  2701,   955,  3437,   169,  3014,  2796,   217,
     952,  1272,  2642,  2643,   965,   562,  1467,  1468,  3379,   641,
    3070,   963,  3646,   612,  3669,  1733,   633,  3660,   727,  2271,
    3647,   987,  3310,  2996,  1581,  1838,  1462,  2279,  1794,  2281,
    3003,   184,  3304,  2575,   633,     0,   190,   184,     0,  1376,
       0,  3657,     0,  1304,     0,   199,     0,  1325,    34,     0,
    1321,     0,     0,     0,   611,    41,     0,  1671,   864,  4104,
      49,  2709,     0,  3057,   870,  3910,   184,   821,   770,    40,
     770,   997,   998,  3239,   880,   727,   201,  3383,  3309,  4224,
      35,  4226,  1008,     9,  4398,   210,  4281,  3356,     0,     0,
    4262,   213,    55,    62,   219,    48,     5,  4323,  4324,   623,
      22,     0,    22,    11,     0,     0,    41,    41,    29,    55,
     634,  1160,  1161,    55,     9,   111,   109,  1189,    70,    76,
    2307,    11,     5,    84,  4319,  2640,  1208,     5,   159,   102,
    1179,    26,    26,     0,  2016,    13,    14,     5,    39,    33,
       3,    22,     9,   154,  3276,   111,    22,    28,  1078,     5,
      40,    39,    55,     5,     5,   159,  4265,    13,    14,    26,
     169,    13,    14,     5,   930,  2707,     5,    26,    72,     5,
    2798,     5,     5,   114,    33,   160,   260,  1532,  2693,     5,
      70,    26,     5,   102,     5,     5,   162,  4587,    72,   102,
    1339,  2545,  2546,     5,    29,   159,  2550,     4,  4347,     9,
     109,   129,     9,     5,     5,   127,   260,   127,    38,   247,
      68,    62,    27,   159,   292,   327,   140,    80,    56,   244,
    2407,    11,  2409,  1149,  1150,   154,    64,     9,    22,    74,
     302,   233,   101,  2587,  2588,   908,   141,    82,   204,   376,
     339,  2640,   167,   376,  4353,   309,   127,   159,   159,  1175,
     159,   127,   323,   194,    26,    26,    11,   569,   571,   202,
     159,    62,   574,   159,   159,   110,   266,   159,   131,   181,
     181,   274,     3,   585,   415,  3735,   298,  3737,   155,   313,
     246,   260,   181,    26,    24,   181,   181,    72,   310,    72,
      33,    21,   159,   369,  2693,   371,    81,    27,    81,    30,
      31,   900,    55,  2083,    44,   339,   309,   620,  1257,   186,
     313,  3915,   376,   335,   181,    70,   457,   260,   569,  4464,
     457,   920,  4517,   574,   457,  1255,   397,  1209,   330,   329,
    1260,  1261,   298,   127,   585,   934,   339,    11,    72,   411,
     185,   453,   560,  4388,    81,  4745,   564,    81,    11,   179,
     122,   122,   315,   314,   274,  1237,   455,  1066,   334,   397,
      72,   224,   231,    72,   582,   234,    40,   451,  1711,  1078,
    1509,   455,  1715,   315,  1717,   453,  1514,  1720,   403,  1016,
     195,   327,   311,   221,    20,  3013,  1535,   165,  4497,   309,
     366,   312,   365,   274,   403,   320,    70,  4506,   274,   453,
       8,   259,   323,   557,   325,   401,   208,    15,    16,    17,
    4559,   274,   315,   109,  1066,   551,     4,  1054,   342,   339,
     102,     9,   453,   336,   549,  1062,  1135,   158,   309,   160,
     555,  1068,   389,   309,  1364,   554,   554,   554,   554,   554,
     554,   376,   453,  3468,  1374,    72,   365,  1802,  1080,   442,
     102,    26,   606,   457,    81,   349,   397,   116,   339,  4063,
     381,   362,   616,   339,   410,   601,   602,   376,   453,  4695,
     404,  4105,   376,   646,   362,   397,    55,   312,  1749,   642,
     200,   550,   402,  1135,   453,  1446,   414,  1448,   356,   357,
     349,   457,   376,   457,   457,  3468,   457,  4669,   453,   451,
     453,  4901,   134,   455,   140,   368,  1705,   370,  1438,   414,
    1771,  1441,  1442,   358,   773,   457,  1115,  4121,  1779,  1456,
    1791,  1603,  1046,   641,   642,   641,   452,   655,   655,   657,
     657,   659,   659,   442,  3386,  4849,  1502,   665,   665,   666,
     667,   449,  3830,  1252,   456,   456,   455,  1496,  1675,   444,
     445,  1260,  1261,   689,   457,  3615,  1362,   456,  2745,   449,
     456,   456,   315,   640,   686,   457,  1837,  3839,   451,  3656,
     453,  3843,   455,   669,   699,   453,  1528,   444,   445,   715,
    1510,  3747,  1106,   642,   420,  1712,   420,   723,  1637,   456,
     726,   727,   728,  1117,  1721,   908,   408,   453,  3829,   724,
    1252,   453,   453,   439,  4799,   439,   349,   408,  1132,   762,
    1312,   453,  1312,  1419,   453,   762,  4811,   453,   743,   453,
     453,  3638,  3891,   841,   842,   747,  2712,   453,  2714,  1383,
     453,  4776,   453,   453,   444,   445,   332,   444,   445,   376,
     765,   453,   376,   453,   762,   764,   764,   764,   764,   764,
     764,  4496,   453,  4257,   262,   777,   446,   447,   448,   449,
    4264,  2097,   444,   445,   376,   297,  1748,   376,  1750,   365,
      11,  3803,  3324,  2127,  1756,  2030,     5,  3036,   409,   457,
    1762,  1763,  1764,   365,  1610,  1611,  4881,   323,   259,  4149,
    1772,  1773,   751,  4153,  4154,  1777,  4156,   102,   820,    40,
     114,  4746,     5,    64,   457,   923,   342,   282,   835,   405,
       5,   836,   113,   365,   159,  3709,   102,  2969,   159,   161,
    3368,   140,   418,   109,  2976,  2977,  3578,   181,  2980,    70,
    4503,  4504,   950,   951,   340,  2987,   315,   457,  2174,   893,
     399,   117,  2190,   439,   159,     3,   764,     5,   256,   376,
     904,  1424,  2030,   971,   725,   409,   109,   453,   729,   334,
    2642,  2643,  2644,     3,     4,     5,   755,     5,  3566,     9,
     137,  4387,   446,   447,   448,   449,   102,   138,   156,   153,
    2117,   444,   445,   446,   447,   448,   449,  3302,   266,  3304,
     250,  2978,  2979,   811,   369,   156,   371,  2245,   323,   764,
     201,  4846,   764,  2158,   764,   114,   764,   160,   764,    88,
     764,  1577,  3354,   764,   206,   764,   764,   764,   943,   973,
     764,   453,   320,  1422,  1042,  1043,   764,   273,     5,   108,
     418,   198,   440,   441,   442,   365,   444,   445,   446,   447,
     448,   449,   967,   968,   969,   273,   104,   453,    26,    22,
     256,   439,   244,   103,  2347,    28,   444,   445,  4258,   256,
     246,  2043,   141,   141,  3218,  3219,  3220,  3221,  3383,   109,
    3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,  3233,
     866,   867,   453,   325,  3682,   194,   346,   256,   114,  2702,
    2656,     3,   109,   339,   247,   160,    64,  1718,  1719,   266,
     398,   127,  4208,  3302,  1503,  3304,  1788,   230,   977,    55,
    2996,   285,    32,    81,  2361,   173,   261,  3003,   244,  1518,
      46,  4209,   251,   342,   163,  2012,  3280,  3281,   453,   290,
    1066,   376,  2022,   309,   184,   376,   114,   379,  1537,  4245,
     114,  4213,  1078,   385,  2299,   453,  4218,  4574,   251,  4221,
     342,  1078,  4258,  2671,   127,  1592,   251,   169,  4613,   199,
     365,   376,  1080,  4597,  1080,  3990,     3,  4610,    80,   355,
     138,  4598,   358,  1682,   266,   233,  1112,  1650,   236,   457,
    1105,   221,   221,   397,  3383,  1584,  4602,  1083,   156,  1085,
      48,  1087,  1609,  1089,  3080,  1091,  1092,  1093,  1597,  1135,
    4121,    34,  1098,   457,  1641,   397,  1131,   111,  1645,   244,
    1609,  4098,   277,   251,  1651,  1652,   194,  3990,  4791,   131,
     194,   141,  1621,   332,   391,  1143,   305,   442,   161,   151,
     109,   392,   244,  4093,   251,   109,  4168,  1674,    78,   399,
     455,  1598,   100,    80,  1162,  1208,   399,   453,    78,  1681,
     176,  1668,  3904,   332,   332,   181,   453,    64,   657,   658,
     659,   287,   111,   662,   663,   664,  1665,   453,   169,  1668,
     207,   266,   330,   672,  1210,  1193,   109,   327,   423,   119,
     345,  3945,   169,  1219,   453,   378,   365,   365,   397,   119,
    1208,   217,  4398,   453,  4857,   132,  1769,  1233,   244,   104,
     204,   274,   109,   444,   445,   446,   447,   448,   449,  1282,
    2453,  1424,   224,  4747,   364,   365,  1252,   339,  1642,  1255,
    1256,   243,   290,  4494,  1260,  1261,   405,   405,  1255,   262,
     369,  1655,   371,  1260,  1261,   193,   309,   104,   113,   418,
     418,  1266,   246,   244,  1297,  1298,  1670,  1300,    36,   186,
    1297,  1298,  4756,  1300,   332,   273,   395,   244,  4600,   137,
     439,   439,   274,   264,    24,   457,   339,   246,   173,   315,
     161,  1483,   246,   339,   453,   453,   434,  1998,   274,  1297,
    1298,  3889,  1300,  1401,    44,   154,   244,   274,  4460,   273,
    1315,   403,  1314,   339,   298,   164,  4959,   309,  1797,   103,
     435,   313,   251,   453,   444,   445,   173,   274,  3860,    78,
     384,  2566,   181,   309,  3866,  3855,   159,  2572,   344,   397,
     339,   339,   309,   397,   392,   358,   201,   339,   233,  4845,
     118,   236,  3586,   266,  4850,   457,   276,  1364,   181,   246,
     218,  1553,   309,   280,   251,  1557,   276,  1374,   327,  3727,
     119,  1469,  1470,  1471,  1472,   339,   368,  1569,   370,   454,
     149,  2400,   457,  4663,  1389,   154,   233,  4292,  2198,   236,
     328,   262,  2410,  1398,   453,  2227,  2206,  2404,  2208,   111,
     184,   376,    81,   290,  2545,  2546,  1413,  1414,  4904,  2550,
    1359,   457,  2374,  4380,  1512,  1513,  4428,   304,  3550,   162,
    2195,  1426,   403,  1521,  3556,  3557,   418,  3559,     0,  1434,
     109,  1438,  1437,  1531,  1441,  1442,   403,    78,  1454,  4292,
    2126,  1958,  4672,  4673,  3839,   330,  2587,  2588,  3843,   218,
     370,  1643,  4638,   127,  2043,   195,   163,  1650,   457,  1461,
     370,  1559,  1560,  1561,  1562,  2664,   181,   442,  1473,   318,
    4966,    88,   112,   390,    78,   227,  4373,  4663,   119,  1671,
     455,   398,  1487,   330,   401,   149,  2813,  3362,  3148,   258,
    3637,   151,   204,    30,    31,  1500,  2328,  2329,  2330,  2331,
     120,   456,  3468,  1510,   122,   392,   124,  4519,  2340,  2195,
     130,  4523,  4524,   264,   221,   119,   111,  2740,   325,  3191,
     139,   323,   173,   274,  2370,   399,   122,   276,   124,   442,
    1428,  2217,  2085,   325,   246,  1433,  2909,   177,   451,  1555,
     453,   454,   455,   327,   457,  1550,   457,   164,   311,   434,
     210,    88,   354,   137,   218,   274,  1654,  1591,   309,  1657,
    3839,  2247,  3324,   182,  3843,   149,  1571,   246,   453,  1667,
     154,   108,   112,  1578,   381,   327,  1769,   302,  1676,   453,
     364,   365,   233,   274,  1482,  2547,   298,   434,  1486,   381,
     264,   334,   112,   188,   309,   302,   399,  2559,   313,  2036,
    1607,  2080,  1081,  2919,   141,  1084,  1640,  1086,   333,  1088,
    1617,  1090,  1619,  2092,   198,  1094,   368,  4349,   309,  1626,
     339,   370,   289,   366,   339,    61,    62,  1634,   246,  2591,
    3697,    89,  3699,   292,   218,   276,   348,   177,   256,   313,
     365,  4608,  3136,   395,   387,  4875,  4586,  2457,   339,   244,
     453,   246,  2887,  2132,   274,   418,   378,   177,   206,   410,
     256,   418,   369,  4849,   371,   339,   418,  2629,   420,  3211,
     418,  2750,   276,   451,   258,  1680,   439,   455,   309,   330,
    1714,   381,   266,  1681,   289,  1681,   411,  4584,   395,   309,
     323,    22,   325,   369,   457,   371,   244,    28,  3240,   421,
     457,   453,   160,   418,   411,   313,   274,  1805,   339,   457,
    2356,   378,    53,  1718,  1719,  1691,  1741,  1693,  4148,  1695,
    2124,  1697,  3063,  1699,   439,  3066,  1728,  1703,  4625,   370,
    1735,   339,   190,  4411,  1733,  1733,  1733,  1733,  1733,  1733,
    2710,   309,   111,  1682,   137,  1761,  2716,   205,   381,  2186,
     298,  1758,  1759,   418,   421,  4756,   149,   215,  1765,  1766,
     101,   154,   453,    83,  2782,   420,   370,  3002,   305,  4513,
     420,   339,   297,   378,   439,  4507,  2365,   411,  4289,     8,
     309,   255,    11,   241,   439,   154,  1793,   149,   329,   439,
    1740,  2720,   154,    89,   342,   332,   127,   208,  1747,   324,
     160,  4407,   260,   453,   124,   198,   453,   391,   455,  1807,
     339,    40,  2291,  4208,  4071,  4755,   421,    46,  4213,   188,
    4331,   161,  4252,  4218,  4254,   218,  4221,  1832,   365,    64,
     190,   163,   101,  2365,  2026,    70,  1852,  1842,  2427,  2031,
    4097,    70,   183,  2035,  4083,   205,    81,  2657,   232,   397,
    4245,   191,     4,   274,   332,   215,   218,     9,  3925,  3926,
    2377,   319,    11,  4258,   160,   258,   420,   451,   405,  2061,
     454,   455,   409,   266,   109,   244,   111,   246,   246,     4,
     453,   418,  2399,   251,     9,   439,   155,   365,   309,   221,
     231,    40,  2085,   234,   190,  2427,   258,  2414,   230,   453,
    2417,  2418,   439,   244,   381,  2422,  2423,  1551,  4040,   205,
    4042,  4043,  2429,  2105,  4046,   154,   453,   186,   339,   215,
     302,    70,   274,  3146,  2770,  2649,  1570,   405,   296,  4208,
    4164,  2123,   273,   122,  4213,   124,   175,   149,   381,  4218,
     418,   399,  4221,  4675,  4622,   241,   451,   176,   453,   274,
    3387,   333,   181,   188,  1959,   442,  1961,   309,   147,   319,
     311,   439,   231,  2155,    42,   234,  4245,  3046,   455,  1977,
    1977,    13,    14,   314,  2491,   453,  3055,   227,   230,  4258,
    2078,  2079,  2799,   365,   309,    63,  2654,   339,   217,  2087,
     329,  2089,  2123,  1998,   154,  2093,   230,  2189,   391,   332,
    2479,  2193,  4899,  4398,  2003,  2003,   218,  2824,   323,   324,
    4950,   246,   353,    81,   339,   175,   251,  2496,  3253,  2211,
    2045,  1960,  2047,   319,  3990,   184,   418,  2043,  2507,   411,
    2222,   454,   365,   262,   457,  2043,  2043,   369,   454,   371,
       5,   457,  2076,  2235,    85,    10,   258,   439,   454,  2083,
    2603,   457,  2244,    18,  1428,   290,  4662,   246,  2189,  1433,
     232,  4793,   251,   395,   418,  4460,   420,   256,  2657,   304,
     260,    36,   405,   175,   381,   265,   452,  3218,  3219,  3220,
    3221,   457,   418,  3224,  3225,  3226,  3227,  3228,  3229,  3230,
    3231,  3232,  3233,  3855,  2096,   163,  2112,   452,  3860,  3440,
    3441,  3435,   457,   439,  3866,  3421,  2204,  3174,  1482,  3260,
    3251,    77,  1486,  2244,  2800,   344,   184,   411,   368,  4398,
     453,   457,     8,   208,   137,    11,  4547,    52,  4549,    15,
      16,    17,  4553,   860,  4555,   453,   149,   448,   260,  3280,
    3281,   154,   453,   265,   455,   395,  2151,     9,   875,  3101,
    3102,   878,   454,   221,    40,   457,  3472,   392,   329,  2558,
      46,  2560,  2561,  3182,  2262,   453,  3007,  2172,   418,   451,
     420,   453,  2270,   455,  2272,   369,   454,   371,  2767,   457,
    2278,  4460,   448,   454,    70,   198,   457,   453,  2874,   455,
     260,  2198,   454,  4427,   383,   457,   453,   265,   455,  2206,
    4932,  2208,  4334,   453,   393,   218,   454,   454,   437,   457,
     457,   454,  3363,   327,   457,   444,   445,   446,   447,   448,
     449,   454,  3659,   227,   457,   369,   454,   371,   454,   457,
       8,   457,  3467,    11,  3469,  2767,  2753,    15,    16,    17,
     418,   454,   420,  4638,   457,   258,   454,  2263,   454,   457,
     456,  3213,  2350,   266,    32,  2271,   122,   454,   124,   454,
     457,   454,   457,  2279,   457,  2281,   454,  4873,  4663,   457,
       8,  2463,   454,    11,   454,   457,   456,    15,    16,    17,
     454,   147,   457,   457,   454,  3247,   453,   457,   454,  2481,
     176,   457,  2771,   454,    32,   181,   457,  2489,    52,  4366,
    4906,   369,   411,   371,  2309,  3384,  3385,    42,  2406,  2788,
    2408,  2327,   454,   381,   454,   457,  2833,   457,  2835,   454,
     323,   324,   457,   327,   392,   454,  4292,   395,   457,   436,
    3292,   217,  3178,  2737,  2738,  3662,   409,   454,  3645,   227,
     457,  2357,   455,   454,   454,     8,   457,   457,    11,  2365,
    2349,  2349,    15,    16,    17,   204,   263,  2314,  4120,  4638,
    4790,   263,   454,   454,   368,   457,   457,   454,   260,  4975,
     457,   137,   154,  3183,   454,   227,   262,   457,   391,   454,
    2387,  2388,   457,   149,  4663,   251,  3032,  2394,   154,   454,
     256,   395,   457,   454,   454,   454,   457,   457,   457,   454,
     376,   454,   457,  2882,   457,  2884,     8,   260,   436,    11,
    2603,  2427,  2510,   263,   418,   454,   420,   418,   457,   420,
    3009,    42,  3011,   454,   202,   454,   457,  2944,   457,  2391,
    2392,  2393,   198,  2950,  4400,     3,  3365,   454,    40,   327,
     457,   436,   204,  3413,    46,  3586,   446,   158,   454,   453,
    2457,   457,   218,    52,  4849,    23,  3158,   454,   344,  2493,
     457,   767,   453,   769,   202,  2499,  2945,   454,    70,   454,
     457,   454,   457,   454,   457,   327,   457,  3009,  2483,  3011,
     368,  3844,  2675,  3846,   262,   457,  2890,  3710,  3711,  3712,
    3079,  2970,   258,   454,   454,   454,  2900,   227,   457,  3328,
     266,   159,   454,   454,  2547,   457,   457,   395,   454,   200,
     454,   457,    80,   457,   453,   455,   368,   383,   181,   454,
     454,   339,   457,   457,   262,   454,   422,   393,   457,  2721,
     418,   454,   420,   135,   457,   454,   309,   454,   457,   202,
     457,   454,   454,   395,   457,   457,   181,  3079,  2591,  2547,
     453,   437,   142,  3315,   440,   441,   442,   455,   444,   445,
     446,   447,   448,   449,   132,   453,   418,   142,   420,   453,
    4849,   260,  2764,   454,   176,  3092,   457,   454,   454,   181,
     457,   457,   454,  3062,  4841,   457,   454,   454,  1781,   457,
     457,  1784,   181,  2591,  3318,  3319,  3320,   327,   260,   262,
     309,   453,  3119,  3120,   142,  3122,  2640,  3124,  3125,  3943,
    2608,   181,   142,   181,  3093,   217,   260,   154,   186,  3023,
    3137,  3025,  2634,  2635,  2636,   391,  2624,   454,  2633,   309,
     457,   454,   227,   454,   457,   142,   457,   454,   368,   216,
     457,  2657,  2640,   454,   454,   111,   457,   457,  2655,   454,
    2657,   454,   457,  2696,   457,   399,   260,     0,  3175,  2693,
     262,   232,   440,   441,   442,   395,   444,   445,   446,   447,
     448,   449,  2671,  2671,  2671,  2671,  2671,  2671,   453,  2777,
    2872,  2779,  2780,  2781,   381,  4345,   255,   411,   418,   329,
     420,   154,   208,  2885,   454,  2693,   248,   453,  2696,    64,
      35,   246,   440,   441,   442,  3856,   444,   445,   446,   447,
     448,   449,   280,   453,   422,   246,   260,  3196,    42,    42,
     386,   274,  3563,   453,   154,  3542,   411,   411,    77,   227,
     154,   293,   327,   142,  3885,   142,   453,   142,  3217,   408,
     453,   453,   344,   286,   142,    88,    34,   422,   142,   142,
     457,  2767,   320,   142,  3989,   142,   260,   142,   142,   260,
     142,   142,   154,  3242,   142,   260,   142,    48,   142,  3173,
     142,   365,  2964,   368,   453,    35,   216,   440,   441,   442,
     332,   444,   445,   446,   447,   448,   449,   154,  4011,  4012,
     260,  4014,   154,   453,   137,   363,   453,  3276,     5,     8,
     395,     5,    11,  2996,   453,   453,   149,   154,   453,    90,
    3003,   154,   453,   365,   453,   453,   159,   453,  3780,     5,
       5,   164,   390,   418,   167,   420,  3793,   170,   453,   327,
     398,    40,     5,   401,   115,   437,   453,    46,  2854,   453,
     453,  3673,   444,   445,   446,   447,   448,   449,   453,     5,
     131,   271,  4614,   405,   135,   198,   227,   453,   453,   419,
     453,    70,   453,   227,   200,   453,   418,   247,   248,   453,
     368,   453,   453,  2971,   155,   218,   227,   158,   457,   453,
     453,   453,  2898,  2888,    35,   216,   453,   439,   453,   453,
     171,   457,   453,    92,    35,   154,   154,   395,   258,   256,
     339,   453,   454,     8,   456,  3715,    11,   376,   376,   327,
      15,    16,    17,   455,   376,   258,   376,   260,   218,   327,
     418,   376,   420,   266,   376,   442,   135,    32,   376,    81,
       8,  2947,   327,    11,   142,   260,   213,    15,    16,    17,
       8,   260,   376,    11,  3136,   331,   251,    15,    16,    17,
     376,   376,   332,  2969,    32,   453,   327,   398,   368,  3151,
    2976,  2977,    40,   327,  2980,   260,   260,   176,    46,   323,
     251,  2987,   181,   316,  2990,   453,   327,   256,   259,   376,
    2996,   174,   453,    81,  3176,   365,   376,  3003,   274,  2996,
     457,     0,    70,  3009,   181,  3011,  3003,   368,   142,   399,
    4079,   103,    52,   399,   368,    52,   376,   376,   217,   264,
    3015,  3016,    41,   376,    41,   296,   368,   368,   376,  3026,
     376,   376,   365,  4164,   395,   405,  3031,   260,  3126,   327,
    3128,   395,  4173,  3049,  3132,   376,   376,   376,   418,   376,
     457,   202,  3047,   376,   395,   422,   260,   418,   391,   420,
     260,  3056,  3057,   262,   418,   202,   420,   202,   376,   439,
     386,    35,  3078,  3079,    24,   418,   260,   418,  3073,   420,
    3069,  3069,   415,   453,   417,   418,   142,   246,  4385,    88,
     453,   109,   453,   399,   142,   453,   224,   246,  3186,   453,
     410,  3098,  3091,  3091,   256,    35,   246,   202,   176,   154,
      35,   208,   453,   181,  4339,   453,   328,   453,   451,    34,
     374,   454,   455,   456,  3148,   339,   142,   374,   142,   451,
     376,   451,   376,   376,   202,   203,   453,   376,   137,   399,
     142,   399,   142,   255,  3613,   344,   142,   376,   250,   217,
     149,   159,   414,   453,   238,   154,   238,    11,  3910,  3288,
     159,   457,   453,   374,   453,   164,  3158,   262,   167,   376,
     167,   170,   150,   159,   457,   378,   458,   454,   453,  3174,
     174,   249,   174,   198,   457,   342,  3183,  3694,   261,   457,
     399,    35,   268,   206,   262,  3702,  3703,  3704,  3705,   198,
      52,   454,   376,   376,   262,  4855,  4856,   327,  3881,   327,
     251,   453,   399,   206,   376,  3609,  3610,   206,   251,   218,
     376,   376,   232,   453,   329,   411,   154,   381,  3622,   208,
     251,   144,   260,    42,  3416,   348,   144,   246,   437,   216,
    4453,   216,   216,   323,   376,   444,   445,   446,   447,   448,
     449,  4464,   259,  3286,   368,   260,  3262,   376,   309,   258,
     376,   260,   457,   175,   336,   260,   376,   266,   298,   202,
      35,  3304,   399,   202,   399,   202,   344,   208,  3302,   202,
    3304,   202,   184,   295,   442,  3468,   259,   142,   154,   442,
     411,   154,  3294,  3295,  3296,  3297,  4427,   156,  3286,   256,
     336,   142,   142,   453,  3299,  3300,  3301,   418,   453,   246,
      20,    35,   246,   260,  3302,    25,  3304,   316,  3406,  3407,
    3408,  3409,   260,   208,   172,   172,  4539,   154,    35,   451,
    3873,   454,   436,   436,  3803,  4985,  4986,   454,   236,  3521,
     330,   142,  3524,   260,   260,   440,   441,   442,    58,   444,
     445,   446,   447,   448,   449,   454,   454,   208,   454,  3383,
     260,    71,    72,   154,   336,   246,   365,   181,   181,   437,
     181,    81,   440,   441,   442,    85,   444,   445,   446,   447,
     448,   449,   440,   441,   442,    23,   444,   445,   446,   447,
     448,   449,   391,   103,   457,   457,   422,   457,   165,   453,
     376,   159,   235,   260,   457,    52,   365,   418,   411,   255,
     381,   208,   454,   159,  3921,   125,   415,   279,   417,   418,
     454,   271,   454,   454,   159,   454,   136,   454,  4064,   454,
     453,  4644,   454,   457,   144,   376,   270,   397,   436,   226,
     405,   260,  3624,    52,   260,   415,   156,   453,  3955,  3956,
     454,   161,   451,   454,  3923,   454,   455,   456,   438,   415,
     263,   442,  3468,   454,   260,   453,   453,   184,   453,   453,
     453,  3468,   454,   142,   184,   376,  4701,   422,   192,   376,
    4432,   376,   251,   376,   453,  3954,   246,   142,   264,   331,
     142,   142,  4544,   331,   331,  3501,  3584,   216,  3504,   209,
    3506,   184,  3500,  3500,   144,   376,  3975,   399,   280,   218,
     280,  4520,  4343,  4521,  4228,  4247,   396,   228,   376,  4471,
     230,  4235,   228,   376,   228,   327,   260,  4034,  4035,   327,
     246,   376,   327,   376,   327,   339,  3718,   376,  4535,   142,
    4537,   376,    41,   202,  3550,   376,  3940,   376,   376,   202,
    3556,  3557,   262,  3559,   376,   376,   376,   202,   376,  3565,
     202,   169,     3,   454,  4033,   454,   376,   457,    42,   386,
     311,  3568,  3569,   283,   102,   454,   453,     8,   454,   457,
      11,   259,    35,   293,    15,    16,    17,  3582,   260,   142,
     376,   142,   154,   169,    62,   142,   452,  3592,   327,   399,
     399,    32,   327,   452,   327,   263,   336,   140,   140,  4003,
     320,   202,   202,   202,   133,   325,   159,   327,   454,   451,
      11,  4128,   271,   333,  4131,  4132,   336,   457,   154,   454,
     454,   457,  3627,   410,   159,   266,   415,   159,   167,   454,
    4147,   453,  4711,  4712,   261,   316,   454,   454,   453,    79,
     439,  4703,  3658,  4122,   386,   365,   154,    35,   368,   399,
    3655,   453,   372,   457,   452,  3654,  3654,   457,   399,   379,
     454,   381,   454,  4364,   454,   376,   386,  4902,   208,   192,
      52,   368,   142,  4635,   386,   453,   376,   331,   376,   442,
    3873,   376,   327,   327,   376,  4647,   376,   454,   454,  4168,
    4652,   411,  4654,   454,     0,   309,   453,    52,   368,    22,
     418,    24,   154,    70,  3709,    28,  4259,   144,  3715,   142,
      33,    34,    35,   102,    37,   386,  3732,    40,    41,  3735,
      43,  3737,    45,  4447,   454,   202,   202,   202,   202,   418,
    4965,   453,   294,   206,  4544,   422,   154,   187,   453,    35,
    4819,    75,   368,   453,   457,   454,   453,   386,   376,  4984,
    4303,   457,   457,   457,   453,   336,   164,   102,   454,   159,
     202,   202,   159,   202,   202,    52,   452,   202,     8,   454,
     453,    11,   303,   416,   454,    15,    16,    17,  3970,   416,
     454,   457,    88,   271,   205,   205,   269,   454,   454,   453,
    3982,   367,    32,   453,    52,   453,   267,  3990,   170,   256,
      40,   454,   442,   454,   386,  3839,    46,   454,   376,  3843,
     159,   418,   186,    70,    52,   251,   368,  3822,  3823,  3824,
    3825,   262,   251,   457,   457,   442,  4888,   376,    64,   376,
      70,   137,   376,   142,   202,   161,   336,   453,   159,   399,
     181,  3839,   453,   149,   399,  3843,    35,   246,   154,   128,
     414,   418,  3868,   159,  3870,    35,   159,   260,   164,   418,
     453,   167,    54,  4882,   170,   154,   159,   190,   191,   192,
     193,   189,   195,   263,   197,   200,   199,  3902,   201,   453,
     453,   204,   404,   352,  3883,  3883,   303,   210,   454,  4293,
     213,   278,   198,   205,   217,    87,   219,     8,   454,   453,
      11,   417,   453,  4420,    15,    16,    17,    81,   454,   123,
     260,   304,   218,   454,   376,  4013,   453,   376,   116,   453,
     453,   154,    35,   453,   251,   117,   453,   229,   184,   294,
    4028,   142,   453,   141,   454,   453,   176,    35,   324,   454,
     264,   181,   386,  3951,  3951,   324,   350,   454,   350,  4428,
      52,    52,   258,   145,   260,  4544,  4148,    35,   453,   453,
     266,   454,   202,   203,   453,   457,  3973,  3974,   453,   399,
     368,  3978,  3979,   454,  3990,   244,   368,   217,  4495,   260,
       5,   453,   148,  3990,   368,    64,   178,  4466,   454,   294,
     263,    64,   123,   418,   418,   303,   403,   453,  4096,   440,
     441,   442,   457,   444,   445,   446,   447,   448,   449,   249,
     316,    35,   159,   404,   368,  4031,  4032,   339,   301,   453,
     415,   213,   262,  4540,  4040,   265,  4042,  4043,  4674,   154,
    4046,   251,  4066,   128,   186,   260,   260,   453,   336,    35,
    4519,    35,   263,   453,  4523,  4524,     8,   263,   454,    11,
      52,   161,   161,   323,   246,   114,     5,   453,   397,   365,
    4252,   323,  4254,   310,    21,    32,  4259,   141,   453,   376,
     159,   454,   294,   454,  4090,   453,   350,   457,    40,   350,
     457,   418,   274,   275,    46,   391,   418,   453,  2312,   453,
     161,   202,   161,   867,  1485,   827,  4095,  4095,  2657,  4292,
    2167,   866,  3467,  4119,   344,  2239,  2824,  1261,    70,   415,
    4303,   417,   418,  2994,  4703,   764,  3565,   309,  4671,  4557,
    4125,   313,  4701,     8,  4888,   317,    11,  4381,  4385,  3607,
    4057,  4363,   324,  4149,  2744,  2445,  4615,  4153,  4154,   331,
    4156,  4797,  4258,  4879,  4729,   451,  4828,   339,   454,   455,
     456,   262,  4728,  3655,  2748,    40,  3640,  3599,  3462,   351,
    2849,    46,  4260,  4261,  4262,  2302,  2302,   359,  1556,  3623,
    4082,  3048,  2296,   135,  4208,  4890,  4984,  4965,     8,  4213,
    4358,    11,  3002,  2998,  4218,    70,  4839,  4221,  4222,  4689,
    4305,  4807,    27,  1107,  4308,  1545,  3718,   437,  4493,  1118,
     440,   441,   442,  2017,   444,   445,   446,   447,   448,   449,
      40,  4245,  3662,  2719,   176,  4213,    46,   457,  4614,   181,
    4218,   413,     8,  4221,  4258,    11,   549,   602,  1736,    15,
      16,    17,   555,  1736,   557,  1737,  3989,   560,  2948,   562,
      70,   564,  4854,  4968,   742,  1960,    32,  1343,   571,  4247,
     135,  1961,   575,  1682,    40,   217,  3643,  3884,   631,   582,
      46,  4789,  3360,  2672,  4240,  1238,  2683,  2001,  4302,  4782,
    2678,  3327,  4656,  3869,  2000,  2693,  4292,  1307,  3830,  3304,
    3845,  4461,  3302,   606,    70,  4292,  4638,     8,   611,  4637,
      11,   176,  3361,   616,  3107,  4430,   181,   620,  4396,  4888,
     262,     8,  1614,  3255,    11,   135,  4237,  4785,    15,    16,
      17,  4345,  1288,  4786,   637,  4772,  1830,  2675,  4334,    40,
    2518,  2608,  2660,  2606,  1833,    46,    -1,    -1,  1306,   440,
     441,   442,   217,   444,   445,   446,   447,   448,   449,    -1,
      -1,  1309,  1314,  4348,    -1,    -1,   176,    -1,    -1,    70,
      -1,   181,    -1,    -1,    -1,    -1,    -1,  4874,    -1,  4364,
      -1,    -1,    -1,   686,  4398,    -1,    -1,    -1,    -1,  4368,
    4368,    -1,    -1,    -1,    -1,    -1,   699,   262,   701,    -1,
      -1,    -1,   344,    -1,    -1,    -1,    -1,   217,    -1,    -1,
     176,    -1,  4397,    -1,    -1,   181,  4395,  4395,   721,   722,
      -1,   724,   725,    -1,    -1,    -1,   729,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,   202,   203,    -1,    -1,
     743,    -1,    -1,    -1,   747,    -1,  4460,    -1,  4471,    -1,
     753,   217,   262,    -1,    -1,    -1,    -1,    -1,  4536,    -1,
    4538,    -1,   765,    -1,    -1,    -1,    -1,  4490,    -1,    -1,
      -1,    -1,    -1,    -1,   777,   176,    -1,    -1,    -1,   344,
     181,    -1,  4460,   249,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4471,    -1,   437,   262,    -1,  4671,   265,
      -1,    -1,   444,   445,   446,   447,   448,   449,    -1,    -1,
      -1,    -1,  4490,    -1,    -1,   202,   217,   820,    -1,    -1,
    4505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   836,   344,    -1,    -1,    -1,   841,   842,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4544,    -1,
      -1,    -1,  4548,    -1,    -1,    -1,    -1,  4544,  4572,    -1,
      -1,   262,  4558,   866,   867,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,    -1,    -1,   262,    -1,    -1,   344,   444,
     445,   446,   447,   448,   449,    -1,    -1,    -1,    -1,    -1,
     893,  4669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   904,    -1,  4588,    -1,   908,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4595,  4595,  4790,    -1,
     923,    -1,    -1,    -1,  4638,    -1,    -1,   437,    -1,    -1,
      -1,    -1,    -1,    -1,   444,   445,   446,   447,   448,   449,
     943,    -1,    -1,   344,    -1,    -1,    -1,   950,   951,  4663,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4738,    -1,    -1,    -1,   967,   968,   969,    -1,   971,    -1,
     973,   437,    -1,    -1,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,    -1,    -1,    22,    -1,    -1,    -1,
      -1,   457,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4703,    -1,    -1,
      -1,  4707,    -1,  4709,    -1,    -1,    -1,  4713,  4714,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4744,    -1,    68,    -1,  4812,    -1,   437,  1040,    -1,  1042,
    1043,    -1,    -1,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,    -1,   440,   441,   442,    -1,   444,   445,   446,
     447,   448,   449,    -1,    -1,    -1,    -1,  1070,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,  4802,    -1,
      -1,   127,    -1,    -1,   130,    -1,    -1,  1100,  1101,    -1,
      -1,    -1,  1105,    -1,  1107,  4883,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,
      -1,    -1,    -1,    -1,    -1,  1128,    -1,    -1,  1131,    -1,
      -1,  1134,    -1,    -1,    -1,  4849,    -1,    -1,    -1,    -1,
      -1,  4855,  4856,    25,  1147,    -1,    -1,    -1,    -1,    -1,
     186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4840,  4840,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1176,    -1,  4854,  4854,  4854,  4854,  4854,
    4854,    -1,    -1,    -1,    -1,  4908,    -1,    -1,    -1,    -1,
      72,    -1,  4888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1204,  1205,  1206,    -1,  1208,  4902,    -1,   244,    -1,
     246,    -1,    -1,    -1,    -1,  4902,    -1,    -1,    -1,    -1,
     256,   103,    -1,    -1,    -1,  1228,    -1,    -1,   264,  4908,
    4908,  4908,  4908,  4908,  4908,    -1,    -1,    -1,   274,    -1,
      -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,  4973,
      -1,    -1,    -1,  1266,    -1,    -1,  1269,    -1,    -1,  4965,
      -1,  4985,  4986,   309,   156,    -1,   312,   313,  4965,   161,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,  4984,  4968,
    4968,  4968,  4968,  4968,  4968,    -1,  1299,  4984,    -1,    -1,
    1303,  1304,    -1,   339,    -1,    -1,    54,    -1,    -1,    -1,
      -1,  1314,  1315,  1316,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,    22,    -1,
      -1,    -1,    -1,  1336,    28,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,  1371,    -1,
      -1,    -1,    -1,  1376,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1389,  1390,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1398,    -1,   145,  1401,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,    -1,    -1,
      -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1424,    -1,  1426,    -1,    -1,   120,    -1,    -1,    -1,
     178,  1434,    -1,   127,  1437,    -1,   130,    -1,   320,     8,
      -1,    -1,    11,    -1,    -1,   327,    15,    16,    17,    -1,
      -1,   333,    -1,    -1,    -1,    -1,    -1,    -1,  1461,    -1,
     208,   155,    -1,    32,    -1,   213,  1469,  1470,  1471,  1472,
    1473,    40,    -1,     8,    -1,    -1,    11,    46,    -1,    -1,
      15,    16,    17,   365,  1487,    -1,   368,    -1,    -1,   183,
      -1,    -1,   186,    -1,    -1,  1498,    -1,  1500,   246,    -1,
      -1,    70,    -1,    -1,   386,    40,    -1,    -1,    -1,  1512,
    1513,    46,    -1,    -1,    -1,    -1,    -1,    -1,  1521,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   275,  1531,   411,
      -1,    -1,    -1,    -1,    -1,    70,    -1,   231,    -1,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,  1550,    -1,    -1,
     244,    -1,   246,    -1,    -1,    -1,  1559,  1560,  1561,  1562,
      -1,    -1,   256,    -1,    -1,   313,    -1,    -1,  1571,   317,
     264,    -1,    -1,    -1,    -1,  1578,   324,    -1,  1581,   273,
     274,    -1,    -1,   331,    -1,     3,    -1,    -1,  1591,    -1,
       8,   339,    -1,    11,    -1,  1598,    -1,    15,    16,    17,
    1603,    -1,    -1,   351,    -1,    -1,    -1,   176,    -1,    -1,
      -1,   359,   181,    -1,    32,   309,    -1,    35,   312,   313,
     314,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,   379,    -1,   202,   203,    -1,    -1,  1640,    -1,    -1,
      -1,   176,    -1,    -1,    -1,   339,   181,  1650,   217,    -1,
      -1,  1654,    70,    -1,  1657,    -1,    -1,    -1,    -1,   353,
      -1,    -1,    -1,    -1,  1667,   413,    -1,   202,   203,   417,
     418,    -1,  1675,  1676,    -1,    -1,    -1,  1680,    -1,    -1,
     249,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   262,    -1,    -1,   265,    -1,    -1,    -1,
      54,    -1,  1705,    -1,    -1,    -1,    -1,    -1,   402,  1712,
      -1,  1714,    -1,    -1,   249,  1718,  1719,    -1,  1721,    -1,
      -1,    -1,    -1,    -1,    -1,  1728,    -1,   262,    -1,    -1,
      -1,    -1,  1735,    87,    -1,    -1,    -1,  1740,  1741,    -1,
      -1,  1744,    -1,    -1,    -1,  1748,    -1,  1750,    -1,    -1,
      -1,    -1,  1755,  1756,    -1,    -1,    -1,    -1,   176,  1762,
    1763,  1764,    -1,   181,    -1,  1768,  1769,  1770,  1771,  1772,
    1773,  1774,  1775,    -1,  1777,   344,  1779,  1780,    -1,    -1,
    1783,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,    -1,
      -1,   145,    -1,    -1,    -1,  1798,  1799,  1800,  1801,   217,
      -1,    -1,  1805,  1806,    -1,    -1,    -1,  1810,    -1,   344,
    1813,    -1,    -1,  1816,  1817,  1818,  1819,  1820,  1821,  1822,
    1823,  1824,    -1,  1826,   178,    -1,    -1,    -1,    -1,  1832,
    1833,   249,  1835,    -1,    -1,    -1,    -1,    -1,    -1,  1842,
      -1,    -1,    -1,    -1,   262,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,
      -1,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
     449,    -1,    -1,    -1,    -1,   454,    -1,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,   444,
     445,   446,   447,   448,   449,    -1,    -1,    -1,    -1,    -1,
      -1,   275,    -1,    -1,    -1,    -1,   344,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1959,    -1,  1961,   313,
    1963,   315,    -1,   317,    -1,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,    -1,   331,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,  1998,    -1,   351,    -1,    -1,
      -1,    -1,  2005,    -1,  2007,   359,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      -1,    -1,   440,   441,   442,    58,   444,   445,   446,   447,
     448,   449,     8,  2036,    -1,    11,    -1,    -1,    71,    15,
      16,    17,  2045,    -1,  2047,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    -1,    -1,    -1,    32,    -1,    -1,   413,
      -1,  2064,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,  2076,    -1,  2078,  2079,    -1,    -1,    -1,
    2083,    -1,  2085,    -1,  2087,    -1,  2089,    -1,     8,    -1,
    2093,    11,   125,  2096,    70,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    -1,  2117,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,   156,  2127,    -1,    46,    -1,   161,    -1,
      -1,    -1,  2135,    -1,    -1,    -1,    -1,    -1,    -1,  2142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2151,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,  2172,
      -1,    -1,    -1,    -1,  2177,  2178,    -1,    -1,    -1,    -1,
      -1,    32,    -1,  2186,  2187,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    46,    -1,   230,    -1,    -1,
     176,  2204,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,   202,   203,  2231,   262,
    2233,  2234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,  2262,
     293,   181,    -1,    -1,    -1,    -1,    -1,  2270,    -1,  2272,
      -1,    -1,    -1,   249,    -1,  2278,    -1,    -1,    -1,    -1,
      -1,    -1,   202,   203,    -1,    -1,   262,  2290,    -1,   265,
      -1,    -1,    -1,    -1,   327,    -1,    -1,   217,    -1,    -1,
     333,  2304,    -1,   336,  2307,    -1,  2309,    -1,    -1,  2312,
      -1,    -1,  2315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,   249,
     181,    -1,   365,    -1,    -1,    -1,    -1,    -1,  2341,   372,
      35,    -1,   262,    -1,    -1,   265,   379,  2350,  2351,    -1,
      -1,   202,   203,   386,    -1,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,   344,    -1,
      -1,  2374,    -1,    -1,    -1,    -1,    -1,    -1,   411,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2389,    -1,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,   249,    -1,
      -1,  2404,    -1,  2406,  2407,  2408,  2409,    -1,    -1,    -1,
      -1,   262,    -1,    -1,   265,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,   344,    -1,    15,    16,    17,  2432,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2445,    32,    -1,    -1,    -1,    -1,    -1,    -1,
     145,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,   437,    -1,    -1,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,   449,    -1,    -1,    -1,    -1,   454,    -1,
    2483,    70,    -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,
    2493,    -1,    -1,   344,    -1,    -1,  2499,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2510,    -1,    -1,
      -1,    -1,    -1,   208,  2517,    -1,    -1,   437,   213,  2522,
     440,   441,   442,    -1,   444,   445,   446,   447,   448,   449,
      -1,    -1,    -1,    -1,   454,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2545,  2546,  2547,    -1,    -1,  2550,    -1,    -1,
      -1,   246,    -1,    -1,    -1,  2558,  2559,  2560,  2561,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2571,    -1,
      -1,  2574,    -1,  2576,    -1,    -1,    -1,    -1,    -1,    -1,
     275,    -1,    -1,    -1,  2587,  2588,   437,   176,  2591,   440,
     441,   442,   181,   444,   445,   446,   447,   448,   449,    -1,
    2603,    -1,  2605,   454,  2607,    -1,  2609,    -1,    -1,    -1,
      -1,    -1,    -1,   202,   203,    -1,    -1,    -1,   313,    -1,
      -1,    -1,   317,    -1,    -1,    -1,  2629,    -1,   217,   324,
    2633,    -1,    -1,    -1,    -1,    -1,   331,  2640,    -1,  2642,
    2643,  2644,    -1,    -1,   339,     8,    -1,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,   351,  2660,    -1,    -1,
     249,    -1,    -1,    -1,   359,    -1,    -1,    -1,    -1,  2672,
      -1,    -1,    -1,   262,  2677,    -1,   265,    40,    -1,    -1,
    2683,    -1,    -1,    46,   379,    -1,    -1,    -1,    -1,    -1,
    2693,    -1,    -1,  2696,    -1,    -1,  2699,    -1,  2701,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    70,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,    -1,
       8,    -1,   417,    11,    -1,    32,    -1,    15,    16,    17,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,
    2743,    -1,  2745,    -1,    32,    -1,    -1,  2750,    -1,    -1,
      -1,    -1,    40,    -1,    -1,   344,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2777,    -1,  2779,  2780,  2781,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,
      -1,   440,   441,   442,   217,   444,   445,   446,   447,   448,
     449,    -1,    -1,    -1,    -1,   454,    -1,    -1,    -1,   176,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2888,   249,    -1,   176,    -1,
      -1,    -1,    -1,   181,    -1,   202,   203,    -1,    -1,   262,
      -1,    -1,    -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,
     217,    19,    -1,    -1,   202,   203,    -1,    -1,    -1,    -1,
      -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,   265,    -1,
      -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,  2971,    -1,
      -1,    -1,    -1,    -1,   262,  2978,  2979,   265,    -1,    -1,
      -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,
      -1,    -1,  3015,  3016,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,  3031,    40,
      -1,    -1,    -1,    -1,    -1,    46,    -1,   344,    -1,    -1,
      -1,    -1,    -1,  3046,  3047,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3055,  3056,  3057,    -1,   344,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3073,    -1,    -1,    -1,   437,    -1,    -1,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,    -1,    -1,   197,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,
     208,   209,    -1,   211,    -1,    -1,   214,    -1,   216,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3126,    -1,  3128,    -1,    -1,    -1,  3132,
     437,    -1,    -1,   440,   441,   442,    -1,   444,   445,   446,
     447,   448,   449,    -1,    -1,  3148,    -1,   454,    -1,   437,
      -1,    -1,   440,   441,   442,  3158,   444,   445,   446,   447,
     448,   449,    -1,    -1,    -1,   176,   454,    -1,    -1,    -1,
     181,  3174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3186,    -1,    35,    -1,    -1,    -1,    -1,
    3193,   202,   203,    -1,    -1,    -1,    -1,    -1,    -1,  3202,
      -1,    -1,    -1,    -1,    54,  3208,   217,  3210,    -1,    -1,
    3213,    -1,    -1,    -1,    -1,  3218,  3219,  3220,  3221,    -1,
      -1,  3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,
    3233,    -1,    -1,    -1,  3237,  3238,    -1,    87,   249,    -1,
      -1,    -1,    -1,    -1,  3247,    -1,    -1,    -1,  3251,    -1,
      -1,   262,  3255,    -1,   265,    -1,    -1,    -1,    -1,    -1,
    3263,    -1,    -1,  3266,    -1,  3268,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3277,    -1,    -1,  3280,  3281,    -1,
      -1,    -1,  3285,  3286,    -1,    -1,    -1,  3290,    -1,  3292,
      -1,    -1,    -1,    -1,    -1,   145,  3299,  3300,  3301,  3302,
      -1,  3304,  3305,    -1,    -1,    -1,  3309,  3310,    -1,    -1,
      -1,    -1,    -1,  3316,    -1,    -1,    -1,    -1,    -1,  3322,
    3323,  3324,    -1,     8,    -1,    -1,    11,    -1,   178,    -1,
      15,    16,    17,   344,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3349,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,  3360,   208,  3362,
      -1,    46,    -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3383,  3384,  3385,    -1,  3387,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,
      -1,    -1,    -1,  3406,  3407,  3408,  3409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   275,   437,    -1,    -1,   440,
     441,   442,  3435,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,    -1,   454,    -1,    -1,  3449,    -1,    -1,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   566,    -1,
      -1,    -1,    -1,   313,    -1,   573,    -1,   317,   576,   577,
      -1,    -1,    -1,   581,   324,    -1,    -1,    -1,    -1,    -1,
      22,   331,    -1,    -1,   592,    -1,    28,    -1,    -1,   339,
      -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,   607,
      -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,
      -1,    -1,    -1,    -1,   622,    -1,   624,   202,   203,   627,
      -1,   629,    -1,    -1,   632,    -1,    68,    -1,    -1,   379,
      -1,    -1,   217,    -1,    -1,    -1,  3539,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   413,   249,    -1,    -1,   417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,   262,   120,  3582,
     265,  3584,    -1,  3586,    -1,   127,    -1,    -1,   130,  3592,
      -1,    -1,   700,    -1,    -1,  3598,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3607,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3627,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3637,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3645,    -1,   186,    -1,    -1,   755,    -1,    -1,
      -1,    -1,  3655,    -1,    -1,    -1,  3659,    -1,    -1,   344,
    3663,  3664,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3697,    -1,  3699,    -1,    -1,    -1,
      -1,    -1,   244,    -1,   246,    -1,  3709,   815,    -1,    -1,
      -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,  3739,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3750,    -1,    -1,
      -1,    -1,   437,    -1,    -1,   440,   441,   442,    -1,   444,
     445,   446,   447,   448,   449,    -1,    -1,   309,    -1,   454,
     312,   313,    -1,   881,    -1,    -1,    -1,  3780,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3790,  3791,   897,
      -1,    -1,    -1,    -1,  3797,  3798,    -1,   339,    -1,  3802,
      -1,   909,    -1,   911,  3807,    -1,    -1,  3810,  3811,    -1,
      -1,   919,  3815,  3816,    -1,    -1,    -1,    -1,  3821,  3822,
    3823,  3824,  3825,   931,    -1,    -1,  3829,  3830,   936,  3832,
      -1,   939,  3835,    -1,    -1,    -1,  3839,    -1,    -1,    -1,
    3843,     8,    -1,    -1,    11,    -1,  3849,    -1,    15,    16,
      17,    -1,  3855,    -1,    -1,    -1,    -1,  3860,    -1,    -1,
     402,    -1,    -1,  3866,    -1,    32,   974,    -1,    -1,    -1,
    3873,    -1,    -1,    40,    -1,    -1,    -1,    -1,  3881,    46,
      -1,  3884,    -1,    -1,    -1,    -1,  3889,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,  3902,
      11,    -1,  3905,    70,    15,    16,    17,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,
      -1,    32,  3925,  3926,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    53,
    3943,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3952,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,    -1,    -1,
    3993,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1109,    -1,    -1,    -1,    -1,   120,    -1,    -1,   176,
    4013,    -1,    -1,   127,   181,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4028,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,
      -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,    -1,  4055,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4066,    -1,   176,    -1,    -1,  4071,   183,
     181,    -1,   186,    -1,    -1,    -1,  4079,    -1,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   202,   203,  4096,  4097,   262,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1220,    -1,    -1,   231,    -1,    -1,
     234,    -1,  4125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     244,    -1,   246,    -1,    -1,    -1,    -1,    -1,   249,    -1,
      -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     264,   262,    -1,    -1,   265,    -1,    22,    -1,    -1,   273,
     274,  4164,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4173,    -1,    -1,    -1,    -1,    -1,    -1,   344,  1284,    -1,
    1288,  1289,    -1,    -1,    -1,    -1,    -1,  4190,  4191,    -1,
      -1,  4194,    -1,    -1,    -1,   309,    -1,    -1,   312,   313,
     314,    -1,    68,    -1,    -1,  4208,  4209,    -1,    -1,    -1,
    4213,    -1,    -1,    -1,    -1,  4218,    -1,    -1,  4221,  4222,
      -1,  4224,    -1,  4226,    -1,   339,  4229,  4230,    -1,    -1,
      -1,    -1,    -1,   344,    -1,    -1,    -1,    -1,    -1,   353,
      -1,    -1,  4245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1360,    -1,   120,  4258,  4259,  4260,  4261,  4262,
      -1,   127,    -1,    -1,   130,    -1,    22,    -1,    -1,    -1,
     437,    -1,    28,   440,   441,   442,    -1,   444,   445,   446,
     447,   448,   449,    -1,    -1,    -1,    -1,   454,   402,   155,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4302,
    4303,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,  1425,    -1,    -1,
     186,    -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,  4345,   454,    -1,  4348,    22,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,  4358,    -1,    -1,    -1,    -1,
      -1,  4364,    -1,  4366,   120,    -1,    -1,    -1,    -1,  4372,
      -1,   127,    -1,    -1,   130,    -1,    -1,    -1,   244,    -1,
     246,    -1,  4385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     256,    -1,    68,  4396,  4397,  4398,    -1,    -1,   264,   155,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4427,    -1,    -1,  4430,    -1,  4432,
     186,    -1,    -1,  1541,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   309,   120,    -1,   312,   313,    -1,    -1,
      -1,   127,    -1,  4456,   130,    -1,    -1,  4460,    -1,    -1,
      -1,  4464,    -1,    -1,    -1,    -1,    -1,    -1,  4471,    -1,
      -1,    -1,    -1,   339,    -1,     8,    -1,  4480,    11,   155,
      -1,    -1,    15,    16,    17,    -1,    -1,  4490,   244,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
     256,    -1,  4505,    -1,    -1,    -1,    -1,    40,   264,    -1,
     186,    -1,    -1,    46,    -1,    -1,    -1,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,  4528,    -1,    -1,    -1,    -1,
      -1,  1639,  4535,  4536,  4537,  4538,   402,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1653,    -1,    -1,  1656,    -1,
    1658,    -1,  1660,   309,    -1,    -1,   312,   313,  1666,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,  4572,
     246,    -1,  1678,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     256,    -1,    -1,   339,    -1,  4588,    -1,    -1,   264,    -1,
    4593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,    -1,    -1,  1711,    -1,    -1,    -1,  1715,    -1,  1717,
      -1,    -1,  1720,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4635,   309,    -1,  4638,   312,   313,    -1,    -1,
      -1,    -1,    -1,   176,  4647,    -1,   402,  1753,   181,  4652,
      -1,  4654,    -1,  4656,    -1,    -1,    -1,    -1,    -1,    -1,
    4663,  1767,    -1,   339,    -1,  1771,  4669,    -1,  4671,   202,
     203,    -1,    -1,    -1,    -1,    -1,    -1,  4680,    -1,  1785,
    1786,  1787,    -1,  1789,   217,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4711,  4712,
      -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1831,   402,    -1,    -1,   262,
      -1,    -1,   265,    -1,    -1,  4738,    -1,    -1,    -1,    -1,
      -1,  4744,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1868,    -1,    -1,    -1,    -1,    -1,  4771,  4772,
      -1,    -1,    -1,  4776,    -1,    -1,    -1,    -1,    -1,  4782,
       8,    -1,  4785,    11,    -1,    -1,  4789,    15,    16,    17,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4802,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,  4812,
      -1,   344,    40,    -1,    -1,    -1,  4819,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4841,    -1,
      -1,    -1,    70,    -1,    -1,    -1,  4849,    -1,    -1,    -1,
      -1,    -1,  4855,  4856,  4857,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1973,     8,    -1,
      -1,    11,    -1,  4876,    -1,    15,    16,    17,    -1,  1985,
    4883,    -1,  1988,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,   437,    -1,    46,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,    -1,    -1,  2027,
    2028,   454,    -1,    -1,  2032,  2033,    -1,    -1,    -1,  2037,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2051,    -1,    -1,    -1,    -1,   176,    -1,
    2058,    -1,    -1,   181,  2062,  2063,  4959,  4960,  2066,  2067,
      -1,    -1,    -1,    22,    -1,  2073,    -1,    -1,    -1,    28,
    4973,    -1,    -1,    -1,   202,   203,    -1,    -1,  2086,    -1,
    2088,    -1,  4985,  4986,     8,    -1,    -1,    11,    -1,   217,
      -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,  2107,
      -1,    -1,    -1,    -1,  2112,    -1,    -1,    -1,    32,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    40,  2125,    -1,    -1,
      -1,   249,    46,    -1,    -1,    -1,  2134,    -1,  2136,    -1,
      -1,  2139,  2140,  2141,   262,    -1,   176,   265,  2146,  2147,
      -1,   181,    -1,    -1,    -1,    -1,    70,    -1,  2156,    -1,
      -1,    -1,    -1,  2161,    -1,    -1,    -1,    -1,  2166,    -1,
      -1,   120,   202,   203,    -1,    -1,    -1,    -1,   127,    -1,
      -1,   130,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,  2205,    -1,  2207,
      -1,    -1,    -1,    -1,  2212,    -1,    -1,    -1,  2216,   249,
    2218,  2219,  2220,  2221,    -1,  2223,   344,    -1,    -1,    -1,
      -1,    -1,   262,    -1,    -1,   265,    -1,   186,  2236,  2237,
    2238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2248,  2249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,   203,
      -1,    -1,    -1,    -1,    -1,   244,    -1,   246,    -1,    -1,
      -1,    -1,  2300,   217,    -1,    -1,    -1,   256,    -1,    -1,
      -1,    -1,    -1,    -1,   344,   264,    -1,    -1,    -1,   437,
      -1,    -1,   440,   441,   442,   274,   444,   445,   446,   447,
     448,   449,    -1,    -1,    -1,   249,   454,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
      -1,   265,    -1,    -1,    -1,    -1,     0,    -1,    -1,    -1,
     309,    -1,    -1,   312,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    30,    31,    -1,    -1,
     339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,
     440,   441,   442,    -1,   444,   445,   446,   447,   448,   449,
      -1,    65,   452,    67,    68,    -1,    -1,    -1,    -1,    73,
     344,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    -1,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   402,    -1,  2453,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,    -1,   123,
      -1,    -1,    -1,   127,    -1,    -1,  2484,    -1,    -1,   133,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,    -1,   143,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     164,    -1,    -1,   437,  2520,    -1,   440,   441,   442,    -1,
     444,   445,   446,   447,   448,   449,   180,    -1,    -1,    -1,
     454,    -1,    -1,    -1,  2540,    -1,  2542,    -1,    -1,  2545,
    2546,    -1,  2548,    -1,  2550,    -1,    -1,    -1,  2554,    -1,
      -1,  2557,    -1,    -1,    -1,    -1,  2562,    -1,    -1,    -1,
      -1,    -1,  2568,    -1,    -1,   219,   220,  2573,    -1,    -1,
      -1,   225,    -1,    -1,  2580,  2581,  2582,  2583,    -1,    -1,
      -1,  2587,  2588,   237,  2590,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   248,    -1,  2602,    -1,  2604,    -1,
      -1,    -1,    -1,    -1,    -1,  2611,  2612,  2613,  2614,  2615,
    2616,  2617,  2618,  2619,  2620,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    22,    -1,    -1,
      -1,    -1,  2648,    28,    -1,    -1,   300,    -1,    -1,    -1,
      -1,   305,   306,    -1,   308,    -1,    -1,    -1,    -1,   313,
      -1,    -1,  2670,    -1,   318,    -1,    -1,   321,    -1,    -1,
      -1,    -1,   326,    -1,    -1,    -1,    -1,   331,   332,    -1,
      -1,    -1,    -1,    68,    -1,   339,    -1,    -1,    -1,   343,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   365,    -1,    -1,  2722,  2723,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,
     384,    -1,  2740,    -1,    -1,   120,    -1,    -1,    -1,    -1,
     394,    32,   127,    -1,    -1,   130,   400,    -1,    -1,    40,
      -1,   405,  2758,    -1,    -1,    46,    -1,  2765,    -1,    -1,
      -1,  2769,    -1,    -1,   418,    -1,    -1,  2775,    -1,    -1,
     155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,  2791,  2792,   439,    -1,    -1,  2796,    -1,
      -1,    -1,    -1,  2801,  2802,  2803,    -1,  2805,    -1,   453,
       8,   186,   456,    11,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2826,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,  2836,  2837,
    2838,  2839,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,   246,    70,    -1,    -1,  2873,    -1,    -1,  2876,  2877,
    2878,   256,    -1,    -1,    -1,    -1,    -1,    -1,  2886,   264,
      -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,   274,
     181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    28,     8,    -1,    -1,
      11,   202,   203,    -1,    15,    16,    17,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   309,    -1,   217,   312,   313,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    46,    68,    -1,    -1,  2957,
      -1,    -1,    -1,    -1,   339,    -1,    -1,  2965,   249,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,    70,
      -1,   262,    -1,   181,   265,    -1,  2984,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2999,   202,   203,    -1,    -1,   120,    -1,
      -1,    -1,  3010,    -1,    -1,   127,    -1,    -1,   130,   217,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   249,    -1,    -1,    -1,    -1,  3054,    -1,    -1,    -1,
    3058,    -1,    -1,   344,   262,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,   186,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,  3087,
     181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   202,   203,    -1,    -1,    -1,    -1,    -1,    -1,  3117,
      -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,
      -1,    -1,   244,  3131,   246,    -1,    -1,  3135,    -1,    -1,
      -1,    -1,    -1,  3139,   256,    -1,   344,    -1,  3146,    -1,
      -1,    -1,   264,    -1,    -1,    -1,   437,    -1,   249,   440,
     441,   442,   274,   444,   445,   446,   447,   448,   449,    -1,
      -1,   262,    -1,   454,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3192,   309,    -1,    -1,
     312,   313,  3198,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,  3214,  3215,
      -1,    -1,  3218,  3219,  3220,  3221,    -1,   339,  3224,  3225,
    3226,  3227,  3228,  3229,  3230,  3231,  3232,  3233,  3234,   437,
      -1,    -1,   440,   441,   442,    -1,   444,   445,   446,   447,
     448,   449,    -1,   344,    -1,    68,   454,    -1,    -1,    -1,
    3256,    -1,    -1,  3259,    -1,  3261,    -1,    -1,  3264,  3265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3279,  3280,  3281,  3282,    -1,  3284,    -1,
     402,    -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   199,   200,    -1,    -1,    -1,   120,    -1,    -1,
     207,    -1,    -1,    -1,   127,    -1,    -1,   130,    -1,    -1,
      -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3332,    -1,    -1,    -1,
      -1,    -1,   155,    -1,    -1,    -1,   437,  3343,    -1,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,    -1,   454,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,  3380,    -1,    28,    -1,    -1,    -1,
      -1,    -1,  3390,    -1,  3392,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3400,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,  3417,
      -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    32,    -1,
      -1,   244,    -1,   246,    -1,  3433,    40,    -1,    -1,    -1,
      -1,    -1,    46,   256,    -1,    -1,    -1,    -1,    -1,  3447,
      -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   274,    -1,    -1,    -1,    -1,    70,  3465,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3475,   120,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,   130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   309,    -1,  3496,   312,
     313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3507,
    3508,  3509,    -1,   155,  3512,  3513,  3514,  3515,  3516,  3517,
      -1,    -1,    -1,    -1,  3522,  3523,   339,  3525,  3526,  3527,
    3528,  3529,  3530,    -1,  3532,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3541,   186,  3543,  3544,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3566,    -1,
      -1,    -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3585,    -1,   402,
    3586,    -1,    -1,    -1,    -1,    -1,    -1,    22,   202,   203,
      -1,    -1,   244,    28,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   217,   256,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,   249,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
     557,   265,    -1,    -1,    -1,    -1,    -1,   309,    -1,    -1,
     312,   313,   569,    -1,    -1,    -1,    -1,   574,    -1,    -1,
      -1,    -1,    -1,    -1,  3682,    -1,    -1,    -1,   585,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   339,    -1,    -1,
      -1,    -1,   127,    -1,   601,   130,    -1,    -1,    -1,   606,
      -1,    -1,  3710,  3711,  3712,   612,    -1,    -1,    -1,   616,
     617,    -1,    -1,    -1,  3722,    -1,   623,    -1,    -1,    -1,
     155,    -1,    -1,    -1,    -1,    -1,   633,   634,    -1,    -1,
     344,    -1,    -1,    -1,  3740,   642,    -1,    -1,  3744,  3745,
    3746,    -1,    -1,    -1,    -1,    -1,  3752,  3753,  3754,  3755,
     402,   186,    -1,    -1,  3760,  3761,  3762,  3763,  3764,  3765,
    3766,  3767,  3768,  3769,  3770,  3771,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3796,    -1,    -1,  3799,    -1,  3801,    -1,    -1,    -1,  3805,
      -1,    -1,  3808,  3809,    -1,    -1,  3812,  3813,    -1,   244,
      -1,   246,    -1,    -1,   721,   722,    -1,    -1,    -1,    -1,
     727,   256,    -1,   437,    -1,    -1,   440,   441,   442,   264,
     444,   445,   446,   447,   448,   449,    -1,    -1,    -1,   274,
     454,     8,    -1,    -1,    11,    -1,   753,    -1,    15,    16,
      17,  3857,    -1,    -1,    -1,    -1,    -1,    -1,  3864,  3865,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,  3880,    -1,    -1,   312,   313,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,   339,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3931,    -1,    -1,    -1,  3935,  3936,  3937,
    3938,    -1,    -1,  3941,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3965,  3966,  3967,
      -1,  3969,    -1,  3971,  3972,    -1,    -1,   402,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3983,  3984,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   893,    -1,    -1,    -1,
      -1,    -1,    -1,   900,    -1,    -1,  4004,   904,    -1,    -1,
      -1,    -1,    -1,  4011,  4012,    -1,  4014,    -1,    -1,   176,
      -1,    -1,    -1,   920,   181,    -1,    -1,    -1,  4026,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   934,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,     8,  4058,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,   973,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,  4086,    36,
      -1,    -1,   249,    40,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,   265,  4107,
      -1,    -1,    -1,    -1,  1011,    -1,    -1,    -1,    -1,    -1,
      -1,  4117,  4118,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1046,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4158,    -1,    -1,    -1,    -1,  4163,  4164,  1066,
      -1,   118,    -1,  1070,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1078,  4178,    -1,  4180,    -1,    -1,   344,  4184,  4185,
    4186,    -1,    -1,  4189,    -1,    -1,  4192,  4193,    -1,    -1,
      -1,  4197,    -1,    -1,    -1,  4201,    -1,    -1,    -1,  1106,
      -1,    -1,    -1,  4211,    -1,    -1,    -1,    -1,  1115,    -1,
    1117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4226,   176,
      -1,    -1,    -1,    -1,   181,  1132,    -1,    -1,  1135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1147,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,
    4256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1176,
     437,    -1,    -1,   440,   441,   442,    -1,   444,   445,   446,
     447,   448,   449,    -1,    -1,    -1,  4294,   454,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,  1204,  1205,  1206,
      -1,  1208,    -1,    -1,    -1,   262,    -1,  4315,   265,    -1,
    4316,    -1,  4320,  4321,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4350,  1252,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1260,  1261,    -1,    -1,  4365,    -1,    -1,
      -1,    -1,  1269,  1270,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,   344,    -1,    -1,
      -1,    -1,  1299,    -1,    -1,    -1,  1303,  1304,    -1,    -1,
      -1,    32,    -1,  4411,    -1,    -1,    -1,    -1,    -1,    40,
    4418,    -1,  1319,    -1,    -1,    46,    -1,    -1,  1325,    -1,
    4426,  4427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4442,  4443,  4444,    70,
      -1,    -1,   399,    -1,    -1,  4453,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4464,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4478,  4479,    -1,    -1,    -1,  1384,  4486,    -1,
     437,    -1,    -1,   440,   441,   442,    -1,   444,   445,   446,
     447,   448,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,  4509,    -1,    11,    -1,    -1,    -1,    15,    16,    17,
    4518,    -1,    -1,    -1,    -1,  1422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   154,    32,    -1,    -1,    -1,   159,    -1,
      -1,  4539,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,
     181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   202,   203,    -1,    -1,    -1,  1483,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1503,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1518,    -1,    -1,  4622,    -1,    -1,    -1,   249,  1526,
      -1,  4627,    -1,    -1,    -1,  1532,    -1,    -1,    -1,    -1,
    1537,   262,    -1,    -1,   265,    -1,  4644,  4643,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1553,    -1,    -1,    -1,
    1557,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1569,    -1,    -1,    -1,    -1,    -1,   176,    -1,
    4678,    -1,    -1,   181,    -1,    -1,    -1,  1584,    -1,    -1,
      -1,    -1,    -1,    -1,  1591,  4693,  4692,    -1,    -1,    -1,
    1597,    -1,    -1,    -1,   202,   203,  1603,    -1,    -1,    -1,
      -1,    -1,  1609,    -1,    -1,    -1,    -1,    -1,    -1,   217,
      -1,    -1,    -1,   344,  1621,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4730,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1640,    -1,  1642,  1643,  4743,    -1,    -1,
      -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,  1655,    -1,
      -1,    -1,    -1,    -1,   262,    -1,    -1,   265,  1665,    -1,
      -1,  1668,    -1,  1670,  1671,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1682,    -1,    -1,    -1,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4801,  4800,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   437,  1714,    -1,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4837,
      -1,    -1,    -1,    -1,    -1,    -1,   344,    -1,    -1,    -1,
      -1,  1748,    -1,  1750,    -1,    -1,    -1,    -1,  1755,  1756,
      -1,    -1,   360,    -1,  4860,  1762,  1763,  1764,    -1,    -1,
      -1,  1768,    -1,  1770,  1771,  1772,  1773,  1774,  1775,    -1,
    1777,    -1,  1779,  1780,    -1,    -1,  1783,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1797,  1798,  1799,  1800,  1801,  1802,    -1,    -1,    -1,  1806,
      -1,    -1,    -1,  1810,    -1,    -1,  1813,    -1,    -1,  1816,
    1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,    -1,  1826,
      -1,    -1,    -1,    -1,    -1,  4931,  1833,    -1,  1835,   437,
      -1,    -1,   440,   441,   442,    -1,   444,   445,   446,   447,
     448,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,  4972,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    32,    -1,    15,    16,    17,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    70,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1963,    -1,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,  2012,   153,    -1,    -1,  2016,
    2017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2026,
      -1,    -1,    -1,  2030,  2031,    -1,    -1,    -1,  2035,   176,
      -1,    -1,    -1,    -1,   181,    -1,  2043,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,    -1,
      -1,    -1,    -1,   181,  2061,   202,   203,  2064,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2076,
     217,    -1,    -1,  2080,   202,   203,  2083,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2092,    -1,    -1,    -1,   217,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2105,    -1,
      -1,    -1,   249,    -1,   176,    -1,    -1,    -1,    -1,   181,
      -1,    -1,    -1,    -1,    -1,   262,  2123,  2124,   265,    -1,
      -1,   249,    -1,    -1,    -1,  2132,    -1,    -1,    -1,    -1,
     202,   203,    -1,    -1,   262,    -1,    -1,   265,   285,    -1,
      -1,    -1,    -1,    -1,    -1,   217,    -1,  2154,  2155,    -1,
      -1,  2158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,
      -1,    -1,  2189,    -1,    -1,    -1,  2193,    -1,    -1,    -1,
     262,    -1,    -1,   265,    -1,    -1,    -1,   344,    -1,    -1,
      -1,    -1,    -1,    -1,  2211,    -1,    -1,    -1,    -1,   281,
      -1,    -1,    -1,    -1,    -1,  2222,   344,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2244,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2290,  2291,    -1,    -1,    -1,    -1,    -1,
     437,    -1,  2299,   440,   441,   442,    -1,   444,   445,   446,
     447,   448,   449,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      -1,    -1,   440,   441,   442,    -1,   444,   445,   446,   447,
     448,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2361,    -1,    -1,    -1,  2365,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    -1,  2374,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,   449,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
    2427,    -1,    15,    16,    17,  2432,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,  2463,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2479,    -1,  2481,    -1,    -1,    70,    -1,    -1,
      -1,    -1,  2489,    -1,    -1,    -1,  2493,     8,    -1,  2496,
      11,    -1,  2499,    -1,    15,    16,    17,    -1,    -1,    -1,
    2507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2517,    32,    -1,    -1,    -1,  2522,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2545,  2546,
    2547,    -1,    -1,  2550,    -1,    -1,    -1,    -1,    -1,    70,
      -1,  2558,  2559,  2560,  2561,    -1,    -1,    -1,    -1,  2566,
      -1,    -1,    -1,    -1,  2571,  2572,    -1,  2574,    -1,  2576,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2587,  2588,    -1,   176,  2591,    -1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2605,    -1,
    2607,    -1,  2609,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2629,    -1,   217,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2640,    -1,  2642,  2643,  2644,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2657,    -1,    -1,  2660,    -1,   176,   249,    -1,    -1,    -1,
     181,    -1,    -1,    -1,    -1,  2672,    -1,    -1,    -1,   262,
    2677,    -1,   265,    -1,    25,    -1,  2683,    -1,    -1,    -1,
      -1,   202,   203,    -1,    -1,    -1,  2693,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,
      -1,    -1,  2709,    -1,    -1,  2712,    -1,  2714,    -1,    -1,
      -1,    -1,  2719,    -1,  2721,    -1,    -1,    -1,    -1,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,
    2737,  2738,    -1,    -1,    85,    -1,  2743,    -1,    -1,    -1,
      -1,   262,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,   344,   103,    -1,    -1,    -1,    -1,  2764,   109,    -1,
    2767,    -1,    -1,    -1,  2771,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,
      -1,  2788,    -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   156,  2813,    -1,    -1,    -1,
     161,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,
      -1,    -1,    -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   184,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2848,  2849,  2850,   437,    -1,    -1,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,  2872,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2882,    -1,  2884,  2885,   230,
    2887,    -1,    -1,  2890,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2900,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   262,    -1,    -1,    -1,    -1,   437,    -1,    -1,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,  2945,    -1,
      -1,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2964,    -1,    -1,
      -1,   200,    -1,  2970,    -1,    -1,    -1,    -1,   207,   320,
      -1,    -1,    -1,    -1,   325,    -1,   327,    -1,    -1,   218,
      -1,    -1,   333,    -1,    -1,   336,    -1,    -1,    -1,  2996,
      -1,    -1,    -1,    -1,    -1,  3002,  3003,    -1,    -1,    -1,
      -1,    -1,  3009,    -1,  3011,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   364,   365,    -1,  3023,   368,  3025,    -1,
      -1,   372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     381,    -1,    -1,    -1,    -1,   386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3062,    -1,    -1,    -1,    -1,
     411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3079,  3080,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3093,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,    -1,    -1,    35,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,  3136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3148,    -1,    -1,  3151,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3173,    -1,    -1,  3176,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3193,    -1,    -1,  3196,
      -1,    -1,    -1,    -1,    -1,  3202,    -1,    -1,    -1,    -1,
      -1,  3208,    -1,  3210,    -1,    -1,  3213,    -1,    -1,    -1,
    3217,  3218,  3219,  3220,  3221,    -1,    -1,  3224,  3225,  3226,
    3227,  3228,  3229,  3230,  3231,  3232,  3233,    -1,    -1,    -1,
    3237,  3238,    -1,    -1,    -1,  3242,    -1,    -1,    -1,    -1,
    3247,    -1,    -1,    -1,  3251,    -1,  3253,    -1,  3255,    -1,
      -1,    -1,    -1,    -1,    -1,   176,  3263,    -1,    -1,  3266,
     181,  3268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3276,
    3277,    -1,    -1,  3280,  3281,    -1,    -1,    -1,  3285,  3286,
      -1,   202,   203,    -1,    -1,  3292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3302,   217,  3304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3316,
      -1,    -1,    -1,    -1,    -1,  3322,  3323,  3324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,
     569,    -1,    -1,    -1,    -1,   574,    -1,    -1,    -1,    -1,
      -1,   262,  3349,    -1,   265,    -1,   585,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3362,    -1,    -1,    -1,    -1,
      -1,  3368,   601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3383,    -1,   617,    -1,
      -1,    -1,    -1,     8,   623,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,   634,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   642,    -1,    -1,    -1,    32,    -1,  3416,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    46,    -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3462,    32,    -1,    -1,    35,
    3467,  3468,  3469,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,
      -1,    -1,    -1,    -1,    -1,   207,    -1,    -1,   727,    -1,
      -1,    -1,    -1,    -1,    70,    -1,   218,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3521,    -1,   437,  3524,    -1,   440,
     441,   442,    -1,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,   203,  3586,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,    -1,  3609,  3610,    -1,   181,  3613,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3622,    -1,  3624,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,   202,   203,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,
     265,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3662,  3663,  3664,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3718,    -1,    -1,    -1,     8,    -1,    -1,    11,   344,
      -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3739,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    -1,  3750,    -1,    -1,    -1,    40,   373,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   344,    -1,
      -1,    -1,    -1,  3780,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,  3790,  3791,    -1,  3793,    -1,    -1,    -1,
    3797,  3798,    -1,    -1,    -1,  3802,  3803,    -1,    -1,    -1,
    3807,    -1,    -1,  3810,  3811,    -1,    -1,  1046,  3815,    -1,
      -1,    -1,   437,    -1,  3821,   440,   441,   442,    -1,   444,
     445,   446,   447,   448,   449,    -1,    -1,  1066,    -1,    -1,
      -1,    -1,  3839,    -1,    -1,    -1,  3843,    -1,    -1,  1078,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   569,  3855,    -1,
      -1,    -1,   574,  3860,    -1,    -1,    -1,    -1,    -1,  3866,
      -1,   437,    -1,   585,   440,   441,   442,  1106,   444,   445,
     446,   447,   448,   449,  3881,    -1,    -1,    -1,  1117,   601,
      -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,  1132,    -1,   617,  1135,    -1,  3905,    -1,
      -1,   623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     203,    -1,   634,    -1,    -1,    -1,  3923,    -1,    -1,    -1,
     642,    -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3940,    -1,    -1,    -1,    -1,  3945,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3954,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,
      -1,    -1,    -1,  3970,    -1,    -1,    -1,    -1,  3975,   262,
      -1,    -1,   265,    -1,    -1,  3982,    -1,    -1,    -1,    -1,
      -1,    -1,  3989,  3990,    -1,    -1,  3993,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4003,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   727,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1260,  1261,    -1,    -1,    -1,  4033,    -1,    -1,    -1,
      -1,  1270,    -1,    -1,    -1,   721,   722,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4055,   612,
      -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4066,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   753,    -1,    -1,
     633,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1325,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4120,    -1,  4122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4148,    -1,    -1,   437,    -1,    -1,   440,   441,   442,
      -1,   444,   445,   446,   447,   448,   449,  4164,    -1,    -1,
      -1,  4168,    -1,    -1,    -1,    -1,  4173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4190,  4191,    -1,    -1,  4194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4208,    -1,    -1,    -1,    -1,  4213,    -1,    -1,    -1,
      -1,  4218,    -1,    -1,  4221,  4222,    -1,    -1,    -1,    -1,
      -1,    -1,  4229,  4230,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4245,    -1,
      -1,    -1,    -1,    -1,  1483,  4252,    -1,  4254,    -1,    -1,
      -1,  4258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4292,  4293,    -1,    -1,    -1,
      -1,    -1,    -1,  1532,    -1,  4302,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1553,    -1,    -1,    -1,  1557,    -1,
      -1,    -1,    20,    -1,  1046,    -1,    -1,    25,    -1,    -1,
    1569,    -1,  4339,    -1,    -1,    -1,    -1,   900,  4345,    37,
      -1,    -1,    -1,    -1,  1066,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1078,   920,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   934,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1106,    -1,    -1,    85,    -1,    -1,
      -1,  4398,    -1,  4400,    -1,  1117,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1642,  1643,   103,    -1,    -1,    -1,    -1,
    1132,    -1,    -1,  1135,    -1,    -1,  1655,    -1,    -1,    -1,
    4427,  4428,    -1,  4430,    -1,  4432,    -1,   125,    -1,    -1,
      -1,  1670,  1671,    -1,    -1,    -1,    -1,    -1,   136,    -1,
      -1,    -1,    -1,  1682,    -1,    -1,   144,    -1,  1011,  4456,
      -1,    -1,    -1,  4460,    -1,    -1,    -1,    -1,   156,  4466,
      -1,  1147,    -1,   161,  4471,    -1,    -1,    -1,    -1,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4490,    -1,    -1,   184,    -1,    -1,    -1,
    1176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4513,    -1,    -1,    -1,
      -1,    -1,  4519,    -1,    -1,    -1,  4523,  4524,  1204,  1205,
    1206,  4528,  1208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1252,    -1,   230,    -1,    -1,    -1,    -1,  4544,  1260,  1261,
      -1,    -1,  1228,    -1,    -1,    -1,    -1,    -1,  1270,    -1,
      -1,    -1,  1115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1802,   262,  4572,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1269,    -1,   283,  4593,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1325,    -1,    -1,    -1,  4614,  4615,    -1,
      -1,    -1,    -1,  1299,    -1,    -1,    -1,  1303,  1304,    -1,
      -1,    -1,   320,    -1,    -1,    -1,    -1,   325,  4635,   327,
      -1,  4638,    -1,    -1,    -1,   333,    -1,    -1,   336,    -1,
    4647,    -1,    -1,    -1,    -1,  4652,    -1,  4654,    -1,  4656,
      -1,    -1,    -1,    -1,    -1,    -1,  4663,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   365,    -1,    -1,
     368,    -1,    -1,  4680,   372,    -1,    -1,    -1,    -1,    -1,
      -1,   379,    -1,   381,    -1,    -1,    -1,    -1,   386,    -1,
      -1,    -1,    -1,    -1,  4701,    -1,  4703,    -1,    -1,    -1,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   411,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4744,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1319,    -1,    -1,    -1,
      -1,  1483,    -1,    -1,  4771,  4772,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4782,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4790,    -1,    -1,    -1,  2026,    -1,    -1,
      -1,  2030,  2031,    -1,    -1,  4802,  2035,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2043,    -1,    -1,    -1,    -1,    -1,
    1532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1384,  2061,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1553,    -1,    -1,    -1,  1557,    -1,    -1,    -1,    -1,
      -1,    -1,  4849,    -1,    -1,    -1,    -1,  1569,  4855,  4856,
    4857,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1422,
      -1,    -1,    -1,    -1,    -1,    -1,  2105,    -1,    -1,  4876,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4888,    -1,    -1,  2123,  2124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4902,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2154,  2155,    -1,    -1,  2158,
    1642,  1643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1655,    -1,    -1,    -1,    -1,    -1,    -1,
    1503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1670,  1671,
    2189,    -1,  4959,  4960,  2193,  1518,    -1,    -1,  4965,    -1,
    1682,    -1,    -1,  1526,    -1,    -1,  4973,    -1,    -1,    -1,
      -1,    -1,  2211,    -1,  1537,    -1,    -1,  4984,  4985,  4986,
      -1,    -1,    -1,  2222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2244,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1597,    -1,    -1,    -1,    -1,    -1,
      -1,   612,    -1,    -1,    -1,    -1,  1609,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1621,    -1,
    2299,    -1,   633,    -1,    -1,    -1,    -1,    -1,    -1,  1755,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1802,    -1,  1768,    -1,  1770,    -1,    -1,  1773,  1774,  1775,
      20,    -1,    -1,    -1,  1780,    25,    -1,  1783,    -1,    -1,
      -1,    -1,  1665,    -1,    -1,  1668,    -1,    37,    -1,    -1,
      -1,    -1,  1798,  1799,  1800,  1801,    -1,    -1,    -1,    -1,
    1806,    -1,    -1,    -1,  1810,    -1,  2365,  1813,    58,    -1,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,    -1,
    1826,    71,    -1,    -1,    -1,    -1,    -1,  1833,    -1,  1835,
      -1,    81,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,   109,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2427,    -1,
      -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2463,    -1,   156,    -1,    -1,    -1,
      -1,    -1,    -1,   163,  1797,    -1,    -1,   167,    -1,    -1,
      -1,    -1,  2481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2489,    -1,    -1,    -1,   184,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1835,    -1,    -1,    -1,    -1,  1963,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,    -1,    -1,    -1,  2026,    -1,    -1,    -1,  2030,  2031,
      -1,    -1,    -1,  2035,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2043,    -1,    -1,    -1,    -1,    -1,  2566,    -1,   900,
      -1,    -1,   262,  2572,    -1,   265,    -1,    -1,    -1,  2061,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   920,
      -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   934,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,  2064,    -1,
      -1,    -1,    -1,  2105,    -1,    -1,    -1,    -1,    -1,    -1,
     320,    -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,
      -1,  2123,  2124,   333,    -1,    -1,   336,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2657,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2154,  2155,    -1,   365,  2158,    -1,   368,   369,
    1011,   371,   372,    -1,    -1,    -1,    -1,    -1,    -1,  2012,
      -1,   381,    -1,  2016,  2017,    -1,   386,    -1,    -1,    -1,
      -1,    -1,   392,    -1,    -1,   395,    -1,  2189,   398,    -1,
      -1,  2193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   411,  2721,    -1,    -1,    -1,    -1,    -1,    -1,  2211,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2737,  2738,
    2222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2235,    -1,    -1,    -1,  2080,    -1,    -1,
      -1,    -1,  2244,    -1,    -1,  2764,    -1,    -1,  2767,  2092,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1115,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2132,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2299,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2290,    -1,    -1,    -1,    -1,  2848,
    2849,  2850,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2872,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2365,    -1,    -1,  2885,    -1,  2887,    -1,
      -1,  2890,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2900,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1255,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   633,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2427,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2964,    -1,    -1,  2291,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2463,    -1,    -1,    -1,    -1,  2432,    -1,  1319,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2481,
      -1,    -1,    -1,  3002,    -1,    -1,    -1,  2489,    -1,    -1,
    3009,    -1,  3011,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3023,    -1,  3025,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2361,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2517,    -1,    -1,    -1,    -1,  2522,    -1,    -1,    -1,
    3079,    -1,    -1,    -1,  2566,    -1,    -1,    -1,    -1,    -1,
    2572,  1422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2547,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2558,    -1,  2560,  2561,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2571,    -1,    -1,  2574,    -1,
    2576,    -1,    -1,    -1,    -1,    -1,    -1,  3136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3151,    -1,    -1,    -1,  2479,    -1,    -1,  2605,
      -1,  2607,    -1,  2609,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1503,  2496,  3173,  2657,    -1,  3176,    -1,    -1,
      -1,    -1,    -1,    -1,  2507,    -1,    -1,  1518,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1526,  2642,  2643,  2644,    -1,
     900,    -1,    -1,    -1,    -1,    -1,  1537,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2660,    -1,    -1,    -1,    -1,    -1,
     920,    -1,    -1,    -1,    -1,    -1,  2672,    -1,    -1,    -1,
      -1,  2677,    -1,    -1,   934,    -1,    -1,  2683,    -1,  2721,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1584,  3253,  2737,  2738,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1597,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1609,    -1,
      -1,    -1,  2764,    -1,    -1,  2767,    -1,    -1,    -1,    -1,
    1621,    -1,    -1,    -1,    -1,    -1,    -1,  2743,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1011,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2642,
    2643,  2644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1665,    -1,    -1,  1668,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2848,  2849,  2850,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2709,    -1,    -1,  2712,
    2872,  2714,    -1,    -1,    -1,    -1,  2719,    -1,    -1,    -1,
      -1,    -1,    -1,  2885,    -1,  2887,    -1,    -1,  2890,    -1,
      -1,    -1,    -1,    -1,    -1,  1115,    -1,  3416,  2900,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2771,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3462,    -1,  2788,  1797,    -1,  3467,    -1,
    3469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2964,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2813,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3002,    -1,  3521,    -1,    -1,  3524,    -1,  3009,    -1,  3011,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3023,    -1,  3025,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2882,
      -1,  2884,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3079,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3609,  3610,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1319,
      -1,    -1,  2945,  3622,    -1,  3624,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2970,    -1,    -1,
      -1,    -1,    -1,    -1,  3136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3151,
      -1,    -1,    -1,  2996,    -1,    -1,    -1,    -1,    -1,    -1,
    3003,  2012,    -1,    -1,  1384,  2016,  2017,    -1,    -1,    -1,
      -1,  3173,    -1,    -1,  3176,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3718,
      -1,    -1,  1422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3062,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3193,    -1,  2080,
      -1,    -1,    -1,    -1,    -1,    -1,  3202,  3080,    -1,    -1,
      -1,  2092,  3208,    -1,  3210,    -1,    -1,   612,    -1,    -1,
    3093,  3253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   633,    -1,
      -1,  3237,  3238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2132,    -1,  1503,    -1,    -1,    -1,    -1,    -1,  3255,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,  1518,    -1,
    3266,    -1,  3268,    -1,    -1,    -1,  1526,    -1,    -1,    -1,
      -1,  3277,    -1,    -1,    -1,    -1,    -1,  1537,    -1,  3285,
    3286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3316,    -1,    -1,  3196,    -1,    -1,  3322,  3323,  3324,    -1,
      -1,    -1,    -1,    -1,  1584,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3217,    -1,    -1,  1597,    -1,    -1,
      -1,    -1,    -1,  3349,    -1,    -1,    -1,    -1,    -1,  1609,
      -1,    -1,    -1,    -1,    -1,    -1,  3362,    -1,    -1,  3242,
      -1,  1621,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3416,    -1,    -1,    -1,    -1,    -1,
      -1,  3940,    -1,    -1,    -1,    -1,  3945,    -1,    -1,    -1,
      -1,    -1,    -1,  3276,    -1,    -1,    -1,    -1,    -1,    -1,
    2291,    -1,    -1,    -1,    -1,  1665,    -1,    -1,  1668,    -1,
      -1,  3970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3462,    -1,    -1,  3982,    -1,  3467,    -1,  3469,    -1,    -1,
    3989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3324,    -1,    -1,  4003,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2361,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3521,
      -1,    -1,  3524,    -1,    -1,  3368,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   900,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   920,    -1,    -1,    -1,    -1,
      -1,    -1,   612,    -1,    -1,    -1,    -1,    -1,    -1,   934,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1797,    -1,    -1,
      -1,    -1,    -1,   633,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3609,  3610,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3622,    -1,  3624,    -1,    -1,  3468,    -1,    -1,  2479,  4148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2496,  1011,   612,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2507,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   633,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3663,  3664,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3718,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4252,    -1,  4254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3613,    -1,    -1,  3739,  4293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3750,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2012,    -1,    -1,    -1,  2016,  2017,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3662,
    4339,    -1,    -1,    -1,  3790,  3791,    -1,    -1,    -1,    -1,
      -1,  3797,  3798,    -1,    -1,    -1,  3802,    -1,    -1,    -1,
      -1,  3807,    -1,    -1,  3810,  3811,    -1,    -1,    -1,  3815,
     900,    -1,    -1,    -1,    -1,  3821,    -1,    -1,  2709,    -1,
    2080,  2712,    -1,  2714,    -1,    -1,    -1,    -1,  2719,    -1,
     920,    -1,  2092,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   934,    -1,    -1,    -1,    -1,  3855,
      -1,    -1,    -1,    -1,  3860,    -1,    -1,    -1,    -1,    -1,
    3866,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2132,    -1,    -1,  3881,    -1,    -1,    -1,    -1,
    2771,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   612,    -1,    -1,   900,    -1,  2788,  3940,  3905,
      -1,    -1,    -1,  3945,    -1,    -1,    -1,    -1,    -1,    -1,
    3793,    -1,    -1,   633,  1319,   920,    -1,    -1,    -1,    -1,
    3803,  1011,  2813,    -1,    -1,    -1,    -1,    -1,  3970,   934,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3982,    -1,    -1,    -1,    -1,    -1,    -1,  3989,    -1,    -1,
      -1,    -1,    -1,    -1,  4513,    -1,    -1,    -1,    -1,    -1,
      -1,  4003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3855,    -1,    -1,    -1,    -1,  3860,    -1,  1384,
      -1,    -1,    -1,  3866,    -1,  4544,    -1,  3993,    -1,    -1,
      -1,  2882,    -1,  2884,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1011,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1115,    -1,    -1,    -1,    -1,
      -1,  2291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4055,
      -1,    -1,    -1,    -1,  2945,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2970,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3975,    -1,    -1,    -1,    -1,    -1,  1503,    -1,
      -1,  2361,    -1,    -1,    -1,  2996,  4148,  3990,    -1,    -1,
    1115,    -1,  3003,  1518,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4701,    -1,  4703,    -1,    -1,    -1,    -1,    -1,
    4033,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3062,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1584,
     900,    -1,    -1,    -1,  4190,  4191,    -1,    -1,  4194,  3080,
      -1,    -1,  1597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     920,    -1,  3093,    -1,  1609,    -1,    -1,    -1,    -1,    -1,
    4252,    -1,  4254,    -1,   934,    -1,  1621,    -1,    -1,  2479,
      -1,    -1,    -1,  4229,  4230,    -1,    -1,    -1,    -1,  1319,
      -1,  4790,    -1,    -1,    -1,    -1,  2496,  4120,    -1,  4122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2507,    -1,    -1,
      -1,  4293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1665,    -1,    -1,  1668,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,
      -1,  1011,    -1,    -1,  1384,    -1,    -1,  4339,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1319,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3217,    -1,    -1,  4888,
      -1,    -1,  1422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4902,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1384,
      -1,    -1,    -1,    -1,    -1,  3276,    -1,    -1,    -1,    -1,
      -1,    -1,  1797,    -1,    -1,  1115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4965,    -1,    -1,  4292,
      -1,    -1,    -1,  1503,    -1,    -1,    -1,  1422,    -1,    -1,
      -1,    -1,    -1,    -1,  4430,  4984,    -1,    -1,  1518,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1537,    -1,  2709,
    4456,    -1,  2712,    -1,  2714,    -1,    -1,    -1,    -1,  2719,
      -1,    -1,    -1,    -1,    -1,  4471,    -1,    -1,    -1,    -1,
      -1,  4513,    -1,    -1,    -1,    -1,    -1,  3368,    -1,    -1,
      -1,    -1,    -1,    -1,  4490,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1584,    -1,    -1,    -1,  1503,    -1,
      -1,    -1,  4544,    -1,    -1,    -1,    -1,  1597,    -1,    -1,
      -1,  2771,    -1,  1518,    -1,    -1,    -1,  4400,    -1,  1609,
      -1,  1526,  4528,    -1,    -1,    -1,    -1,    -1,  2788,    -1,
      -1,  1621,  1537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2813,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1665,    -1,  3468,  1668,  1584,
      -1,    -1,    -1,  4466,    -1,    -1,    -1,  4593,    -1,    -1,
      -1,    -1,  1597,    -1,    -1,    -1,    -1,    -1,    -1,  1319,
      -1,    -1,    -1,    -1,  1609,    -1,    -1,  2012,    -1,    -1,
      -1,  2016,  2017,    -1,    -1,    -1,  1621,    -1,    -1,    -1,
      -1,    -1,  2882,    -1,  2884,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4519,    -1,    -1,    -1,
    4523,  4524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4656,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4701,
    1665,  4703,    -1,  1668,  1384,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4680,  2080,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2945,    -1,  2092,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1422,    -1,    -1,    -1,    -1,  1797,    -1,    -1,
    2970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3613,    -1,    -1,    -1,    -1,  2132,    -1,    -1,
      -1,  4614,  4615,    -1,    -1,    -1,  2996,    -1,    -1,    -1,
      -1,    -1,    -1,  3003,    -1,    -1,    -1,    -1,  4790,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4771,  4772,    -1,    -1,    -1,
      -1,  3662,    -1,    -1,    -1,    -1,  4782,    -1,    -1,    -1,
      -1,    -1,    -1,  1503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1797,    -1,    -1,    -1,    -1,    -1,  1518,    -1,
      -1,    -1,  3062,    -1,    -1,    -1,  1526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1537,    -1,    -1,
    3080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3093,    -1,    -1,    -1,    -1,   612,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4888,    -1,    -1,    -1,
      -1,  4857,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   633,
    4902,    -1,    -1,    -1,  1584,    -1,    -1,    -1,    -1,    -1,
    4876,    -1,    -1,    -1,    -1,    -1,    -1,  1597,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2291,    -1,    -1,  1609,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1621,  3793,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3803,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2012,  4965,    -1,    -1,  2016,  2017,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3196,    -1,    -1,    -1,
      -1,    -1,  4984,    -1,    -1,  1665,    -1,    -1,  1668,    -1,
      -1,    -1,    -1,  4959,  4960,    -1,  2361,  3217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2092,    -1,    -1,    -1,    -1,  2012,    -1,    -1,
      -1,  2016,  2017,    -1,    -1,    -1,  3276,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3954,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2479,  2080,    -1,  1797,    -1,    -1,
      -1,    -1,    -1,    -1,  3975,    -1,    -1,  2092,    -1,    -1,
      -1,  2496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3990,
      -1,    -1,  2507,    -1,    -1,    -1,    -1,    -1,  3368,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   900,  2132,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4033,    -1,    -1,    -1,   920,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     934,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2291,    -1,    -1,    -1,    -1,    -1,    -1,  3468,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4122,    -1,    -1,    -1,    -1,    -1,  1011,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2361,    -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2291,    -1,    -1,    -1,
      -1,    -1,  2012,    -1,    -1,    -1,  2016,  2017,    -1,    -1,
      -1,    -1,    -1,    -1,  2709,    -1,    -1,  2712,    -1,  2714,
      -1,    -1,    -1,    -1,  2719,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3613,    -1,    -1,  2361,    -1,    -1,    -1,
    2080,    -1,    -1,    -1,    -1,    -1,  2771,    -1,    -1,    -1,
      -1,    -1,  2092,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2788,    -1,    -1,    -1,    -1,    -1,  2479,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4292,  3662,    -1,    -1,    -1,  2496,    -1,  2813,    -1,
      -1,    -1,  2132,    -1,    -1,    -1,    -1,  2507,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2479,    -1,    -1,  2882,    -1,  2884,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2507,    -1,    -1,    -1,    -1,    -1,    -1,  4400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3793,    -1,    -1,    -1,  4428,    -1,    -1,
    2945,    -1,    -1,  3803,    -1,  1319,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2970,    -1,    -1,    -1,    -1,
      -1,  2291,    -1,    -1,    -1,  4466,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2996,    -1,    -1,    -1,    -1,    -1,    -1,  3003,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2709,
      -1,    -1,  2712,    -1,  2714,    -1,    -1,    -1,  4519,  2719,
      -1,    -1,  4523,  4524,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2361,    -1,    -1,    -1,    -1,    -1,    -1,  1422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3062,    -1,    -1,
      -1,    -1,    -1,  3923,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3080,    -1,    -1,    -1,    -1,
      -1,  2771,    -1,    -1,    -1,    -1,    -1,    -1,  3093,    -1,
      -1,    -1,    -1,    -1,  3954,    -1,    -1,    -1,  2788,    -1,
      -1,    -1,    -1,    -1,  2709,    -1,    -1,  2712,    -1,  2714,
      -1,    -1,    -1,    -1,  2719,  3975,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2813,  4615,    -1,    -1,    -1,    -1,  1503,
    3990,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1518,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1526,    -1,    -1,    -1,    -1,    -1,    -1,  2479,
      -1,    -1,    -1,  1537,    -1,    -1,  2771,    -1,    -1,    -1,
      -1,    -1,    -1,  4033,    -1,    -1,  2496,    -1,    -1,    -1,
      -1,    -1,    -1,  2788,    -1,    -1,    -1,  2507,    -1,    -1,
      -1,  3196,  2882,    -1,  2884,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2813,    -1,
    1584,    -1,  3217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1597,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1609,    -1,  3242,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1621,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2945,    -1,    -1,    -1,    -1,
      -1,    -1,  4122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3276,    -1,    -1,    -1,    -1,    -1,  2882,    -1,  2884,
    2970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1665,    -1,    -1,  1668,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2996,    -1,  4168,    -1,
      -1,    -1,    -1,  3003,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3368,    -1,  2970,    -1,    -1,    -1,    -1,
      -1,    -1,  3062,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2709,
    3080,  2996,  2712,    -1,  2714,    -1,    -1,    -1,  3003,  2719,
      -1,    -1,    -1,  3093,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1797,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2771,    -1,    -1,    -1,    -1,    -1,  3062,    -1,    -1,
      -1,    -1,    -1,  3468,    -1,    -1,    -1,    -1,  2788,    -1,
      -1,    -1,    -1,    -1,    -1,  3080,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3093,    -1,
      -1,    -1,    -1,  2813,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2882,    -1,  2884,    -1,    -1,    -1,  4428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3276,    -1,    -1,    -1,
      -1,  3196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4466,    -1,  3613,    -1,
      -1,    -1,  3217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2945,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3242,  2012,    -1,
      -1,    -1,  2016,  2017,    -1,    -1,    -1,    -1,    -1,    -1,
    2970,    -1,    -1,    -1,    -1,    -1,    -1,  3662,    -1,  4519,
      -1,    -1,    -1,  4523,  4524,    -1,    -1,    -1,    -1,    -1,
      -1,  3276,    -1,    -1,    -1,    -1,  2996,    -1,  3368,    -1,
      -1,    -1,    -1,  3003,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2080,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2092,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3062,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4615,    -1,    -1,  2132,    -1,
    3080,    -1,    -1,  3368,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3093,    -1,    -1,    -1,    -1,  3468,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3793,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3803,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2291,  3923,    -1,
      -1,    -1,  3242,  3613,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3954,
      -1,    -1,    -1,    -1,    -1,    -1,  3276,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3975,    -1,  3662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3990,    -1,  2361,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3613,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4033,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3368,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3662,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3793,    -1,  2479,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3803,    -1,    -1,    -1,  4122,    -1,    -1,
      -1,    -1,  2496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2507,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3468,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3793,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3803,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3923,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3954,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3975,    -1,  4292,    -1,    -1,
      -1,    -1,    -1,  3613,    -1,    -1,    -1,    -1,    -1,    -1,
    3990,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3923,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2709,    -1,    -1,  2712,    -1,
    2714,    -1,  3662,  4033,    -1,  2719,    -1,    -1,    -1,  3954,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3975,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4400,    -1,  2771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2788,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4428,    -1,    -1,    -1,    -1,  4033,    -1,
      -1,    -1,  4122,    -1,    -1,    -1,    -1,    -1,    -1,  2813,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3793,    -1,    -1,    -1,    -1,  4168,    -1,
      -1,    -1,    -1,  3803,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2882,    -1,
    2884,    -1,    -1,    -1,  4519,    -1,    -1,  4122,  4523,  4524,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2970,    -1,    -1,    -1,
      -1,    -1,  4292,  3923,    -1,    -1,    -1,    -1,    -1,    -1,
    4615,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2996,    -1,    -1,    -1,    -1,    -1,    -1,  3003,
      -1,    -1,    -1,    -1,  3954,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3975,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3990,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4292,  3062,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3080,    -1,    -1,    -1,
    4400,    -1,    -1,  4033,    -1,    -1,    -1,    -1,    -1,  3093,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4466,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4400,    -1,    -1,    -1,    -1,
      -1,    -1,  4122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3196,  4428,    -1,    -1,    -1,    -1,    -1,  4519,
      -1,    -1,    -1,  4523,  4524,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3217,    -1,    -1,    -1,    -1,  4168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4466,    -1,    -1,    -1,    -1,    -1,    -1,  3242,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4519,    -1,    -1,    -1,  4523,  4524,
      -1,    -1,    -1,    -1,    -1,  4615,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3368,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4615,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3468,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4466,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4519,
      -1,    -1,    -1,  4523,  4524,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3613,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3662,    -1,
      -1,    -1,    -1,    -1,    -1,  4615,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3793,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3803,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3923,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3975,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4033,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4292,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4400,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4428,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4519,    -1,    -1,    -1,  4523,
    4524,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,  4615,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,   446,
      -1,    -1,    -1,    -1,    -1,    -1,   453,   454,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,    -1,    -1,    -1,    -1,   444,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,   454,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,
      -1,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,   454,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,    -1,    -1,
      -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   453,   454,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
      -1,     3,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,   454,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   454,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    -1,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,    -1,   143,   144,
     145,    -1,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,    -1,    -1,    -1,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,    -1,
     215,   216,   217,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
     285,    -1,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,    -1,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,    -1,   381,    -1,    -1,   384,
     385,   386,   387,   388,   389,   390,    -1,    -1,   393,   394,
     395,   396,   397,    -1,    -1,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,
     435,   436,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,   454,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,    -1,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,    -1,    -1,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,   285,    -1,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,    -1,   381,    -1,
      -1,   384,   385,   386,   387,   388,   389,   390,    -1,    -1,
     393,   394,   395,   396,   397,    -1,    -1,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,   434,   435,   436,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,   454,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,   412,   413,    -1,    -1,   416,    -1,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,    -1,
      -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   453,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
      -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   453,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
      -1,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,
      -1,    -1,    -1,   451,   452,   453,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,   446,
      -1,    -1,    -1,    -1,    -1,    -1,   453,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,    -1,    -1,    -1,    -1,    -1,   444,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,    -1,
     444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,
      -1,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,    -1,    -1,    -1,
      -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   453,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,    -1,    -1,
      -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   453,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,    -1,
      -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   453,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
      -1,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   453,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   453,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,    -1,    -1,    -1,    -1,    -1,   444,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   444,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,    -1,    -1,    -1,    -1,    -1,
     444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   444,   445,    -1,    -1,     3,     4,     5,     6,     7,
     453,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
      -1,     3,     4,     5,     6,     7,    -1,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,   453,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,   453,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,    -1,    -1,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,    -1,     3,    -1,    -1,    -1,    -1,   444,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,   261,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,    -1,   439,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   453,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,   158,    -1,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,    -1,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,   158,    -1,   160,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   453,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,   158,    -1,   160,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,     3,     4,
       5,    -1,    -1,    -1,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   453,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,   158,    -1,   160,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,    -1,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,    -1,    -1,   393,   394,
     395,   396,   397,    -1,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,     3,    -1,    -1,    -1,    -1,   444,
     445,   446,    -1,    -1,    -1,    -1,    -1,    -1,   453,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
     439,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   453,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,    -1,   439,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,    -1,
      -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,   168,
     169,    -1,   171,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,
     209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,    -1,   247,   248,
      -1,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,    -1,   366,    -1,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,   400,   401,   402,   403,   404,   405,   406,    -1,   408,
      -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,    -1,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,   171,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,   206,   207,   208,   209,   210,    -1,    -1,
     213,   214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,    -1,   262,
     263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,    -1,   366,    -1,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,    -1,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,    -1,    -1,
     393,   394,   395,   396,   397,    -1,    -1,   400,   401,   402,
     403,   404,   405,   406,    -1,   408,    -1,   410,   411,   412,
     413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,    -1,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,   152,   153,    -1,   155,    -1,
     157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,
      -1,   168,   169,    -1,   171,   172,   173,   174,   175,    -1,
     177,   178,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,
     207,   208,   209,   210,    -1,    -1,   213,   214,    -1,   216,
      -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,    -1,
     247,   248,    -1,   250,    -1,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,
     267,   268,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,    -1,   366,
      -1,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
      -1,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,    -1,    -1,   393,   394,   395,   396,
     397,    -1,    -1,   400,   401,   402,   403,   404,   405,   406,
      -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   453,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,    -1,    -1,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,
     161,   162,   163,    -1,   165,   166,    -1,   168,   169,    -1,
     171,   172,   173,   174,   175,    -1,   177,   178,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,    -1,
     201,    -1,    -1,   204,    -1,   206,   207,   208,   209,   210,
      -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,
     221,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,    -1,   247,   248,    -1,   250,
      -1,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
      -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,    -1,   366,    -1,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,    -1,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
      -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,   400,
     401,   402,   403,   404,   405,   406,    -1,   408,    -1,   410,
     411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    -1,    -1,
      -1,    -1,   453,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,    -1,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   434,   435,   436,    -1,    -1,    -1,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,   449,     3,     4,
       5,    -1,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,    -1,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,    -1,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,
     435,   436,    -1,     3,    -1,   440,   441,   442,     8,   444,
     445,   446,   447,   448,   449,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,     3,    -1,
     440,   441,   442,     8,   444,   445,   446,   447,   448,   449,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,    -1,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,
      -1,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
      -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,    -1,   247,   248,    -1,   250,    -1,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,    -1,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,    -1,    -1,   393,   394,
     395,   396,   397,    -1,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,    -1,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,     3,    -1,   440,   441,   442,     8,   444,
     445,   446,   447,   448,   449,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,     3,    -1,
     440,   441,   442,     8,   444,   445,   446,   447,   448,   449,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,    -1,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,
      -1,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
      -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,    -1,   247,   248,    -1,   250,    -1,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,    -1,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,    -1,    -1,   393,   394,
     395,   396,   397,    -1,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,    -1,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,     3,    -1,   440,   441,   442,     8,   444,
     445,   446,   447,   448,   449,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,     3,    -1,
     440,   441,   442,     8,   444,   445,   446,   447,   448,   449,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,    -1,    -1,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,   152,   153,    -1,
     155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,
     165,   166,    -1,   168,   169,    -1,   171,   172,   173,   174,
     175,    -1,   177,   178,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,
      -1,   206,   207,   208,   209,   210,    -1,    -1,   213,   214,
      -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,    -1,   247,   248,    -1,   250,    -1,   252,   253,   254,
     255,   256,   257,    -1,   259,    -1,    -1,   262,   263,   264,
      -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
      -1,   366,    -1,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,    -1,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,    -1,    -1,   393,   394,
     395,   396,   397,    -1,    -1,   400,   401,   402,   403,   404,
     405,   406,    -1,   408,    -1,   410,   411,   412,   413,    -1,
      -1,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,     3,    -1,   440,   441,   442,     8,   444,
     445,   446,   447,   448,   449,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
     440,   441,   442,    -1,   444,   445,   446,   447,   448,   449,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     446,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   446,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,   285,    -1,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,    -1,   381,    -1,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,   434,   435,   436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   446,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,    -1,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,   135,   136,    -1,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,    -1,   148,
      -1,   150,   151,   152,   153,    -1,   155,    -1,   157,   158,
      -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,    -1,
     169,    -1,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,    -1,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,    -1,    -1,   213,    -1,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,    -1,
     259,    -1,    -1,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,   285,    -1,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,    -1,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,    -1,   378,
     379,    -1,   381,    -1,    -1,   384,   385,   386,   387,   388,
     389,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   446,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,     4,     5,
      -1,    -1,    -1,     9,    -1,    -1,   446,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,     4,     5,    -1,    -1,    -1,     9,   444,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,   260,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,     4,     5,    -1,    -1,
      -1,     9,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,     5,    -1,    -1,    -1,     9,   444,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,     9,
     444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,   159,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,     4,     5,
      -1,    -1,    -1,     9,   444,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    -1,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
     164,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,   164,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
     156,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,   261,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,   261,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,   261,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    35,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,    -1,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,    -1,    -1,
      -1,   161,   162,   163,    -1,   165,   166,    -1,   168,   169,
      -1,   171,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,   206,   207,   208,   209,
     210,    -1,    -1,   213,   214,    -1,   216,    -1,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,    -1,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,   363,   364,    -1,   366,    -1,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,   405,   406,    -1,   408,    -1,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,    -1,    -1,    -1,   161,
     162,   163,    -1,   165,   166,    -1,   168,   169,    -1,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
      -1,    -1,   204,    -1,   206,   207,   208,   209,   210,    -1,
      -1,   213,   214,    -1,   216,    -1,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,    -1,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,   268,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,   363,   364,    -1,   366,    -1,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,   405,   406,    -1,   408,    -1,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
      -1,    -1,    -1,   161,   162,   163,    -1,   165,   166,    -1,
     168,   169,    -1,   171,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,    -1,    -1,   204,    -1,   206,   207,
     208,   209,   210,    -1,    -1,   213,   214,    -1,   216,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,    -1,   247,
     248,    -1,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
     268,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,   363,   364,    -1,   366,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,   405,   406,    -1,
     408,    -1,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,    -1,    -1,    -1,   161,   162,   163,
      -1,   165,   166,    -1,   168,   169,    -1,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,    -1,    -1,
     204,    -1,   206,   207,   208,   209,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,    -1,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,    -1,   366,    -1,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,   405,   406,    -1,   408,    -1,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,    -1,    -1,    -1,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,    -1,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,    -1,    -1,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,   285,    -1,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
      -1,   381,    -1,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   434,   435,   436,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,   285,    -1,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,    -1,   381,    -1,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   434,   435,   436,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,    -1,    -1,    -1,   161,   162,   163,    -1,   165,
     166,    -1,   168,   169,    -1,   171,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
     206,   207,   208,   209,   210,    -1,    -1,   213,   214,    -1,
     216,    -1,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,   244,   245,
      -1,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,   268,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,   363,   364,    -1,
     366,    -1,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,   405,
     406,    -1,   408,    -1,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,    -1,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,   285,    -1,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,    -1,   381,
      -1,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   434,   435,   436,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,    -1,    -1,    -1,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,    -1,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,    -1,    -1,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,   285,    -1,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
      -1,   381,    -1,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   434,   435,   436,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,   152,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
      -1,   199,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,   285,    -1,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,    -1,
     378,   379,    -1,   381,    -1,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   434,   435,   436,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,    -1,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,   134,   135,
     136,    -1,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,    -1,   148,    -1,   150,   151,   152,   153,    -1,   155,
      -1,   157,   158,    -1,   160,   161,   162,   163,    -1,   165,
      -1,    -1,    -1,   169,    -1,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,    -1,   199,    -1,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,    -1,    -1,   213,    -1,   215,
     216,   217,    -1,   219,   220,   221,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,    -1,    -1,   253,   254,   255,
     256,   257,    -1,   259,    -1,    -1,   262,   263,   264,    -1,
      -1,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,   285,
      -1,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,    -1,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,    -1,   378,   379,    -1,   381,    -1,    -1,   384,   385,
     386,   387,   388,   389,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,    -1,   400,   401,   402,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,   413,    -1,    -1,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,   435,
     436,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,    -1,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,    -1,   148,    -1,   150,   151,   152,   153,
      -1,   155,    -1,   157,   158,    -1,   160,   161,   162,   163,
      -1,   165,    -1,    -1,    -1,   169,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,    -1,   199,    -1,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,    -1,    -1,   213,
      -1,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,    -1,    -1,   253,
     254,   255,   256,   257,    -1,   259,    -1,    -1,   262,   263,
     264,    -1,    -1,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,   285,    -1,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,    -1,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,    -1,   378,   379,    -1,   381,    -1,    -1,
     384,   385,   386,   387,   388,   389,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,   413,
      -1,    -1,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     434,   435,   436,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
      -1,    -1,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,    -1,   148,    -1,   150,   151,
     152,   153,    -1,   155,    -1,   157,   158,    -1,   160,   161,
     162,   163,    -1,   165,    -1,    -1,    -1,   169,    -1,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,    -1,   199,    -1,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,   213,    -1,   215,   216,   217,    -1,   219,   220,   221,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,    -1,   259,    -1,    -1,
     262,   263,   264,    -1,    -1,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,   285,    -1,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
      -1,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,    -1,   378,   379,    -1,   381,
      -1,    -1,   384,   385,   386,   387,   388,   389,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,   400,   401,
     402,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,   413,    -1,    -1,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   434,   435,   436,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,    -1,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,    -1,   134,   135,   136,    -1,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,    -1,   148,    -1,
     150,   151,   152,   153,    -1,   155,    -1,   157,   158,    -1,
     160,   161,   162,   163,    -1,   165,    -1,    -1,    -1,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,    -1,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,    -1,   199,
      -1,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,    -1,    -1,   213,    -1,   215,   216,   217,    -1,   219,
     220,   221,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,    -1,   247,   248,   249,
     250,    -1,    -1,   253,   254,   255,   256,   257,    -1,   259,
      -1,    -1,   262,   263,   264,    -1,    -1,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,   285,    -1,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,    -1,   339,
     340,    -1,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,    -1,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,    -1,   378,   379,
      -1,   381,    -1,    -1,   384,   385,   386,   387,   388,   389,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,    -1,
     400,   401,   402,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,   413,    -1,    -1,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   434,   435,   436,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    -1,
      48,    -1,    -1,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    -1,    -1,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,    -1,    -1,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,    -1,    -1,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,    -1,
     148,    -1,   150,   151,    -1,   153,    -1,   155,    -1,   157,
     158,    -1,   160,   161,   162,   163,    -1,   165,    -1,    -1,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,    -1,   192,   193,   194,   195,    -1,    -1,
      -1,    -1,    -1,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,    -1,    -1,   213,    -1,   215,   216,   217,
      -1,   219,   220,   221,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,    -1,   243,   244,    -1,    -1,   247,
     248,   249,   250,    -1,    -1,   253,    -1,   255,   256,   257,
      -1,   259,    -1,    -1,   262,   263,   264,    -1,    -1,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,   285,    -1,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
      -1,   339,   340,    -1,   342,   343,   344,   345,   346,    -1,
     348,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,    -1,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,    -1,    -1,    -1,
     378,   379,    -1,   381,    -1,    -1,   384,   385,   386,   387,
     388,   389,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,    -1,   400,   401,   402,   403,   404,    -1,    -1,    -1,
     408,   409,   410,   411,   412,   413,    -1,    -1,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   434,   435,   436
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    18,    28,    30,    31,    45,    65,    67,    68,    73,
      75,    86,    88,   105,   108,   121,   123,   127,   133,   141,
     143,   149,   164,   180,   219,   220,   225,   237,   248,   288,
     300,   305,   306,   308,   313,   318,   321,   326,   331,   332,
     339,   343,   353,   365,   384,   394,   400,   405,   418,   439,
     453,   460,   461,   462,   463,   469,   470,   472,   473,   474,
     475,   476,   477,   478,   480,   481,   485,   497,   502,   503,
     506,   507,   508,   520,   523,   524,   540,   577,   580,   583,
     584,   585,   592,   598,   600,   602,   603,   606,   609,   610,
     614,   615,   624,   628,   629,   630,   631,   632,   635,   637,
     638,   639,   640,   641,   648,   649,   662,   663,   667,   669,
     670,   671,   681,   683,   690,   691,   694,   695,   696,   697,
     698,   704,   706,   709,   713,   717,   718,   728,   729,   732,
     737,   748,   771,   774,   775,   776,   779,   782,   784,   786,
     788,   789,   794,   795,   798,   799,   800,   803,   804,   811,
     812,   814,   815,   816,   821,   823,   824,   830,   831,   832,
     833,   834,   835,   837,   838,   840,   841,   843,   846,   847,
     852,   858,   861,   863,   864,   872,   874,   879,   886,   890,
     891,   892,   893,   894,   895,   898,   933,   378,   421,   817,
      25,    71,    85,   103,   109,   125,   136,   144,   156,   161,
     167,   184,   209,   230,   262,   283,   293,   320,   325,   327,
     333,   336,   364,   365,   368,   372,   381,   386,   398,   411,
     599,   817,     3,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    37,    38,    40,    41,    43,
      44,    45,    46,    47,    49,    50,    52,    53,    54,    55,
      56,    59,    60,    61,    62,    63,    65,    66,    67,    68,
      69,    73,    74,    75,    76,    78,    79,    80,    82,    83,
      84,    85,    86,    87,    90,    91,    92,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   110,   112,   113,   114,
     115,   116,   117,   119,   120,   121,   124,   125,   126,   127,
     128,   130,   131,   132,   134,   135,   136,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   148,   150,   151,   152,
     153,   155,   157,   161,   162,   163,   165,   166,   168,   169,
     171,   172,   173,   174,   175,   177,   178,   179,   180,   182,
     183,   184,   185,   186,   187,   189,   191,   192,   193,   194,
     195,   196,   197,   199,   201,   204,   206,   207,   208,   209,
     210,   213,   214,   216,   219,   220,   221,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   242,   243,   244,   245,   247,   248,
     250,   252,   253,   254,   255,   256,   257,   259,   262,   263,
     264,   267,   268,   270,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   282,   283,   284,   285,   286,   287,   288,
     289,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   317,   318,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   333,
     334,   335,   336,   337,   339,   340,   341,   342,   343,   345,
     346,   347,   348,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   363,   364,   366,   368,   369,
     370,   371,   372,   374,   375,   378,   379,   380,   381,   382,
     384,   385,   386,   387,   388,   389,   390,   393,   394,   395,
     396,   397,   400,   401,   402,   403,   404,   405,   406,   408,
     410,   411,   412,   413,   416,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   887,  1055,  1069,  1073,  1074,   409,   848,
     260,   289,   817,    48,   453,   531,    20,    25,    37,    58,
      71,    81,   103,   109,   125,   136,   144,   156,   163,   167,
     221,   262,   265,   283,   320,   327,   336,   368,   369,   371,
     372,   381,   386,   392,   395,   398,   541,   582,   686,   738,
     749,    26,   288,  1055,   887,    26,   282,   334,   369,   371,
       5,   208,   780,   781,  1064,    20,    25,    37,    58,    71,
      85,   103,   125,   136,   144,   156,   161,   167,   184,   230,
     262,   273,   283,   320,   325,   327,   333,   336,   365,   368,
     372,   379,   381,   386,   398,   411,   599,   699,   817,  1055,
      88,   409,   453,   577,   580,   583,   847,   853,   861,   864,
     872,   879,   886,   890,     9,    19,    26,    43,   151,   157,
     159,   181,   210,   243,   291,   307,   444,   445,   714,   715,
     887,  1063,  1065,    26,    88,   304,   332,   719,   720,   721,
    1069,   156,  1069,  1060,  1064,   365,   901,   714,  1069,   378,
    1055,   273,   230,   103,   184,   327,   364,   365,   453,   790,
     791,   326,  1069,    26,   337,   374,   378,   489,   498,   499,
    1069,    23,   164,   719,   720,   289,   817,  1069,   207,    26,
     122,   903,   904,    59,    82,   221,   239,   320,   327,   337,
     374,   378,   424,   486,   487,   488,   489,    26,   337,   374,
     378,   489,   378,   261,   944,  1053,  1069,   901,   446,  1069,
     160,   453,   849,   453,  1048,   302,   896,   897,  1055,   896,
     891,   892,   895,     0,   456,   848,   137,   198,   266,   391,
     905,   906,   891,   893,   894,   114,   194,   397,   457,     3,
      42,    48,    71,    77,    89,    96,   158,   160,   176,   190,
     202,   203,   205,   215,   217,   241,   249,   269,   271,   319,
     344,   367,   409,  1061,  1069,  1070,  1073,  1075,   701,  1069,
     701,  1056,  1069,   292,   701,   381,   701,  1055,  1069,   102,
     365,   727,  1061,     3,    99,   338,  1066,  1067,  1071,  1073,
    1074,  1075,    26,   175,  1053,   255,   411,     8,    15,    16,
      17,    66,   148,   440,   441,   442,   444,   445,   446,   447,
     448,   449,   778,  1014,  1015,  1069,   175,  1055,    26,  1066,
    1067,  1055,  1055,   175,  1053,  1055,   313,   339,    26,   175,
     944,  1055,   329,  1055,   701,    26,   228,  1066,  1067,   175,
    1053,   208,   111,   204,   246,   298,   818,   819,   820,  1053,
    1059,  1069,    20,    25,    58,    71,    72,    81,    85,   103,
     125,   136,   144,   156,   161,   184,   209,   230,   262,   283,
     320,   325,   327,   333,   336,   365,   368,   372,   379,   381,
     386,   411,   599,   707,  1064,   860,   864,   872,   879,   890,
    1053,   232,  1061,  1055,   453,   701,   381,  1056,   701,   381,
     175,  1055,   102,   365,   369,   371,  1066,  1067,   369,   371,
      66,   148,   778,   311,  1055,  1066,   175,   482,  1069,  1055,
    1055,   329,  1055,   701,   228,  1066,   302,   333,   365,   411,
     230,    85,   184,   161,   325,   379,   385,   593,    26,  1055,
     888,   496,  1064,  1071,   781,   232,   175,  1061,  1055,   175,
     785,   175,  1056,     3,    47,    49,    50,    61,    62,   106,
     107,   126,   152,   175,   196,   197,   199,   240,   242,   254,
     299,   341,   347,   374,   375,   406,   703,   959,   961,   963,
     965,   967,   969,   970,   971,   973,   974,   975,   978,   979,
    1070,  1073,   381,   102,   365,   175,  1061,   175,  1067,  1068,
      77,   411,    66,   148,   175,   778,    52,   175,  1055,   175,
    1068,   175,  1055,   175,  1055,   175,  1055,   329,   785,   175,
    1055,   175,   703,   175,   228,  1068,   208,   175,   700,   701,
     453,   862,   541,   853,   405,   847,   854,   855,   856,  1071,
     848,  1065,   715,   716,    26,   716,  1065,   716,    26,   716,
    1065,   716,   716,   716,  1065,  1063,  1063,   887,   716,   292,
     453,   453,   560,   560,   560,   260,   376,   457,   560,   327,
     944,   945,   457,   813,  1064,   453,   859,    52,   411,   409,
     792,   793,  1053,  1055,  1069,    42,   436,   204,   455,   263,
     263,   260,   159,  1064,   376,   154,   710,   260,     4,     6,
       7,     8,    10,    34,    47,    49,    50,    57,    58,    61,
      62,    69,    71,    93,    94,    95,    96,    97,    98,    99,
     106,   107,   142,   146,   147,   152,   166,   168,   196,   197,
     199,   214,   222,   223,   240,   242,   246,   251,   252,   254,
     262,   272,   284,   299,   323,   338,   347,   361,   374,   375,
     380,   382,   383,   392,   398,   406,   426,   427,   428,   429,
     430,   431,   432,   433,   437,   444,   445,   446,   453,   891,
     962,   965,   968,   969,   970,   972,   973,   974,   978,   979,
     983,   985,   986,   987,   989,  1010,  1011,  1012,  1016,  1035,
    1040,  1050,  1051,  1061,  1062,  1063,  1064,  1069,  1049,  1050,
    1064,    26,   504,  1052,  1053,   337,   486,   109,   495,  1064,
     496,  1064,    42,    63,   486,   436,   348,   819,   263,   159,
     376,   442,    42,   436,   204,   820,   453,  1053,   446,   451,
     455,  1041,  1043,   945,     3,   158,   160,   409,   844,   845,
     847,   158,   850,   109,   983,  1046,  1047,   896,   457,   453,
     851,   454,   454,   462,  1053,    26,   122,   902,   902,    52,
     902,   149,   154,   218,   258,   909,   911,   912,   927,   929,
     930,   931,   905,   906,   159,   200,   944,   946,  1048,   453,
     761,  1043,   274,   309,   339,   455,   702,   274,   309,   339,
       3,    80,   131,   224,   274,   309,   339,   368,   370,   418,
     497,   500,   825,   826,   827,   828,   733,    22,   127,   274,
     309,   339,   402,   511,  1055,   339,    22,   127,   397,   479,
     422,   175,   944,    54,    87,   117,   145,   178,   213,   246,
     274,   275,   309,   317,   324,   331,   339,   351,   359,   413,
     497,   501,   764,   772,   453,   750,   309,   479,   181,   142,
      22,    28,    68,   117,   120,   127,   130,   155,   186,   244,
     246,   256,   264,   274,   309,   312,   313,   339,   402,   509,
     510,   618,     4,   444,   445,   590,  1065,    26,   175,  1053,
     701,   701,   453,   777,   455,   142,   260,   181,   471,   309,
     418,   439,   464,   471,   260,   274,   309,   142,    53,   101,
     183,   231,   234,   244,   273,   309,   314,   339,   353,   509,
     587,   588,   274,   309,   410,   618,   626,   499,   487,   489,
     181,   142,   309,   339,   509,   274,   309,   313,   339,    78,
     119,   276,   370,   260,    22,    28,   127,   274,   309,   339,
     521,   522,   471,   154,   309,   464,   471,   142,   309,   339,
     509,  1055,   216,   111,   261,   423,   457,   818,   399,   842,
     260,   232,  1061,   453,  1055,   959,   381,   102,   365,  1061,
     255,   411,    66,   148,   778,  1055,  1055,   329,   154,  1055,
     959,   208,   701,   454,   560,  1055,   453,   676,   761,    64,
     959,   159,   453,   672,  1055,   464,    35,   836,  1055,   246,
     464,   422,   175,  1053,   464,   701,   701,   672,   395,   541,
     260,   464,   246,    42,   483,   386,   625,   274,   601,    78,
     119,   276,   370,    24,    44,   195,   650,    35,   672,   154,
     464,   411,   175,  1053,   175,   578,  1053,  1053,   411,   701,
      77,   739,  1061,  1055,   154,   599,    48,   100,   193,   244,
     328,   142,   761,    55,   315,   512,   142,   453,   142,   408,
     976,   976,   976,   453,   964,   964,   286,   453,   966,   142,
      61,    62,   976,   964,   961,   420,   439,   453,   980,   453,
     980,   457,   512,    34,   960,    62,   453,   977,   104,   173,
     233,   236,   330,   434,   453,   981,   982,   702,   964,   422,
     142,   750,   142,   457,   175,   700,   175,   701,   175,   701,
     142,   777,  1068,   142,   260,   142,   142,   260,   142,   512,
     142,    78,   119,   276,   370,   154,   142,   260,   142,   512,
     142,   154,   175,   175,   496,   142,   457,   512,   983,  1019,
     365,   454,   457,   147,   260,   383,   493,   496,   590,   857,
     853,   716,   887,   716,   887,   716,   887,   716,   887,   716,
     887,   887,   887,   716,   887,   453,   561,   562,  1069,   561,
      26,   103,   125,   156,   161,   208,   209,   327,   333,   365,
     368,   386,   722,  1052,  1068,   721,  1055,   181,   457,   875,
    1064,   959,  1022,    35,  1068,   739,   454,   457,   216,  1069,
     154,   154,   722,  1068,   326,  1069,   496,   260,   453,  1044,
     451,   891,  1023,   983,  1039,   453,   453,   154,   453,   453,
     891,   453,   453,   453,   453,   453,   453,   983,   453,   453,
     453,   453,   453,   453,   453,   453,   891,   453,   453,   453,
     453,   453,   453,   453,   453,   983,   983,   983,   891,   983,
    1019,  1043,  1064,   453,  1064,     3,     8,    11,    15,    16,
      17,    32,    35,    40,    46,    70,   176,   181,   202,   203,
     217,   249,   262,   265,   344,   437,   440,   441,   442,   444,
     445,   446,   447,   448,   449,  1014,  1016,  1018,   419,   998,
     271,   983,   200,   457,   899,   453,  1064,  1043,   899,   112,
     177,   505,   457,    63,   109,   496,    35,     3,   109,   221,
     494,   590,   979,  1064,  1064,    83,   124,   995,    92,   109,
     490,   491,   493,   590,   109,   490,   216,  1053,   983,  1042,
       3,    26,    30,    31,    32,    33,    34,    35,    36,    39,
      51,    57,    58,    64,    70,    72,    81,    88,    93,    94,
      95,    97,    98,    99,   109,   111,   118,   122,   123,   129,
     133,   137,   147,   149,   154,   156,   159,   164,   167,   170,
     181,   188,   198,   200,   211,   212,   218,   222,   223,   246,
     251,   258,   260,   261,   265,   266,   281,   290,   304,   316,
     332,   338,   349,   362,   365,   373,   376,   377,   383,   391,
     392,   398,   399,   407,   414,   415,   417,   418,   446,  1058,
    1072,  1073,  1074,  1075,  1076,  1041,    84,   314,   705,   454,
     457,   848,   454,   457,   897,  1054,  1055,    35,   851,   893,
     893,   907,   908,   983,   893,   151,   243,   918,   206,   244,
     298,   342,   397,    26,   913,   983,   914,   916,   983,   985,
     927,   928,   912,   911,   909,   910,   154,   930,   256,   932,
     909,   927,   946,   865,  1053,    35,  1069,   339,   181,   191,
     266,   268,   341,   407,   446,   754,   755,   756,   758,   760,
     762,   959,  1070,   274,   309,   339,   376,   376,   327,  1058,
     455,   376,   376,   327,   218,   376,   376,   368,   486,   274,
     825,   827,   442,   829,   154,   164,   181,   318,   734,   735,
      64,    81,   138,   156,   290,   392,   557,   558,    81,   109,
     246,   376,    81,   376,   109,   246,   327,    81,   120,   130,
     274,   309,   668,   327,   607,    20,    25,    58,    71,    85,
     125,   136,   156,   161,   230,   262,   327,   333,   336,   365,
     372,   379,   386,   411,   599,  1055,   142,   309,   339,   509,
     260,   590,   260,   331,   213,   376,  1069,   376,   251,   590,
     113,   201,   327,   337,   378,   488,   315,   339,   764,   773,
     454,   751,   754,   376,   398,   368,  1053,    72,   138,   175,
     548,   557,  1069,    72,    81,   796,   260,   260,   323,   325,
     381,    81,   796,    29,   312,   323,   325,   381,   323,  1053,
     155,   186,   256,   701,   453,   376,   376,   174,   453,   516,
     227,   368,   395,   418,   420,   516,    81,   457,     4,     4,
     274,   181,   142,   117,   309,   339,   509,   399,   399,   245,
     959,   274,   339,   778,  1055,  1053,   103,   339,   500,   376,
     466,   500,  1053,   376,   376,  1053,   590,    52,   589,   590,
     590,   101,   231,   234,    52,   376,   464,   327,   464,   244,
     588,   376,   376,   251,  1064,   618,   368,   944,    81,   376,
     796,   327,   376,   376,   516,   516,   701,   701,   701,   701,
    1053,    41,   404,    41,    41,   376,    41,   376,   327,   457,
     500,   398,   636,  1067,   376,   466,   500,  1053,   376,   327,
     274,   309,   298,   310,   335,   492,   818,  1059,  1069,  1053,
     761,   959,   260,   202,   422,   750,   590,   701,   701,   777,
     260,   202,   260,    78,   119,   276,   370,   959,   260,   202,
     701,   202,   376,   418,   532,   386,     3,   677,   678,   672,
     453,    35,   701,   673,   674,  1072,    24,   825,   959,   260,
     142,   604,  1055,   246,   453,   465,   686,   399,   302,   411,
    1053,   465,   142,  1067,    88,   164,   484,   540,   584,   649,
     717,   737,   821,  1064,   626,   627,  1067,   224,   701,   701,
     701,   701,   256,   114,   194,   384,   397,   651,   652,   134,
     297,   453,   636,   465,  1053,   246,   586,   587,   246,    35,
     256,   453,   560,   560,   175,   581,  1053,   154,   175,   740,
    1059,   453,   752,    35,   959,   208,   418,   420,   889,   328,
    1061,   512,   959,  1056,   453,  1019,  1063,   703,   976,   976,
      34,   960,   374,   374,  1063,  1063,   959,   451,   451,   339,
    1063,   376,   376,   376,   453,   376,  1063,   964,   175,  1055,
    1061,   512,  1068,  1067,   142,   512,   142,   399,   142,   399,
     778,   512,   512,  1055,   701,  1068,  1055,   701,  1055,  1055,
     959,  1055,   701,   703,  1068,   636,   142,   142,   512,   700,
     701,   454,   457,   175,  1053,   853,   855,   887,   887,   887,
     887,   887,   887,   561,   454,   457,   454,   162,   334,   366,
    1054,   700,   102,   336,   726,   727,  1054,   255,  1054,  1052,
    1052,  1054,   700,   376,   418,   730,   137,   218,   633,   634,
      20,   140,   323,   342,   876,   944,   250,   877,   454,   457,
     860,   376,  1053,   790,   791,   793,   720,   719,   720,   159,
     165,   731,  1069,    25,    72,   103,   125,   136,   156,   161,
     209,   230,   320,   327,   333,   365,   368,   386,   411,   599,
     711,  1019,  1041,   452,  1019,  1023,  1024,   414,  1036,  1037,
     983,  1019,   453,  1063,  1063,     3,   104,   173,   233,   236,
     330,   434,  1025,  1026,  1064,  1019,  1019,  1019,  1063,  1063,
     983,   778,   983,  1027,   323,   444,   445,   453,   984,   985,
    1016,  1029,   454,  1019,   983,  1019,  1030,   983,    51,   159,
     212,   377,   983,  1019,  1033,  1019,   238,   985,   983,   993,
     994,   995,   238,   983,   995,   454,   457,  1063,   981,   959,
     983,   983,   983,   983,  1072,   374,    39,   362,  1045,   701,
     983,   453,   891,  1034,   122,   124,   147,   246,   251,   256,
     383,   393,   983,   453,   983,   376,    46,   176,   181,   217,
     344,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,    26,    33,   349,  1013,   167,   150,   999,   323,   453,
    1010,   163,   221,   365,   369,   371,   395,   900,  1053,  1051,
     159,   934,    26,   122,   407,   446,   454,   756,   983,  1020,
    1021,  1070,   934,  1053,   378,   453,  1064,   457,   454,   452,
     458,   174,   174,   512,  1053,   845,   846,  1053,  1046,   454,
     457,   453,   457,    36,   118,   399,   746,   453,   915,  1065,
     342,   206,   261,   457,   323,   324,   917,  1052,   250,   346,
     878,   928,   910,   399,   873,   109,   453,   866,   890,    35,
    1069,   453,   880,   881,   882,   883,   884,  1069,   268,    52,
    1070,   454,   756,   758,   755,   758,  1070,   266,   454,   457,
     702,   376,   376,   327,  1067,  1055,  1055,  1058,  1067,  1055,
    1055,  1067,  1056,  1055,   109,   493,  1065,   320,   398,   719,
     327,   164,   719,   453,  1055,   399,   741,   206,   206,   399,
     453,   576,   175,  1055,   251,  1067,  1055,  1055,   983,   251,
    1055,  1055,    29,   312,   376,   376,  1055,   376,   608,   232,
    1061,   453,   701,   701,   959,   381,   102,   365,   727,   411,
      66,   148,   778,  1055,   701,  1055,   701,   329,   154,   959,
     701,   208,   169,   244,   274,   309,   403,   611,   612,   613,
     944,   376,   796,   327,   251,   144,   113,   201,  1067,  1055,
     260,  1055,   454,   457,  1066,  1068,  1055,   309,   509,   175,
     548,   246,   959,  1055,  1069,  1055,   144,   216,  1055,    26,
     398,  1055,   175,  1055,   175,  1069,   325,   381,   325,   381,
     216,  1055,    26,   398,  1055,   216,   323,  1053,    22,   127,
     339,   619,   620,   621,   622,  1072,  1067,  1055,   109,   160,
     247,   399,   515,   518,   519,  1072,  1055,   259,    68,   259,
    1055,   510,   376,   368,  1053,   260,   376,   796,   327,  1057,
    1069,  1057,   457,   454,   457,   376,   327,   453,   260,   309,
     376,   645,  1056,  1066,     3,    80,   132,   186,   280,   390,
     398,   401,   467,   309,  1067,  1055,   309,   339,   509,   587,
     590,   701,  1055,   590,  1055,   590,  1067,  1055,  1055,   309,
     339,   509,  1055,  1055,  1055,  1055,  1067,  1055,    22,    28,
     127,   274,   309,   339,   274,   309,   339,   672,   309,   339,
     309,   339,   117,   309,   958,  1069,   175,   682,  1069,   175,
    1069,  1067,  1055,  1055,  1055,    22,   522,   336,  1066,   309,
     339,   509,  1055,  1055,   376,   376,    76,   389,   298,   202,
      35,   125,   701,   251,   708,  1064,   202,   202,   399,   399,
     202,   701,   708,   701,   208,   701,   708,   202,   708,   295,
     526,   259,   159,   376,   525,   184,   442,   454,   457,   983,
     959,   454,   457,   442,   651,   550,  1072,  1055,    55,   159,
     327,   410,   605,   612,   613,   142,   217,   542,   544,   546,
     548,   554,   557,    23,   181,   320,   363,   467,   468,   154,
    1057,   411,  1053,   154,   646,   482,  1069,   483,   265,   541,
     156,  1064,   672,   672,   672,   672,   256,   260,   265,   453,
     672,   956,   957,   958,   336,   453,   142,   142,   141,   890,
     701,   542,  1069,   418,   420,   572,   418,   517,   246,    35,
     560,  1064,   246,   260,   454,   753,   754,   759,    35,   208,
     317,   379,   417,   763,   764,   765,   260,   208,   496,   172,
     172,   154,   761,    35,  1019,   454,   454,   512,   451,   436,
     436,   454,   454,  1063,   452,  1063,  1069,   454,   173,   233,
     982,   233,   982,   982,  1063,   236,   454,   142,   512,   750,
     700,   701,  1057,   701,  1057,   777,   260,   512,   260,   512,
     512,   208,   260,   512,   512,   336,   154,   496,   512,   983,
     246,   454,   562,   181,   181,   181,   422,  1054,   457,   590,
     591,   167,   723,   724,  1067,    23,   731,   376,   453,   159,
     140,   342,   140,   342,   323,   397,   235,   959,  1067,   418,
     579,  1053,  1055,   159,   260,   723,    52,   512,  1061,   959,
     381,   365,  1061,   255,   411,   959,   208,   701,   454,   452,
     452,   457,   983,   129,  1037,  1038,    35,   454,   983,   454,
     454,   454,   159,   454,   454,   454,   454,   454,   457,   454,
     281,  1028,   454,   453,   984,   984,  1019,    11,    15,    16,
      17,   181,   202,   262,   440,   441,   442,   444,   445,   446,
     447,   448,   449,  1016,   984,   454,   454,   154,   159,  1031,
    1032,   454,    35,  1033,  1019,  1033,  1033,   159,   454,   454,
    1072,   279,   997,    35,   454,   457,   983,  1072,   457,   983,
    1044,   983,   454,   436,   984,   984,   135,  1019,   159,   122,
     124,   147,   251,   256,   383,   393,   453,   135,   778,   983,
     362,  1045,   983,  1034,   983,   376,   453,   891,   453,   453,
     270,  1003,   453,  1019,   369,   371,   369,   371,  1053,   901,
     901,   901,   211,   324,   453,   891,   935,   936,   937,   944,
     949,   986,   988,   989,  1061,  1069,   415,   954,  1020,  1020,
    1021,   454,    13,    14,   457,   905,   906,   954,   819,  1063,
     981,   491,   983,  1042,   851,  1055,   860,   908,   262,  1014,
    1017,   438,   747,   983,   917,   397,   914,   226,   935,   415,
     955,   405,   867,   868,  1069,   260,   869,  1069,   884,   885,
     457,   934,   442,  1044,   762,   702,   758,   758,    52,   760,
     448,  1067,  1055,  1055,  1068,  1068,   260,  1054,   263,   260,
     983,   558,  1057,   453,   453,   453,   576,   184,   561,   660,
     142,   512,   376,  1067,  1055,   496,  1055,   761,   959,  1055,
     422,   701,   701,   701,   701,   777,    78,   119,   276,   370,
     959,  1055,   594,  1055,   169,   403,   376,   376,   594,   611,
     618,   309,   339,   509,  1055,  1055,  1055,   192,  1055,   251,
     754,   273,   339,   376,   246,   142,   264,   616,   660,   127,
     313,   339,   511,   618,   797,  1055,   331,   142,   512,   142,
     512,  1055,  1055,  1055,  1055,   331,   331,   216,   621,   622,
     621,   454,   457,   623,  1064,   184,   454,   457,   442,   455,
    1067,  1055,   309,   339,   509,   144,  1055,  1055,  1055,   274,
     309,   339,    22,   127,   274,   309,   339,   959,   245,   959,
    1067,  1055,   801,   802,  1072,  1053,   376,  1068,   399,   642,
     218,   280,   251,  1064,   280,  1068,   396,   376,   376,   327,
     273,   339,    81,   376,   796,   327,   376,   376,   228,   228,
     228,   376,   376,   327,   376,   376,   327,   376,   327,   376,
     327,   260,   376,   512,   959,   246,  1064,   339,   797,   142,
     512,   376,  1055,   376,   327,  1067,  1055,   708,   959,   701,
     202,   708,   708,  1057,  1057,   708,   202,   202,  1055,   202,
     708,   356,   357,   527,  1064,   526,   169,   262,   444,   445,
     590,   675,   758,  1017,  1064,  1076,     3,   678,   454,   454,
     674,   675,   260,    64,    70,    81,   109,   111,   188,   246,
     251,   290,   304,   392,   551,   552,   553,   141,   414,   464,
     496,  1055,   496,   616,  1053,  1053,   454,   457,  1068,   167,
     320,  1068,  1063,   386,  1053,   560,    26,   114,   194,   332,
     397,   647,   376,   644,    42,   483,   311,   365,   102,   517,
     561,  1053,   652,   679,   680,  1064,   454,   457,  1055,   561,
    1053,   578,  1053,  1055,   579,   453,   543,   454,   259,   516,
     259,   260,   573,   516,    35,   142,   890,   517,   376,   142,
    1053,   454,   457,   109,   442,   766,  1064,   496,   365,   757,
     758,   154,   767,   418,   765,   768,   114,   194,   332,   397,
     809,  1055,   169,   890,   512,   959,   454,  1063,   980,   980,
     452,   452,   977,   454,  1055,   512,   512,   399,   512,   399,
     512,   512,   701,   701,  1055,   701,  1055,   636,   512,   142,
     327,   327,   327,  1054,   727,   457,  1067,   418,   457,   725,
     263,   945,   336,   140,   140,   102,   244,  1068,   722,   512,
    1067,   761,   202,   750,   590,   202,   701,   202,  1023,   373,
     983,   133,   959,   454,   983,   983,   983,  1031,   454,  1019,
     457,   959,   984,   984,   984,   984,   122,   124,   246,   256,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     983,   983,  1032,  1031,   959,   454,   454,   454,  1019,   454,
     457,    52,   985,   454,  1072,   994,   287,   360,   996,   454,
     457,   410,   990,    35,   454,  1064,   983,    32,    32,   983,
     454,   983,   159,   453,  1022,   983,   454,   135,   984,   984,
     135,   135,   983,   983,   906,   415,   453,  1004,  1069,   454,
    1019,   457,   901,   901,   901,   901,  1053,  1053,  1053,   891,
     949,   159,   891,   936,   937,    35,   938,   939,  1069,   457,
      89,   160,   190,   205,   215,   241,   319,   941,   939,    35,
     938,   940,  1069,   439,   953,   453,  1043,   983,   167,   919,
     457,   905,   905,   905,   983,   983,   407,  1021,   454,   919,
     454,   452,   454,   453,   747,   151,   210,   454,   261,    92,
     983,   316,   871,   454,   457,  1044,    79,   871,   454,   457,
     881,   955,  1046,   454,   448,   762,   386,   162,   334,   366,
     387,   736,   154,   736,   454,   453,   564,   565,   743,   988,
    1069,   561,   561,   660,  1059,   454,   111,   188,   244,   246,
     661,  1055,  1055,    35,  1055,   399,   399,   701,   701,   701,
     701,   208,   702,  1067,  1055,   376,   796,   327,   376,   192,
      52,   368,  1055,   142,   548,   453,   550,   246,   516,   102,
     246,   355,   358,   516,   386,  1055,  1069,   331,   620,  1055,
     519,   675,  1072,   273,   339,   376,   796,   327,  1055,   376,
     376,   376,   327,   161,   262,   358,   684,   685,   161,   262,
     692,   693,   376,   376,   327,   454,   454,   454,   454,   457,
     442,   309,  1055,   453,   418,   643,  1065,  1064,  1064,  1064,
    1055,  1055,  1055,    52,   368,  1055,  1055,  1055,  1055,  1055,
    1055,   154,   154,   311,   154,   175,  1067,  1055,  1055,  1067,
    1055,  1055,  1055,  1055,  1055,  1055,   144,  1055,    70,   513,
     142,    24,    44,   386,  1069,  1055,   618,  1055,  1055,   454,
     202,   708,   202,   202,   708,   708,   202,   708,   464,   527,
     594,   660,   418,   420,  1053,   453,   701,  1055,   984,   112,
     177,   111,   251,   206,  1053,   768,   294,   664,   665,  1069,
     604,   453,   555,   187,   571,   546,  1068,  1068,   959,   453,
     517,  1068,   642,  1067,   175,  1053,   422,   154,   653,   454,
     457,   958,   616,   454,   586,    35,   256,   453,   862,   545,
     547,   549,   557,  1069,   572,   571,    75,   368,   574,   890,
     581,   579,   574,  1064,  1059,   741,   759,   983,   983,   457,
     453,   763,   386,   457,   672,   376,   453,   594,   454,   452,
     512,  1057,  1057,   512,   512,   512,   512,   336,  1054,  1054,
    1054,   590,   164,   724,   454,  1055,   102,   731,   159,   202,
     251,   712,  1064,   202,   202,   712,   202,   712,   983,   454,
     454,  1032,   454,   983,   159,   122,   124,   256,   453,   454,
     425,   992,  1019,   303,    52,   416,   416,   454,   983,   244,
     983,   457,   991,   961,   983,   983,   983,  1022,   454,   983,
      32,    32,   983,   983,   135,   454,   454,   983,  1005,  1069,
     454,   983,  1053,  1053,  1053,  1053,   939,   940,   453,   454,
    1069,   453,   936,   205,   269,   942,   936,   942,   205,   941,
     942,   205,   367,   947,   453,  1069,   453,   267,  1020,    52,
     170,   926,   454,   454,   454,  1021,  1064,   926,  1064,   778,
     256,  1050,   890,   868,   260,   453,   870,   442,   884,   871,
     386,   454,   376,   719,   159,   660,   983,   454,   457,   418,
      70,   744,   744,   454,   454,   768,   112,   177,   186,   111,
     401,   512,   959,  1057,  1057,  1055,  1055,  1055,  1055,  1055,
    1068,  1055,   548,   617,   621,   251,   251,  1065,  1069,   959,
     512,   512,   442,    52,   368,  1055,  1055,  1055,  1055,  1067,
    1055,  1055,  1063,  1063,   959,   457,  1063,  1063,   457,  1067,
    1055,  1055,   802,   245,   675,   376,   983,    64,  1068,  1055,
     376,   376,  1054,  1054,   701,  1054,   142,  1055,   701,  1064,
    1064,   959,   512,   512,   202,   708,   708,   708,   708,   453,
     528,   529,   399,   533,   534,   161,   191,   161,   159,   659,
     983,   246,   552,   768,   560,   399,   575,  1061,    32,   141,
     181,   542,   139,   182,   453,   336,   399,   561,    35,   643,
     483,   246,   453,  1055,   128,   654,   414,   656,  1064,   517,
     890,   701,   542,   579,   454,   457,   418,   573,   572,   114,
     127,   287,  1055,   418,   822,    35,   159,   260,   453,  1064,
     756,   769,   770,  1070,   768,   959,   154,  1053,   159,   376,
     787,   189,   595,   512,   512,   512,  1055,   263,   200,   512,
     723,   712,   712,   712,   712,   454,   984,   159,   453,  1022,
     453,   454,   457,   454,   985,   303,   454,   404,   352,   454,
     454,   454,   983,   983,   983,   454,   278,  1006,   454,   950,
     951,   988,   938,   453,  1054,   936,   260,   399,   943,   936,
     205,   936,  1061,   957,   453,   957,  1069,   905,    91,   168,
     322,   453,   920,   921,   922,   923,   924,   925,   983,   983,
     417,  1000,   905,  1000,   454,   887,    81,   742,   743,   123,
     453,   891,  1048,   723,   260,   723,   454,   768,   565,   262,
     778,   701,   701,   745,   745,   304,   768,   575,   454,   376,
     339,   877,   454,   457,   513,   675,  1068,  1055,   376,   453,
    1061,   778,   685,   453,   453,   693,  1055,   454,   453,   339,
     877,  1055,  1055,   418,   439,   839,   311,   839,   839,   154,
     513,   708,   535,   536,  1072,    48,    90,   115,   131,   135,
     155,   158,   171,   251,   259,   296,   530,   464,   116,   727,
      35,   783,   783,  1053,   660,   454,   575,   229,   563,   184,
     453,   665,   294,   453,   454,    26,    74,    82,   110,   185,
     358,   556,   556,  1052,  1055,  1057,   454,   890,   142,   616,
     323,   354,   655,   453,   141,    35,   579,   543,   454,   547,
     264,   574,   573,   324,   324,    56,    64,   221,   890,   701,
    1053,   742,   758,   454,   457,   386,   954,   350,   350,   454,
     594,   244,   403,   596,   597,  1055,   512,   984,  1022,   454,
     993,  1019,    52,   244,   435,    52,   905,   454,   457,    35,
     952,  1054,   454,   983,   453,   936,   943,   453,   454,   957,
     454,   454,   453,   340,   453,   454,   457,  1001,  1002,  1069,
     454,  1055,   454,   457,   247,   397,   725,   736,   512,   744,
     575,   453,   746,   746,  1053,   575,   660,  1055,   368,   621,
     399,   514,   339,   877,  1055,  1022,   750,   154,   688,   777,
    1022,  1022,   983,   368,   700,   701,   700,   701,  1054,   512,
     454,   457,   446,   453,   493,   537,   590,   836,  1064,   836,
     246,   251,   296,   836,   836,   528,  1064,   783,    38,   179,
     154,   244,   559,   160,   277,   345,   260,   567,   568,   569,
     368,   454,  1061,     5,   666,   571,   454,   616,   148,   687,
     517,   822,  1053,   983,   294,   890,   572,   571,   550,   574,
      64,   263,    64,   579,   741,   454,   763,   769,   959,   123,
     418,   418,   403,   594,   616,   454,   454,   454,   303,   404,
    1019,   297,   324,  1007,   953,   950,   453,   454,  1054,  1019,
     454,  1019,   453,  1019,   921,   457,    35,   954,   743,   339,
     159,   745,   415,   566,   778,   747,   747,   560,   660,  1055,
     983,   368,   454,   266,   329,   301,   689,   688,   454,   454,
     454,  1055,   839,   536,   493,   538,   539,  1064,  1064,   251,
     561,   446,   561,  1064,  1064,   128,   186,   114,   397,   260,
     569,   260,   568,  1055,   453,   454,   457,   336,   701,    35,
      35,   453,   454,  1061,   822,   573,   572,   263,   263,   453,
     517,   768,    27,   195,   810,   161,   161,    46,    92,   388,
     983,  1008,  1009,  1008,   454,   957,   454,   454,   454,   920,
     454,  1002,  1004,   880,   723,   746,   453,   660,   454,   563,
     877,  1055,  1061,    52,   689,   877,   701,   454,   457,   561,
     323,    55,   244,   315,   339,   570,   570,   454,     5,  1055,
     684,   890,   453,   574,   573,   742,   574,   247,   453,   805,
     807,   812,   864,   872,   879,   890,   727,   727,  1009,   323,
     153,   285,   153,   285,   454,   310,   948,   454,   954,   512,
     747,   983,   567,   877,   750,   701,   539,   656,    21,   109,
     251,   616,   822,     4,   657,   658,  1063,  1064,  1072,   574,
     454,   954,   806,   807,   808,   891,   892,   457,   457,    32,
     453,   454,   660,   141,   454,   457,   517,   454,   456,   376,
     159,  1009,   983,   294,   658,   574,   808,   350,   350,   454,
    1061,   954,   418,   418,   453,   161,   161,   657,   727,   727,
     454
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   459,   460,   461,   461,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   463,   464,   464,   464,   465,   465,   466,   466,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   468,   468,
     468,   468,   468,   468,   469,   470,   471,   471,   472,   472,
     473,   474,   474,   475,   475,   476,   476,   477,   478,   479,
     479,   480,   480,   481,   481,   481,   481,   482,   482,   483,
     483,   484,   484,   484,   484,   484,   484,   485,   485,   485,
     486,   486,   486,   487,   487,   487,   487,   488,   488,   488,
     488,   488,   488,   488,   488,   488,   488,   488,   489,   489,
     490,   490,   491,   491,   492,   492,   492,   492,   493,   493,
     493,   493,   494,   494,   494,   494,   494,   494,   494,   495,
     495,   495,   496,   496,   497,   498,   498,   498,   498,   499,
     499,   500,   500,   501,   501,   502,   502,   502,   502,   502,
     503,   504,   504,   505,   505,   506,   507,   507,   507,   507,
     507,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   509,   509,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   511,   511,   512,   512,   512,   513,   513,   514,   514,
     515,   515,   515,   515,   516,   517,   517,   518,   518,   519,
     519,   519,   519,   520,   521,   521,   522,   522,   522,   522,
     523,   523,   524,   524,   525,   525,   526,   526,   527,   527,
     527,   528,   528,   529,   529,   530,   530,   530,   530,   530,
     530,   530,   530,   530,   530,   530,   530,   530,   530,   531,
     531,   532,   532,   533,   533,   534,   534,   535,   535,   536,
     537,   537,   537,   537,   537,   538,   538,   539,   540,   540,
     540,   540,   541,   541,   541,   541,   541,   541,   541,   541,
     542,   542,   543,   543,   544,   544,   545,   545,   546,   546,
     546,   547,   547,   548,   549,   550,   550,   551,   551,   551,
     551,   552,   552,   552,   552,   552,   552,   552,   553,   553,
     553,   553,   554,   555,   555,   555,   556,   556,   556,   556,
     556,   556,   557,   557,   558,   558,   558,   558,   558,   558,
     558,   559,   559,   560,   560,   561,   561,   562,   563,   563,
     563,   563,   564,   564,   565,   565,   566,   566,   567,   567,
     567,   567,   567,   568,   569,   570,   570,   570,   570,   570,
     571,   571,   572,   572,   572,   572,   573,   573,   573,   573,
     574,   574,   575,   575,   576,   577,   577,   578,   579,   579,
     579,   580,   580,   581,   582,   582,   583,   584,   584,   585,
     585,   586,   586,   587,   587,   588,   588,   588,   588,   588,
     588,   588,   588,   588,   588,   588,   588,   589,   589,   590,
     590,   590,   590,   591,   591,   592,   592,   593,   593,   594,
     594,   595,   595,   596,   596,   597,   597,   598,   598,   599,
     599,   600,   601,   601,   602,   602,   603,   603,   604,   604,
     605,   605,   605,   605,   606,   607,   607,   608,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   610,   611,   611,   611,   611,   612,
     612,   613,   613,   614,   614,   615,   615,   616,   616,   617,
     617,   618,   619,   619,   620,   620,   620,   620,   621,   622,
     623,   624,   625,   625,   626,   626,   627,   627,   628,   628,
     629,   629,   629,   630,   630,   631,   631,   632,   633,   633,
     634,   634,   635,   636,   636,   637,   637,   638,   639,   640,
     641,   641,   642,   642,   643,   643,   644,   644,   645,   645,
     646,   646,   647,   647,   647,   647,   647,   648,   649,   649,
     650,   650,   650,   651,   651,   652,   652,   652,   652,   652,
     653,   653,   654,   654,   655,   655,   656,   656,   657,   657,
     657,   658,   658,   658,   658,   659,   659,   660,   660,   661,
     661,   661,   661,   661,   661,   662,   662,   663,   663,   664,
     664,   665,   666,   666,   667,   668,   668,   668,   668,   669,
     670,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   671,   672,   673,   673,   674,   674,
     675,   675,   675,   675,   675,   676,   677,   677,   678,   679,
     679,   680,   680,   681,   681,   681,   682,   682,   683,   684,
     684,   685,   685,   685,   685,   685,   686,   686,   687,   687,
     688,   688,   688,   689,   689,   690,   691,   691,   692,   692,
     693,   693,   694,   694,   695,   695,   696,   697,   698,   698,
     698,   698,   698,   698,   698,   698,   699,   699,   699,   699,
     699,   699,   699,   699,   699,   699,   699,   699,   699,   699,
     699,   699,   700,   700,   701,   701,   702,   702,   703,   703,
     704,   705,   705,   705,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   708,   708,   709,   709,   709,   709,
     709,   709,   709,   710,   710,   711,   711,   711,   711,   711,
     711,   711,   711,   711,   711,   711,   712,   712,   713,   713,
     714,   714,   714,   714,   714,   714,   714,   714,   714,   714,
     714,   714,   714,   714,   714,   714,   715,   715,   716,   716,
     717,   718,   718,   719,   719,   719,   719,   719,   720,   720,
     721,   721,   721,   721,   722,   722,   722,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   722,   722,   722,   722,
     723,   723,   724,   724,   725,   725,   726,   726,   727,   728,
     729,   729,   730,   730,   731,   731,   732,   733,   733,   734,
     734,   734,   735,   735,   735,   736,   736,   736,   736,   737,
     737,   738,   738,   739,   739,   740,   740,   741,   741,   742,
     742,   743,   743,   743,   744,   744,   745,   745,   746,   746,
     746,   747,   747,   747,   748,   748,   748,   749,   749,   750,
     750,   751,   751,   752,   752,   753,   753,   754,   754,   754,
     754,   754,   755,   755,   755,   755,   755,   756,   757,   758,
     758,   758,   759,   759,   759,   760,   761,   761,   761,   761,
     762,   762,   763,   763,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   764,   764,   764,   764,
     765,   765,   765,   765,   765,   766,   766,   767,   767,   768,
     768,   769,   770,   770,   771,   772,   772,   773,   773,   774,
     774,   775,   775,   776,   776,   777,   777,   777,   777,   778,
     778,   779,   780,   780,   781,   781,   782,   782,   782,   783,
     783,   783,   784,   785,   785,   786,   787,   787,   787,   787,
     788,   789,   789,   789,   789,   790,   790,   791,   791,   791,
     792,   792,   793,   794,   794,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   796,   796,   797,   797,   798,   798,   798,
     798,   799,   799,   799,   799,   799,   799,   799,   799,   799,
     799,   799,   799,   799,   799,   799,   799,   799,   799,   799,
     799,   799,   799,   799,   799,   800,   801,   801,   802,   802,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   804,
     805,   805,   805,   806,   806,   807,   807,   807,   807,   807,
     808,   808,   809,   809,   809,   809,   810,   810,   810,   811,
     811,   812,   813,   813,   814,   815,   815,   816,   816,   816,
     816,   816,   816,   816,   816,   816,   816,   816,   816,   816,
     816,   817,   817,   817,   818,   818,   818,   818,   818,   819,
     819,   819,   820,   820,   821,   821,   821,   821,   822,   822,
     822,   822,   823,   824,   825,   825,   826,   826,   827,   827,
     827,   828,   828,   828,   828,   828,   828,   828,   829,   829,
     830,   830,   830,   831,   832,   832,   833,   833,   834,   835,
     835,   835,   835,   835,   835,   835,   836,   836,   837,   838,
     838,   838,   838,   838,   838,   839,   839,   840,   841,   841,
     841,   842,   842,   843,   843,   843,   843,   843,   844,   844,
     845,   845,   845,   845,   845,   846,   846,   847,   847,   848,
     848,   849,   849,   850,   850,   851,   851,   852,   852,   852,
     852,   853,   853,   853,   853,   853,   853,   853,   853,   853,
     854,   854,   855,   856,   856,   857,   857,   857,   858,   859,
     859,   860,   860,   860,   860,   861,   861,   862,   862,   863,
     863,   863,   863,   864,   865,   865,   866,   866,   866,   867,
     867,   868,   869,   869,   869,   870,   870,   870,   871,   871,
     872,   873,   873,   874,   875,   875,   876,   876,   876,   876,
     876,   876,   876,   876,   877,   877,   878,   878,   878,   879,
     880,   880,   881,   881,   882,   883,   883,   884,   885,   885,
     886,   887,   888,   888,   888,   888,   888,   889,   889,   889,
     890,   890,   891,   891,   892,   892,   892,   892,   892,   892,
     892,   892,   893,   893,   894,   894,   894,   894,   894,   894,
     894,   895,   895,   895,   896,   896,   897,   898,   898,   899,
     899,   900,   900,   900,   900,   900,   900,   900,   900,   900,
     901,   901,   902,   902,   902,   903,   903,   904,   904,   905,
     905,   906,   907,   907,   908,   908,   909,   909,   909,   909,
     910,   910,   911,   911,   911,   912,   912,   913,   913,   914,
     915,   915,   915,   916,   917,   917,   918,   918,   919,   919,
     920,   920,   921,   921,   921,   921,   921,   922,   923,   924,
     925,   926,   926,   927,   927,   928,   928,   929,   929,   930,
     931,   931,   931,   931,   932,   932,   933,   933,   934,   934,
     935,   935,   936,   936,   936,   936,   936,   936,   936,   936,
     937,   937,   937,   937,   937,   937,   938,   938,   938,   938,
     939,   939,   940,   940,   940,   940,   940,   941,   941,   941,
     941,   942,   942,   943,   943,   944,   944,   944,   944,   945,
     945,   946,   946,   946,   947,   948,   948,   949,   949,   950,
     951,   951,   952,   952,   953,   953,   954,   954,   955,   955,
     955,   956,   956,   957,   957,   958,   959,   959,   959,   959,
     959,   959,   960,   960,   960,   961,   961,   961,   961,   961,
     961,   961,   962,   962,   962,   962,   963,   963,   964,   964,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   966,   966,   967,   967,   968,   968,   969,   970,   971,
     971,   972,   972,   973,   974,   975,   975,   975,   975,   975,
     975,   976,   976,   977,   977,   978,   978,   978,   978,   979,
     980,   980,   980,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   982,   982,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   983,   983,   983,   983,   983,   983,   983,   983,
     983,   983,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   984,   984,   984,   984,   984,
     984,   984,   984,   984,   984,   984,   984,   985,   985,   985,
     985,   985,   985,   985,   985,   985,   985,   985,   985,   985,
     985,   986,   986,   986,   986,   986,   986,   986,   987,   987,
     988,   988,   989,   989,   989,   989,   989,   989,   989,   989,
     989,   989,   989,   989,   989,   989,   989,   989,   989,   989,
     989,   989,   989,   989,   989,   989,   989,   989,   989,   989,
     989,   989,   989,   989,   989,   989,   989,   989,   989,   989,
     989,   989,   989,   989,   990,   990,   991,   991,   991,   991,
     992,   993,   993,   994,   994,   995,   995,   996,   996,   996,
     997,   997,   997,   997,   998,   998,   999,   999,  1000,  1000,
    1001,  1001,  1002,  1003,  1003,  1003,  1004,  1005,  1005,  1006,
    1006,  1007,  1007,  1007,  1008,  1008,  1009,  1009,  1009,  1009,
    1009,  1010,  1010,  1010,  1011,  1011,  1012,  1013,  1013,  1013,
    1014,  1014,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1016,  1016,  1017,  1017,  1018,  1018,
    1018,  1018,  1018,  1018,  1019,  1019,  1020,  1020,  1021,  1021,
    1021,  1022,  1022,  1023,  1023,  1023,  1024,  1024,  1025,  1025,
    1026,  1026,  1026,  1026,  1026,  1026,  1026,  1026,  1027,  1027,
    1028,  1029,  1029,  1030,  1030,  1030,  1030,  1030,  1030,  1031,
    1032,  1033,  1033,  1033,  1034,  1034,  1035,  1036,  1036,  1037,
    1038,  1038,  1039,  1039,  1040,  1040,  1041,  1041,  1041,  1041,
    1042,  1042,  1043,  1043,  1044,  1044,  1045,  1045,  1046,  1046,
    1047,  1047,  1048,  1049,  1049,  1050,  1050,  1051,  1051,  1051,
    1051,  1052,  1052,  1053,  1053,  1054,  1054,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1061,  1062,  1062,  1062,  1062,  1062,
    1062,  1062,  1062,  1062,  1062,  1062,  1062,  1062,  1063,  1064,
    1065,  1065,  1065,  1066,  1067,  1067,  1067,  1068,  1068,  1069,
    1069,  1069,  1070,  1070,  1070,  1071,  1071,  1071,  1071,  1072,
    1072,  1072,  1072,  1072,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1073,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     5,     1,     1,     0,     2,     0,     2,     0,     2,
       2,     3,     3,     1,     3,     3,     2,     1,     1,     2,
       2,     2,     3,     3,     5,     5,     0,     3,     5,     5,
       5,     5,     5,     3,     5,     3,     5,     5,     6,     1,
       1,     3,     5,     6,     4,     9,     7,     1,     0,     2,
       0,     1,     1,     1,     1,     1,     1,     2,     3,     3,
       2,     5,     1,     3,     3,     3,     3,     1,     3,     3,
       2,     2,     2,     2,     3,     3,     3,     3,     1,     3,
       1,     3,     1,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     5,     1,     1,     1,     1,
       1,     0,     1,     1,     2,     1,     2,     3,     2,     1,
       1,     2,     1,     2,     1,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     4,     6,    10,    13,     4,     6,    10,    13,     4,
       6,     4,     6,     5,     7,    11,    14,     1,     3,     2,
       5,     3,     6,     4,     6,     6,     6,     5,     5,     6,
       6,     4,     8,     4,     2,     4,     3,     6,     4,     3,
       3,     3,     3,     2,     2,     3,     4,     4,     3,     3,
       3,     3,     3,     3,     4,     4,     3,     2,     3,     2,
       2,     3,     3,     2,     2,     3,     4,     4,     4,     5,
       1,     3,     2,     1,     1,     0,     2,     0,     2,     0,
       1,     1,     1,     3,     3,     2,     0,     1,     3,     3,
       1,     5,     3,     4,     1,     3,     4,     6,     4,     8,
       2,     2,    11,     9,     1,     1,     1,     0,     1,     1,
       1,     1,     3,     2,     0,     1,     1,     1,     3,     3,
       1,     1,     3,     3,     3,     3,     4,     3,     2,     1,
       0,     2,     0,     3,     0,     1,     0,     1,     3,     2,
       1,     1,     1,     3,     0,     1,     3,     1,    11,    14,
      10,    13,     1,     1,     2,     2,     2,     2,     1,     0,
       1,     0,     3,     0,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     4,     4,     2,     0,     3,     1,     1,
       2,     2,     1,     3,     4,     5,     2,     5,     1,     2,
       2,     2,     3,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     3,     1,     5,     7,     3,     8,     4,     9,
      11,     2,     0,     3,     0,     1,     3,     1,     2,     2,
       2,     0,     1,     3,     3,     6,     4,     0,     1,     1,
       2,     2,     0,     3,     3,     2,     1,     1,     2,     2,
       4,     0,     2,     2,     2,     0,     3,     4,     4,     0,
       2,     0,     4,     0,     3,     7,    10,     5,     2,     3,
       0,     8,    11,     4,     1,     0,     6,     5,     8,     4,
       6,     1,     0,     1,     2,     2,     1,     2,     3,     2,
       2,     2,     2,     3,     3,     1,     3,     1,     0,     1,
       2,     2,     1,     1,     3,     6,    10,     1,     0,     1,
       2,     2,     0,     2,     2,     1,     0,     5,     7,     1,
       0,     7,     2,     0,     3,     5,     5,     8,     2,     0,
       2,     2,     2,     1,     5,     2,     0,     2,     7,     7,
      10,     6,     6,     6,     6,     7,     7,     9,     9,     6,
       7,     6,     8,     8,     8,     8,     6,     6,     7,     7,
       8,     6,     9,     6,     7,     2,     2,     2,     2,     1,
       2,     1,     0,     6,     8,     7,     6,     4,     0,     1,
       3,     4,     1,     3,     1,     2,     2,     2,     2,     1,
       1,    10,     2,     0,     2,     2,     1,     0,     4,     6,
       5,     4,     4,    11,    14,     5,     7,    11,     2,     1,
       4,     0,     8,     1,     1,     7,     9,     8,     9,     8,
       6,     8,     4,     0,     5,     0,     2,     0,     2,     0,
       2,     0,     1,     1,     1,     1,     1,     8,    15,    20,
       1,     1,     2,     1,     3,     1,     1,     1,     3,     1,
       3,     0,     1,     0,     1,     1,     4,     0,     1,     3,
       0,     1,     1,     1,     1,     2,     0,     0,     2,     2,
       1,     2,     2,     2,     2,     6,     8,    11,    13,     1,
       3,     5,     1,     3,     5,     1,     2,     2,     1,     8,
       4,     5,     4,     4,     4,     3,     7,     8,     6,     6,
       6,     6,     6,     4,     5,     3,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     3,     1,
       0,     1,     3,     7,     9,     9,     3,     0,    13,     1,
       3,     5,     6,     4,     7,     2,     1,     0,     2,     0,
       2,     4,     0,     1,     0,     6,     8,     8,     1,     3,
       5,     5,     7,     9,     7,     9,     5,     6,     6,     4,
       4,     6,     4,     6,     5,     7,     1,     1,     1,     2,
       1,     2,     2,     2,     1,     1,     1,     1,     3,     3,
       3,     3,     1,     3,     1,     2,     2,     3,     1,     3,
       5,     2,     2,     0,     6,     6,     6,     7,     7,     7,
       8,     9,     8,     8,     6,     9,     8,     9,     9,     7,
      10,     7,     2,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     1,     3,     2,
       3,     3,     3,     3,     1,     1,     8,     8,     8,     9,
       9,     9,     9,     2,     0,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     2,     2,
       1,     2,     3,     3,     3,     3,     4,     4,     3,     3,
       3,     4,     4,     3,     4,     4,     1,     1,     1,     0,
       7,     7,    10,     1,     1,     2,     4,     5,     1,     3,
       2,     2,     2,     2,     1,     2,     2,     4,     3,     2,
       2,     2,     2,     3,     2,     2,     2,     5,     5,     5,
       1,     3,     1,     2,     3,     0,     1,     3,     2,     6,
       6,     9,     3,     0,     3,     0,     5,     2,     0,     3,
       3,     3,     7,     7,    10,     1,     1,     1,     1,    14,
      17,     1,     0,     1,     0,     1,     0,     2,     0,     1,
       3,     5,     5,     7,     2,     0,     1,     0,     1,     1,
       0,     2,     2,     0,     9,    12,     7,     2,     0,     3,
       2,     1,     3,     3,     2,     1,     3,     3,     3,     2,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       4,     5,     1,     3,     3,     1,     3,     3,     5,     6,
       1,     3,     1,     2,     4,     5,     1,     1,     1,     1,
       3,     3,     2,     2,     1,     2,     2,     2,     1,     2,
       2,     2,     2,     1,     1,     1,     3,     3,     5,     2,
       0,     2,     1,     3,     5,     1,     2,     1,     0,     5,
       7,     5,     7,     5,     7,     3,     5,     5,     5,     1,
       3,     2,     1,     2,     1,     2,    11,    10,    10,     2,
       2,     0,     9,     2,     0,    10,    11,    11,     5,     5,
       8,     3,     3,     6,     6,     1,     1,     1,     1,     1,
       1,     3,     1,     5,     5,     7,     6,     6,     6,     6,
       8,     8,     6,     6,     7,     9,     9,     8,    10,     6,
       6,     6,     8,     6,     8,     6,     8,     7,     9,     6,
       8,     7,     9,     8,    10,     9,    11,     8,    10,     9,
      11,     8,     8,     7,     6,     6,     6,     8,     8,     8,
       8,     6,     9,     1,     0,     2,     0,     7,     9,     8,
       7,     7,     6,     6,     6,     6,     6,     7,     9,     9,
       6,     8,     8,     8,     8,     8,     6,     8,     6,     8,
       7,     9,     7,     9,     6,     8,     1,     3,     3,     3,
       7,     6,     6,     6,     6,     6,     7,     7,     7,     9,
       9,     6,     6,     6,     8,     8,     8,     6,     7,    13,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     0,     6,
       8,     3,     2,     0,     2,     2,     2,     2,     3,     3,
       2,     2,     2,     2,     3,     2,     5,     4,     3,     3,
       3,     1,     1,     0,     3,     2,     2,     1,     2,     1,
       3,     2,     1,     0,     9,    11,    12,    14,     3,     4,
       4,     0,     2,     5,     1,     0,     1,     2,     3,     3,
       3,     1,     2,     1,     1,     1,     1,     1,     1,     0,
       5,     4,     6,     4,     3,     5,     4,     4,     6,     4,
       6,     6,     5,     7,     9,     6,     1,     0,     6,    11,
      11,    11,    13,     9,    11,     1,     1,    10,     4,     2,
       5,     2,     0,     4,     5,     5,     4,     6,     1,     3,
       1,     1,     1,     1,     1,     2,     4,     1,     1,     1,
       0,     1,     0,     1,     0,     3,     0,     2,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     2,     1,     1,     1,     1,     0,     5,     3,
       0,     1,     1,     1,     1,     3,     9,     3,     0,     2,
       3,     2,     3,     7,     1,     3,     1,     4,     2,     1,
       3,     2,     8,     5,     0,     4,     3,     0,     2,     0,
       7,     2,     0,     5,     3,     0,     2,     2,     2,     3,
       1,     3,     1,     2,     1,     0,     1,     2,     0,     8,
       1,     3,     1,     1,     3,     5,     5,     2,     1,     3,
       7,     1,     0,     3,     2,     2,     2,     0,     2,     2,
       1,     1,     3,     3,     1,     2,     4,     4,     2,     3,
       5,     5,     1,     1,     9,     9,     1,     2,     4,     4,
       4,     2,     2,     3,     1,     3,     6,     1,     0,     2,
       0,     3,     3,     4,     4,     4,     4,     3,     2,     1,
       1,     0,     1,     1,     0,     1,     5,     1,     0,     1,
       0,     3,     1,     3,     4,     3,     2,     2,     1,     1,
       1,     0,     2,     4,     5,     2,     3,     1,     1,     1,
       1,     3,     0,     1,     1,     1,     1,     1,     3,     0,
       1,     3,     1,     1,     1,     1,     1,     2,     4,     4,
       5,     2,     0,     1,     3,     1,     0,     1,     2,     3,
       2,     4,     2,     3,     2,     0,     2,     3,     2,     0,
       1,     3,     2,     3,     2,     3,     2,     3,     1,     4,
       3,     4,     5,     4,     5,     4,     5,     2,     4,     1,
       1,     0,     1,     4,     5,     4,     0,     2,     2,     2,
       1,     1,     0,     4,     2,     1,     2,     2,     4,     1,
       3,     1,     2,     3,     6,     4,     0,     2,     6,     2,
       1,     3,     4,     0,     2,     0,     2,     0,     2,     4,
       0,     1,     0,     1,     3,     3,     2,     3,     5,     6,
       2,     3,     3,     4,     0,     1,     1,     1,     1,     1,
       2,     4,     1,     1,     1,     1,     2,     3,     3,     0,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       1,     3,     0,     1,     1,     1,     1,     5,     2,     1,
       1,     1,     1,     5,     2,     2,     2,     1,     3,     3,
       2,     1,     0,     3,     0,     5,     2,     5,     2,     1,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     0,     1,     4,     1,
       3,     3,     5,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     3,     2,     2,     3,     5,     4,     6,     3,     5,
       4,     6,     4,     6,     5,     7,     3,     2,     4,     2,
       3,     3,     4,     3,     4,     3,     4,     5,     6,     6,
       7,     6,     7,     6,     7,     3,     4,     4,     6,     2,
       3,     4,     1,     3,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     5,     6,     6,     7,     3,     4,     1,     1,     2,
       4,     1,     1,     1,     2,     2,     2,     2,     1,     1,
       4,     3,     5,     6,     8,     6,     6,     4,     4,     1,
       1,     1,     5,     1,     1,     4,     1,     4,     1,     4,
       1,     4,     1,     1,     1,     1,     1,     1,     6,     4,
       4,     4,     4,     6,     5,     5,     5,     4,     6,     4,
       4,     4,     4,     5,     7,     7,     9,     5,     4,     6,
       5,     7,     7,     7,     2,     3,     3,     3,     4,     0,
       4,     1,     3,     3,     1,     1,     1,     2,     2,     0,
       2,     4,     4,     6,     5,     0,     5,     0,     2,     0,
       1,     3,     3,     2,     2,     0,     6,     1,     0,     3,
       0,     2,     2,     0,     1,     4,     2,     2,     2,     2,
       2,     4,     3,     5,     4,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     4,     1,     4,
       1,     2,     1,     2,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     2,     1,     3,     3,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       2,     3,     0,     3,     3,     2,     2,     1,     0,     2,
       2,     3,     2,     1,     1,     3,     5,     1,     2,     4,
       2,     0,     1,     0,     1,     2,     2,     2,     3,     5,
       1,     0,     1,     2,     0,     2,     1,     0,     1,     1,
       1,     3,     3,     1,     0,     1,     3,     3,     2,     1,
       1,     1,     3,     1,     2,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     6,     2,     3,     5,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 735 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 23070 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 742 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 23081 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 749 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1((yyvsp[0].node));
					else
						(yyval.list) = NIL;
				}
#line 23092 "gram.c" /* yacc.c:1646  */
    break;

  case 130:
#line 884 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 23098 "gram.c" /* yacc.c:1646  */
    break;

  case 131:
#line 895 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23110 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 905 "gram.y" /* yacc.c:1646  */
    {}
#line 23116 "gram.c" /* yacc.c:1646  */
    break;

  case 133:
#line 906 "gram.y" /* yacc.c:1646  */
    {}
#line 23122 "gram.c" /* yacc.c:1646  */
    break;

  case 134:
#line 907 "gram.y" /* yacc.c:1646  */
    {}
#line 23128 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 916 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23134 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 917 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23140 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 921 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23146 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23152 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 23161 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 932 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
#line 23169 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 936 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 23178 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 941 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 23187 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 946 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
#line 23195 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 950 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 23203 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 954 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)));
				}
#line 23211 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 959 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 23219 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 963 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 23268 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1010 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 23274 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1013 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 23282 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1017 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list));
				}
#line 23290 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1021 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 23298 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1025 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 23306 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1029 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 23314 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1043 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23326 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1061 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].node);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 23338 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1071 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23344 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1072 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23350 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1077 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].node);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 23362 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1085 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 23374 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1103 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].node);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 23386 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1115 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].node);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 23398 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1123 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 23410 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1144 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23421 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1151 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23432 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1168 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23443 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1175 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 23454 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1192 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23466 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1210 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].node);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 23479 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1220 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 23485 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1221 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 23491 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1234 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23502 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1241 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23513 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1258 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].node);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 23527 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1268 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 23541 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1278 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].node);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 23560 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1293 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 23579 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1310 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23585 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1311 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23591 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1316 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 23601 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1322 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23607 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1350 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 23617 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1356 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 23627 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1362 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 23637 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1371 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 23649 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1379 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 23661 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1391 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 23673 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1399 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 23685 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1407 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 23696 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1414 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 23707 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1422 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 23713 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1424 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 23724 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1432 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 23739 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1443 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 23751 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1451 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23763 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1459 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 23778 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1470 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23790 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1478 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23802 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1486 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 23813 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1493 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23825 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1502 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 23837 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1511 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23843 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1513 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 23849 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1516 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 23855 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1517 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 23861 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1521 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 23867 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1523 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 23873 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1526 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 23879 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1527 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 23885 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1528 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 23891 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1529 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 23897 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1533 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 23903 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1534 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 23909 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1535 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 23915 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1541 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23921 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1554 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 23929 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1558 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 23937 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1562 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 23956 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1577 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 23967 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1583 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 23973 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1584 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 23979 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1585 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 23985 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1589 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23991 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1590 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23997 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1591 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24003 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1595 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24009 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1596 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24015 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1600 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 24021 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1604 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 24027 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1606 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 24038 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1613 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 24049 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1620 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 24060 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1630 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 24071 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1637 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 24081 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1646 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 24087 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1647 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 24093 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1652 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 24099 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1653 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 24105 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1659 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24115 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1665 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 24125 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1671 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 24135 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1677 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 24145 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1683 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 24155 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1693 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 24166 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1702 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24172 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1703 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24178 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1707 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 24184 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1708 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24190 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1717 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 24199 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1732 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 24209 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1738 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 24219 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1744 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 24229 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1750 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 24239 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1756 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 24249 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1775 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24262 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1784 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24275 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1793 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24290 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1804 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24305 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1815 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24318 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1824 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24331 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1833 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24346 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1844 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24361 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1855 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24374 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1864 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24387 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1873 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24400 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1882 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24413 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1891 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24426 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1900 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24439 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1909 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24454 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1920 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 24469 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 24475 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 24481 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1940 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24493 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1949 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24505 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1958 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24517 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1967 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24529 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1976 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 24541 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1985 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 24552 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1993 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 24563 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2001 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 24575 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2010 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24587 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2019 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24599 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2028 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 24611 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2037 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 24624 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2047 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 24637 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2060 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 24655 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2075 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24667 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2084 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 24678 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2092 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 24696 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2107 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24707 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2115 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 24720 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2125 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 24733 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2135 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 24743 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2142 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 24753 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2149 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24764 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2157 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 24775 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2165 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
#line 24785 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2172 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
#line 24795 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2179 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24806 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2187 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24817 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2195 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24828 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2203 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 24838 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2210 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 24848 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2217 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24859 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2225 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 24869 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2232 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 24879 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2239 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24890 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2247 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24901 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2255 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24912 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2263 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24923 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2271 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 24934 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2279 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 24945 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2287 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 24958 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2297 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 24968 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2304 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 24979 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2312 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24990 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2320 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25001 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2328 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25012 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2336 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 25023 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2344 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 25033 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2351 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 25043 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2358 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 25053 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2365 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 25063 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2371 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25074 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2380 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25080 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2381 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25086 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2385 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 25092 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2386 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 25098 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2387 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 25104 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2392 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 25116 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2399 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25122 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2403 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25128 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2404 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25134 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2409 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 25145 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2416 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 25156 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2423 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 25167 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2430 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25178 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2439 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25184 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2442 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25190 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2443 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25196 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2447 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25202 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2448 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25208 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2454 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 25216 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2458 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 25224 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2462 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC);
				}
#line 25233 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2467 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC);
				}
#line 25241 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2482 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 25255 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2494 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 25261 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2495 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 25267 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2501 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 25279 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2510 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 25292 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2520 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 25305 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2530 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 25324 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2556 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 25334 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2562 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 25344 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2596 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-5].boolean);
					n->is_program = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-6].defelt))
						n->options = lappend(n->options, (yyvsp[-6].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 25376 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2624 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *)n;
				}
#line 25399 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2645 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25405 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2646 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25411 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2650 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25417 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2651 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25423 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2660 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25429 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2661 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25435 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2662 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25441 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2665 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25447 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2666 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25453 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2671 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 25459 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2672 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25465 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2677 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 25473 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2681 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 25481 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2685 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
#line 25489 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2689 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 25497 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2693 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
				}
#line 25505 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2697 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
#line 25513 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2701 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
#line 25521 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
				}
#line 25529 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2709 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
				}
#line 25537 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2713 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
				}
#line 25545 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2717 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
#line 25553 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2721 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
				}
#line 25561 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list));
				}
#line 25569 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2729 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 25577 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2738 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 25585 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2741 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 25591 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2746 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 25599 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2749 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 25605 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2754 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 25613 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2757 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 25619 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2761 "gram.y" /* yacc.c:1646  */
    {}
#line 25625 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2762 "gram.y" /* yacc.c:1646  */
    {}
#line 25631 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2768 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 25639 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2772 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 25647 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2779 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 25655 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2785 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 25661 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2786 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 25667 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2787 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 25673 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2788 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 25679 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2789 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25685 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2794 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 25693 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2798 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 25701 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2805 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 25707 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2818 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-9].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 25726 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2835 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 25745 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2851 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-8].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->inhRelations = NIL;
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 25765 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2868 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->inhRelations = NIL;
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 25785 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2896 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 25791 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2897 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 25797 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2898 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 25803 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2899 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 25809 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2901 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 25820 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2908 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 25831 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2914 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 25837 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2915 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 25843 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2919 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25849 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2920 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25855 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2924 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25861 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2925 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25867 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2930 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 25875 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2934 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 25883 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2941 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 25891 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2945 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 25899 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2951 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25905 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2952 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25911 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2953 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25917 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2957 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25923 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2958 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 25929 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2962 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 25952 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2983 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 25974 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3003 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 25980 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3004 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25986 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3009 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 25998 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3016 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26004 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3017 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26010 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3019 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 26027 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3050 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 26038 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3057 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 26049 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3064 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26064 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3075 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26079 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3086 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 26095 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3098 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 26108 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3107 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 26127 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3140 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 26138 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3147 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 26149 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3154 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 26160 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3161 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 26171 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3172 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 26182 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3181 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 26188 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3182 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 26194 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3183 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 26200 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3187 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 26206 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3188 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 26212 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3189 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 26218 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3190 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 26224 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3191 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 26230 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3192 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 26236 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3202 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 26248 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3209 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26254 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3214 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 26271 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3228 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26289 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3242 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26307 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3257 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26325 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3271 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26343 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3287 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 26363 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3304 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 26385 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3323 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 26391 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3324 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 26397 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3328 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 26403 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3329 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26409 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3333 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26415 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3334 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26421 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3338 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 26429 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3344 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 26437 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3348 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 26449 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3356 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 26457 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3360 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 26465 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3366 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 26471 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3368 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 26477 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3372 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 26485 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3377 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 26493 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3383 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 26499 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3384 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 26505 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3395 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 26511 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3397 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 26517 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3399 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 26523 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3401 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 26529 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3403 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 26535 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3406 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 26541 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3409 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 26547 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3413 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 26553 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3414 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 26559 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3415 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 26565 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3416 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 26571 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3417 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 26577 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3420 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 26583 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3421 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26589 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3426 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26595 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3427 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(true)); }
#line 26601 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3428 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(false)); }
#line 26607 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26613 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3432 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 26619 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3433 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 26625 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3434 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 26631 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3435 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 26637 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3438 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26643 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3439 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26649 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3442 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26655 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3443 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26661 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3446 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26667 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3462 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 26684 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3475 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 26701 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3491 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 26716 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3504 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26722 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3505 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26728 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3506 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26734 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3519 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 26751 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3532 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 26768 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3548 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-3].range);
					(yyval.into)->colNames = (yyvsp[-2].list);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 26783 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3560 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 26789 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3561 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 26795 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3574 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 26807 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3594 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 26821 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3604 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 26835 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3617 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26847 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3625 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26859 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3635 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26865 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3636 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26871 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3639 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 26877 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3640 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26883 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3644 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value));
				}
#line 26891 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3648 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
#line 26899 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3652 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
#line 26907 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3656 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value));
				}
#line 26915 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3660 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value));
				}
#line 26923 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3664 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value));
				}
#line 26931 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3668 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
#line 26939 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
#line 26947 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3676 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list));
				}
#line 26955 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3680 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value));
				}
#line 26963 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3684 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
#line 26971 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3688 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value));
				}
#line 26979 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3693 "gram.y" /* yacc.c:1646  */
    {}
#line 26985 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3694 "gram.y" /* yacc.c:1646  */
    {}
#line 26991 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3698 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 26997 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3699 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 27003 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3701 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 27012 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3705 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 27018 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 27024 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3709 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 27030 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3722 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 27046 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3735 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 27061 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3748 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27067 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3749 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27073 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3757 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 27079 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3758 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 27085 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3762 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27091 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3763 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27097 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3767 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27103 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3768 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27109 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 3772 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27115 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3773 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27121 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3778 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27136 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 3789 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27150 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3801 "gram.y" /* yacc.c:1646  */
    {}
#line 27156 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 3802 "gram.y" /* yacc.c:1646  */
    {}
#line 27162 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3813 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].node);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27175 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 3823 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 27181 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3824 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 27187 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 3838 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 27198 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 3845 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 27209 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3862 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27221 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3870 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27233 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3881 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27239 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3883 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27245 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3888 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)));
				}
#line 27253 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3892 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 27261 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3896 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 27269 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3900 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(TRUE));
				}
#line 27277 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3912 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27288 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27294 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3924 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27300 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 3929 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 27308 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 3942 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_ACCESS_METHOD;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27321 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 3951 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 27335 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 3961 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-3].typnam));
					n->objargs = list_make1((yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 27349 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 3971 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27362 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 3980 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27375 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 3989 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = list_make1((yyvsp[0].typnam));
					(yyval.node) = (Node *)n;
				}
#line 27388 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 3998 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[0].funwithargs)->funcname;
					n->objargs = (yyvsp[0].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
#line 27402 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4008 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27415 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4017 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27429 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4027 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 27442 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4036 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 27455 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4045 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27468 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4054 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27481 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4063 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27494 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4072 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27507 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4081 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27520 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4090 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27533 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4099 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27546 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4108 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27559 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4117 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27572 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4126 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27585 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4135 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27598 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4144 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27611 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4153 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27624 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4162 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 27638 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4172 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[0].typnam));
					(yyval.node) = (Node *)n;
				}
#line 27651 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4190 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27663 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4200 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list)); }
#line 27669 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4201 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL); }
#line 27675 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4202 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list)); }
#line 27681 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4203 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL); }
#line 27687 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4207 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27693 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4208 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27699 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4212 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27705 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4213 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27711 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4224 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 27726 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4235 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 27741 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4255 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27753 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4263 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 27765 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 27771 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4275 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27777 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4280 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 27785 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4284 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 27793 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4291 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 27799 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4296 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 27807 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4300 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 27815 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4307 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 27823 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4311 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 27832 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4316 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 27841 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4321 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP);
				}
#line 27849 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4328 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 27857 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4334 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27863 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4339 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 27869 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4351 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27883 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4363 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27889 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4364 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27895 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4369 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27901 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4370 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27907 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4374 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27913 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4375 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27919 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4386 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 27934 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4397 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 27949 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4417 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 27962 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4426 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 27974 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4434 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27985 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4453 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28007 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4473 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28029 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4501 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28042 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4510 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28055 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4532 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 28070 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4545 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 28076 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4546 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 28082 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4551 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 28093 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4558 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 28104 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4574 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].node);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28116 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4584 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28122 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4585 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 28128 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4598 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].node);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 28140 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4606 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].node);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 28152 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4623 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[-3].node);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28164 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4647 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[-6].str);
					n->table = (yyvsp[-4].range);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 28179 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4662 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 28193 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4675 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_POLICY;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28208 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4686 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_POLICY;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28223 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4699 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 28229 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4700 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28235 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4704 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 28241 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4705 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28247 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4709 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28253 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4710 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 28259 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4714 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28265 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4715 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 28271 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4719 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28277 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4720 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 28283 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4724 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 28289 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4725 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 28295 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4726 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 28301 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4727 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 28307 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4728 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 28313 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4739 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = AMTYPE_INDEX;
					(yyval.node) = (Node *) n;
				}
#line 28325 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4760 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-12].str);
					n->relation = (yyvsp[-8].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-11].ival);
					n->events = intVal(linitial((yyvsp[-10].list)));
					n->columns = (List *) lsecond((yyvsp[-10].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 28347 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4781 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 28370 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4802 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 28376 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4803 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 28382 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4804 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 28388 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4809 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28394 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4811 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 28417 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4833 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 28423 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4835 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 28429 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 28435 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4839 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 28441 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4841 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 28447 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4846 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 28455 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4850 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 28467 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4860 "gram.y" /* yacc.c:1646  */
    {}
#line 28473 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4861 "gram.y" /* yacc.c:1646  */
    {}
#line 28479 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4865 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28485 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4866 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28491 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 4870 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 28497 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 4871 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28503 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 4875 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 28509 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 4876 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 28515 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 4877 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28521 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 4882 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 28529 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 4885 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 28535 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 4886 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 28541 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 4887 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 28547 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 4891 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 28553 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 4892 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 28559 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 4897 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 28565 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 4899 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 28593 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 4925 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 28599 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 4926 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 28605 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 4927 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 28611 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 4928 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 28617 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 4929 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 28623 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 4930 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 28629 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 4936 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28644 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 4947 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28659 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 4971 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 28672 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 4982 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 28685 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 4994 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28691 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 4996 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 28697 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5001 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list)); }
#line 28703 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5006 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 28709 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5008 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 28715 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5013 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 28726 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5022 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 28732 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5023 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 28738 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5024 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 28744 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5025 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 28750 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5039 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 28770 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5058 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 28786 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5081 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28800 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5091 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28815 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5102 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28829 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5112 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28843 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5122 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 28858 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5133 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 28871 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5142 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 28882 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5149 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28893 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5156 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28906 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5165 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28919 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5174 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28932 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5183 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28945 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5192 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28958 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5201 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 28971 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5211 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28977 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5214 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28983 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5215 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 28989 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5219 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 28997 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5223 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 29005 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5229 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 29011 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5230 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 29017 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5231 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 29023 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5232 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 29029 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5233 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 29035 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29041 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5239 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 29047 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5240 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 29053 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5249 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node));
				}
#line 29061 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5255 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29067 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5256 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29073 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5260 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 29079 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5262 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 29085 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5273 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 29099 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5283 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 29113 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5293 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 29127 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5304 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29133 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5305 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29139 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5323 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29154 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5336 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29160 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5337 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29166 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5342 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = NIL;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29180 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5353 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-3].list);
					n->args = (yyvsp[-2].list);
					n->number = (yyvsp[-4].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29194 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5363 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 29207 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5372 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-5].ival);
					n->class_args = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 29221 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5382 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 29232 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5390 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 29238 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5391 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29244 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5394 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29250 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5395 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29256 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5398 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29262 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5399 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29268 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5400 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29274 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5404 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 29292 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5417 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29298 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5423 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29309 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5433 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29322 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5442 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29335 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5453 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29341 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5454 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29347 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5459 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29359 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5467 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29371 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5479 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29385 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5489 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29399 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5502 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29413 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5512 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29427 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5534 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 29438 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5544 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29449 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5562 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 29464 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5573 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 29479 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5584 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29493 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5594 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29507 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5604 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29521 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5614 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29535 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5624 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 29550 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5635 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 29565 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5648 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 29571 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5649 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 29577 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5650 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 29583 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5651 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 29589 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5652 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 29595 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5653 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 29601 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5654 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 29607 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5655 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 29613 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5656 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 29619 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5657 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 29625 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5658 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 29631 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5659 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 29637 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5660 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 29643 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5661 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 29649 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5662 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 29655 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5663 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 29661 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5667 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 29667 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5668 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 29673 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5671 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 29679 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5672 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 29685 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5676 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 29691 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5678 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 29697 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5682 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(list_make1((yyvsp[0].typnam))); }
#line 29703 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), list_make1((yyvsp[0].typnam))); }
#line 29709 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5694 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 29721 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5704 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29727 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5705 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29733 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5706 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29739 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5741 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29752 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5750 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29765 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5759 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29778 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5768 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29791 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5777 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29804 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5786 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29817 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 5795 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29830 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 5804 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->objname = list_make1(makeTypeNameFromNameList((yyvsp[-2].list)));
					n->objargs = list_make1(makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29848 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 5818 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_POLICY;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29861 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 5827 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29874 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 5836 "gram.y" /* yacc.c:1646  */
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[-2].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29888 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 5846 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->objname = list_make1((yyvsp[-4].typnam));
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29901 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 5855 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29914 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 5864 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29926 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 5872 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29939 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 5881 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29952 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 5890 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-5].typnam));
					n->objargs = list_make1((yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29965 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 5899 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29978 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 5910 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 29984 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 5911 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 29990 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 5912 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 29996 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 5913 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 30002 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 5914 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 30008 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 5915 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 30014 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 5916 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 30020 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 5917 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 30026 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 5918 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 30032 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 5919 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 30038 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 5920 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 30044 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 5921 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 30050 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 5922 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 30056 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 5923 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 30062 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 5924 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 30068 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 5925 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 30074 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 5926 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 30080 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 5927 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 30086 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 5928 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 30092 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 5929 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 30098 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 5930 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 30104 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 5931 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 30110 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 5935 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30116 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 5936 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30122 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 5952 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30136 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 5963 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30150 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 5974 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[-2].typnam));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30164 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 5985 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30178 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 5996 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30192 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6007 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30206 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6018 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30220 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6029 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30226 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6030 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30232 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6034 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 30238 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6035 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 30244 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6036 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 30250 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6037 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 30256 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6038 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 30262 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6039 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 30268 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6040 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 30274 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6041 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 30280 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6042 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 30286 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6043 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 30292 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6044 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 30298 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6047 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30304 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6048 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30310 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6059 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 30320 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6065 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 30330 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6073 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30342 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6081 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30354 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6089 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30366 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6097 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30378 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6105 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30390 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6113 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 30402 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6121 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30414 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6129 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30426 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6137 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30438 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6145 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 30450 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6153 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30462 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6161 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30474 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6169 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 30486 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6177 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 30498 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6185 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 30510 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6193 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 30522 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6202 "gram.y" /* yacc.c:1646  */
    {}
#line 30528 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6203 "gram.y" /* yacc.c:1646  */
    {}
#line 30534 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6206 "gram.y" /* yacc.c:1646  */
    {}
#line 30540 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6207 "gram.y" /* yacc.c:1646  */
    {}
#line 30546 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6219 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 30562 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6235 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 30579 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6249 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 30596 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30602 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6276 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30608 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6278 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30614 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6280 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 30625 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6287 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 30636 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6295 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 30642 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6296 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 30648 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6300 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 30659 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6307 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 30670 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6314 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 30681 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6321 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 30692 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6335 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30704 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6343 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30716 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6351 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30728 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6359 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30740 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6367 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30752 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6375 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30764 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6383 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30776 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6391 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30788 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6399 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30800 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6407 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30812 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6415 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30824 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6423 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30836 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6431 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30848 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6439 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30860 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6447 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30872 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6455 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 30884 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6466 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30890 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6467 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30896 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6471 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30902 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6472 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30908 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6477 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30914 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6478 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30920 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6482 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].funwithargs)); }
#line 30926 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6484 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].funwithargs)); }
#line 30932 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6489 "gram.y" /* yacc.c:1646  */
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[-1].list);
					n->funcargs = extractArgTypes((yyvsp[0].list));
					(yyval.funwithargs) = n;
				}
#line 30943 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6505 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 30957 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6518 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 30971 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6528 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 30985 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6539 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30991 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6540 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30997 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6543 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31003 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6544 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31009 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6555 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 31020 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6564 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31026 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6565 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31032 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6570 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list));
				}
#line 31040 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6574 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 31048 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6578 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 31056 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6590 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 31072 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6603 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 31089 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6617 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 31106 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6632 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 31112 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6633 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 31118 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6634 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 31124 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6635 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 31130 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6650 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 31158 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6676 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-15].boolean);
					n->concurrent = (yyvsp[-13].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 31186 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6702 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31192 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6703 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31198 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6707 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31204 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6708 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31210 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6712 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31216 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6713 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31222 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6717 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31228 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6718 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 31234 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6721 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 31240 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 31246 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6731 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 31261 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6742 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 31276 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6753 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 31291 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6765 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31297 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31303 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6769 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31309 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6770 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31315 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6773 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 31321 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6774 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 31327 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6775 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 31333 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6778 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 31339 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6779 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 31345 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6780 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 31351 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6798 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31366 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6810 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31382 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6823 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31397 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6836 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31403 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6837 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31409 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 6840 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31415 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 6841 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31421 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 6845 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 31427 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 6846 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 31433 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 6854 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31439 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 6855 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31445 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 6859 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 31451 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 6861 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 31457 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 6876 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31470 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 6885 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31483 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 6894 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31496 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 6903 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31509 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 6912 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31522 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 6923 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 31528 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 6924 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 31534 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 6925 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 31540 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 6926 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 31546 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 6927 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 31552 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 6938 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 31564 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 6952 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31570 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 6954 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 31580 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 6960 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 31591 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 6970 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 31599 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 6974 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 31608 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 6979 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 31617 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 6987 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 31631 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7028 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 31639 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7032 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 31647 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7036 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 31655 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7040 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 31664 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7047 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 31670 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7048 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 31676 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31682 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7054 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31688 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7062 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
#line 31696 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7066 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 31704 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7070 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 31712 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7074 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
#line 31720 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7078 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
#line 31728 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7082 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
#line 31736 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7086 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 31744 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7090 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 31752 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7094 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 31760 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7098 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 31768 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
#line 31776 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7106 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
#line 31784 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7110 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value));
				}
#line 31792 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7114 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value));
				}
#line 31800 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7118 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt));
				}
#line 31809 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[0].str)));
				}
#line 31817 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7130 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list));
				}
#line 31825 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7134 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 31833 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7138 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[0].list));
				}
#line 31841 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7142 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
#line 31849 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7146 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 31857 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7151 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 31863 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7153 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 31871 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7159 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 31877 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7160 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 31883 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7164 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31889 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7165 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31895 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7169 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 31908 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7181 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 31916 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7185 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 31924 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7200 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].funwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 31935 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7210 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31941 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7211 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31947 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7233 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 31962 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7244 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 31977 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7258 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 31992 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7269 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32007 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7283 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32022 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7294 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32037 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7308 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 32049 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7316 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 32055 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7318 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 32061 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7320 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 32067 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7325 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32073 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7327 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 32079 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7340 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32089 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7348 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32095 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7349 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32101 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7354 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)));
				}
#line 32109 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7358 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 32117 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7371 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].funwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 32131 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7382 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 32145 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7393 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 32159 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7404 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 32165 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7405 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 32171 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7406 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 32177 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7411 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[-4].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32192 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7423 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32198 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7424 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32204 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7435 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 32218 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7447 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].funwithargs), (yyvsp[0].funwithargs));
				}
#line 32226 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7451 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].funwithargs), (yyvsp[-6].funwithargs));
				}
#line 32234 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7455 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].funwithargs), NULL);
				}
#line 32242 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7459 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].funwithargs));
				}
#line 32250 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7466 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make1((yyvsp[-3].typnam)));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *)n;
				}
#line 32264 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7487 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 32277 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7496 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 32290 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7505 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = (yyvsp[-3].ival);
					(yyval.node) = (Node *)n;
				}
#line 32303 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7514 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = (yyvsp[-3].ival);
					(yyval.node) = (Node *)n;
				}
#line 32316 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7524 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 32322 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7525 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 32328 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7528 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 32334 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7529 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 32340 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7530 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 32346 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7533 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 32352 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7534 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 32358 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7537 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEXOPT_VERBOSE; }
#line 32364 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7548 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 32377 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7557 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 32390 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7574 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32404 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7584 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32417 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7593 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32430 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7602 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32443 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7611 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32456 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7620 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 32469 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7629 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32482 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7638 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32496 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7648 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32509 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7657 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32522 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7666 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32535 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7675 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32548 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7684 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32562 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7694 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32576 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7704 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32589 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7713 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32602 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7722 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32616 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7732 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32630 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7742 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32644 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7752 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32658 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7762 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32672 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7772 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32686 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7782 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32700 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7792 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32714 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7802 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32728 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7812 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32742 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 7822 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32756 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 7832 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32770 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 7842 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32785 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 7853 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32800 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 7864 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32815 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7875 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32830 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7886 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32844 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7896 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32858 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7906 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32873 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7917 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32888 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7928 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32902 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 7938 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32916 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 7948 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 32928 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 7956 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32941 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 7965 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32954 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 7974 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32967 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 7983 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32980 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 7992 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32993 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8001 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33006 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8010 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33019 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8019 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33032 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8028 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33048 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8041 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 33054 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8042 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 33060 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8045 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 33066 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8046 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 33072 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8057 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->relation = NULL;
					n->objname = (yyvsp[-4].funwithargs)->funcname;
					n->objargs = (yyvsp[-4].funwithargs)->funcargs;
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33086 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8067 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-4].range);
					n->objname = list_make1(makeString((yyvsp[-6].str)));
					n->objargs = NIL;
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33100 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8077 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-4].range);
					n->objname = NIL;
					n->objargs = NIL;
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33114 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8087 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-4].range);
					n->objname = NIL;
					n->objargs = NIL;
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33128 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8106 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33142 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8116 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33155 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8125 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33168 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8134 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33181 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8143 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33194 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8152 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33208 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8162 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33222 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8172 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33235 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8181 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33248 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8190 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33261 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8199 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33274 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8208 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33287 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8217 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33300 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8226 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33313 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8235 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33326 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8244 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33339 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8253 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33352 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8262 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33365 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8271 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33378 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8280 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33391 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8289 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33404 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8298 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33417 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8307 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33430 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8316 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33443 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8334 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[-5].list);
					n->operargs = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 33455 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8343 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33461 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8344 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33467 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8348 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL); }
#line 33473 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8350 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node)); }
#line 33479 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8360 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33492 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8369 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33504 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8377 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33516 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8385 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33528 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8393 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33540 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8401 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33553 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8410 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33565 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8418 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[-3].value));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33577 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8426 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33590 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8435 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33602 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8443 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33614 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8451 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33626 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8459 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33638 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8467 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33650 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8475 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33662 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8483 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33674 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8491 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33686 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8499 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33698 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8507 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 33710 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8526 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33726 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8540 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33732 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8541 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33738 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8542 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33744 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8548 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 33754 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8554 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 33764 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8570 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33770 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8571 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33776 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8574 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 33782 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8575 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 33788 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8576 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 33794 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8577 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 33800 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8581 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 33806 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8582 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33812 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8583 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33818 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8589 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33833 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8600 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 33848 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8622 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 33859 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8631 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33865 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8632 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33871 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8636 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 33881 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8645 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 33891 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8651 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 33901 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8670 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 33912 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8677 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33923 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8684 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33934 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8691 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 33945 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8698 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 33956 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8705 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 33967 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8712 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 33979 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8720 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 33991 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8728 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 34003 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8736 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 34015 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8744 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 34027 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8752 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34038 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8759 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34049 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8766 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34060 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8774 "gram.y" /* yacc.c:1646  */
    {}
#line 34066 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8775 "gram.y" /* yacc.c:1646  */
    {}
#line 34072 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8776 "gram.y" /* yacc.c:1646  */
    {}
#line 34078 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8781 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0]))); }
#line 34085 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8784 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1]))); }
#line 34092 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8787 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 34099 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8790 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0]))); }
#line 34106 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8793 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 34113 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8800 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34119 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8802 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 34125 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8804 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34131 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8810 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34137 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8824 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 34153 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8837 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 34169 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8850 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 34190 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8868 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 34211 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8887 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 34217 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8888 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 34223 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 8889 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 34229 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 8890 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 34235 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 8901 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34245 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 8917 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34256 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 8926 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34262 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 8927 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34268 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 8931 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34274 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 8932 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34280 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 8937 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 34288 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 8941 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)));
				}
#line 34296 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 8945 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL);
				}
#line 34304 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 8962 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34310 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 8963 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 34316 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 8964 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34322 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 8965 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34328 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 8966 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34334 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 8967 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34340 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 8968 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 34346 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 8975 "gram.y" /* yacc.c:1646  */
    {}
#line 34352 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 8976 "gram.y" /* yacc.c:1646  */
    {}
#line 34358 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 8988 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 34369 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 8995 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 34380 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9002 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				 }
#line 34392 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9013 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 34403 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9030 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 34414 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9037 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 34425 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9055 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 34435 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9061 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 34445 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9077 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 34458 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9090 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 34470 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9099 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 34481 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9107 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 34492 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9115 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 34504 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9124 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 34518 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9135 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 34532 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9146 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 34544 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9155 "gram.y" /* yacc.c:1646  */
    {}
#line 34550 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9156 "gram.y" /* yacc.c:1646  */
    {}
#line 34556 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9168 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34567 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9178 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 34582 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9189 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 34597 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9200 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 34612 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9211 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 34627 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9222 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 34640 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9231 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 34653 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9242 "gram.y" /* yacc.c:1646  */
    {}
#line 34659 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9243 "gram.y" /* yacc.c:1646  */
    {}
#line 34665 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9259 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 34679 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9281 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 34691 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9289 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 34703 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9298 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 34715 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9308 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34721 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9309 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34727 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9322 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34745 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9336 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34763 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9350 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					(yyval.node) = (Node *)n;
				}
#line 34779 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9362 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 34791 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9370 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 34805 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9382 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 34811 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9383 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 34817 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9387 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_ANALYZE; }
#line 34823 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9388 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 34829 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9389 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FREEZE; }
#line 34835 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9390 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FULL; }
#line 34841 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9392 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "disable_page_skipping") == 0)
						(yyval.ival) = VACOPT_DISABLE_PAGE_SKIPPING;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized VACUUM option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 34855 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9405 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34869 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9415 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34883 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9427 "gram.y" /* yacc.c:1646  */
    {}
#line 34889 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9428 "gram.y" /* yacc.c:1646  */
    {}
#line 34895 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9432 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34901 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9433 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34907 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9436 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34913 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9437 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34919 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9440 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34925 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9441 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34931 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9445 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34937 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9446 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34943 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9460 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 34954 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9467 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 34968 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9477 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 34979 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9484 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 34990 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9506 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34998 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9510 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 35006 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9517 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 35014 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9523 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35020 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9524 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 35026 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9528 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35032 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9529 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 35038 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9530 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35044 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9541 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35056 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9550 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35062 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35068 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9569 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35079 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9577 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35098 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9593 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35104 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9594 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35110 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9605 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 35120 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9611 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 35130 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9617 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 35140 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9623 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 35150 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9640 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 35162 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 9657 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 35170 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 9661 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 35179 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 9669 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 35189 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 9675 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 35199 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 9681 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 35209 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9690 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35215 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9692 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 35221 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9697 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 35233 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9708 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 35246 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9718 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 35259 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9727 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 35267 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9734 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 35279 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9743 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 35291 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9751 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 35299 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9757 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35305 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9758 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35311 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9771 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 35325 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9783 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35331 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9784 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35337 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 9796 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 35350 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 9806 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 35356 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 9807 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 35362 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 9810 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 35368 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 9811 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 35374 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 9812 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 35380 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 9813 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 35386 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 9814 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 35392 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 9815 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 35398 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 9816 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 35404 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 9817 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 35410 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 9820 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 35416 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 9821 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35422 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 9825 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 35428 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 9826 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 35434 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 9827 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 35440 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 9843 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 35455 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 9856 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35461 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 9857 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 35467 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 9861 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35473 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 9862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35479 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 9867 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = (yyvsp[-2].target);
					(yyval.target)->val = (Node *) (yyvsp[0].node);
				}
#line 35488 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 9883 "gram.y" /* yacc.c:1646  */
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  This is semantically
					 * equivalent to, and much cheaper to process than, the
					 * general case.
					 */
					if (list_length((yyvsp[-3].list)) != list_length((yyvsp[0].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[0]))));
					forboth(col_cell, (yyvsp[-3].list), val_cell, (yyvsp[0].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 35518 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 9909 "gram.y" /* yacc.c:1646  */
    {
					SubLink *sl = makeNode(SubLink);
					int ncolumns = list_length((yyvsp[-3].list));
					int i = 1;
					ListCell *col_cell;

					/* First, convert bare SelectStmt into a SubLink */
					sl->subLinkType = MULTIEXPR_SUBLINK;
					sl->subLinkId = 0;		/* will be assigned later */
					sl->testexpr = NULL;
					sl->operName = NIL;
					sl->subselect = (yyvsp[0].node);
					sl->location = (yylsp[0]);

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) sl;
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 35552 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 9942 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 35564 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 9952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35570 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 9953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 35576 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 9964 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 35589 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 9974 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35595 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 9977 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35601 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 9978 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 35607 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 9979 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 35613 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 9980 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 35619 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 9981 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 35625 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 9984 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35631 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 9985 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 35637 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 9986 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35643 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 10039 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35649 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 10040 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35655 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 10055 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35661 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 10057 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 35672 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 10064 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 35684 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 10072 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 35696 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 10080 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 35708 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 10088 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 35720 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 10096 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 35732 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 10104 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 35744 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 10114 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35750 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 10115 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35756 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 10145 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35772 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 10159 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35789 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 10171 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35795 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 10173 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 35818 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10192 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 35826 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10196 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 35834 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10200 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 35842 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10217 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 35853 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10224 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 35864 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 10231 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 35875 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 10240 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35881 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10241 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35887 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10245 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 35900 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10256 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 35906 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10257 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 35912 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10262 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 35927 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10273 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 35933 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 10282 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 35942 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10287 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 35951 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10292 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 35960 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10297 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 35969 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10302 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 35981 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10310 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 35993 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10318 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 36002 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 10323 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 36011 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 10328 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 36020 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10334 "gram.y" /* yacc.c:1646  */
    {}
#line 36026 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10335 "gram.y" /* yacc.c:1646  */
    {}
#line 36032 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10339 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 36038 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10340 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 36044 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10341 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 36050 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10348 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 36056 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10349 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36062 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10353 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL;}
#line 36068 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10354 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36074 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10358 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 36080 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10359 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36086 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10363 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36092 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10367 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 36098 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10368 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 36104 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 36117 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10381 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 36130 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10393 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 36136 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10394 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 36142 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10395 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 36148 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10396 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 36154 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10400 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36160 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10401 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL,NULL); }
#line 36166 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10406 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36172 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10408 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 36185 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10418 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 36191 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10423 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36197 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10426 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 36203 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10430 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36209 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10432 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 36218 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10439 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36224 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10449 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0])); }
#line 36230 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10450 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 36236 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10451 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(1, -1); }
#line 36242 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10459 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36248 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10463 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 36254 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10464 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 36260 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10467 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 36266 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10468 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 36272 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10493 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36278 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10494 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36284 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36290 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10499 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 36296 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10503 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36302 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10504 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36308 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10505 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36314 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10506 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36320 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10507 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36326 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10512 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 36334 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10525 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 36342 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10532 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 36350 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10539 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 36358 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10545 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36364 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 10546 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36370 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 10550 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36376 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 10551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36382 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 10555 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36388 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 10556 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36394 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 10560 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36400 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 10561 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36406 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 10566 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 36418 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 10576 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 36424 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10577 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 36430 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10578 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 36436 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10579 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 36442 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10583 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36448 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10584 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36454 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10590 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 36464 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10596 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-2].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 36474 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10613 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36480 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10614 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36486 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10618 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36492 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10619 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36498 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 10626 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 36507 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 10631 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);
					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 36519 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 10639 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 36530 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 10646 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 36542 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10654 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 36581 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10689 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 36610 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 10714 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 36618 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 10718 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 36627 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 10744 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 36635 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 10748 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 36651 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 10760 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 36668 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 10773 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 36686 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 10787 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 36701 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 10798 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 36717 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 10813 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 36727 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 10819 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 36736 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 10824 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 36746 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 10830 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 36755 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 10836 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 36761 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 10837 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 36767 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 10846 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 36775 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 10850 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 36783 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 10854 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 36793 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 10860 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 36803 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 10866 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 36811 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 10871 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 36817 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 10872 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 36823 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 10873 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 36829 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 10874 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 36835 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 10878 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36841 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 10879 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36847 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 10891 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 36853 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 10892 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36859 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 10898 "gram.y" /* yacc.c:1646  */
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
#line 36870 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 10905 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
#line 36881 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 10912 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 36892 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 10919 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 36903 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 10929 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 36909 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 10930 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 36915 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 10944 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 36923 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 10948 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 36934 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 10955 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 36945 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 10968 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 36959 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 10980 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 36965 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 10981 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36971 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 10997 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 36985 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 11007 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 36999 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 11019 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 37005 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 11023 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 37011 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 11024 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 37017 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 11027 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37023 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 11028 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37029 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 11031 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37035 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 11032 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37041 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 11037 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 37047 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 11038 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37053 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 11043 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 37059 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 11045 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 37071 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 11052 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37077 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 11057 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37083 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 11058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37089 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 11063 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 37097 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 11067 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 37105 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 11073 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 37127 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 11103 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 37136 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 11108 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 37146 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 11115 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 37155 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 11120 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 37165 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 11126 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 37174 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 11131 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 37184 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 11140 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 37190 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 11142 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 37196 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 11144 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 37202 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 11148 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37208 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 11149 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37214 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 11150 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37220 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 11151 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37226 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 11152 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37232 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 11154 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 37241 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 37251 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11178 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37257 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11179 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37263 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11180 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37269 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11181 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37275 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11193 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37285 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11199 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 37295 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11206 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37301 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11207 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37307 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11214 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37316 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11219 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37325 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11224 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37334 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11229 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37343 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11234 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37352 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11239 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37361 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11244 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37370 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11249 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37380 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11255 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37390 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11261 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37400 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11267 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37409 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11274 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 37434 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11295 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 37442 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11305 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37450 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11309 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37458 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11317 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37466 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11321 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 37475 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11329 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 37488 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11341 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37506 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11362 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37514 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11366 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37522 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37530 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11376 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 37545 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11389 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-4].str) = psprintf("%s_%s", (yyvsp[-4].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-4].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 37558 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11400 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-1].str) = psprintf("%s_%s", (yyvsp[-1].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-1].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[-1].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37575 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11415 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37581 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11417 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37587 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11419 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 37593 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11421 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37599 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11423 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37605 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11425 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 37611 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11429 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37617 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11430 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37623 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11434 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37629 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11435 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37635 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11443 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 37648 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11452 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37660 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11460 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 37673 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11469 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 37685 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11480 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 37694 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11487 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37700 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11488 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37706 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11489 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37712 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11494 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 37718 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11496 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 37724 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 37730 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11500 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 37736 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11502 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 37742 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11504 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37748 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11506 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 37757 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11511 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 37766 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11516 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 37776 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11522 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 37788 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11530 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 37797 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11535 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 37808 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11542 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 37818 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11548 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37824 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11553 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 37832 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11557 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 37841 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11592 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 37847 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11594 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 37853 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11596 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 37865 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11604 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 37875 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11619 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 37881 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11621 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 37887 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11623 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37893 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11625 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37899 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11627 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37905 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11629 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37911 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11631 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37917 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11633 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37923 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11635 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37929 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11637 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37935 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11639 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37941 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11641 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37947 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11643 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37953 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11645 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37959 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11648 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37965 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 11650 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 37971 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 11652 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 37977 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 11655 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37983 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 11657 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 37989 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 11659 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 37995 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 11661 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 38001 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 11664 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 38010 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 11669 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 38022 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 11677 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 38031 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 11682 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 38043 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 11690 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 38052 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 11695 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 38064 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 11703 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 38073 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 11708 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 38085 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 11717 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 38097 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 11725 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 38109 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 11733 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 38121 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 11741 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 38133 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 11759 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 38145 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 11767 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 38157 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 11775 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 38169 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 11783 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 38181 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 11791 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 38201 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 11807 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 38213 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 11815 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 38225 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 11823 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 38237 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 11831 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 38249 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 11839 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 38261 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 11847 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 38273 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 11855 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 38281 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 11859 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 38289 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 11863 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 38297 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 11867 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 38305 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 11871 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 38317 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 11879 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 38329 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 11887 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 38341 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 11895 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 38353 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 11903 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 38377 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 11923 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 38403 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 11945 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 38418 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 11956 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 38429 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 11963 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 38449 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 11979 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 38458 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 11984 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 38468 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 12001 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38474 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 12003 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 38480 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 12005 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 38486 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 12007 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 38492 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 12009 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38498 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 12011 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38504 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 12013 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38510 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 12015 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38516 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 12017 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38522 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 12019 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38528 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 12021 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38534 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 12023 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38540 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 12025 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38546 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 12027 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38552 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 12029 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38558 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12031 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38564 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12033 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 38570 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12035 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 38576 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12037 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 38582 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12039 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 38590 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12043 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 38598 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12047 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 38606 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12051 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 38614 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12055 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 38623 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12060 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 38633 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12075 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38639 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12076 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38645 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12078 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 38664 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12093 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else if (operator_precedence_warning)
					{
						/*
						 * If precedence warnings are enabled, insert
						 * AEXPR_PAREN nodes wrapping all explicitly
						 * parenthesized subexpressions; this prevents bogus
						 * warnings from being issued when the ordering has
						 * been forced by parentheses.  Take care that an
						 * AEXPR_PAREN node has the same exprLocation as its
						 * child, so as not to cause surprising changes in
						 * error cursor positioning.
						 *
						 * In principle we should not be relying on a GUC to
						 * decide whether to insert AEXPR_PAREN nodes.
						 * However, since they have no effect except to
						 * suppress warnings, it's probably safe enough; and
						 * we'd just as soon not waste cycles on dummy parse
						 * nodes if we don't have to.
						 */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_PAREN, NIL, (yyvsp[-2].node), NULL,
												 exprLocation((yyvsp[-2].node)));
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 38702 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12127 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38708 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12129 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38714 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12131 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 38729 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12142 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 38757 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12166 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 38772 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12177 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 38787 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12188 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[0].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 38799 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12196 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 38813 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12206 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 38827 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12216 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *)g;
			  }
#line 38838 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12225 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 38846 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12229 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38856 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12235 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38867 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12242 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 38878 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12249 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 38892 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12259 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 38903 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12266 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 38923 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12294 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 38962 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12329 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38968 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12339 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38974 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12340 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 38980 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 38990 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12354 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[0]));
				}
#line 39020 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12380 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[0]));
				}
#line 39034 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12390 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 39051 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12403 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[0]));
				}
#line 39063 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12411 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 39080 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12424 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[0]));
				}
#line 39094 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12434 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[-3]));
				}
#line 39111 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12447 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[0]));
				}
#line 39125 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12457 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 39142 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12470 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 39150 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12474 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 39158 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12478 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[0]));
				}
#line 39166 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12482 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 39174 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12486 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[0]));
				}
#line 39182 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12490 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[0]));
				}
#line 39190 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12494 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 39196 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39204 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12500 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39217 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12509 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39226 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12514 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39237 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12521 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 39256 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12536 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 39267 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12543 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 39275 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 12547 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 39283 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 12551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39291 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 12555 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 39299 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 12559 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 39310 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 12566 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 39322 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 12574 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 39334 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 12582 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39342 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 12586 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 39350 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 12590 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 39358 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 12594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 39366 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 12598 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 39374 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 12602 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 39384 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 12608 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 39392 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 12612 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 39405 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 12621 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 39413 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 12625 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 39421 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 12629 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 39430 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 12634 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 39443 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 12648 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39449 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 12650 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 39455 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 12654 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 39461 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 12656 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 39467 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 12658 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 39473 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 12660 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 39479 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 12663 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39485 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 12666 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 39491 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 12667 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 39497 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 12671 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 39509 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 12679 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 39521 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 12688 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 39527 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 12689 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 39533 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 12692 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 39539 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 12693 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 39545 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 12694 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 39551 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 12700 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 39559 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 12704 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 39567 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 12708 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 39575 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 12712 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 39583 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 12722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39589 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 12723 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39595 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 12727 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 39601 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 12728 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 39607 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 12736 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39613 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 12737 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39619 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 12741 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 39625 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 12743 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 39631 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 12748 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 39641 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 12756 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 39647 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 12758 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 39664 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 12771 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 39670 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 12776 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 39688 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 12801 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39694 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 12802 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39700 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 12805 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39706 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 12806 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39712 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 12818 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 39734 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 12836 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 39744 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 12842 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39756 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 12852 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 39777 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 12869 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 39818 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 12914 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39830 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 12922 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39842 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 12930 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39854 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 12938 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39866 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 12946 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 39878 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 12966 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39884 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 12967 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39890 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 12968 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 39896 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 12971 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39902 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 12972 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39908 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 12975 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 39914 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 12978 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 39920 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 12979 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 39926 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 12980 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 39932 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 12983 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39938 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 12984 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39944 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 12987 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 39950 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 12988 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 39956 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 12989 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 39962 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 12990 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 39968 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 12991 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 39974 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 12992 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 39980 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 12993 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 39986 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 12994 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 39992 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 12995 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 39998 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 12996 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 40004 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 12997 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 40010 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 12998 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 40016 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 13002 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40022 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 13004 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40028 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 13009 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40034 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 13011 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40040 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 13016 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40046 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 13018 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40052 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 13020 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 40058 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 13022 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 40064 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 13024 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 40070 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 13026 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 40076 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 13038 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 40084 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 13042 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 40092 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 13049 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 40100 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 13053 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 40108 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 13059 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 40116 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 13063 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 40129 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 13072 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 40142 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 13082 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 40148 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 13083 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 40154 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 13087 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 40162 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 13091 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 40170 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 13095 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 40178 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 13100 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40184 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 13101 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 40190 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 13107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 40198 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 13110 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40204 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 13117 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40210 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 13118 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 40216 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 13119 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 40222 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 13120 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 40228 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 13121 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 40234 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 13122 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 40240 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 13123 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 40246 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 13124 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40252 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 13135 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 40260 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 13139 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 40268 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 13146 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40274 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 13152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 40280 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 13153 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40286 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 13170 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 40294 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 13174 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 40303 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 13179 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 40311 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 13183 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 40330 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 13198 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 40338 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 13202 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40344 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 13206 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40350 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 13209 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40356 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 13212 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 40362 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 13213 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40368 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 13214 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40374 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 13218 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 40385 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 13224 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 40391 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 13235 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 40405 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 13248 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40411 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 13249 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 40417 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 13254 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 40429 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 13264 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40435 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 13265 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40441 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 13268 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40447 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 13269 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40453 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 13273 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 40461 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 13277 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 40469 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 13284 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 40477 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 13288 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 40485 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 13292 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 40497 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 13300 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 40509 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 13310 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40515 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 13311 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40521 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 13315 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40527 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 13316 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 40533 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 13320 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40539 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 13321 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 40545 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 13336 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 40551 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 13338 "gram.y" /* yacc.c:1646  */
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 40561 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 13346 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40567 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 13347 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 40573 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 13355 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40579 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 13365 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40585 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 13366 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40591 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 13370 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 40597 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 13371 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 40603 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 13375 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 40615 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 13391 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 40627 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 13399 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 40639 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 13407 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 40655 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 13428 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 40661 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 13429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 40667 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 13441 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 40675 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 13445 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 40704 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 13472 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40710 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 13474 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 40716 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 13478 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40722 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 13481 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40728 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 13484 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40734 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 13486 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40740 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 13488 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40746 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 13490 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40752 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 13501 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40758 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 13503 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 40767 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 13514 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 40775 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 13518 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 40783 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 13522 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 40791 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 13526 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 40799 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 13530 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 40812 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 13539 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 40823 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 13546 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 40859 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 13578 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 40867 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 13582 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 40877 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 13588 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 40888 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 13595 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 40896 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 13599 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 40904 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 13603 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 40912 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 13608 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 40918 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 13609 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40924 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 13611 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 40930 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 13612 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 40936 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 13613 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 40942 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 13618 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[0].node);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
					}
				}
#line 40974 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 13648 "gram.y" /* yacc.c:1646  */
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[0].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[0].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[0]))));
						}
						else
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
							n->rolename = pstrdup((yyvsp[0].str));
						}
						(yyval.node) = (Node *) n;
					}
#line 41005 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 13675 "gram.y" /* yacc.c:1646  */
    {
						(yyval.node) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
					}
#line 41013 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 13679 "gram.y" /* yacc.c:1646  */
    {
						(yyval.node) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
					}
#line 41021 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 13685 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41027 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 13687 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41033 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 13703 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41039 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 13704 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41045 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 13705 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41051 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 13710 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41057 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 13711 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41063 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 13712 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41069 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 13717 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41075 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 13718 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41081 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 13719 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41087 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 13720 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41093 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 13726 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41099 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 13727 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41105 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 13728 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41111 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 13729 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41117 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 13730 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41123 "gram.c" /* yacc.c:1646  */
    break;


#line 41127 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 14206 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static Node *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return (Node *) spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
